#ifndef MCLASSINFO_H
#define MCLASSINFO_H

#include "mString.h"
#include "mDefs.h"
#include "mList.h"
#include "mMethod.h"
#include "mVariable.h"
#include <iostream>
#include "mLiteral.h"
#include "mCode.h"
#include "mMethodTable.h"


class mMethod;
class mParseTree;


class methodSignature{
 public:
  mMethod* method;        // the method
  int indexInMethodTable; // index in method table 
};

// classinfo contains: 
//   - signature for every method
//   - direct superclasses

class mClassInfo{
 public:
  mClassInfo(){
    // create lists for method signatures and superclasses
    signatures = new mList<mMethod>();
    superclasses = new mList<mClass>();    
  }
  virtual ~mClassInfo(){
    delete signatures;
    delete superclasses;
  }
  

  // list of method signatures
  mList<methodSignature> *signatures;

  // list of direct superclasses
  mList<mClass> *superclasses;

  
 

  // returns string representation of class info
  mString toString(){
    mString s;   
    return s;
  }
  
};



#endif
