#include "mClosure.h"

mClosure::mClosure(int offset/*, FrameRecord* frame*/, int ref, mCode* code)
{
  relocEntries = 0;

  linkEntries = 0;

  nRelocEntries = nLinkEntries = 0;

  codeOffset = offset;

  closureReference = ref;

  parentCode = code;

  //parentFrame = frame;
}

mClosure::~mClosure()
{
  delete[] relocEntries;  
  delete[] linkEntries;
  
}

void mClosure::addRelocationEntry(int offset)
{
  if(!relocEntries){
    // 1st entry
    relocEntries = new int[1];
    relocEntries[0] = offset;        

    nRelocEntries++;

  }else{
    // append to end
    int *newReloc = new int[nRelocEntries + 1];
    for(int i=0;i<nRelocEntries;i++) newReloc[i] = relocEntries[i];
    newReloc[nRelocEntries] = offset;
    nRelocEntries++;
    delete[] relocEntries;
    relocEntries = newReloc;
  }
}


void mClosure::addLinkEntry(linkTableEntry* entry, int offset)
{
  if(!linkEntries){
    // 1st entry
    linkEntries = new link[1];
    linkEntries[0].entry = entry;
    linkEntries[0].entries = new int[1];
    linkEntries[0].entries[0] = offset;    
    linkEntries[0].nEntries=1;

    nLinkEntries++;
  }else{

    // find if we already have any entries for this linkEntry
    for(int i=0;i<nLinkEntries;i++){

      if( linkEntries[i].entry == entry ){
	
	// we just add index to this entry
	int *newReloc = new int[ linkEntries[i].nEntries + 1 ];
	for(int j=0;j<linkEntries[i].nEntries;j++) newReloc[j] = linkEntries[i].entries[j];

	newReloc[ linkEntries[i].nEntries ] = offset;

	linkEntries[i].nEntries++;

	delete[] linkEntries[i].entries;
	linkEntries[i].entries = newReloc;
	return;
      }

    }

    // no linkentry was found so we add it
    link *newReloc = new link[ nLinkEntries + 1];
    for(int i=0;i<nLinkEntries;i++) newReloc[i] = linkEntries[i];
    newReloc[nLinkEntries].entry = entry;
    newReloc[nLinkEntries].entries = new int[1];
    newReloc[nLinkEntries].entries[0] = offset;
    newReloc[nLinkEntries].nEntries=1;

    nLinkEntries++;
    
    delete[] linkEntries;

    linkEntries = newReloc;

    
  }
}


void mClosure::updateRelocationTable(int* reloc, int newOffset)
{
  //reloc[i] = newOffset + reloc[i] - start_offset_of_closure 
  for(int i=0;i<nRelocEntries;i++){
    //cout<<"-- updating offset "<<reloc[ relocEntries[i] ]<< " to "
    //<<newOffset + reloc[ relocEntries[i] ] - codeOffset<<endl;
    reloc[ relocEntries[i] ] = newOffset + reloc[ relocEntries[i] ] - codeOffset;

  }   
  
}


void mClosure::updateLinkTable(int newOffset)
{

  for(int i=0;i<nLinkEntries;i++){

    link& lentry = linkEntries[i];
    //cout<<"-- updating offset "<<reloc[ relocEntries[i] ]<< " to "
    //<<newOffset + reloc[ relocEntries[i] ] - codeOffset<<endl;

    for(int j=0;j<lentry.nEntries;j++){

      lentry.entry->offsets[ lentry.entries[j] ] = newOffset + 
	lentry.entry->offsets[ lentry.entries[j] ] - codeOffset;

    }

  }

}


void mClosure::fixParentCode(int newOffset, int delta)
{
  // update offset in closure instantiation instruction

  //cout<<"fixing address of myself in parent at "<<closureReference + delta<<" to "<<newOffset<<endl;
  parentCode->setInstructionValue( closureReference + delta, newOffset );
}



void mClosure::calculateSize(int current)
{
  // size is current offset - starting offset
  codeLength =  current - codeOffset;
}
