#include "mCode.h"


mCode::mCode()
{
  binary = 0;
  binaryLength = 0;
  text = new mString();
  bytes = new mString();
}

mCode::~mCode()
{
 delete text;
 delete bytes;

 if( binary ) delete binary;
}


int mCode::appendInstruction(mString& st, short opc, int dest, int l1, int l2, int l3, int l4, int l5)
{

  // calculate instruction size
  int size = 2;   // opcode which is 16 bits, is always present
  
  char *instruction = new char[ 28 ];  // 28 bytes max

  // copy opcode
  memcpy( instruction, &opc, 2 );

  mString byterep;          // byte representation

  byterep += toShort( opc ); 

  //cout<<"opcode="<<opc<<endl;

  if( dest != -1 ){
    memcpy( instruction + 2, &dest, 4 );  
    byterep += '.';  byterep += toInt( dest );
    size += 4;
    //cout<<"adding dest "<<dest<<"."<<endl;
  }
  if( l1 != -1 ){
    memcpy( instruction + 6, &l1, 4 );
    byterep += '.';  byterep += toInt( l1 );
    size += 4;
  }
  if( l2 != -1 ){
    memcpy( instruction + 10, &l2, 4 );
    byterep += '.';  byterep += toInt( l2 );
    size += 4;
  }
  if( l3 != -1 ){
    memcpy( instruction + 14, &l3, 4 );
    byterep += '.';  byterep += toInt( l3 );
    size += 4;
  }
  if( l4 != -1 ){
    memcpy( instruction + 18, &l4, 4 );
    byterep += '.';  byterep += toInt( l4 );
    size += 4;
  }
  if( l5 != -1 ){
    memcpy( instruction + 22, &l5, 4 );
    byterep += '.';  byterep += toInt( l5 );
    size += 4;
  }
  
  
  byterep += '\n';
  //cout<<"byterep="<<byterep<<endl;


  *bytes += byterep;

  // do we have code or is this the first instruction
  if( !binary ){
    // allocate space for this instruction
    binary = new char[ size ];
    memcpy( binary, instruction, size );
  }else{
    // otherwise we append this instruction to end

    // allocate new space
    char *newbinary = new char[ binaryLength + size ];

    // copy old code
    memcpy( newbinary, binary, binaryLength );
    
    //... and add new 
    memcpy( newbinary+binaryLength, instruction, size );
    delete[] binary;
    binary = newbinary;
  }

  binaryLength += size;

  delete[] instruction;

  *text += st;

  return size;
}


int mCode::prependInstruction(mString& st, short opc, int dest, int l1, int l2, int l3, int l4)
{

  // calculate instruction size
  int size = 2;   // opcode which is 16 bits, is always present
  
  char *instruction = new char[ 24 ];  // 24 bytes max

  // copy opcode
  memcpy( instruction, &opc, 2 );

  mString byterep;          // byte representation

  byterep += toShort( opc ); 


  if( dest != -1 ){
    memcpy( instruction + 2, &dest, 4 );  
    byterep += '.';  byterep += toInt( dest );
    size += 4;
  }
  if( l1 != -1 ){
    memcpy( instruction + 6, &l1, 4 );
    byterep += '.';  byterep += toInt( l1 );
    size += 4;
  }
  if( l2 != -1 ){
    memcpy( instruction + 10, &l2, 4 );
    byterep += '.';  byterep += toInt( l2 );
    size += 4;
  }
  if( l3 != -1 ){
    memcpy( instruction + 14, &l3, 4 );
    byterep += '.';  byterep += toInt( l3 );
    size += 4;
  }
  if( l4 != -1 ){
    memcpy( instruction + 18, &l4, 4 );
    byterep += '.';  byterep += toInt( l4 );
    size += 4;
  }
  
  byterep += '\n';
 
  bytes->prepend( byterep );

  // do we have code or is this the first instruction
  if( !binary ){
    // allocate space for this instruction
    binary = new char[ size ];
    memcpy( binary, instruction, size );
  }else{
    // otherwise we append this instruction to the beginning

    // allocate new space
    char *newbinary = new char[ binaryLength + size ];

    // first copy new instruction
    memcpy( newbinary, instruction, size );

    // and now old code
    memcpy( newbinary+size, binary, binaryLength );
    delete[] binary;
    binary = newbinary;
  }

  binaryLength += size;

  delete[] instruction;
 
  text->prepend( st );

  return size;
}


void mCode::setInstructionValue(int offset, int value)
{
  memcpy( binary + offset, &value, 4 );
}

