#ifndef __MCODE_H
#define __MCODE_H

#include "mString.h"
#include <iostream>

using namespace std;

// code or code fragment
class mCode{
 public:
  mCode();

  virtual ~mCode();

  // adds instruction to the end of current code. format is: string,
  // opcode (16 bits), destination local, source1, source2, source3.
  // destination and source local variables are all 32 bits long
  // if any of the variables is not used its location is set to -1  
  // returns length of generated instruction
  int appendInstruction(mString&, short=-1, int=-1, int=-1, int=-1, int=-1,int=-1,int=-1);

  
  // same as above, only here instruction is prepended at the beginning of code
  int prependInstruction(mString&, short=-1, int=-1, int=-1, int=-1, int=-1,int=-1);

  // apends text to text representation
  void appendText(mString& s){ *text += s; }

  // sets value inside instruction
  // args: offset in code, value
  void setInstructionValue(int, int);

  
    
  // textual representation in assembler mnemonics
  // i.e. 'l0.add l4'  
  mString *text;

  // binary representation in bytes
  // i.e. 04 f1 5d
  mString *bytes;

  // pure binary representation
  char *binary;
  
  // # of bytes in binary representation
  int binaryLength;

 private:
  // converts byte to hex string (i.e. 255 becomes ff )
  mString toHex(int value){
    mString s;
    s.setBase( 16 );
    s += (unsigned)value;

    if(s.length() == 1){ mString n('0');  n += s; s=n; } // add leading 0
    else
      s = s.right(s.length()-2);   // only 1 lsb byte
    return s;
  }

  // converts short to hex string (i.e. 65535 becomes ff ff )
  mString toShort(short value){
    mString s;
    s += toHex( (unsigned)value >> 8 ); // high 8 bits
    s += ' ';
    s += toHex( (unsigned)value & 0x00ff ); // low 8 bits
    return s;
  }

  // converts int to hex string
  mString toInt(int value){
    mString s;
    
    s += toHex( (unsigned)value >> 24 ); // high 8 bits
    s += ' ';    
    s += toHex( ((unsigned)value & 0x00ff0000) >> 16 ); 
    s += ' ';    
    s += toHex( ((unsigned)value & 0x0000ff00) >> 8 );
    s += ' ';    
    s += toHex( (unsigned)value & 0x000000ff );
    return s;
  }

};

#endif
