#ifndef MMETHODCLASS_H
#define MMETHODCLASS_H

#include "mString.h"
#include "mDefs.h"
#include "mClass.h"
#include <iostream>




class mMethodClass : public mClass{
      public:
             // class of generic Method, superclass, list of parameter types, return type
             mMethodClass(mClass*, mClass*, mList<mClass>*, mClass*);

	     // class of generic Method, superclass, list of parameters, return type
             mMethodClass(mClass*, mClass*, mList<mParameter>*, mClass*);

             virtual ~mMethodClass();
                          
             
	     // returns hieararhical distance between this and another class. 0 if the types are
	     // equal, -1 if the types are disjunctive (foreign)
	     // i.e. (object, integer) = 1, (integer, integer) = 0, (integer, some_user_type ) = -1
	     //int distance(mClass*);

	     // returns true if this class is a subclass of another one
	     //bool isSubclass(mClass*);

	     // returns true if this class is a subtype of another one. this includes Self
	     //bool isSubtype(mClass*);


	     // creates method type name from parameter types and return type
	     static mString getTypeName(mList<mClass>*, mClass*);

	     // creates method type name from parameters and return type
	     static mString getTypeName(mList<mParameter>*, mClass*);
	     
	     mList<mMethod> *methodList;
	     mClass         *returnType;
	     mList<mClass>  *parameters;

	     	     	     

 private:            

	     
	     // returns true if method is compatible with this class. this means that no such method
	     // must exist in class or signature of method must be compatible with existing method.
	     // the latter means that this method must be submethod of existing one
	     //mClass* isCompatibleWith(mMethod*);

	     // fills a list of all possible methods in this class first and then in superclasses)
	     // returns true on success, false on error (ambiguity)
	     //bool getPossibleMethods( mString*, mParseTree*,mList<candidateMethod>*,
	     //		      mMethod*&, bool );

	     // fills a list of all possible methods in this class first and then in superclasses)
	     // returns true on success, false on error (ambiguity).
	     // used for parameterless mehods
	     //bool getPossibleMethods( mString*, mList<candidateMethod>*,
	     //		      mMethod*&, bool );
	     
	     
};


#endif
