#ifndef __MSTACK__H
#define __MSTACK__H


template<class T>
class mStack{
      public:
             /*!Constructs new (empty) list of size 0.*/
             mStack(){ First = Last = Current = 0; Size = MaxSize = 0; autoDel = false; }
             /*!Constructs new list with specified size.*/
             mStack(unsigned s) { First=Last=Current=0; Size=0; MaxSize=s; autoDel = false; }
             /*!Copy constructor.*/
             mStack(mStack const &s){
                    First=Last=Current=0;
                    Size = 0;
                    //for(unsigned i=0;i<s.size();i++) push(s.at(i));
	                 Size=s.size();
	                 MaxSize=s.maxSize();
	                 autoDel=s.autoDeletion();
             }
             /*!Assignment operator.*/
             mStack& operator=(mStack const &s){
               if(this != &s){
                  clear();
                  MaxSize = s.maxSize();
                  autoDel = s.autoDeletion();
                  //for(unsigned i=0;i<s.size();i++) append(s.at(i));
               }
               return (*this);
             }
             /*!Destructor.*/
             virtual ~mStack(){ clear(); }
             /*!Deletes all elements.*/
             virtual void clear(){
               item *it = First;
               while(it){
                     item *next = it->next;
                     removeItem(it);
                     it = next;
               }
               Size = 0;
               First=Last=Current=0;
             }
             /*!Sets whether objects should be deleted when removed from collection.
             Default is false.*/
             void setAutoDelete(bool on) { autoDel = on; }
             /*!Returns true if auto deletion enabled.*/
             bool autoDeletion() const { return autoDel; }
             /*!Returns size (# elements) of this collection.*/
             unsigned size() const { return Size; }
             /*!Returns max size or 0 if unlimited.*/
             unsigned maxSize() const { return MaxSize; }
             /*!Returns true if collection is empty.*/
             bool empty() const { return Size == 0; }
             
             /*!Pushes element on top. Returns true if successful.*/
             inline bool push(T*);
             /*!Pops top element. Returns true if successful.*/
             inline bool pop();

             /*!Returns top element.*/
             T* top() { if(Size>0) return Last->i; return 0; }

      private:
             struct item{
                    T    *i;
                    item *next,*prev;
             };
             
             item *First;          // 1st item
             item *Last;           // last
             item *Current;
             
             void removeItem(item*);
             unsigned Size;
             unsigned MaxSize;
             bool     autoDel;
             
};

template<class T>
bool mStack<T>::push(T *e)
{
 if(MaxSize > 0 && Size >= MaxSize) return false;

  if(Size == 0){     // 1st element
    First = new item;
    First->i = e; First->next = First->prev = 0;
    Last = Current = First;
 }else{
  item *it = new item;
  it->i = e; it->next = 0; it->prev = Last;
  Last = it;
 }
 
 Size++;
 
 return true;
}


template<class T>
bool mStack<T>::pop()
{
 if(Size == 0) return false;
 
 item *prev = Last->prev;

 removeItem(Last);
 
 Last = prev;   // top becomes old last

 if(prev) prev->next = 0;

 Size--;
 
 if(Size==0) { First = Last = Current = 0; }
 
 return true; 
}


template<class T>
void mStack<T>::removeItem(item *it)
{
 if(!it) return;
 if(autoDel) delete it->i; 
 delete it;
}


#endif

