#include "mString.h"
#include <iostream>

using namespace std;

mString::mString()
{
 string = new char[1];
 string[0] = '\0';
 _temp_str = 0;
 Base = 10;
}

mString::mString(char const *str)
{
 string = new char[strlen(str) + 1];
 strcpy(string,str);
 _temp_str = 0;
 Base = 10;
}

mString::mString(mString const &str)
{
 string = new char[str.length() + 1];
 strcpy(string,str.string);
 _temp_str = 0;
 Base = 10;
}

mString::mString(char ch)
{
 string = new char[2];
 string[0] = ch; string[1] = '\0';
 _temp_str = 0;
 Base = 10;
}

mString::mString(int val)
{
 Base = 10;
 char *temp = new char[1024];
 switch(Base){
        case 8:  ::sprintf(temp,"%o",val);
                 break;
        case 10: ::sprintf(temp,"%d",val);
                 break;
        case 16: ::sprintf(temp,"%x",val);
                 break;
 } // switch

 string = new char[strlen(temp) + 1];

 strcpy(string,temp);
 delete[] temp;
 _temp_str = 0;
}

mString::mString(unsigned int val)
{
 Base = 10;
 char *temp = new char[1024];

 switch(Base){
        case 8:  ::sprintf(temp,"%o",val);
                 break;
        case 10: ::sprintf(temp,"%u",val);
                 break;
        case 16: ::sprintf(temp,"%x",val);
                 break;
 } // switch

 string = new char[strlen(temp) + 1];

 strcpy(string,temp);
 delete[] temp;
 _temp_str = 0;
}

mString::mString(double val)
{
 Base = 10;
 char *temp = new char[1024];

 ::sprintf(temp,"%f",val);
 string = new char[strlen(temp) + 1];

 strcpy(string,temp);
 delete[] temp;
 _temp_str = 0;
}


mString::~mString()
{
  //delete[] string;
  //if(_temp_str) delete[] _temp_str;
}

mString& mString::operator=(mString const &str)
{
 if(this != &str){
    delete[] string;
    string = new char[str.length() + 1];
    strcpy(string,str.string);
 }
 _temp_str = 0;
 return (*this);
}

mString& mString::operator=(char ch)
{
 delete[] string;
 string = new char[2];
 string[0] = ch; string[1] = '\0';
 return (*this);
}

mString& mString::operator=(int val)
{
 delete[] string;

 char *temp = new char[1024];

 switch(Base){
        case 8:  ::sprintf(temp,"%o",val);
                 break;
        case 10: ::sprintf(temp,"%d",val);
                 break;
        case 16: ::sprintf(temp,"%x",val);
                 break;
 } // switch


 string = new char[strlen(temp) + 1];

 strcpy(string,temp);
 delete[] temp;

 return (*this);
}

mString& mString::operator=(unsigned int val)
{
 delete[] string;

 char *temp = new char[1024];

 switch(Base){
        case 8:  ::sprintf(temp,"%o",val);
                 break;
        case 10: ::sprintf(temp,"%u",val);
                 break;
        case 16: ::sprintf(temp,"%x",val);
                 break;
 } // switch

 string = new char[strlen(temp) + 1];

 strcpy(string,temp);
 delete[] temp;

 return (*this);
}

mString& mString::operator=(double val)
{
 delete[] string;

 char *temp = new char[1024];

 ::sprintf(temp,"%f",val);
 string = new char[strlen(temp) + 1];

 strcpy(string,temp);
 delete[] temp;

 return (*this);
}

mString& mString::operator+=(mString const &str)
{
 mString s = str;
 unsigned len = strlen(string);
 _store(string,len+1);     // copy current string

 delete[] string;
 string = new char[len + s.length() + 1];

 strcpy(string,_temp_str);
 strcat(string,s);
 return (*this);
}


mString& mString::operator+=(char const* str)
{
 unsigned len = strlen(string);
 _store(string, len+1);     // copy current string

 delete[] string;
 string = new char[len + strlen(str) + 1];

 strcpy(string,_temp_str);
 strcat(string,str);
 return (*this);
}

mString& mString::operator+=(char ch)
{
 unsigned len = strlen(string);
 _store(string,len+1);     // copy current string

 delete[] string;
 string = new char[len + 2];

 strcpy(string,_temp_str);

 string[len] = ch;
 string[len + 1] = '\0';
 return (*this);
}

mString& mString::operator+=(int val)
{
 unsigned len = strlen(string);
 _store(string,len+1);     // copy current string
 delete[] string;

 char *temp = new char[1024];

 switch(Base){
        case 8:  ::sprintf(temp,"%o",val);
                 break;
        case 10: ::sprintf(temp,"%d",val);
                 break;
        case 16: ::sprintf(temp,"%x",val);
                 break;
 } // switch

 string = new char[len + strlen(temp) + 1];

 strcpy(string,_temp_str);
 strcat(string,temp);
 delete[] temp;

 return (*this);
}

mString& mString::operator+=(unsigned int val)
{
 unsigned len = strlen(string);
 _store(string,len+1);     // copy current string
 delete[] string;

 char *temp = new char[1024];

 switch(Base){
        case 8:  ::sprintf(temp,"%o",val);
                 break;
        case 10: ::sprintf(temp,"%u",val);
                 break;
        case 16: ::sprintf(temp,"%x",val);
                 break;
 } // switch

 string = new char[len + strlen(temp) + 1];

 strcpy(string,_temp_str);
 strcat(string,temp);
 delete[] temp;

 return (*this);
}

mString& mString::operator+=(double val)
{
 unsigned len = strlen(string);
 _store(string,len+1);     // copy current string
 delete[] string;

 char *temp = new char[1024];

 ::sprintf(temp,"%f",val);
 string = new char[len + strlen(temp) + 1];

 strcpy(string,_temp_str);
 strcat(string,temp);
 delete[] temp;

 return (*this);
}

bool mString::operator==(mString const &str)
{
 return(strcmp(string,str) == 0);
}

bool mString::operator==(char const *str)
{
 return(strcmp(string,str) == 0);
}

bool mString::operator!=(mString const &str)
{
 return(strcmp(string,str) != 0);
}

bool mString::operator!=(char const *str)
{
 return(strcmp(string,str) != 0);
}

bool mString::operator>(mString const &str)
{
 return(strcmp(string,str) > 0);
}

bool mString::operator>(char const *str)
{
 return(strcmp(string,str) > 0);
}

bool mString::operator>=(mString const &str)
{
 return(strcmp(string,str) >= 0);
}

bool mString::operator>=(char const *str)
{
 return(strcmp(string,str) >= 0);
}

bool mString::operator<(mString const &str)
{
 return(strcmp(string,str) > 0);
}

bool mString::operator<(char const *str)
{
 return(strcmp(string,str) > 0);
}

bool mString::operator<=(mString const &str)
{
 return(strcmp(string,str) >= 0);
}

bool mString::operator<=(char const *str)
{
 return(strcmp(string,str) >= 0);
}

bool mString::setBase(int b)
{
 if(b != 8 && b != 10 && b != 16) return false;
 Base = b;
 return true;
}

void mString::fill(char ch,int len)
{
 int l = strlen(string);
 if(len > l || len == -1) len = l;
 for(int i=0;i<len;i++) string[i] = ch;
}

bool mString::isSpace(unsigned pos) const
{
 char ch = string[pos];
 return(ch == 32 || ch == 9 || ch == 10 || ch == 11 || ch == 12 || ch == 13);
}

mString& mString::upper()
{
 for(unsigned i=0;i<strlen(string);i++) string[i]=toupper(string[i]);
 return (*this);
}

mString& mString::lower()
{
 for(unsigned i=0;i<strlen(string);i++) string[i]=tolower(string[i]);
 return (*this);
}

mString& mString::replace(unsigned pos,char ch)
{
 if(strlen(string) <= pos) return (*this);
 string[pos] = ch;

 return (*this);
}

mString& mString::append(mString const &str)
{
 mString s = str;

 unsigned len = strlen(string);
 _store(string,len+1);

 delete[] string;
 string = new char[s.length()+len+1];

 strcpy(string,_temp_str);
 strcat(string,s);

 return (*this);
}

mString& mString::prepend(mString const &str)
{
 mString s = str;

 unsigned len = strlen(string);
 _store(string,len+1);

 delete[] string;
 string = new char[s.length()+len+1];

 strcpy(string,s);
 strcat(string,_temp_str);

 return (*this);
}


mString& mString::truncate(unsigned pos)
{
 unsigned len = strlen(string);
 // check limits
 if(pos < 0 || pos >= len) return (*this);

 _store(string,len+1);

 _temp_str[pos] = '\0';
 delete[] string;

 string = new char[pos + 1];
 strcpy(string,_temp_str);
 return (*this);
}

mString& mString::remove(unsigned pos,unsigned l)
{
 unsigned len = strlen(string);
 // check limits
 if(pos < 0 || pos >= len || l == 0) return (*this);
 if(pos + l >= len) l = len-pos;

 _store(string,len+1);
 delete[] string;
 string = new char[len-l+1];
 memcpy(string,_temp_str,pos);     // copy 1st part
 unsigned i;
 for(i = pos;i<pos+len-l;i++)   // copy 2nd part
     string[i] = _temp_str[l+i];

 string[i] = '\0';
 return (*this);
}

mString& mString::insert(unsigned pos,mString const &str)
{
 if(str.length() == 0) return (*this);

 unsigned len = strlen(string);
 // check limits
 if(pos < 0 || pos > len) return (*this);

 _store(string,len+1);
 delete[] string;
 string = new char[len + str.length() + 1];

 memcpy(string,_temp_str,pos);   // 1st part
 string[pos] = '\0';

 strcat(string,str);

 unsigned newlen = strlen(string);
 unsigned i,j;
 for(i=newlen,j=pos;i<newlen+len-pos;i++,j++) string[i] = _temp_str[j];
 string[i] = '\0';

 return (*this);
}

int mString::find(char ch,unsigned pos,bool cs) const
{
 if(cs){
    for(unsigned i=pos;i<strlen(string);i++)
        if(string[i] == ch) return i;
 } else{
   for(unsigned i=pos;i<strlen(string);i++)
        if(tolower(string[i]) == tolower(ch)) return i;
 }
 return -1;
}

int mString::find(mString const &str,unsigned pos,bool cs) const
{
 unsigned j=0,count=0;
 unsigned len = str.length();
 if(cs){
    for(unsigned i=pos;i<strlen(string);i++,j++){
        if(j >= len) return -1;
        if(string[i] == str[j]) count++;
        else{ j=(unsigned)-1; count = 0; }
        if(count == len) return i-len+1;
    }
 } else{
   for(unsigned i=pos;i<strlen(string);i++,j++){
       if(j >= len) return -1;
       if(tolower(string[i]) == tolower(str[j])) count++;
       else{ j=(unsigned)-1; count = 0; }
       if(count == len) return i-len+1;
   }
 }
 return -1;
}


int mString::findRev(char ch,unsigned pos,bool cs) const
{
 int len = strlen(string);
 if(cs){
    for(int i=len-1-pos;i>=0;i--){
        if(string[i] == ch) return i;
    }
 } else{
   for(int i=len-1-pos;i>=0;i--)
        if(tolower(string[i]) == tolower(ch)) return i;
 }
 return -1;
}

unsigned mString::contains(char ch,unsigned pos,bool cs) const
{
 unsigned count = 0;
 if(cs){
    for(unsigned i=pos;i<strlen(string);i++)
        if(string[i] == ch) count++;
 }else
    for(unsigned i=pos;i<strlen(string);i++)
        if(tolower(string[i]) == tolower(ch)) count++;

 return count;
}

unsigned mString::contains(mString const &str,unsigned pos,bool cs) const
{
 unsigned count = 0,len = str.length();
 for(unsigned i=pos;i<strlen(string);){
     int pos = find(str,i,cs);
     if(pos != -1){ count++; i = pos+len; }
     else i++;
 }
 return count;
}


mString mString::left(unsigned pos)
{
 mString s(string);
 s.truncate(pos);
 return s;
}

mString mString::right(unsigned pos)
{
 mString s(string);
 s.remove(0,pos);
 return s;
}

mString mString::middle(unsigned pos,unsigned len)
{
 mString s(string);
 mString s1(s.remove(0,pos));
 s1.truncate(len);
 return s1;
}

mString& mString::removeWhiteSpace()
{
 unsigned len = strlen(string);

 unsigned left=0;
 for(unsigned i=0;i<len;i++){
     char ch = string[i];
     if(ch != 32 && ch != 9 && ch != 10 && ch != 11 && ch != 12 && ch != 13){
        left = i;
        break;
     }
 }
 unsigned right=0;
 for(int i=len-1;i>=0;i--){
     char ch = string[i];
     if(ch != 32 && ch != 9 && ch != 10 && ch != 11 && ch != 12 && ch != 13){
        right = i;
        break;
     }
 }

 mString *n = new mString(middle(left,right-left+1));
 delete[] string;

 string = new char[n->length() + 1];
 strcpy(string,*n);

 delete n;

 return (*this);
}

void mString::sprintf(char const *format,...)
{
 va_list arg;

 char *buff = new char[strlen(format)+4096];

 va_start(arg,format);
 vsprintf(buff,format,arg);
 va_end(arg);

 delete[] string;
 string = new char[strlen(buff)+1];
 strcpy(string,buff);

 delete[] buff;
}

void mString::_store(char *str,unsigned len)
{
 if(_temp_str) delete[] _temp_str;
 _temp_str = new char[len];
 strcpy(_temp_str,str);
}

mString operator+(mString const &s1,mString const &s2)
{
 mString s(s1);
 s+=s2;
 return s;
}

mString operator+(int s1,mString const &s2)
{
 mString s(s1);
 s+=s2;
 return s;
}

mString operator+(mString const &s1,int s2)
{
 mString s(s1);
 s+=s2;
 return s;
}

mString operator+(mString const &s1,char ch)
{
 mString s(s1);
 s+=ch;
 return s;
}

bool operator==(mString const &s1,mString const &s2)
{
 return(strcmp(s1,s2) == 0);
}
