#include "mUtil.h"

#include <iostream>
using namespace std;

bool mUtil::fileNameValid(mString* fname)
{
  int dot = fname->findRev('.');

  if( dot == -1 ) return false;

  if( fname->right( dot ) != ".z0" ) return false;
  
  return true;
}

mString mUtil::classNameFromFile(mString* fname)
{

  return fname->left( fname->findRev('.') );

}


bool mUtil::hasNativeModifier(mList<mString> *list)
{

  if( !list ) return false;
  for(mString *mod = list->first();  mod != 0; mod = list->next())

    if( *mod == "native" ) return true;
			      
  
  return false;
}


mClass* mUtil::getQualifiedType(mList<mString>* list, mEnvironment* env)
{

  // for now we just use single component type
  // later we'll extend thit to packages


  // 1 component means direct class
  if(list->size() == 1){              
    mSymbol *classOfType = env->getSymbol( list->at(0), SYMBOL_CLASS );
              
              
    if( classOfType == 0){

      return 0;

    }

    return (mClass*)classOfType;

  }

  return 0;

}


mString mUtil::getQualifiedTypeName(mList<mString>* list)
{

  mString full;
  unsigned i=0;
  for(mString *s = list->first();  s != 0; s = list->next(), i++){

    full += *s;
    if(i < list->size()-1) full += '.';
  }

  return full;

}
