#ifndef __OBJECT_OFFSETS
#define __OBJECT_OFFSETS



// offsets are calculated as 2 for self and meta + 3 * # entries in method table + descriptors

// offset of value in Integer objects
const int INTEGER_OFFSET = 2 +  4 * 3 + 4;

// offset of value in Double objects
const int DOUBLE_OFFSET = 2 +  4 * 3 + 4;

// offset of value in String objects
const int STRING_OFFSET = 2 +  4 * 3 + 4;

// offset of value in Boolean objects
const int BOOLEAN_OFFSET = 2 +  4 * 3 + 4;

// offset of value in Block objects
const int BLOCK_OFFSET = 2 +  4 * 3 + 4;

// offset of value in While objects
const int WHILE_OFFSET = 2 +  4 * 3 + 4;

// offset of value in DoWhile objects
const int DOWHILE_OFFSET = 2 +  4 * 3 + 4;

// offset of value in If objects
const int IF_OFFSET = 2 +  4 * 3 + 4;

// offset of value in For objects
const int FOR_OFFSET = 2 +  4 * 3 + 4;


// offset of value in Class objects  
// 13 methods (2 for Object + 11 for Class)
const int CLASS_OFFSET = 2 +  13 * 3 + 4;

// offset of value in Method objects  
// 19 methods (2 for Object + 17 for Method)
const int METHOD_OFFSET = 2 +  19 * 3 + 4;



#endif
