#ifndef __MABSTRACTINTERPRETER_H
#define __MABSTRACTINTERPRETER_H

#include "mString.h"
#include "mLoadedClass.h"

class mVirtualMachine;

class mAbstractInterpreter{
 public:
  mAbstractInterpreter(mVirtualMachine* v){ 
    vm = v;// theClass = cl; 
  }

  virtual ~mAbstractInterpreter(){  }

  // executes method main of given class
  virtual void execute(mLoadedClass*) = 0;

  // executes method at a given address
  virtual void executeMethod(int) = 0;


  // returns stack pointer
  virtual int* getStack() = 0;

  // pushes address onto stack
  virtual void push(int) = 0;


  // setsup environment
  // used to set internal variable (nPushed) to size of environment
  // this method is used in native code when invoking methods with environment
  virtual void setEnvironmentSize(int s) = 0;

 protected:
  //mLoadedClass* theClass;
  mVirtualMachine* vm;

};

#endif
