#ifndef __MLOADEDCLASS_H
#define __MLOADEDCLASS_H

#include "mString.h"
#include "mDefs.h"

// this is how we represent loaded class
class mLoadedClass{
      public:
             // address is direct class address with literal pool
             mLoadedClass(mString* n, unsigned addr, classHeader h){
                name = new mString(*n);
                address = addr;
		// after literal pool
		dataStartAddress = address + h.literalLength + h.metaLength;
		head = h;

		nMethods = h.nMethods;
             }

             // address is class data address (no literal pool)
	     // this is used for primitive classes
	     mLoadedClass(mString* n, unsigned addr, int nm){
                name = new mString(*n);
                address = addr;
		// after literal pool
		dataStartAddress = address;// + h.literalLength;

		nMethods = nm;
             }
             virtual ~mLoadedClass(){ delete name; }

             mString* name;     // name of the class
	     classHeader head;  // class header

	     // number of methods in this class only. this is the same as head.nMethods
	     int nMethods;

	     // memory address of entire classdata including literal pool
             unsigned address;

	     // memory address of classdata immediately after literal pool and meta data 
	     // (this is used for linking because link addresses are intially set to 0
	     int dataStartAddress;
};


#endif
