#ifndef __MVM_PARAMETERS_H
#define __MVM_PARAMETERS_H


#include "mString.h"
#include "mList.h"
#include <iostream>


using namespace std;


// this class provides parameters to a virtual machine such as:
// - base directory of VM
// - native libs directory
// - heap size
// - .........

class mVMParameters{
 public:

  // builds parameters accepting those passed as arguments to the vm instance
  mVMParameters(char** argv);

  virtual ~mVMParameters();


  // returns base dir of vm 
  mString& getBaseDirectory(){ return *baseDirectory; }

  // returns native library dir
  mString& getLibDirectory(){ return *libDirectory; }


 private:

  

  // root directory of vm
  mString* baseDirectory;

  // native library directory of vm
  mString* libDirectory;

};

#endif
