#include <iostream>
#include "nativeInterface.h"
#include "shared.h"
#include "../base_classes/mDefs.h"


/*

 Implements functions of Block in native.
 Class Class contains a 4-byte value, after method table, which is 
 the address of classdata for specified class. This address is used to gather
 all meta information about that class. Meta information is placed after literal
 pool and before class info fields.
 Meta information layout is as follows:
 
 int flags;                  // flags for this block
                             // .....xxxxxxx - 1 if top level
			     //          
 

*/


extern "C" {

  // Returns true if this is a top level Block i.e. a method block.
  void Z__Block__isTopLevel__0(functionFrame* &frame, mVMEnvironment* env);

  // Sets the name of the Class.
  //void Z__Class__setName__1__String(procedureFrame* &frame, mVMEnvironment* env);


  // Returns vector of nested blocks
  void Z__Block__getNested__0(functionFrame*& frame, mVMEnvironment *env );
  

}


using namespace std;




void Z__Block__isTopLevel__0(functionFrame*& frame, mVMEnvironment *env )
{

  // get block info at end of Block object
  int* object = (int*)Utils::getSelf(frame);  

  int flags = *(object + BLOCK_OFFSET + 4);  

  // create String object and push it as return value
  int* name = env->createBoolean( flags & 1 == 1 ? 1 : 0 );

  
  Utils::pushObject( (int*)frame, name + 4 );
  
}




