#include "nativeInterface.h"


int* Utils::performCast(int toClass, int* object)
{

  // toClass must be present in object's class table

  // get to object's object table which starts in classdata after classinfo

  int *ctable = (int*)(**( (int**)object+1) + 20);   // --> class table

  int nEntries = *(int*)(**((int**)object+1) + 12);


  int newAddress = (int)*((int**)object+1) + 8;  // starting address is 1st descriptor
  bool found=false;

  for(int i=0;i<nEntries;i++){
    //cout<<"offset into vtable is "<<*(ctable + i*2 +1)<<", classaddress="<<*(ctable + i*2)<<endl;

    if( *(ctable + i*3) == toClass ){

      found = true;
      return (int*)newAddress;

    }
    newAddress += 8;
  }


  // classaddress not found in classtable, so we return 0
  
  return 0;
}



int Utils::getDescriptor(int* object, int* classData, int* &ctableEntry)
{

  
  // check if classdata is present in object's classtable 


  // classdata of object
  int* sourceClassData = (int*)*object;

  
  int *ctable =  sourceClassData + 5;   // --> class table

  int nEntries = *(sourceClassData + 3);


  int descriptor = 8;  // 1st descriptor starts at object + 8 bytes
  bool found=false;

  for(int i=0;i<nEntries;i++){
    //cout<<"offset into vtable is "<<*(ctable + i*2 +1)<<", classaddress="<<*(ctable + i*2)<<endl;

    if( *(ctable + i*3) == (int)classData ){

      found = true;
      ctableEntry = (ctable + i*3);
      return descriptor;

    }
    descriptor += 8;
  }


  // -1 when not found
  return -1;

}

