/*
  

  napaka:
    pri izrazu 4*4 literal 4 ostane v seznamu, poleg tega da se nov
    literal 16 zgenerira pravilno
    
    
    
  ----------------------------------------------------------------------------------
  NEXT:
          
         
          dopolni tip Self 
  


          0. dodaj implicitni klic konstruktorja nadrazreda v proceduri

	    	    
             	           	  
          1. dodaj preverjanje pravic dostopa za updejtanje metod
          
	    	  

	  4. dodaj $ na zacetek vsakega literala (zaradi preverjanja imen v okolju), ker kaj ce imamo
	  spremenljivko poimenovano const_i_17   in literal 17 v istem okolju!
	  


  
  -----
  
*/


%{
  // includes
#include <iostream>
#include <stdio.h>
#include <math.h>
#include <getopt.h>

#include "mString.h"
#include "mGlobals.h"
#include "mLiteral.h"
#include "mParameter.h"
#include "mParseTree.h"
#include "mCode.h"
#include "mEnvironment.h"
#include "mStack.h"
#include "mClassDumper.h"
#include "mClassBuilder.h"
#include "mUtil.h"
#include "mClassExtension.h"
#include "mOptions.h"
#include "mMethodClass.h"


using namespace std;

// our stdin
extern FILE* yyin;

// our current filename
extern mString* currentBufferName;
mString thisClassFile;

// read token
extern char* yytext;

// current line number in source
extern int yylineno;

// parser
extern int yyparse();

// lexer
extern int yylex();

// switches to another buffer
extern bool switchBuffer(mString*);

// transfers control back to old buffer
extern bool deleteBuffer();

// our error routine
int myerror();

// number of errors after parsing should be 0 to continue with code generation
int numErrors = 0;

// true if error in expression 
bool expressionError = false;

// true if error in method 
bool methodError = false;


// the dumper
mClassDumper *dumper;


// environment stack
mStack<mEnvironment> *envStack;

// we declare topmost environment for efficiently accessing classes which
// reside (currently) only in this environment
mEnvironment *root;


// type stack
mStack<mClass> *typeStack;

// current method stack
mStack<mMethod> *methodStack;


// partial expression stack
mStack<mParseTree> *expressionStack;

// true if updating. 
bool performingUpdate = false;


// true if formal parameters are allowed in method invocation expression
bool allowParameters = !false;



// import stuff

// import buffer has classname and fp
class ImportBuffer{
 public:
  ImportBuffer(mString* cname){ className = new mString(*cname); open=false; }
  virtual ~ImportBuffer(){ delete className; }
  mString* className;
  bool open;
};

// stack of import files
mStack<ImportBuffer> *importFiles;

// this is true when importing a class
bool importing = false;

mString thisClassName;
//bool firstTime=true;

///////////////////////// literals realted stuff //////////////////////////

// literal list
mList<mSymbol> *literalList;

// the offset of next literal in constant pool
int currentLiteralOffset = 0;


// variable declarations use synthesised attrs
mClass *currentType, *mainClass;

// method currently being compiled
mMethod *currentMethod=0;

// this is the partial expression (used at invocation on expressions and literals)
mParseTree* partialExpression = 0;


// true if Self type
bool isSelfType = false;

bool start=true;

// this is used in FieldReference and MethodAccess
mParseTree  *currentMethodTree,*currentFieldTree;  // blah

%}

%union{
  int                      intVal;
  double                   doubleVal;
  mString*                 stringVal;
  mList<mString>*          stringList;
  mClass*                  classVal;
  //mField*                  fieldVal;
  //mList<mField>*           fieldListVal;
  //mMethod*                 methodVal;
  mVariable*               variableVal;
  mLiteral*                literalVal;
  mCode*                   codeVal;
  mParseTree*              treeVal;
  mList<mClassExtension>*  extensionList;
  mList<mClass>*           classList;
  //mParameter*              parameterVal;
  mList<mParameter>*       parameterListVal;
  //mLocalDefinition*        localDefinitionVal;
  //mList<mLocalDefinition>* localDefinitionListVal;
  //mSymbol*                 symbolVal;
//  mEnvironment*            environmentVal;

}

// keywords
%token CATEGORY USE CLASS FIELD METHOD IS INHERITS IMPLEMENTS
%token PUBLIC PRIVATE PROTECTED RESTRICTED NATIVE STATIC CONSTRUCTOR DESTRUCTOR
%token THIS SUPER AS
%token RETURN WHILE DO IF THEN ELSE FOR METHOD
%token BYTE CHAR SHORT INT LONG FLOAT DOUBLE STRING VOID BOOLEAN SELF
%token TRUE FALSE NIL NEW METHODTYPE

// multichar operators
%token OP_EQ OP_NOT_EQ OP_GREATER_OR_EQ OP_LESS_OR_EQ OP_AND OP_OR OP_METHODASSIGN

%token OP_ADDASSIGN OP_DECASSIGN OP_MULASSIGN OP_DIVASSIGN OP_INCREMENT OP_DECREMENT


// literals
%token <intVal> INTEGER_LITERAL
%token <doubleVal> DOUBLE_LITERAL
%token <stringVal> STRING_LITERAL IDENTIFIER 

// production types

%type <treeVal> Expression AssignmentExpression MultiplicativeExpression JustArguments
%type <treeVal> AdditiveExpression PrimitiveExpression PowerExpression CastExpression LogicalExpression
%type <treeVal> BooleanExpression ReturnStatement OtherStatement NewExpression PartialReference
%type <treeVal> WhileStatement DoWhileStatement IfStatement ForStatement UpdateReference MethodExpression
%type <treeVal> LocalOrStatement Statement

%type <intVal> MethodAccessModifier
%type <literalVal> Literal

%type <classVal> Type PredefinedType ReturnTypeOpt
%type <classList> MethodTypeParameters

%type <stringVal> AdditionalMethodModifier
%type <stringList> QualifiedIdentifier ExternalClasses AdditionalMethodModifiers AdditionalMethodModifiersOpt

%type <parameterListVal> MethodParametersOpt MethodParameterList

%type <extensionList> ClassExtension ClassExtensions ClassList ClassExtensionOpt ClassList

//%type <fieldVal> FieldDeclaration
//%type <methodVal> MethodDeclaration ConstructorDeclaration DestructorDeclaration
//%type <variableVal> VariableDeclaration

//%type <parameterListVal> MethodParametersOpt MethodParameterList

%type <treeVal> LocalVariableDeclaration LocalVariableDeclarations Arguments
%type <treeVal> MethodReferenceWithArgs MethodAccess FieldReference FieldAccess
%type <treeVal> ArrayAccess LocalsOrStatements Block MethodBody

//%type <treeVal>  MethodOrVariableAccess SingleAccess
//%type <stringVal> MethodSpecification


//%type <environmentVal> LocalsOrStatements LocalsOrStatementsOpt Block MethodBody

//%type <environmentVal> ClassDefinition

%start Unit

//%left '+' '-'
//%left '*' '/'

///////////////////////////////////////////////////////////
///////////////////////// Grammar /////////////////////////
///////////////////////////////////////////////////////////

%%

// it makes sense to define special production for semicolon
Semicolon:  ';'
            | error {
               cout<<"semicolon expected"<<endl;
               yyerrok;
            }
            ;
            

QualifiedIdentifier:IDENTIFIER {

                        // create new list of strings and add the 1st string
                        mList<mString> *list = new mList<mString>();
			list->setAutoDelete( true );
                        list->append ( $1 );
                        $$ = list;
                       }
                     | QualifiedIdentifier '.' IDENTIFIER {
                        // append the rest of the strings
                        $1->append ( $3 );
			$$ = $1;
                       }
/*| error ';' {
                       cout<<"identifier expected"<<endl;
                       yyerrok;
		       }*/
                     ;

// literals

// here we create new literal (if it doesn't already exist)
Literal:    INTEGER_LITERAL  {

	       // do nothing if just importing
	       if( importing ) break;


               // find class for integer
               mString className( "Integer" );
               mSymbol *classOfInteger = root->getSymbol( &className, SYMBOL_CLASS );

               // constructor itself will create appropriate name for us
               // so we first create it and then check for its existance
               mLiteral* newlit = new mLiteral($1, (mClass*)classOfInteger );
                              
               
               mLiteral* lit = mLiteral::find(newlit->name, literalList);

               if(lit != 0){  // already exists?
		 delete newlit; newlit = lit; newlit->multiple = true;
               }else
                  // append it to list
                  literalList->append( newlit );
                  
               $$ = newlit;
            }
            | DOUBLE_LITERAL  {

               // do nothing if just importing
	       if( importing ) break;

               // find class for double
               mString className( "Double" );
               mSymbol *classOfDouble = root->getSymbol( &className, SYMBOL_CLASS );

               mLiteral* newlit = new mLiteral($1, (mClass*)classOfDouble );
              
               
               mLiteral* lit = mLiteral::find(newlit->name, literalList);

               if(lit != 0){  // already exists?
                  delete newlit; newlit = lit; newlit->multiple = true;
               }else
                  // append it to list
                  literalList->append( newlit );
                  
               $$ = newlit;
            }
          | STRING_LITERAL  {

	       // do nothing if just importing
	       if( importing ) break;

               // find class for string
               mString className( "String" );
               mSymbol *classOfString = root->getSymbol( &className, SYMBOL_CLASS );

               mLiteral* newlit = new mLiteral($1, (mClass*)classOfString );
                             
               mLiteral* lit = mLiteral::find(newlit->name, literalList);

               if(lit != 0){  // already exists?
                  delete newlit; newlit = lit; newlit->multiple = true;
               }else
                  // append it to list
                  literalList->append( newlit );
                  
               $$ = newlit;
            }

          | TRUE {

	       // do nothing if just importing
	       if( importing ) break;

               // find class for string
               mString className( "Boolean" );
               mSymbol *classOfBoolean = root->getSymbol( &className, SYMBOL_CLASS );

	       // true is represented as 1
               mLiteral* newlit = new mLiteral(1, (mClass*)classOfBoolean );
                             
               mLiteral* lit = mLiteral::find(newlit->name, literalList);

               if(lit != 0){  // already exists?
                  delete newlit; newlit = lit; newlit->multiple = true;
               }else
                  // append it to list
                  literalList->append( newlit );
                  
               $$ = newlit;

	  }
          | FALSE {  

	       // do nothing if just importing
	       if( importing ) break;

               // find class for string
               mString className( "Boolean" );
               mSymbol *classOfBoolean = root->getSymbol( &className, SYMBOL_CLASS );

	       // false is represented as 0
               mLiteral* newlit = new mLiteral(0, (mClass*)classOfBoolean );
                             
               mLiteral* lit = mLiteral::find(newlit->name, literalList);

               if(lit != 0){  // already exists?
                  delete newlit; newlit = lit; newlit->multiple = true;
               }else
                  // append it to list
                  literalList->append( newlit );
                  
               $$ = newlit;
	  }

          | NIL {

	       // do nothing if just importing
	       if( importing ) break;

               // find class for Object
               mString className( "Object" );
               mSymbol *classOfObject = root->getSymbol( &className, SYMBOL_CLASS );

	       // nil is special literal (has no value)
               mLiteral* newlit = new mLiteral(new mString("nil"), (mClass*)classOfObject, true );
              
               
               mLiteral* lit = mLiteral::find(newlit->name, literalList);

               if(lit != 0){  // already exists?
                  delete newlit; newlit = lit;
               }else
                  // append it to list
                  literalList->append( newlit );
                  
               $$ = newlit;
            }
          ;



// possible structures of a file
        
Unit:   UnitSection
        | Unit UnitSection
        ;

UnitSection:  CategoryStatement
              | IncludeStatement
              | ClassDefinition
              ;

//| CategoryStatement IncludeStatements
//      | IncludeStatements ClassDefinitions
//      | CategoryStatement ClassDefinitions
//      | ClassDefinitions
//    ;


// domain definition  ie. domain this.is.my.domain;
CategoryStatement: CATEGORY QualifiedIdentifier Semicolon {
                   //cout<<"full name ="<<list2String ( $2 )<<endl;

                 }
                  ;


//IncludeStatements: IncludeStatement
//                 | IncludeStatements IncludeStatement
//                 ;



// include statement ie. use MyClass;
IncludeStatement:  USE ExternalClasses Semicolon {
                     
                     if(!importing) break;


                     bool somePushed = false;
                     for(mString* name = $2->first(); name != 0; name = $2->next()){
		       

		       mClass* theClass = root->getDeclaredClass( name );
		       
		       // add class only if it hasn't been imported yet
		       if( theClass == 0 ){
			 
			 // create class and add it to root environment so that it
			 // is available henceforth. if the same class is 'used' in
			 // some other file it will already be available
			 // create and add class to environment
			 theClass = new mClass( name, ACCESS_PUBLIC );
			 root->append( theClass );


			 // import external class
			 ImportBuffer* buff = new ImportBuffer(name);
			 importFiles->push( buff );
                         somePushed = true;
			 
		       }else{
			 
		       }

                     }

		     //delete $2;

		     // import 1st class 
		     if( importing && somePushed ){
		      
		       importClass( *importFiles->top(), false );
		     }

                     
                   }
                   | error ';' {
                       cout<<endl;
                       yyerrok;
                     }
                   ;



ExternalClasses:   QualifiedIdentifier {

		     // create new list of strings and add the 1st string
		     mList<mString> *list = new mList<mString>();
		     list->setAutoDelete( true );
		     list->append ( new mString(list2String($1)) );
		     delete $1;
		     $$ = list;

                  }                  

                  | ExternalClasses ',' QualifiedIdentifier {

		     $1->append ( new mString(list2String($3)) );
		     delete $3;
		     $$ = $1;
                  }
                  ;

/*ClassDefinitions: ClassDefinition 
                  | ClassDefinitions ClassDefinition 
                ;
*/

// class definition
ClassDefinition:  CLASS IDENTIFIER ClassExtensionOpt
                  {		    

		    if( importing ) {
		      //cout<<"parsing definitions for class "<<*$2<<endl;
		      //cout<<"currentBufferName="<<*currentBufferName<<endl;

		      

		    }

		    // class name must match filename
		    mString fileName(*$2);
		    fileName += ".z0";
		    
		    if( fileName != *currentBufferName ){
		      myerror();
		      cout<<"class '"<<*$2<<"' doesn't match filename "<<*currentBufferName<<endl;
		    }


		    if( !mSymbol::isValid( $2 ) ){
		      myerror();
		      cout<<"class '"<<*$2<<"' cannot be declared"<<endl;
		    }



                    // create class symbol and add it to environment		   		    
		    
		    mEnvironment *env = 0;

		    if( !importing ){

		      
		      // class must already be in environment
		      mClass* c = envStack->top()->getDeclaredClass( $2 );
		      mainClass = c;
		      
		      env = envStack->top()->getClassEnvironment( $2 );

		      // if environment wasn't found it means that class exists but no
		      // environment for it, this is possible only for
		      // class that is being compiled. we create it's environment here
		      if(!env){
			 env = new mEnvironment(ENVIRONMENT_CLASS, $2, envStack->top(), c);
		      }

		      // if this is our main class we update return types and parameter types of all
		      // methods in superclasses to this class

		      c->updateSelfSuperTypes();

		    }else{

		      mClass *c = 0;
		      
		      // find class if already in environment
		      if( (c = root->getDeclaredClass( $2 )) == 0 )

			// create and add class to environment
			c = new mClass( $2, ACCESS_PUBLIC );

		      

                      // add superclasses
                      if( $3 ){

			for(mClassExtension* ext = $3->first(); ext != 0; ext = $3->next()){


			  // if this is superclass we find it first
			  if( ext->type == 0 ){

			    mSymbol *classOfType = root->getSymbol( ext->className, SYMBOL_CLASS );

			    if( classOfType == 0){

			      myerror();
			      cout<<"class '"<<*ext->className<<"' not found"<<endl;

			    }else{
			      

			      // otherwise we add this class to the list of superclasses

			      c->addSuperClass( (mClass*)classOfType );

			      //cout<<"adding superclass "<<*ext->className<<endl;

			    }

			  }  // if( ext->type == 0 )

			}

		      }else{   //  if( $3 )

			// if no explicit superclass was given then Object is set as default
			mString object("Object");
			mSymbol *classObject = root->getSymbol( &object, SYMBOL_CLASS );

			//cout<<"adding superclass Object"<<endl;

			c->addSuperClass( (mClass*)classObject );


		      }


		      // append it to env only if it's not already
		      if( root->getDeclaredClass( $2 ) == 0 )
			envStack->top()->append( c );
		      
                  
		      // now create an environment for this class
		      env = new mEnvironment(ENVIRONMENT_CLASS, $2, envStack->top(), c);
		      
		    }

		    //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		    //c->environment = env; !!!!!!!!!!!!!!!!!!!!!!!!
		    //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!



                    envStack->push( env );
                  }
                  
                  '{' FieldDeclarations '}'
                  {                    		    

		    if(importing){
		      
		     

		      // we finish with importing if the only class left on stack is our main class
		      
		      if( importFiles->size() == 1 /*&& thisClassName == *importFiles->top()->className*/ ){
			
			importing=false;
		

		      }else{
		
		      }
		      

		      // remove most recently pushed file
		      importFiles->pop();
		      

		      // are there some more files on stack to import?
		      if( importFiles->size() > 1 ){			
			importClass( *importFiles->top(), false );
		      }		      
		     		      		      		      
		    }
		    
		    // if there were some errors we remove class environment completely
		    if( numErrors > 0 ){

		      // stop parsing if error in external class
		      return -1;

		    }
		    
		    envStack->pop();		    

                  }
                  ;



ClassExtensionOpt:  // empty
                    { $$ = 0; }
		    | ClassExtensions { $$ = $1; }
                    ;


ClassExtensions:    ClassExtension {

                      // list is already created here
                      $$ = $1;

                    }

                    | ClassExtensions ClassExtension {

                       // add all extensions from $2 to our list
                       if($2){

			 for(mClassExtension* ext = $2->first(); ext != 0; ext = $2->next()){

			   // if( mClassExtension::inList($1) ) already exists...
			   $1->append( new mClassExtension( ext ) );

			 }

                         delete $2;

		       }

                    }
                    ;



ClassExtension:     INHERITS ClassList { 

                      $$ = $2;

                    }
                    | IMPLEMENTS ClassList {

                      if($2){

			 // set type of extensions in this list to 1

			 $$ = $2;
                      }

                    }
                  ;



ClassList:    QualifiedIdentifier {

                // create new list of classExtensions and add the 1st string
                mList<mClassExtension> *list = new mList<mClassExtension>();
		list->setAutoDelete( true );
		list->append ( new mClassExtension(0, new mString(list2String($1)) ) );
		delete $1;
		$$ = list;

              }

            | ClassList ',' QualifiedIdentifier {

		$1->append ( new mClassExtension(0, new mString(list2String($3)) ));
		delete $3;
		$$ = $1;
            }
            ;



FieldDeclarations:   FieldDeclaration
                   | FieldDeclarations FieldDeclaration
                   ;




// field can be constructor, destructor or method
FieldDeclaration:   MethodDeclaration {
                     
                    }
                  
                  ;




// methods are functions and procedures
MethodDeclaration: FunctionDeclaration
                   | ProcedureDeclaration
                   ;



// method with return type
FunctionDeclaration: MethodAccessModifier AdditionalMethodModifiersOpt IDENTIFIER MethodParametersOpt ':' Type
  {    
    // method must be added as a symbol to class environment before its body
    // because it may reference itself in a recursive manner


    if( !mSymbol::isValid( $3 ) ){
      myerror();
      cout<<"method '"<<*$3<<"' cannot be declared"<<endl;
      break;
    }


    // check if this is 'main' method. 'main' is always a procedure
    if( *$3 == "main"){
       myerror();
       cout<<"method 'main' doesn't return"<<endl;
       break;
    }



    mClass* ownerClass = envStack->top()->ownerClass;



    // check if this is a constructor. if it is it's an error because constructors
    // don't return.
    if(*$3 == *ownerClass->name ){
       myerror();
       cout<<"constructors don't return"<<endl;
       break;
    }

   


    if($6 == 0){
       myerror();
       cout<<"method '"<<*$3<<"' returns unknown type"<<endl;
       break;
    }


    // check if method with this signature has already been defined
    if( importing )
      if( ownerClass->methodDefinedHere( $3, $4 ) ){      
	
	myerror();
	cout<<"method '"<<*$3<<"' already defined"<<endl;
	break;	
      }        

        
    mEnvironment *env = 0;
    mMethod *meth = 0; 

    if( !importing ){


      // create method environment
      env = new mEnvironment(ENVIRONMENT_METHOD, $3, envStack->top(),
			     ownerClass );
      
      // find method in our main class
      meth = ownerClass->getDeclaredMethod( $3, $4 );      
      currentMethod = meth;   // this is the method we are processing at the moment

    }else{
      
      // create new method      
      // ( name, return type, access, binding )
      meth = new mMethod ( $3, $6 ,$1, BIND_NONSTATIC );

      // check if return type was Self
      if(isSelfType)
	meth->returnsSelf = true;

      // back to false
      isSelfType = false;


      currentMethod = meth;   // this is the method we are processing at the moment
            

      // now add method to class environment. note that method is appended to
      // class env. only as a SYMBOL here so that we can search class
      // environments simply for symbols.
      // class environment also has a child environment for every method
      // which is assigned lower    
    
      envStack->top()->append( meth );      

    }        
    
    
    // method environment onto stack
    if( !importing ){

      envStack->push( env );
      meth->environment = env;
      methodStack->push( meth );            

    }


    // finally we add formal parameters to method environment if there are any
    // note: method needs parameters for checking when searching for appropriate method,
    // and environment needs them in searching when a parameter is referenced in code    

    int currentEntry = 5;  // default location for 1st parameter on stack is 5 for function
                           // except for static methods which don't expect anything on stack except
                           // parameters
                           // 1 is stack_ptr, 2 is result destination, 3 is return address, 4 is self, 
                           // 5 is 1st param


    if( !importing )
      // change to static later (the only static method for now is 'main')
      if( *meth->name == "main" ){

	currentEntry = 1;

      }else{

	// we add self to all nonstatic methods
	env->addSelf( 4 );  // for functions it resides at location 4

      }


    if($4){      

      for( mParameter* param = $4->first(); param != 0; param = $4->next() ){
	if( !importing ){
	  param->entry = currentEntry++;
	  env->append( param );
	}else
	  meth->addParameter( param );
      }
      
      delete $4;
    }

    if( !importing )
      env->currentVariableEntry = currentEntry;     // set current entry of method env so that child block
                                                    // will know where its own variables start    
    else{

      // add it to class
      mClass * error = 0;
      
      if(!ownerClass->addMethod( meth, error )){	
	
	myerror();
	cout<<"method '"<<*$3<<"' cannot be overriden with incompatible signature from class '"
	    <<*error->name<<"'"<<endl;
	break;	
      }

    }    
    
  } 

  MethodBody {
  

     // if no explicit return was given we signal error because functions MUST return excplicitly 

     if( !importing ){


       if($8 == 0){

	 // unimplememented method
	 // this means that method block is empty which further means that method is either declared native or
	 // abstract
	 
	 
	 // check if it's native
	 if(mUtil::hasNativeModifier($2)){
	   

	   // mark this method native
	   currentMethod->setNative();
	   
	   // first we check if this method is declared NATIVE. if it is we explicitly generate an environment and
	   // closure as if it were an ordinary (implemented) method. But inside closure we add nodes for calling a 
	   // native method
	   
	   
	   // create empty environment
	   mEnvironment *env = new mEnvironment(ENVIRONMENT_BLOCK, 
						new mString("#empty locals"), 
						envStack->top(), 
						envStack->top()->ownerClass );
	   
	   mParseTree *closure = new mParseTree( NODE_CLOSURE );
	   // return type of closure is Block
	   mString block("Block");
	   mSymbol *classOfType = root->getSymbol( &block, SYMBOL_CLASS );		    
	   closure->returnType = (mClass*)classOfType;
	   
	   
	   env->closure = closure;
	   
	   // this is where we need environment
	   closure->env = env;
	   
	   // we don't push it on stack, because we don't actually need it since we're creating 
	   // a closure here where it should be popped off
	   // envStack->push( env );
	   
	   
	   currentMethod = methodStack->top();
	   
	   
	   // add literal for native method name
	   
	   // find class for string
	   mString className( "String" );
	   mSymbol *classOfString = root->getSymbol( &className, SYMBOL_CLASS );
	   
	   mLiteral* newlit = new mLiteral(currentMethod, (mClass*)classOfString, currentMethod->theClass );
	   
	   mLiteral* lit = mLiteral::find(newlit->name, literalList);
	   
	   if(lit != 0){  // already exists?
	     delete newlit; newlit = lit; newlit->multiple = true;
	   }else
	     // append it to list
	     literalList->append( newlit );

	   
	   
	   /////////////////////////////////////////////////
	   
	   
	   // now we generate node for native invocation
	   
	   mParseTree *tree = new mParseTree( NODE_NATIVECALL, currentMethod, currentMethod->returnType );
	   tree->append( new mParseTree(NODE_LITERAL, newlit, newlit->theClass ) );
	   
	   closure->append( tree );
	   
	   
	 }else{ // hasNativeModifier
	   
	   // abstract...once
	   
	   // otherwise we have an error because bodyless method must be either native or abstract
	   myerror();
	   cout<<"method '"<<*$3<<"' must be declared either native or abstract"<<endl;
	   break;
	   
	 }
	 
	 
       }  else {
	 
	 // implemented method always has one block
	 
	 // check if method was declared native or abstract, if it has we have an error because native and abstract
	 // methods have no implementation
	 
	 // check whether native
	 if(mUtil::hasNativeModifier($2)){
	   
	   myerror();
	   cout<<"native method '"<<*$3<<"' must not be implemented"<<endl;
	   break;
	   
	 }
	 
	 
	 
	 
	 
	 mParseTree* closure = envStack->top()->children->at(0)->closure;
	 
	 if( !closure->endsWithReturn() ){
	   
	   currentMethod = methodStack->top();
	   
	   myerrorBefore();
	   cout<<"method '"<<*currentMethod->name<<"' must return '"<<*currentMethod->returnType->name
	       <<"' at end"<<endl;      
	 }
	 
       }


       
       // remove this method's environment
       if($6 != 0){
	 envStack->pop();
	 methodStack->pop();
       }
       
     }
     
  }
  ;


// no return type for procedures
ProcedureDeclaration: MethodAccessModifier AdditionalMethodModifiersOpt IDENTIFIER MethodParametersOpt
  {
    // method must be added as a symbol to class environment before its body
    // because it may reference itself in a recursive manner    
    
    if( !mSymbol::isValid( $3 ) ){
      myerror();
      cout<<"method '"<<*$3<<"' cannot be declared"<<endl;
      break;
    }


    // returnType of procedure is 0 except for constructors which have a returnType of
    // their own class (this is implicit of course)
    mClass *retType = 0;

    mClass* ownerClass = envStack->top()->ownerClass;


    if(*$3 == *ownerClass->name )
      retType = ownerClass;
    else{
      // if it's not constructor, we set returnType to Void
      mString Void("Void");
      retType = (mClass*)root->getSymbol( &Void, SYMBOL_CLASS );
    }
    

    // check if method with this signature has already been defined
    if( importing )
      if( ownerClass->methodDefinedHere( $3, $4 ) ){      

	myerror();
	cout<<"method '"<<*$3<<"' already defined"<<endl;
	break;

      }

    mEnvironment *env = 0;
    mMethod *meth = 0; 



    if( !importing ){


      // create method environment
      env = new mEnvironment(ENVIRONMENT_METHOD, $3, envStack->top(),
			     ownerClass );

      // find method in our main class
      meth = ownerClass->getDeclaredMethod( $3, $4 );
      currentMethod = meth;   // this is the method we are processing at the moment      


    }else{

      // create new method

      // check if it's 'main'
      short binding = BIND_NONSTATIC;
      if( *$3 == "main") binding = BIND_STATIC;


      // ( name, return type, access, binding )
      meth = new mMethod ( $3, retType ,$1, binding );
      currentMethod = meth;   // this is the method we are processing at the moment
            

      // now add method to class environment. note that method is appended to
      // class env. only as a SYMBOL here so that we can search class
      // environments simply for symbols.
      // class environment also has a child environment for every method
      // which is assigned lower    
    
      envStack->top()->append( meth );
      

    }
    

    
    // method environment onto stack
    if( !importing ){

      envStack->push( env );
      meth->environment = env;
      methodStack->push( meth );
      //currentMethod = meth;   // this is the method we are processing at the moment
    }




    int currentEntry = 4;  // default location for 1st parameter on stack is 4
                           // except for static methods which don't expect anything on stack except
                           // parameters

    // change to static later (the only static method for now is 'main')
    if( !importing )
      if( *meth->name == "main" ){
	currentEntry = 1;
      }else{
	
	// we add self to all nonstatic methods
	env->addSelf( 3 );  // for procedures it resides at location 3
	
      }

    // finally we add formal parameters to method environment if there are any    
    if($4){        

      for( mParameter* param = $4->first(); param != 0; param = $4->next() ){
	if( !importing ){
	  param->entry = currentEntry++;
	  env->append( param );
	}else
	  meth->addParameter( param );	
      }      
      delete $4;
    }


    if( !importing ){
      env->currentVariableEntry = currentEntry;   // set current entry of method env so that child block
                                                  // will know where its own variables start

      //envStack->push( env );

      //meth->environment = env;

      //currentMethod = meth;   // this is the method we are processing at the moment
    }else{

      // add it to class
      mClass * error = 0;
      if(!ownerClass->addMethod( meth, error )){
	
	myerror();
	cout<<"method '"<<*$3<<"' cannot be overriden with incompatible signature from class '"
	    <<*error->name<<"'"<<endl;
	break;
	
      }

    }

  }

  MethodBody {


  // if no explicit return was given we add it here (because return is mapped directly to RETURN 
  // instruction)

  if( !importing ){



    if($6 == 0){   // no method body!

      // unimplememented method
      // this means that method block is empty which further means that method is either declared native or
      // abstract


      // check if it's native
      if(mUtil::hasNativeModifier($2)){
	

	// mark this method native
	currentMethod->setNative();

	// first we check if this method is declared NATIVE. if it is we explicitly generate an environment and
	// closure as if it were an ordinary (implemented) method. But inside closure we add nodes for calling a 
	// native method
	
		
	// create empty environment
	mEnvironment *env = new mEnvironment(ENVIRONMENT_BLOCK, 
					     new mString("#empty locals"), 
					     envStack->top(), 
					     envStack->top()->ownerClass );
	
	mParseTree *closure = new mParseTree( NODE_CLOSURE );
	// return type of closure is Block
	mString block("Block");
	mSymbol *classOfType = root->getSymbol( &block, SYMBOL_CLASS );		    
	closure->returnType = (mClass*)classOfType;
	
	
	env->closure = closure;
	
	// this is where we need environment
	closure->env = env;
	
	// we don't push it on stack, because we don't actually need it since we're creating a closure here where it should
	// be popped off
	// envStack->push( env );
	
	
	currentMethod = methodStack->top();


	// add literal for native method name

	// find class for string
	mString className( "String" );
	mSymbol *classOfString = root->getSymbol( &className, SYMBOL_CLASS );
	
	mLiteral* newlit = new mLiteral(currentMethod, (mClass*)classOfString, currentMethod->theClass );
	
	mLiteral* lit = mLiteral::find(newlit->name, literalList);
	
	if(lit != 0){  // already exists?
	  delete newlit; newlit = lit; newlit->multiple = true;
	}else
	  // append it to list
	  literalList->append( newlit );
	
	/////////////////////////////////////////////////



	
	// now we generate node for native invocation

	mParseTree *tree = new mParseTree( NODE_NATIVECALL, currentMethod, currentMethod->returnType );
	tree->append( new mParseTree(NODE_LITERAL, newlit, newlit->theClass ) );

	closure->append( tree );
       
	
      }else{ // hasNativeModifier

	// abstract...once

	// otherwise we have an error because bodyless method must be either native or abstract
	myerror();
	cout<<"method '"<<*$3<<"' must be declared either native or abstract"<<endl;
	break;
	
      }
      

    } else {

      // implemented method always has one block

      // check if method was declared native or abstract, if it has we have an error because native and abstract
      // methods have no implementation

      // check whether native
      if(mUtil::hasNativeModifier($2)){

	myerror();
	cout<<"native method '"<<*$3<<"' must not be implemented"<<endl;
	break;

      }

      // ...and abstract here



      mParseTree* closure = envStack->top()->children->at(0)->closure;
    

      if( !closure->endsWithReturn() ){
	
	currentMethod = methodStack->top();
	
	if(*currentMethod->name != "main")  // method main doesn't return
	  closure->append( new mParseTree( NODE_RETURN ) );
	
      }    
      
      mClass* ownerClass = envStack->top()->ownerClass;
      
      if(*$3 == *ownerClass->name ){
	
	// if this is constructor add invocations of direct parent constructors
	for(mClass *super = ownerClass->superClasses->last();  super != 0; 
	    super = ownerClass->superClasses->prev()){
	  
	  if(*super->name == "Object") continue;
	  //cout<<"adding constructor "<<*super->name<<endl;
	  mMethod * ctor = super->getDefaultConstructor();
	  
	  if(!ctor){
	    myerror();
	    cout<<"explicit call of constructor for '"<<*super->name<<"' required"<<endl;
	    break;
	  }
	  
	  closure->addSuperConstructorCall( ctor );
	}
	
      }
                        

    }  // $6 != 0 (method with block)


    // remove this method's environment
    envStack->pop();
    methodStack->pop();

  }

  }




/*| MethodAccessModifier IDENTIFIER MethodParametersOpt ';' {


}*/


  ;




// optional parameters for methods
MethodParametersOpt: { $$ = 0; }  // empty
                     | '(' MethodParameterList ')' {

		          $$ = $2;
                       }
                     ;

// classic type id, type id, ...
MethodParameterList:   Type IDENTIFIER {

		       if( !mSymbol::isValid( $2 ) ){
			 myerror();
			 cout<<"parameter '"<<*$2<<"' cannot be declared"<<endl;
			 $$ = 0;
			 break;
		       }

		       // create parameter and add it to list
		       // which is on top of stack
		       if($1){			
			 mList<mParameter> *list = new mList<mParameter>();
			 mParameter* param = new mParameter ( $2, $1 );


			 // check if type was Self
			 if(isSelfType)
			   param->isSelfType = true;
			 
			 // back to false
			 isSelfType = false;

			 list->append ( param  );
			 
			 
			 $$ = list;
		       }else $$ = 0;
                     }
                     | MethodParameterList ',' Type IDENTIFIER {
		         if($3){
			   if(!$1) $1 = new mList<mParameter>();

			   mParameter* param = new mParameter( $4, $3 );

			   // check if type was Self
			   if(isSelfType)
			     param->isSelfType = true;
			 
			   // back to false
			   isSelfType = false;
			   
			   $1->append ( param );			   
			 }
			 $$ = $1;
                       }
                     ;




AdditionalMethodModifiersOpt: { $$ = 0; }
                              | AdditionalMethodModifiers { $$ = $1; }
			      ;


AdditionalMethodModifiers:   AdditionalMethodModifier {

		           // create modifier and add it to list		          			
		           mList<mString> *list = new mList<mString>();
			   list->setAutoDelete( true );
			   list->append ( $1 );
			   $$ = list;		      

                         }

                         | AdditionalMethodModifiers AdditionalMethodModifier {

                           // check whether this modifier already exists

                           for(mString *mod = $1->first();  mod != 0; mod = $1->next()){

			     if( *$2 == *mod ){
			       myerror();
			       cout<<"modifier '"<<*$2<<"' already present"<<endl;
			       break;
			     }
                           
                           }

			   // now add it to list
			   $1->append ( $2 );
			   $$ = $1;

                         }
                       ;



// possible access modifiers for methods...
MethodAccessModifier:        PUBLIC { $$ = ACCESS_PUBLIC; }
                           | PROTECTED { $$ = ACCESS_PROTECTED; }
                           | PRIVATE { $$ = ACCESS_PRIVATE; }
                           | RESTRICTED { $$ = ACCESS_RESTRICTED; }                           
                           | error {
                             cout<<"invalid access modifier"<<endl;
                             //yyerrok;
                           }
                           ;


AdditionalMethodModifier:   NATIVE { $$ = new mString("native"); }
                           | STATIC { $$ = new mString("static"); }
//| error {
//                         cout<<"invalid method modifier"<<endl;
                             //yyerrok;
//                         }
                           ;  



// method body is a block or just ';' for methods without block. methods without block are those
// declared NATIVE or ABSTRACT
MethodBody: Block {

            }

            | ';' {

               // no block
               $$ = 0;

            }
            ;


// block is empty or built of local variables and statements
Block:   '{' LocalsOrStatementsOpt '}' {


            // do nothing if just importing
            if( importing ) break;


	    mParseTree* closure = envStack->top()->closure;

	    // every block except that of top-level method must exit with implicit NODE_BLOCK_EXIT
	    // or explicit return 
	    if( envStack->top()->parent->type != ENVIRONMENT_METHOD ){

	      // we have nested closure

	      if( !closure->endsWithReturn() ){

		// append exit
		closure->append( new mParseTree( NODE_BLOCK_EXIT ) );

	      }
	    }

	    //cout<<"After block="<<closure->toString()<<endl;

            // block now holds a closure
            $$ = closure;

            
            // remove environment for local definitions in this block
            envStack->pop();
           }



         | '{' LocalsOrStatementsOpt '}' '.' MethodAccess Semicolon {

            // do nothing if just importing
	    if( importing ) break;

            envStack->pop();
               //$$ = $2;
         }


         /*| '{' LocalsOrStatementsOpt '}' '.' FieldAccess Semicolon {
            envStack->pop();
               //$$ = $2;
         }*/
         ;


LocalsOrStatementsOpt:    {


	                    // do nothing if just importing
	                    if( importing ) break;


                            // create empty environment
                            mEnvironment *env = new mEnvironment(ENVIRONMENT_BLOCK, 
						new mString("#empty locals"), 
						envStack->top(), 
						envStack->top()->ownerClass );


                            mParseTree *closure = new mParseTree( NODE_CLOSURE );
			    // return type of closure is Block
			    mString block("Block");
			    mSymbol *classOfType = root->getSymbol( &block, SYMBOL_CLASS );		    
			    closure->returnType = (mClass*)classOfType;


                            env->closure = closure;

			    // this is where we need environment
			    closure->env = env;
                            
                            // push on top
                            envStack->push( env );
                          }

                        | LocalsOrStatements {
	                   // environment and its closure are created below
                        }
                        ;


LocalsOrStatements:    {

                          // do nothing if just importing
			  if( importing ) break;


                          // this is where we create new environment for
                          // current local definitions

			  // block is either a plain block or a method block in method update
			  // if there is more than 1 method on stack, we are updating method and
			  // hence we have method block
			  mEnvironment *env = envStack->top();  // top environment

			  // 1. if we're not updating a method
			  // 2. if top environment is not UPDATE then we create it here
			  // otherwise we'll just use the already created one in
			  // MethodExpression
			  if( !performingUpdate && env->type != ENVIRONMENT_UPDATE ){
			    
			    env = new mEnvironment( ENVIRONMENT_BLOCK,
						    new mString("#locals"),
						    envStack->top(),
						    envStack->top()->ownerClass );
			    // push on top
			    envStack->push( env );
			    
			  }else{
			    // we already have block environment on stack!
			    env = envStack->top();
			  }
			  

			  performingUpdate = false;			 			
			  

                          // since locals and statements are always within
                          // a block, we also create a closure for this block
                          mParseTree *closure = new mParseTree( NODE_CLOSURE );

			  // return type of closure is Block
			  mString block("Block");
			  mSymbol *classOfType = root->getSymbol( &block, SYMBOL_CLASS );		    
			  closure->returnType = (mClass*)classOfType;

                          env->closure = closure;

			  // this is where we need environment
			  closure->env = env;
                          

                          
                       }

                       // one statement
                       LocalOrStatement {
                       }
                      // or multiple 
                      | LocalsOrStatements LocalOrStatement {

			 
                      }
                     ;


// local variable definition or statement
LocalOrStatement: Type { 
			if(!importing){ 
			  currentType = $1;
			  typeStack->push($1); 

			}
                  } 
                  LocalVariableDeclarations Semicolon {
  
                         if(importing) break;

                         // remove type of this variable
			 typeStack->pop();			 
			 

                  }
                  | Statement { 

		         if(importing) break;

		         $$=$1; 
		  }
                  ;


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
//
// VARIABLE DECLARATION
//
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

// variable declarations always have a preceeding TYPE, that's how they
// differ from common assignment expression
LocalVariableDeclarations:   LocalVariableDeclaration
                           | LocalVariableDeclarations ',' LocalVariableDeclaration
                           ;



// declaration of a local variable without initialisation
LocalVariableDeclaration:    IDENTIFIER {

                                // do nothing if just importing
                                if( importing ) break;

                                if( !mSymbol::isValid( $1 ) ){
                                    myerror();
                                    cout<<"variable '"<<*$1<<"' cannot be declared"<<endl;
                                    break;
                                }

                                // get active environment from top of stack
                                mEnvironment *env = envStack->top();

                                // first we check if variable with this name
                                // already exists in current environment
                                if( env->getLocalSymbol( $1 ) != 0 ){
                                    myerror();
                                    cout<<"variable '"<<*$1<<"' already defined"<<endl;
                                    break;
                                }

                                // bail out (don't add this variable) if type
                                // is erroneous
                                if(currentType == 0) break;
                                
                                // create new variable
                                // access is public , binding nonstatic
                                mVariable *v = new mVariable( $1, typeStack->top(), 
							      BIND_NONSTATIC, 
							      env->currentVariableEntry );
				

                                // ... and add it to active environment
                                env->append( v );

                                // variable is created with NODE_NEW
                                mParseTree *tree = new mParseTree( NODE_NEW );

                                tree->append( new mParseTree( NODE_VARIABLE, v ) );

				// add this variable declaration to closure
                                env->closure->append( tree );
                                
                                $$ = tree;

                             }
                             
                           // declaration with explicit initialisation expression
                           | IDENTIFIER '=' Expression {

			        // do nothing if just importing
			        if( importing ) break;			       				


			        if( !mSymbol::isValid( $1 ) ){
                                    myerror();
                                    cout<<"variable '"<<*$1<<"' cannot be declared"<<endl;
                                    break;
                                }


			        // bail out (don't create this variable) if type
                                // or expression are erroneous
                                if(currentType == 0 || !$3 ) break;

                                // get active environment from top of stack
                                mEnvironment *env = envStack->top();

                                // check if variable with this name already exists
                                if( env->getLocalSymbol( $1 ) != 0){
                                    myerror();
                                    cout<<"symbol '"<<*$1<<"' already defined"<<endl;
                                    break;
                                }
			

				// perform implicit cast to currentType if necessary
                                if( !$3->performTypeCast( $3, typeStack->top() ) ){
                                  myerror();
                                  cout<<"cannot perform cast from '"
                                      <<$3->getType()<<"' to '"
                                      <<*typeStack->top()->name<<"'"<<endl;				  
                                  break;
                                }
								

				// check whether expression is a block containing return
				if($3->closureReturns()){
                                    myerror();
                                    cout<<"cannot return from escapable block"<<endl;
				    $$ = 0;
                                    break;
                                }


				// check whether expression is a block containing assignment to parent
				// variable
				if($3->closureAssignsToParent()){
				  myerror();
				  cout<<"cannot assign to parent variable from escapable block"<<endl;
				  $$ = 0;
				  break;
				}


                                // create new initialised variable
                                mVariable *v = new mVariable( $1, typeStack->top(), 
					  BIND_NONSTATIC, env->currentVariableEntry );
				

                                //cout<<"variable "<<*$1<<"'s code: "<<*$3->text<<endl;

                                // and add it to environment
                                env->append( v );

                                // variable is created with NODE_NEW
                                mParseTree *tree = new mParseTree( NODE_NEW );
                                
                                tree->append( new mParseTree( NODE_VARIABLE, v ) );

				// append expression
                                tree->append( $3 );                               

				// add this variable declaration to closure
                                env->closure->append( tree );
                                
                                $$ = tree;

                           }
                           
                           ;


// statement is an expression or return statement
Statement:  Expression Semicolon {


              // do nothing if just importing
              if( importing ) break;


	      //cout<<" imam expression  "<<$1->toString()<<endl;


              // get active environment from top of stack
              // this should be closure env
              if( $1 ){
                 mEnvironment *env = envStack->top();

                 // append to current closure not environment

                 env->closure->append( $1 );

              }
              $$ = $1;
	      

            }

            | ReturnStatement {

              // do nothing if just importing
              if( importing ) break;

              if( $1 ){
                 mEnvironment *env = envStack->top();

                 // append to current closure not environment
                 env->closure->append( $1 );
              }

	      $$ = $1;
	    }
            ;



// the return statement

                  // with expression (functions only)
ReturnStatement:  RETURN Expression Semicolon {
           
                    // do nothing if just importing
	            if( importing ) break;


                    if(!$2){ $$=0; break; }    // error in expression
		    
		    mMethod* currentMethod = methodStack->top();


                    // returning expression from procedure is error
		    if(!currentMethod->isFunction()){

		      myerror();
		      cout<<"method '"<<*currentMethod->name<<"'"<<" does not return '"
			  <<$2->getType()<<"'"<<endl;
		      $$ = 0;
		      break;

		    }

		    // returning expression from constructor is error
		    if( currentMethod->isConstructor() ){
		      myerror();
		      cout<<"constructor '"<<*currentMethod->name<<"'"<<" does not return '"
			  <<$2->getType()<<"'"<<endl;
		      $$ = 0;
		      break;

		    }
                   
		    // perform implicit cast to returnType if necessary
		    if( !$2->performTypeCast( $2, currentMethod->returnType ) ){
		      myerror();
		      cout<<"cannot perform cast from '"
			  <<$2->getType()<<"' to return type '"
			  <<*currentMethod->returnType->name<<"'"<<endl;
		      $$ = 0;
		      break;
		    }


		    // we have return statement
		    envStack->top()->setReturn(true, yylineno);
		     		    		    


		    mParseTree *tree = new mParseTree( NODE_RETURN );

		    // append expression		    
		    tree->append( $2 );
		    $$ = tree;

                  }                  

                  // without expression (procedures only)
                  | RETURN Semicolon {


                     // do nothing if just importing
                     if( importing ) break;


		     mMethod* currentMethod = methodStack->top();

                     // returning nothing from function is error (except for constructors)
		    if(currentMethod->isFunction() && !currentMethod->isConstructor() ){
		      myerror();
		      cout<<"method '"<<*currentMethod->name<<"' must return '"
			  <<*currentMethod->returnType->name<<"'"<<endl;
		      $$ = 0;
		      break;

		    }


		    // method main doesn't return
		    if(*currentMethod->name == "main"){
		      $$ = 0;
		      break;
		    }


		    // create return node
		    mParseTree *tree = new mParseTree( NODE_RETURN );
		    $$ = tree;
		     
                  }
                  ;

// all assignable statements
OtherStatement:   //EmptyStatement { $$ = 0; }
		  WhileStatement { 
		    
		    $$ = $1; 

		  }

                  | DoWhileStatement { 

		    $$ = $1; 

		  }


                  | ForStatement { 

		    $$ = $1; 

		  }
           
                  | IfStatement {

		    $$ = $1;

                  }

                  | Block {

                    $$ = $1;

                  }

                  | MethodExpression {
		    
                    $$ = $1;

                  }



/*| MethodUpdate {

                    $$ = $1;

		    }*/
                  /*| error ';' {
                             cout<<"bad statement"<<endl;
                             yyerrok;
                           }*/
                  ;


// nothing
//EmptyStatement:   ';' // Semicolon
//                 ;


// while loop
WhileStatement: WHILE Block Block {

                  // do nothing if just importing
                  if( importing ) break;


		  // condition block must hold exactly one boolean expression
		  // get class Boolean
		  mString tbool("Boolean");
		  mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );

		  if(!$2->isBooleanClosure(classBool)){
		    myerror();
		    cout<<"conditional block for while must have exactly one Boolean expression"<<endl;
		    $$ = 0;
		    break;
		  }

                  // create while node
                  mParseTree *tree = new mParseTree( NODE_WHILE );		

		  // append both blocks
		  tree->append( $2 );  tree->append( $3 );

		  // return type is While
		  mString While("While");
		  mSymbol *classOfType = root->getSymbol( &While, SYMBOL_CLASS );		    
		  tree->returnType = (mClass*)classOfType;
		  

		  $$ = tree;

                }
                ;


// do while loop
DoWhileStatement: DO Block WHILE Block {
 
                   // do nothing if just importing
                  if( importing ) break;


		  // condition block must hold exactly one boolean expression
		  // get class Boolean
		  mString tbool("Boolean");
		  mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );

		  if(!$4->isBooleanClosure(classBool)){
		    myerror();
		    cout<<"conditional block for while must have exactly one Boolean expression"<<endl;
		    $$ = 0;
		    break;
		  }

                  // create while node
                  mParseTree *tree = new mParseTree( NODE_DOWHILE );		

		  // append both blocks
		  tree->append( $2 );  tree->append( $4 );

		  // return type is While
		  mString DoWhile("DoWhile");
		  mSymbol *classOfType = root->getSymbol( &DoWhile, SYMBOL_CLASS );		    
		  tree->returnType = (mClass*)classOfType;
		  

		  $$ = tree;

                }
                ;





// for loop
ForStatement: FOR Block Block Block Block {

                  // do nothing if just importing
                  if( importing ) break;		  

		  // condition block must hold exactly one boolean expression
		  // get class Boolean
		  mString tbool("Boolean");
		  mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );

		  if(!$3->isBooleanClosure(classBool)){
		    myerror();
		    cout<<"conditional block for for must have exactly one Boolean expression"<<endl;
		    $$ = 0;
		    break;
		  }

                  // create while node
                  mParseTree *tree = new mParseTree( NODE_FOR );		

		  // append all blocks
		  tree->append( $2 );  tree->append( $3 ); tree->append( $4 ); tree->append( $5 );  

		  // return type is For
		  mString For("For");
		  mSymbol *classOfType = root->getSymbol( &For, SYMBOL_CLASS );		    
		  tree->returnType = (mClass*)classOfType;
		  

		  $$ = tree;

		  /* odstranimo spremenljivko iz bloka iz trenutnega okolja */

                }
                ;



// NODE_IF:
//
//  if it has 2 children, we have condition(NODE_CLOSURE) and execution block (NODE_CLOSURE)
//  if it has 3 children, we may have:
//   - condition(NODE_CLOSURE), execution block (NODE_CLOSURE) and
//     else block (NODE_CLSOURE)
//   - condition(NODE_CLOSURE), execution block (NODE_CLOSURE) and
//     second if block (NODE_IF) 
     


IfStatement:    IF Block THEN Block {

                    // do nothing if just importing
                    if( importing ) break;

                    // condition block must hold exactly one boolean expression
		    // get class Boolean
		    mString tbool("Boolean");
		    mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );
		    
		    if(!$2->isBooleanClosure(classBool)){
		      myerror();
		      cout<<"conditional block for if must have exactly one Boolean expression"<<endl;
		      $$ = 0;
		      break;
		    }
		    
		    // create if node
		    mParseTree *tree = new mParseTree( NODE_IF );		
		    
		    // append both blocks
		    tree->append( $2 );  tree->append( $4 );
		    
		    // return type is If
		    mString If("If");
		    mSymbol *classOfType = root->getSymbol( &If, SYMBOL_CLASS );		    
		    tree->returnType = (mClass*)classOfType;
		    
		    
		    $$ = tree;
		    
                }


                | IF Block THEN Block ELSE Block {

                  // do nothing if just importing
                  if( importing ) break;

		  // condition block must hold exactly one boolean expression
		  // get class Boolean
		  mString tbool("Boolean");
		  mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );
		  
		  if(!$2->isBooleanClosure(classBool)){
		    myerror();
		    cout<<"conditional block for if must have exactly one Boolean expression"<<endl;
		    $$ = 0;
		    break;
		  }
		  
		  // create if node
		  mParseTree *tree = new mParseTree( NODE_IF );		
		  
		  // append both blocks and else block
		  tree->append( $2 );  tree->append( $4 );  tree->append( $6 ); 
		  
		  // return type is If
		  mString If("If");
		  mSymbol *classOfType = root->getSymbol( &If, SYMBOL_CLASS );		    
		  tree->returnType = (mClass*)classOfType;
		  
		  
		  $$ = tree;
		  
		}


                | IF Block THEN Block ELSE IfStatement {

                  // do nothing if just importing
                  if( importing ) break;
		  
		  // condition block must hold exactly one boolean expression
		  // get class Boolean
		  mString tbool("Boolean");
		  mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );
		  
		  if(!$2->isBooleanClosure(classBool)){
		    myerror();
		    cout<<"conditional block for if must have exactly one Boolean expression"<<endl;
		    $$ = 0;
		    break;
		  }
		  
		  // create if node
		  mParseTree *tree = new mParseTree( NODE_IF );		
		  
		  // append both blocks and else block
		  tree->append( $2 );  tree->append( $4 );  tree->append( $6 ); 
		  
		  // return type is If
		  mString If("If");
		  mSymbol *classOfType = root->getSymbol( &If, SYMBOL_CLASS );		    
		  tree->returnType = (mClass*)classOfType;
		  
		  
		  $$ = tree;

		}
                ;





// tukaj bo namesto method signatura metode:   parametri '->' tip_vracanja { ... }
// s tem natancno dolocimo signaturo, ko bomo metodo poslali npr. kot argument
// druga alternativa bo METHOD(... signatura ...)


// this is somewhat special, because we create environment here instead of in LocalsOrStatements

/*
MethodUpdate:    METHOD MethodParametersOpt {

		  // do nothing if just importing
                  if( importing ) break;


		  // method that is being updated
		  mMethod* method = methodStack->top();

		  // check if signatures match
		  if(!method->parameterTypesMatch( $2 )){

		    myerror();
		    cout<<"types of parameters do not match those in method definition"<<endl;
		    $$ = 0;
		    break;
		  }


		  // create update environment
		  mEnvironment* env = new mEnvironment( ENVIRONMENT_UPDATE,
							new mString("#locals"),
							envStack->top(),
							envStack->top()->ownerClass );		  
		  

		  int currentEntry = 0;

		  if(method->isFunction()){
		    env->addSelf( 4 );
		    env->currentVariableEntry = currentEntry = 5;
		  }else{
		    env->addSelf( 3 );
		    env->currentVariableEntry = currentEntry = 4;

		  }

		  // add formal parameters


		  if($2){      

		    for( mParameter* param = $2->first(); param != 0; param = $2->next() ){
			param->entry = currentEntry++;
			env->append( param );
		    }
      
		    delete $2;
		  }

		  env->currentVariableEntry = currentEntry;

		  envStack->push( env );

		  performingUpdate = true;

                 }

                 Block {
                 
		  // do nothing if just importing
                  if( importing ) break;


		  methodStack->pop();		  

		  // environment has already been popped after Block
		  

		  mParseTree *tree = new mParseTree(NODE_METHOD);
		  tree->append( $4 );

		  $$ = tree;
		  

                 };  
              
*/


// type can be predefined or user defined
Type:     PredefinedType { $$ = $1; }
        
        // Self type
        | SELF {
	  
           // check whether we're in a static method because Self type is only
           // available in non-static methods
          
           if(currentMethod->isStatic()){
	     myerror();
	     cout<<"Self type is not available in static methods"<<endl;
	     $$ = 0;
	     break;

           }


           // Self is simply the type of class we're currently compiling.
	   // find class environment for current class
           mClass* c = envStack->top()->getFirstClass();

	   isSelfType = true;

           $$ = c;

        }


        | QualifiedIdentifier {
        
           //////////////////////////////////////////////////////////
           // !!!!!! we're dealing with built-in types for now !!!!!!
           //////////////////////////////////////////////////////////
           

	  mClass* classOfType = mUtil::getQualifiedType( $1, root );
	  
	  if( classOfType == 0 ){
           

	    // !!! find external class in current dir !!!

	    myerror();
	    cout<<"type '"<<mUtil::getQualifiedTypeName( $1 )<<"' not defined"<<endl;
	    $$ = 0;
	    break;
	  }

	  $$ = classOfType;
        
	}
          
        // special method type with parameters and optional return type
        |  METHODTYPE   '(' MethodTypeParameters ')' ReturnTypeOpt  {
	  
	  
	  // check if this method type already exists
	  mString type = mMethodClass::getTypeName( $3, $5 );
	  mSymbol *classOfType = root->getSymbol( &type, SYMBOL_CLASS );		    

	  if( !classOfType ){
	    
	    // create new special method type

	    // get generic Method type
	    mString tname("Method");
	    mSymbol *generic = root->getSymbol( &tname, SYMBOL_CLASS );	

	    // get Object class
	    mString object("Object");
	    mSymbol *classObject = root->getSymbol( &object, SYMBOL_CLASS );
	    
	    classOfType = new mMethodClass( (mClass*)generic, (mClass*)classObject, $3, $5 );
	    

	    // add it to root environment
	    root->append( (mClass*)classOfType );


	  }else{


	    // we already have this method type
	    
	  }

	  
	  $$ = (mClass*)classOfType;

	}

        // special method type with return type and no arguments

        | METHODTYPE ':' Type   {


	  // check if this method type already exists
	  mList<mParameter>* parameters = 0;   // no parameters
	  mString type = mMethodClass::getTypeName( parameters, $3 );
	  mSymbol *classOfType = root->getSymbol( &type, SYMBOL_CLASS );		    

	  if( !classOfType ){
	    
	    // create new special method type

	    // get generic Method type
	    mString tname("Method");
	    mSymbol *generic = root->getSymbol( &tname, SYMBOL_CLASS );	

	    // get Object class
	    mString object("Object");
	    mSymbol *classObject = root->getSymbol( &object, SYMBOL_CLASS );
	    
	    classOfType = new mMethodClass( (mClass*)generic, (mClass*)classObject, parameters, $3 );
	    

	    // add it to root environment
	    root->append( (mClass*)classOfType );


	  }else{


	    // we already have this method type
	    
	  }

	  
	  $$ = (mClass*)classOfType;

	}
	           
//| error {
//        cout<<"type expected"<<endl;
          //yyerrok;
//      }
        ;


// predefined types
PredefinedType:      BYTE { $$ = 0; }
                   | CHAR {

                     mString tchar("Character");
                     mSymbol *classOfType = root->getSymbol( &tchar, SYMBOL_CLASS );		    
		     $$ = (mClass*)classOfType;
		   }

                   | SHORT { $$ = 0; }

                   | INT {
		     mString tint("Integer");
                     mSymbol *classOfType = root->getSymbol( &tint, SYMBOL_CLASS );		    
		     $$ = (mClass*)classOfType;
                   }

                   | LONG { $$ = 0; }
                   | FLOAT { $$ = 0; }

                   | DOUBLE {
		     mString tdouble("Double");
                     mSymbol *classOfType = root->getSymbol( &tdouble, SYMBOL_CLASS );
		     $$ = (mClass*)classOfType;
                   }

                   | STRING {
		     mString tstr("String");
                     mSymbol *classOfType = root->getSymbol( &tstr, SYMBOL_CLASS );		    
		     $$ = (mClass*)classOfType;
                   }

                   | VOID { $$ = 0; }

                   | BOOLEAN { 
		     mString tbool("Boolean");
                     mSymbol *classOfType = root->getSymbol( &tbool, SYMBOL_CLASS );		    
		     $$ = (mClass*)classOfType;

		   }                    
                   ;



// type, type, ...
MethodTypeParameters:   Type {

		       mList<mClass>*  list = new mList<mClass>();
		       list->setAutoDelete ( false );
		       list->append ( $1 );		    
		       $$ = list;

			 
			 
                     }
                     | MethodTypeParameters ',' Type {
		         if($3){
			   if(!$1) $1 = new mList<mClass>();


			 
			   
			   $1->append ( $3 );
			 }			
		     }
                     ;




UpdateReference:   FieldReference
                 | MethodReferenceWithArgs
                 ;

/*
SpecialModifier:    THIS '.'
                  | SUPER '(' INTEGER_LITERAL ')' '.'
                  ;
*/                  


Expression:   AssignmentExpression {                 
                 $$=$1;
              }
            ;



AssignmentExpression:   LogicalExpression { $$=$1; }


                        //////////////////////////////////////////////////////////////////////////
                        // assignment to variable
			//////////////////////////////////////////////////////////////////////////
                        | IDENTIFIER '='  AssignmentExpression {
			  

			  // do nothing if just importing
	                  if( importing ) break;

			  // bail out on error
			  if( !$1 || !$3 ){ $$ = 0; break; }			   
                        

			  // check whether expression is a block containing return
			  if($3->closureReturns()){
			    myerror();
			    cout<<"cannot return from escapable block"<<endl;
			    $$ = 0;
			    break;
			  }
			  

			  // check whether expression is a block containing assignment to parent
			  // variable
			  if($3->closureAssignsToParent()){
			    myerror();
			    cout<<"cannot assign to parent variable from escapable block"<<endl;
			    $$ = 0;
			    break;
			  }


			  mEnvironment *env = envStack->top();

			  mSymbol *sym = env->getSymbol( $1 );			     
			  //cout<<"done searching local symbol."<<endl;

			  if(sym != 0){
			       			       
			    
			    if(!env->symbolIsLocal)
			      env->setParentAssignment(sym->theClass, true, yylineno );

			    if( sym->symbolType == SYMBOL_VARIABLE || 
				sym->symbolType == SYMBOL_PARAMETER ){
			      // we're assigning to a local variable
                              
     
			      // perform implicit cast to variable's type if necessary
			      if( !$3->performTypeCast( $3, sym->theClass ) ){
				myerror();
				cout<<"cannot perform cast from '"
				    <<$3->getType()<<"' to '"
				    <<*sym->theClass->name<<"'"<<endl;
				$$ = 0;
				break;
			      }
 			      

			      // create assign node
			      mParseTree *tree = new mParseTree( NODE_ASSIGN );
			      
			      // create variable node
			      mParseTree *var = new mParseTree( NODE_VARIABLE, sym );
			      
			      // now append variable(left) and expression(right) node
			      tree->append( var ); tree->append( $3 );
			      
			      tree->returnType = sym->theClass;
			      
			      $$ = tree;			          
			     

			    }else if( sym->symbolType == SYMBOL_METHOD ){
			      
			      // we have method. error
			      myerror();
			      cout<<"cannot assign to method"<<endl;
			      $$=0;
			      break;
			    }
			    
			    
			    
			  }else{ // sym != 0
			    cout<<"no symbol '"<<*$1<<"' found!"<<endl;
			    
			    //mParseTree *tree = new mParseTree( NODE_ASSIGN );
			    
			    // generate unresolved symbol node
			    //mParseTree *var = new mParseTree( NODE_UNRESOLVED, $1->at( 0 ) );
			    //tree->append( var ); tree->append( $4 );
			    
			    $$ = 0;
			  }
                                                        
			}			 
                             			  

                        //////////////////////////////////////////////////////////////////////////
                        // addition with assignment to variable (+=)
			//////////////////////////////////////////////////////////////////////////
                        | IDENTIFIER OP_ADDASSIGN  AssignmentExpression {
			  

			  // do nothing if just importing
	                  if( importing ) break;

			  // bail out on error
			  if( !$3 ){ $$ = 0; break; }			   
			    			  
			  			  


			  mEnvironment *env = envStack->top();

			  mSymbol *sym = env->getSymbol( $1 );			     

			  if(sym != 0){
			       			       
			    
			    if(!env->symbolIsLocal)
			      env->setParentAssignment(sym->theClass, true, yylineno );
			    
			    if( sym->symbolType == SYMBOL_VARIABLE || 
				sym->symbolType == SYMBOL_PARAMETER ){

			      // we're assigning to a local variable
			      			      
			     	
			      // create variable node - this is left node
			      mParseTree *var = new mParseTree( NODE_VARIABLE, sym );
		      
			      mParseTree *tree = new mParseTree( NODE_PLUS );
			      
			      // check for implicit promotion
			       
			      if( !tree->promotePrimitivesViaCast(var, $3, NODE_PLUS)){
				myerror();
				cout<<"cannot perform '+' on "<<var->getType()
				    <<" and "<<$3->getType()<<endl;				 
				$$ = 0;
				break;
			      }

			      
			      // now append variable(left) and additive expression(right) node
			      tree->append( var );  tree->append( $3 );			      


			      // perform implicit cast to variable's type if necessary
			      if( !tree->performTypeCast( tree, sym->theClass ) ){
				myerror();
				cout<<"cannot perform cast from '"
				    <<tree->getType()<<"' to '"
				    <<*sym->theClass->name<<"'"<<endl;
				$$ = 0;
				break;
			      }
 			      

			      // create assign node
			      mParseTree *assign = new mParseTree( NODE_ASSIGN, sym->theClass );
			      assign->append( new mParseTree( NODE_VARIABLE, sym ) );  
			      assign->append( tree );
			      
			      
			      $$ = assign;
			      
			    }else if( sym->symbolType == SYMBOL_METHOD ){
			      
			      // we have method. error
			      myerror();
			      cout<<"cannot assign to method"<<endl;
			      $$=0;
			      break;
			    }
			    
			    
			    
			  }else{ // sym != 0
			    cout<<"no symbol '"<<*$1<<"' found!"<<endl;
			    
			    //mParseTree *tree = new mParseTree( NODE_ASSIGN );
			    
			    // generate unresolved symbol node
			    //mParseTree *var = new mParseTree( NODE_UNRESOLVED, $1->at( 0 ) );
			    //tree->append( var ); tree->append( $4 );
			    
			    $$ = 0;
			  }
			  
			}


                        //////////////////////////////////////////////////////////////////////////
                        // subtraction with assignment to variable (-=)
			//////////////////////////////////////////////////////////////////////////
                        | IDENTIFIER OP_DECASSIGN  AssignmentExpression {
			  

			  // do nothing if just importing
	                  if( importing ) break;

			  // bail out on error
			  if( !$3 ){ $$ = 0; break; }			   
			    			  
			  			  


			  mEnvironment *env = envStack->top();

			  mSymbol *sym = env->getSymbol( $1 );			     

			  if(sym != 0){
			       			       
			    
			    if(!env->symbolIsLocal)
			      env->setParentAssignment(sym->theClass, true, yylineno );
			    
			    if( sym->symbolType == SYMBOL_VARIABLE || 
				sym->symbolType == SYMBOL_PARAMETER ){

			      // we're assigning to a local variable
			      			      
			     	
			      // create variable node - this is left node
			      mParseTree *var = new mParseTree( NODE_VARIABLE, sym );
		      
			      mParseTree *tree = new mParseTree( NODE_MINUS );
			      
			      // check for implicit promotion
			       
			      if( !tree->promotePrimitivesViaCast(var, $3, NODE_MINUS)){
				myerror();
				cout<<"cannot perform '-' on "<<var->getType()
				    <<" and "<<$3->getType()<<endl;				 
				$$ = 0;
				break;
			      }

			      
			      // now append variable(left) and additive expression(right) node
			      tree->append( var );  tree->append( $3 );			      


			      // perform implicit cast to variable's type if necessary
			      if( !tree->performTypeCast( tree, sym->theClass ) ){
				myerror();
				cout<<"cannot perform cast from '"
				    <<tree->getType()<<"' to '"
				    <<*sym->theClass->name<<"'"<<endl;
				$$ = 0;
				break;
			      }
 			      

			      // create assign node
			      mParseTree *assign = new mParseTree( NODE_ASSIGN, sym->theClass );
			      assign->append( new mParseTree( NODE_VARIABLE, sym ) );  
			      assign->append( tree );
			      
			      
			      $$ = assign;
			      
			    }else if( sym->symbolType == SYMBOL_METHOD ){
			      
			      // we have method. error
			      myerror();
			      cout<<"cannot assign to method"<<endl;
			      $$=0;
			      break;
			    }
			    
			    
			    
			  }else{ // sym != 0
			    cout<<"no symbol '"<<*$1<<"' found!"<<endl;
			    
			    //mParseTree *tree = new mParseTree( NODE_ASSIGN );
			    
			    // generate unresolved symbol node
			    //mParseTree *var = new mParseTree( NODE_UNRESOLVED, $1->at( 0 ) );
			    //tree->append( var ); tree->append( $4 );
			    
			    $$ = 0;
			  }
			  
			}


                        //////////////////////////////////////////////////////////////////////////
                        // multiplication with assignment to variable (*=)
			//////////////////////////////////////////////////////////////////////////
                        | IDENTIFIER OP_MULASSIGN  AssignmentExpression {
			  

			  // do nothing if just importing
	                  if( importing ) break;

			  // bail out on error
			  if( !$3 ){ $$ = 0; break; }			   
			    			  
			  			  


			  mEnvironment *env = envStack->top();

			  mSymbol *sym = env->getSymbol( $1 );			     

			  if(sym != 0){
			       			       
			    
			    if(!env->symbolIsLocal)
			      env->setParentAssignment(sym->theClass, true, yylineno );
			    
			    if( sym->symbolType == SYMBOL_VARIABLE || 
				sym->symbolType == SYMBOL_PARAMETER ){

			      // we're assigning to a local variable
			      			      
			     	
			      // create variable node - this is left node
			      mParseTree *var = new mParseTree( NODE_VARIABLE, sym );
		      
			      mParseTree *tree = new mParseTree( NODE_MULTIPLY );
			      
			      // check for implicit promotion
			       
			      if( !tree->promotePrimitivesViaCast(var, $3, NODE_MULTIPLY)){
				myerror();
				cout<<"cannot perform '*' on "<<var->getType()
				    <<" and "<<$3->getType()<<endl;				 
				$$ = 0;
				break;
			      }

			      
			      // now append variable(left) and additive expression(right) node
			      tree->append( var );  tree->append( $3 );			      


			      // perform implicit cast to variable's type if necessary
			      if( !tree->performTypeCast( tree, sym->theClass ) ){
				myerror();
				cout<<"cannot perform cast from '"
				    <<tree->getType()<<"' to '"
				    <<*sym->theClass->name<<"'"<<endl;
				$$ = 0;
				break;
			      }
 			      

			      // create assign node
			      mParseTree *assign = new mParseTree( NODE_ASSIGN, sym->theClass );
			      assign->append( new mParseTree( NODE_VARIABLE, sym ) );  
			      assign->append( tree );
			      
			      
			      $$ = assign;
			      
			    }else if( sym->symbolType == SYMBOL_METHOD ){
			      
			      // we have method. error
			      myerror();
			      cout<<"cannot assign to method"<<endl;
			      $$=0;
			      break;
			    }
			    
			    
			    
			  }else{ // sym != 0
			    cout<<"no symbol '"<<*$1<<"' found!"<<endl;
			    
			    //mParseTree *tree = new mParseTree( NODE_ASSIGN );
			    
			    // generate unresolved symbol node
			    //mParseTree *var = new mParseTree( NODE_UNRESOLVED, $1->at( 0 ) );
			    //tree->append( var ); tree->append( $4 );
			    
			    $$ = 0;
			  }
			  
			}


                        //////////////////////////////////////////////////////////////////////////
                        // division with assignment to variable (/=)
			//////////////////////////////////////////////////////////////////////////
                        | IDENTIFIER OP_DIVASSIGN  AssignmentExpression {
			  

			  // do nothing if just importing
	                  if( importing ) break;

			  // bail out on error
			  if( !$3 ){ $$ = 0; break; }			   
			    			  
			  			  


			  mEnvironment *env = envStack->top();

			  mSymbol *sym = env->getSymbol( $1 );			     

			  if(sym != 0){
			       			       
			    
			    if(!env->symbolIsLocal)
			      env->setParentAssignment(sym->theClass, true, yylineno );
			    
			    if( sym->symbolType == SYMBOL_VARIABLE || 
				sym->symbolType == SYMBOL_PARAMETER ){

			      // we're assigning to a local variable
			      			      
			     	
			      // create variable node - this is left node
			      mParseTree *var = new mParseTree( NODE_VARIABLE, sym );
		      
			      mParseTree *tree = new mParseTree( NODE_DIVIDE );
			      
			      // check for implicit promotion
			       
			      if( !tree->promotePrimitivesViaCast(var, $3, NODE_DIVIDE)){
				myerror();
				cout<<"cannot perform '/' on "<<var->getType()
				    <<" and "<<$3->getType()<<endl;				 
				$$ = 0;
				break;
			      }

			      
			      // now append variable(left) and additive expression(right) node
			      tree->append( var );  tree->append( $3 );			      


			      // perform implicit cast to variable's type if necessary
			      if( !tree->performTypeCast( tree, sym->theClass ) ){
				myerror();
				cout<<"cannot perform cast from '"
				    <<tree->getType()<<"' to '"
				    <<*sym->theClass->name<<"'"<<endl;
				$$ = 0;
				break;
			      }
 			      

			      // create assign node
			      mParseTree *assign = new mParseTree( NODE_ASSIGN, sym->theClass );
			      assign->append( new mParseTree( NODE_VARIABLE, sym ) );  
			      assign->append( tree );
			      
			      
			      $$ = assign;
			      
			    }else if( sym->symbolType == SYMBOL_METHOD ){
			      
			      // we have method. error
			      myerror();
			      cout<<"cannot assign to method"<<endl;
			      $$=0;
			      break;
			    }
			    
			    
			    
			  }else{ // sym != 0
			    cout<<"no symbol '"<<*$1<<"' found!"<<endl;
			    
			    //mParseTree *tree = new mParseTree( NODE_ASSIGN );
			    
			    // generate unresolved symbol node
			    //mParseTree *var = new mParseTree( NODE_UNRESOLVED, $1->at( 0 ) );
			    //tree->append( var ); tree->append( $4 );
			    
			    $$ = 0;
			  }
			  
			}

                        
// NOVA SINTAKSA UPDEJTANJA METODE


                        | UpdateReference OP_METHODASSIGN {

			  // do nothing if just importing
	                  if( importing ) break;


			  // !!! TUKAJ JE PRIVZETO false
			  //allowParameters = false;


			  // preveri, ce je UpdateReference pravilen: samo zadnji node lahko
			  // vsebuje tip NODE_PARAMETER v NODE_ARGUMENTS

			  cout<<"checking validity of left-hand method update expression"<<endl;
			  
			  // we're only interested in last method
			  mParseTree* last = $1->getLastMethodNode();

			  mMethod *method = 0;

			  if(last) method = (mMethod*)last->symbol;

			 
			  if(last && method->numParameters() > 0 ){

			    if( !last->children->at(0)->argumentsMatchExactly() ){

			      myerror();
			      cout<<"parameter types of method in update must match those in declaration"
				  <<endl;
			      $$ = 0;
			      break;
			    }
			    
			  }  //  if(last)

			  

			  methodStack->push( method );


			  performingUpdate = true;

			} 



                        ////////////////////////////////////////
                        // right-hand side is method expression
                        // now we have: myMethod( Integer a, ... ) <- method { statements };
                        ///////////////////////////////////////
                        MethodExpression {
			  
			  // do nothing if just importing
	                  if( importing ) break;

			  methodStack->pop();
			  

			  // again: get last method node from left-side expression
			  mParseTree* last = $1->getLastMethodNode();

			  mMethod *method = 0;

			  // get the method
			  if(last) method = (mMethod*)last->symbol;
			  			
			  // get method that was pushed inside MethodExpression
			  //mMethod* anonymous =methodStack->top();
			  //methodStack->pop();


			  // assignment expression may be:
			  // - a closure which is effectively a block
			  // - another method reference (from another class or Method type variable)

			  mParseTree *block = 0;
			  
			  // check what type is our method expression
			  if( $4->type == NODE_ANONMETHOD ){
			    
			    // anonymous method: this means we have 2 children
			    // 1st is cosure and 2nd is parameter list 

			    
			    block = $4->children->at(0);  // the block
			    mParseTree *params = $4->children->at(1); // the params


			    // a function may be assigned to a function, procedure to a
			    // procedure and return types must match
			    
			    if( method->returnType != $4->functionReturnType ){

			      myerror();
			      cout<<"return types of both methods must match."<<endl;
			      $$=0;
			      break;
			    }


			    // check number of parameters and their types 
			    // # must match
			    if(params->children->size() != method->parameterList->size()){
			      myerror();
			      cout<<"new method must have the same number of parameters as old one."<<endl;
			      $$=0;
			      break;
			    }


			    for(unsigned i=0; i < params->children->size(); i++)
			    
				if( params->children->at(i)->returnType != 
				    method->parameterList->at(i)->theClass ){
				  myerror();
				  cout<<"signatures must match exactly: "
				      <<" expecting '"<<*method->parameterList->at(i)->theClass->name 
				      <<"', found '"<<*params->children->at(i)->returnType->name<<"'."
				      <<endl;
				  $$=0;
				  break;
				}				 			  

			    
			    //mParseTree *closure = block->env->closure;


			    // this is a top-level method closure
			    block->env->methodClosure = true;			    

			    /*
			    // if this is function we must ensure return at end
			    if(!closure->endsWithReturn()){
			      
			      if( method->isFunction()){
				
				myerrorBefore();
				cout<<"method '"<<*method->name<<"' must return '"
				    <<*method->returnType->name<<"' at end"<<endl;
				
			      }else{
				
				
				// Block.exit is already in this closure. remove it!
				closure->removeNode( NODE_BLOCK_EXIT ); 
				
				
				
				// we add explicit return
				closure->append( new mParseTree( NODE_RETURN ) );
				
				//cout<<"Removed Block.exit node"<<endl;
				
			      }
			    }
			    */

			  }else{   // $4->type == NODE_ANONMETHOD


			    // otherwise we may have method reference
			    myerror();
			    cout<<"updating from method reference not yet supported"
				<<endl;
			    $$ = 0;
			    break;
			    

			  }
			    
			    
			  // create method update node
			  mParseTree *tree = new mParseTree( NODE_METHODUPDATE, method /*anonymous*/ );
			  
			  
			  // spremeni strukturo, da bo sledeca
			    
			  //   METHOD_UPDATE
			  //   /         \ 
			  //  /           \
			  // METHOD_CALL  NODE_CLOSURE			     
			      
			      
			  // we don't add single methodcall because the owner of method
			  // that is being updated is our own class
			  if( $1->isMultiMethodCall()){
				
			    //cout<<"removing last method node"<<endl;
			    //cout<<"before:"<<$3->toString()<<endl;
			  
			    // remove last methodcall node
			    $1->removeLastMethodNode();
			    //cout<<"tree now= "<<$3->toString()<<endl;
			    
			    tree->append( $1 );   
			    
			  }
			  
			  
			  // append method block or reference
			  tree->append( block );
			  
			  
			  //tree->returnType = $3->returnType;
			  
			  
			  $$ = tree;
			      
			      
			      
			  // remove field reference
			  //delete $3;			  

			}                      
                        ;



                            // this one takes blocks. it may be with or without parameters:
                            // method : Integer { statements; } or 
                            // method (Integer a, Integer b) { statements; }
MethodExpression:           METHOD MethodParametersOpt ReturnTypeOpt

                             {
			       // do nothing if just importing
			       if( importing ) break;


			       
			       
			       // create update environment
			       mEnvironment* env = new mEnvironment( ENVIRONMENT_UPDATE,
								     new mString("#locals"),
								     envStack->top(),
								     envStack->top()->ownerClass );
			       

			       // add self
			       int currentEntry = 0;

			       // if we have return type then we have a procedure otherwise function
			       if( $3 != 0 ){
				 env->addSelf( 4 );
				 env->currentVariableEntry = currentEntry = 5;
			       }else{
				 env->addSelf( 3 );
				 env->currentVariableEntry = currentEntry = 4;

			       }
			       

			  

			       // add formal parameters so we may access them inside
			       // update environment - inside new method block			       

			       mList<mParameter> *list = $2;
				
			       // if parameters exist we add them
			       if(list != 0)
				 for( mParameter* param = list->first(); 
				      param != 0;  param = list->next() ){
				   
				   
				   param->entry = currentEntry++;
				   
				   env->append( param );

				   //cout<<"******************** appending param "<<*parameter->name<<endl;
				 }
			       
			       //delete $2;				
			       
			       
			       env->currentVariableEntry = currentEntry;
			       
			       // push update environment
			       envStack->push( env );

			       

			       
			       // create anonymous method
			       mMethod* meth = new mMethod ( new mString("anonymous_method"), 
							     $3 ,ACCESS_PUBLIC, BIND_NONSTATIC );

			       // set env and push it because anon method is the same
			       // as ordinary method
			       meth->environment = env;
			       meth->theClass = envStack->top()->ownerClass;  // owner
			       methodStack->push( meth );
			       
			       
                             }

                             // the actual method body
                             Block {

                             // do nothing if just importing
                             if( importing ) break;

			     
			     // remove method
			     mMethod* meth = methodStack->top();  // the above method
			     methodStack->pop();

			     // environment has already been popped after Block
			     //envStack->pop();


			     mParseTree *closure = $5->env->closure;

			     // if this block is function block we must ensure return at end
			    if(!closure->endsWithReturn()){
			      
			      if( meth->isFunction()){
				
				myerrorBefore();
				cout<<"anonymous method must return '"
				    <<*meth->returnType->name<<"' at end"<<endl;
				
			      }else{
				
				
				// Block.exit is already in this closure. remove it!
				closure->removeNode( NODE_BLOCK_EXIT ); 
				
								
				// we add explicit return
				closure->append( new mParseTree( NODE_RETURN ) );
								
			      }
			    }


			     // create NODE_ARGUMENTS and append all parameters
			     mParseTree *args = new mParseTree( NODE_ARGUMENTS );
			     mList<mParameter> *list = $2;
				
			     if(list != 0)
			       for( mParameter* param = list->first(); 
				    param != 0;  param = list->next() ){
				   				   				   
				 args->append( new mParseTree(NODE_PARAMETER, param) );
				 meth->addParameter( param );

			       }


			     // MethodExpression consists of closure and parameters
			     
			     mParseTree *anon = new mParseTree( NODE_ANONMETHOD, meth );
			     anon->append( $5 );   // closure
			     anon->append( args );   // params
			     

			     // return type of this parsetree is set to generic Method or special 
			     // Method


			     // find if such Method type already exists
			     mString type = mMethodClass::getTypeName( $2, $3 );
			     mSymbol *classOfType = root->getSymbol( &type, SYMBOL_CLASS );


			     if( !classOfType ){
	    
			       // create new special method type

			       // get generic Method type
			       mString tname("Method");
			       mSymbol *generic = root->getSymbol( &tname, SYMBOL_CLASS );	

			       // get Object class
			       mString object("Object");
			       mSymbol *classObject = root->getSymbol( &object, SYMBOL_CLASS );
	    
			       classOfType = new mMethodClass( (mClass*)generic, (mClass*)classObject, $2, 
							       $3 );
	    

			       // add it to root environment
			       root->append( (mClass*)classOfType );


			     }else{


			       // we already have this method type
	    
			     }




			     //mString methodType("Method");
			     anon->returnType = (mClass*)classOfType; //root->getDeclaredClass(&methodType);
			     anon->functionReturnType = $3;
			     
                             $$ = anon;			                      


                            }

/*| METHOD MethodParametersOpt UpdateReference {

                              // do nothing if just importing
	                      if( importing ) break;
                              $$ = 0; 

                            }
*/
                          ;



// optinal return type
ReturnTypeOpt:             {  $$ = 0; }
                           |  ':' Type { $$ = $2; }
			   ;



LogicalExpression:         BooleanExpression { $$=$1; }

                           // logical negation (!)
                           | '!' BooleanExpression {


                             // do nothing if just importing
                             if( importing ) break;
                           
			     // bail out on error
			     if(!$2){ $$ = 0; break; }
                             
			     mParseTree *right = $2;
			     
			     // get class Boolean
			     mString tbool("Boolean");
			     mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );
			     
			     // if right side is a literal we can calculate value 
			     // now
			     if( $2->type==NODE_LITERAL){
			       mLiteral *right = (mLiteral*)$2->symbol;
			       
			       mEnvironment* env = envStack->top();
			       			       
			       // calc new value and store its literal into list,
			       // and replace old ones in environment
			       mLiteral *newLit = mLiteral::calculate( right, 0, 
								       NODE_NOT, literalList, env,
								       classBool );

			       
			       // if operation could not be performed, 0 is returned
			       if( !newLit ){
				 myerror();
				 cout<<"cannot perform '!' on "<<*right->theClass->name
				     <<endl;
				 $$ = 0;
				 break;
			       }
			       
			       mParseTree *tree=new mParseTree( NODE_LITERAL, newLit,
								newLit->theClass );
			       $$ = tree;
			       
			     }else{
			       
			       // otherwise we have a '!' expression 
			       
			       mParseTree *tree = new mParseTree( NODE_NOT );
			       
			       // check for implicit promotion
			       if( !tree->promoteSinglePrimitiveViaCast(right, NODE_NOT, classBool)){
				 myerror();
				 cout<<"cannot perform '!' on "<<$2->getType()
				     <<endl;
				 $$ = 0;
				 break;
			       }
			       
			       // add right branch
			       tree->append( right );
			       
			       $$ = tree;
			       
			       
			     }
			     
			   }


                           // logical and (&&)
                           | LogicalExpression OP_AND BooleanExpression {
			     

                               // do nothing if just importing
			       if( importing ) break;
                           
			       // bail out on error
			       if(!$1 || ! $3){ $$ = 0; break; }
                             
			       mParseTree *left = $1;
			       mParseTree *right = $3;
			     
			       // get class Boolean
			       mString tbool("Boolean");
			       mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );

			       // if both sides are literals we can calculate addition
			       // now
			       if( $1->type==NODE_LITERAL && $3->type==NODE_LITERAL ){
				 mLiteral *left = (mLiteral*)$1->symbol;
				 mLiteral *right = (mLiteral*)$3->symbol;
				 
				 mEnvironment* env = envStack->top();
				 
				 // calc new value and store its literal into list,
				 // and replace old ones in environment
				 mLiteral *newLit = mLiteral::calculate( left, right,
									 NODE_AND, literalList, env,
									 classBool );
				 
				 // if addition could not be performed, 0 is returned
				 if( !newLit ){
				   myerror();
				   cout<<"cannot perform '&&' on "<<*left->theClass->name
				       <<" and "<<*right->theClass->name<<endl;
				   $$ = 0;
				   break;
				 }
				 
				 mParseTree *tree=new mParseTree( NODE_LITERAL, newLit,
								  newLit->theClass );
				 $$ = tree;
				 
			       }else{
				 
				 // otherwise we have a '&&' expression 
   
				 mParseTree *tree = new mParseTree( NODE_AND );

				 // check for implicit promotion
				 if( !tree->promotePrimitivesViaCast(left, right, NODE_AND, classBool)){
				   myerror();
				   cout<<"cannot perform '&&' on "<<$1->getType()
				       <<" and "<<$3->getType()<<endl;
				   $$ = 0;
				   break;
				 }
				 
				 // add left & right branches
				 tree->append( left );  tree->append( right );

				 $$ = tree;

				 				 
			       }
			     

                           }
                           
                           // logical or (||)
                           | LogicalExpression OP_OR BooleanExpression {

			     // do nothing if just importing
			       if( importing ) break;
                           
			       // bail out on error
			       if(!$1 || ! $3){ $$ = 0; break; }
                             
			       mParseTree *left = $1;
			       mParseTree *right = $3;
			     
			       // get class Boolean
			       mString tbool("Boolean");
			       mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );

			       // if both sides are literals we can calculate addition
			       // now
			       if( $1->type==NODE_LITERAL && $3->type==NODE_LITERAL ){
				 mLiteral *left = (mLiteral*)$1->symbol;
				 mLiteral *right = (mLiteral*)$3->symbol;
				 
				 mEnvironment* env = envStack->top();
				 
				 // calc new value and store its literal into list,
				 // and replace old ones in environment
				 mLiteral *newLit = mLiteral::calculate( left, right,
									 NODE_OR, literalList, env,
									 classBool );
				 
				 // if addition could not be performed, 0 is returned
				 if( !newLit ){
				   myerror();
				   cout<<"cannot perform '||' on "<<*left->theClass->name
				       <<" and "<<*right->theClass->name<<endl;
				   $$ = 0;
				   break;
				 }
				 
				 mParseTree *tree=new mParseTree( NODE_LITERAL, newLit,
								  newLit->theClass );
				 $$ = tree;
				 
			       }else{
				 
				 // otherwise we have a '&&' expression 
   
				 mParseTree *tree = new mParseTree( NODE_OR );

				 // check for implicit promotion
				 if( !tree->promotePrimitivesViaCast(left, right, NODE_OR, classBool)){
				   myerror();
				   cout<<"cannot perform '||' on "<<$1->getType()
				       <<" and "<<$3->getType()<<endl;
				   $$ = 0;
				   break;
				 }
				 
				 // add left & right branches
				 tree->append( left );  tree->append( right );

				 $$ = tree;

				 				 
			       }

                           }
                           ;
            


BooleanExpression:         AdditiveExpression { $$=$1; }
                           | BooleanExpression '<'  AdditiveExpression {

                               // do nothing if just importing
			       if( importing ) break;
                           
			       // bail out on error
			       if(!$1 || ! $3){ $$ = 0; break; }
                             
			       mParseTree *left = $1;
			       mParseTree *right = $3;
			     
			       // get class Boolean
			       mString tbool("Boolean");
			       mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );

			       // if both sides are literals we can calculate addition
			       // now
			       if( $1->type==NODE_LITERAL && $3->type==NODE_LITERAL ){
				 mLiteral *left = (mLiteral*)$1->symbol;
				 mLiteral *right = (mLiteral*)$3->symbol;
				 
				 mEnvironment* env = envStack->top();
				 
				 // calc new value and store its literal into list,
				 // and replace old ones in environment
				 mLiteral *newLit = mLiteral::calculate( left, right,
									 NODE_LESS, literalList, env,
									 classBool );
				 
				 // if addition could not be performed, 0 is returned
				 if( !newLit ){
				   myerror();
				   cout<<"cannot perform '<' on "<<*left->theClass->name
				       <<" and "<<*right->theClass->name<<endl;
				   $$ = 0;
				   break;
				 }
				 
				 mParseTree *tree=new mParseTree( NODE_LITERAL, newLit,
								  newLit->theClass );
				 $$ = tree;
				 
			       }else{
				 
				 // otherwise we have a '<' expression 
   
				 mParseTree *tree = new mParseTree( NODE_LESS );

				 // check for implicit promotion
				 if( !tree->promotePrimitivesViaCast(left, right, NODE_LESS, classBool)){
				   myerror();
				   cout<<"cannot perform '<' on "<<$1->getType()
				       <<" and "<<$3->getType()<<endl;
				   $$ = 0;
				   break;
				 }
				 
				 // add left & right branches
				 tree->append( left );  tree->append( right );

				 $$ = tree;

				 				 
			       }
                           }

                           // operator >
                           | BooleanExpression '>' AdditiveExpression {

			       // do nothing if just importing
			       if( importing ) break;
                           
			       // bail out on error
			       if(!$1 || ! $3){ $$ = 0; break; }
                             
			       mParseTree *left = $1;
			       mParseTree *right = $3;
			       
			       // get class Boolean
			       mString tbool("Boolean");
			       mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );
			       
			       // if both sides are literals we can calculate addition
			       // now
			       if( $1->type==NODE_LITERAL && $3->type==NODE_LITERAL ){
				 mLiteral *left = (mLiteral*)$1->symbol;
				 mLiteral *right = (mLiteral*)$3->symbol;
				 
				 mEnvironment* env = envStack->top();
				 
				 // calc new value and store its literal into list,
				 // and replace old ones in environment
				 mLiteral *newLit = mLiteral::calculate( left, right,
									 NODE_GREATER, literalList, env,
									 classBool );
				 
				 // if addition could not be performed, 0 is returned
				 if( !newLit ){
				   myerror();
				   cout<<"cannot perform '>' on "<<*left->theClass->name
				       <<" and "<<*right->theClass->name<<endl;
				   $$ = 0;
				   break;
				 }
				 
				 mParseTree *tree=new mParseTree( NODE_LITERAL, newLit,
								  newLit->theClass );
				 $$ = tree;
				 
			       }else{
				 				 
				 // otherwise we have a '>' expression 
   
				 mParseTree *tree = new mParseTree( NODE_GREATER );

				 // check for implicit promotion
				 if( !tree->promotePrimitivesViaCast(left, right, NODE_GREATER, classBool)){
				   myerror();
				   cout<<"cannot perform '>' on "<<$1->getType()
				       <<" and "<<$3->getType()<<endl;
				   $$ = 0;
				   break;
				 }
				 
				 // add left & right branches
				 tree->append( left );  tree->append( right );

				 $$ = tree;
				 
			       }
			       
                           }

                           // operator ==
                           | BooleanExpression OP_EQ  AdditiveExpression {

			       // do nothing if just importing
			       if( importing ) break;
                           
			       // bail out on error
			       if(!$1 || ! $3){ $$ = 0; break; }
                             
			       mParseTree *left = $1;
			       mParseTree *right = $3;
			     
			       // get class Boolean
			       mString tbool("Boolean");
			       mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );

			       // if both sides are literals we can calculate equivalence
			       // now
			       if( $1->type==NODE_LITERAL && $3->type==NODE_LITERAL ){
				 mLiteral *left = (mLiteral*)$1->symbol;
				 mLiteral *right = (mLiteral*)$3->symbol;
				 
				 mEnvironment* env = envStack->top();
				 
				 // calc new value and store its literal into list,
				 // and replace old ones in environment
				 mLiteral *newLit = mLiteral::calculate( left, right,
									 NODE_EQUALS, literalList, env,
									 classBool );
				 
				 // if equals could not be performed, 0 is returned
				 if( !newLit ){
				   myerror();
				   cout<<"cannot perform '==' on "<<*left->theClass->name
				       <<" and "<<*right->theClass->name<<endl;
				   $$ = 0;
				   break;
				 }
				 
				 mParseTree *tree=new mParseTree( NODE_LITERAL, newLit,
								  newLit->theClass );
				 $$ = tree;
				 
			       }else{

				 // first we check if we're dealing with two primitive types
				 if(mParseTree::bothPrimitive(left, right)){

				   // create '==' node
				   mParseTree *tree = new mParseTree( NODE_EQUALS );
			
				   // check for implicit promotion
				   if( !tree->promotePrimitivesViaCast(left,right, NODE_EQUALS, classBool)){
				     myerror();
				     cout<<"cannot perform '==' on "<<$1->getType()
					 <<" and "<<$3->getType()<<endl;
				     $$ = 0;
				     break;
				   }
				   
				   // add left & right branches
				   tree->append( left );  tree->append( right );
				   
				   $$ = tree;
				   
				 }else{  // mParseTree::bothPrimitive(left, right)

				   // operator == on complex type

				   // for now this means reference comparison, but later this operator
				   // may be redefined

				   // create '==' node
				   mParseTree *tree = new mParseTree( NODE_EQUALS );
				   tree->returnType = classBool;

				   // add left & right branches
				   tree->append( left );  tree->append( right );
				   
				   $$ = tree;

				 }

			       }

                           }
                           // operator !=
                           | BooleanExpression OP_NOT_EQ AdditiveExpression {

			       // do nothing if just importing
			       if( importing ) break;
                           
			       // bail out on error
			       if(!$1 || ! $3){ $$ = 0; break; }
                             
			       mParseTree *left = $1;
			       mParseTree *right = $3;
			     
			       // get class Boolean
			       mString tbool("Boolean");
			       mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );

			       // if both sides are literals we can calculate addition
			       // now
			       if( $1->type==NODE_LITERAL && $3->type==NODE_LITERAL ){
				 mLiteral *left = (mLiteral*)$1->symbol;
				 mLiteral *right = (mLiteral*)$3->symbol;
				 
				 mEnvironment* env = envStack->top();
				 
				 // calc new value and store its literal into list,
				 // and replace old ones in environment
				 mLiteral *newLit = mLiteral::calculate( left, right,
									 NODE_NOT_EQUALS, literalList, env,
									 classBool );
				 
				 // if addition could not be performed, 0 is returned
				 if( !newLit ){
				   myerror();
				   cout<<"cannot perform '!=' on "<<*left->theClass->name
				       <<" and "<<*right->theClass->name<<endl;
				   $$ = 0;
				   break;
				 }
				 
				 mParseTree *tree=new mParseTree( NODE_LITERAL, newLit,
								  newLit->theClass );
				 $$ = tree;
				 
			       }else{
				 
				 // first we check if we're dealing with two primitive types
				 if(mParseTree::bothPrimitive(left, right)){

				   // create '!=' node
				   mParseTree *tree = new mParseTree( NODE_NOT_EQUALS );
				 
				   // check for implicit promotion
				   if( !tree->promotePrimitivesViaCast(left, right, NODE_NOT_EQUALS, 
								       classBool)){
				     myerror();
				     cout<<"cannot perform '!=' on "<<$1->getType()
					 <<" and "<<$3->getType()<<endl;
				     $$ = 0;
				     break;
				   }
				   
				   // add left & right branches
				   tree->append( left );  tree->append( right );
				 
				   $$ = tree;

				 }else{  // mParseTree::bothPrimitive(left, right)


				   // operator != on complex type

				   // for now this means reference comparison, but later this operator
				   // may be redefined

				   // create '!=' node
				   mParseTree *tree = new mParseTree( NODE_NOT_EQUALS );
				   tree->returnType = classBool;

				   // add left & right branches
				   tree->append( left );  tree->append( right );
				   
				   $$ = tree;

				 }

			       }

			       
                           }
                           // operator >=
                           | BooleanExpression OP_GREATER_OR_EQ  AdditiveExpression {

			       // do nothing if just importing
			       if( importing ) break;
			       
			       // bail out on error
			       if(!$1 || ! $3){ $$ = 0; break; }
                             
			       mParseTree *left = $1;
			       mParseTree *right = $3;
			     
			       // get class Boolean
			       mString tbool("Boolean");
			       mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );

			       // if both sides are literals we can calculate addition
			       // now
			       if( $1->type==NODE_LITERAL && $3->type==NODE_LITERAL ){
				 mLiteral *left = (mLiteral*)$1->symbol;
				 mLiteral *right = (mLiteral*)$3->symbol;
				 
				 mEnvironment* env = envStack->top();
				 
				 // calc new value and store its literal into list,
				 // and replace old ones in environment
				 mLiteral *newLit = mLiteral::calculate( left, right,
									 NODE_GREATER_OR_EQUALS, 
									 literalList, env, classBool );
				 
				 // if addition could not be performed, 0 is returned
				 if( !newLit ){
				   myerror();
				   cout<<"cannot perform '>=' on "<<*left->theClass->name
				       <<" and "<<*right->theClass->name<<endl;
				   $$ = 0;
				   break;
				 }
				 
				 mParseTree *tree=new mParseTree( NODE_LITERAL, newLit,
								  newLit->theClass );
				 $$ = tree;
				 
			       }else{

                           
				 // create '>=' node
				 mParseTree *tree = new mParseTree( NODE_GREATER_OR_EQUALS );
				 
				 // check for implicit promotion
				 if( !tree->promotePrimitivesViaCast(left, right, NODE_GREATER_OR_EQUALS, 
								     classBool)){
				   myerror();
				   cout<<"cannot perform '>=' on "<<$1->getType()
				       <<" and "<<$3->getType()<<endl;
				   $$ = 0;
				   break;
				 }

				 // add left & right branches
				 tree->append( left );  tree->append( right );
				 
				 $$ = tree;
			       }

                           }
                           // operator <=
                           | BooleanExpression OP_LESS_OR_EQ  AdditiveExpression {

			       // do nothing if just importing
			       if( importing ) break;
                           
			       // bail out on error
			       if(!$1 || ! $3){ $$ = 0; break; }
                             
			       mParseTree *left = $1;
			       mParseTree *right = $3;
			     
			       // get class Boolean
			       mString tbool("Boolean");
			       mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );

			       // if both sides are literals we can calculate addition
			       // now
			       if( $1->type==NODE_LITERAL && $3->type==NODE_LITERAL ){
				 mLiteral *left = (mLiteral*)$1->symbol;
				 mLiteral *right = (mLiteral*)$3->symbol;
				 
				 mEnvironment* env = envStack->top();
				 
				 // calc new value and store its literal into list,
				 // and replace old ones in environment
				 mLiteral *newLit = mLiteral::calculate( left, right,
									 NODE_LESS_OR_EQUALS, 
									 literalList, env, classBool );
				 
				 // if addition could not be performed, 0 is returned
				 if( !newLit ){
				   myerror();
				   cout<<"cannot perform '<=' on "<<*left->theClass->name
				       <<" and "<<*right->theClass->name<<endl;
				   $$ = 0;
				   break;
				 }
				 
				 mParseTree *tree=new mParseTree( NODE_LITERAL, newLit,
								  newLit->theClass );
				 $$ = tree;
				 
			       }else{
				 
				 // create '<=' node
				 mParseTree *tree = new mParseTree( NODE_LESS_OR_EQUALS );
				 
				 // check for implicit promotion
				 if( !tree->promotePrimitivesViaCast(left, right, NODE_LESS_OR_EQUALS, 
								     classBool)){
				   myerror();
				   cout<<"cannot perform '<=' on "<<$1->getType()
				       <<" and "<<$3->getType()<<endl;
				   $$ = 0;
				   break;
				 }

				 // add left & right branches
				 tree->append( left );  tree->append( right );
				 
				 $$ = tree;
			       }
			       
                           }
                           ;


AdditiveExpression:          MultiplicativeExpression { $$=$1; }
                           | AdditiveExpression '+'  MultiplicativeExpression {

			     // do nothing if just importing
			     if( importing ) break;

			     // bail out on error
			     if(!$1 || ! $3){ $$ = 0; break; }
                             
			     mParseTree *left = $1;
			     mParseTree *right = $3;
			     
			     // if both sides are literals we can calculate addition
			     // now
			     if( $1->type==NODE_LITERAL && $3->type==NODE_LITERAL ){
			       mLiteral *left = (mLiteral*)$1->symbol;
			       mLiteral *right = (mLiteral*)$3->symbol;

			       mEnvironment* env = envStack->top();

			       // calc new value and store its literal into list,
			       // and replace old ones in environment
			       mLiteral *newLit = mLiteral::calculate( left, right,
						  NODE_PLUS, literalList, env );

			       // if addition could not be performed, 0 is returned
			       if( !newLit ){
				 myerror();
				 cout<<"cannot perform '+' on "<<*left->theClass->name
				     <<" and "<<*right->theClass->name<<endl;
				 $$ = 0;
				 break;
			       }

			       mParseTree *tree=new mParseTree( NODE_LITERAL, newLit,
								newLit->theClass );
			       $$ = tree;
			     }else{

			       // otherwise we have an addition expression 

			       // 1st we check primitive types
			       //if(mParseTree::primitiveTypes(left,right)){

			       // create '+' node
			       mParseTree *tree = new mParseTree( NODE_PLUS );
			       			      			       
			       // check for implicit promotion
			       if( !tree->promotePrimitivesViaCast(left, right, NODE_PLUS)){
				 myerror();
				 cout<<"cannot perform '+' on "<<$1->getType()
				     <<" and "<<$3->getType()<<endl;				 
				 $$ = 0;
				 break;
			       }
			       

			       // add left & right branches
			       tree->append( left );  tree->append( right );

			       $$ = tree;
			       //}else{ 
			         // now we deal with user defined types 
			         // because we may have operators defined!!
			     }
                             
                           }
                           | AdditiveExpression '-' MultiplicativeExpression {

			     // do nothing if just importing
			     if( importing ) break;
        
			     // bail out on error
			     if(!$1 || ! $3){ $$ = 0; break; }

			     mParseTree *left = $1;
			     mParseTree *right = $3;

			     // if both sides are literals we can calculate addition
			     // now
			     if( $1->type==NODE_LITERAL && $3->type==NODE_LITERAL ){
			       mLiteral *left = (mLiteral*)$1->symbol;
			       mLiteral *right = (mLiteral*)$3->symbol;

			       mEnvironment* env = envStack->top();

			       // calc new value and store its literal into list
			       // and replace old ones in environment
			       mLiteral *newLit = mLiteral::calculate( left, right,
						  NODE_MINUS, literalList, env );

			       // if subtraction could not be performed, 0 is returned
			       if( !newLit ){
				 myerror();
				 cout<<"cannot perform '-' on "<<*left->theClass->name
				     <<" and "<<*right->theClass->name<<endl;
				 $$ = 0;
				 break;
			       }

			       mParseTree *tree=new mParseTree( NODE_LITERAL, newLit );
			       $$ = tree;

			     }else{

			       // otherwise we have a subtraction expression 
   
			       mParseTree *tree = new mParseTree( NODE_MINUS );

			       // check for implicit promotion
			       if( !tree->promotePrimitivesViaCast(left, right, NODE_MINUS)){
				 myerror();
				 cout<<"cannot perform '-' on "<<$1->getType()
				     <<" and "<<$3->getType()<<endl;
				 $$ = 0;
				 break;
			       }
			       
			       // add left & right branches
			       tree->append( left );  tree->append( right );

			       $$ = tree;
			     }
                           }
                           ;


                        
MultiplicativeExpression:    PowerExpression { $$=$1; }
                           | MultiplicativeExpression '*' PowerExpression {

			     // do nothing if just importing
			     if( importing ) break;

			     // bail out on error
			     if(!$1 || ! $3){ $$ = 0; break; }

			     mParseTree *left = $1;
			     mParseTree *right = $3;

			     // if both sides are literals we can calculate addition
			     // now
			     if( $1->type==NODE_LITERAL && $3->type==NODE_LITERAL ){
			       mLiteral *left = (mLiteral*)$1->symbol;
			       mLiteral *right = (mLiteral*)$3->symbol;

			       mEnvironment* env = envStack->top();

			       // calc new value and store its literal into list
			       // and replace old ones in environment
			       mLiteral *newLit = mLiteral::calculate( left, right,
						  NODE_MULTIPLY, literalList, env );


			       if( !newLit ){
				 myerror();
				 cout<<"cannot perform '*' on "<<*left->theClass->name
				     <<" and "<<*right->theClass->name<<endl;
				 $$ = 0;
				 break;
			       }

			       mParseTree *tree=new mParseTree( NODE_LITERAL, newLit );
			       $$ = tree;

			     }else{

			       // otherwise we have a multiplication expression

			       mParseTree *tree = new mParseTree( NODE_MULTIPLY );

			       // check for implicit promotion
			       if( !tree->promotePrimitivesViaCast(left, right, NODE_MULTIPLY)){
				 myerror();
				 cout<<"cannot perform '*' on "<<$1->getType()
				     <<" and "<<$3->getType()<<endl;
				 $$ = 0;
				 break;
			       }

			       tree->append( left );  tree->append( right );
			       $$ = tree;
			     }

                           }
                           | MultiplicativeExpression '/'  PowerExpression {

			     // do nothing if just importing
			     if( importing ) break;

			     // bail out on error
			     if(!$1 || ! $3){ $$ = 0; break; }
			     
			     mParseTree *left = $1;
			     mParseTree *right = $3;

			     // if both sides are literals we can calculate addition
			     // now
			     if( $1->type==NODE_LITERAL && $3->type==NODE_LITERAL ){
			       mLiteral *left = (mLiteral*)$1->symbol;
			       mLiteral *right = (mLiteral*)$3->symbol;

			       mEnvironment* env = envStack->top();

			       // calc new value and store its literal into list
			       // and replace old ones in environment
			       mLiteral *newLit = mLiteral::calculate( left, right,
						  NODE_DIVIDE, literalList, env );

			       if( !newLit ){
				 myerror();
				 cout<<"cannot perform '/' on "<<*left->theClass->name
				     <<" and "<<*right->theClass->name<<endl;
				 $$ = 0;
				 break;
			       }


			       mParseTree *tree=new mParseTree( NODE_LITERAL, newLit );
			       $$ = tree;
			     }else{

			       // otherwise we have a division expression 

			       mParseTree *tree = new mParseTree( NODE_DIVIDE );

			       // check for implicit promotion
			       if( !tree->promotePrimitivesViaCast(left, right, NODE_DIVIDE)){
				 myerror();
				 cout<<"cannot perform '*' on "<<$1->getType()
				     <<" and "<<$3->getType()<<endl;
				 $$ = 0;
				 break;
			       }

			       tree->append( $1 );  tree->append( $3 );
			       $$ = tree;
			     }
                           }
                           
                           | MultiplicativeExpression '%' PowerExpression {

			     // do nothing if just importing
			     if( importing ) break;

			     // bail out on error
			     if(!$1 || ! $3){ $$ = 0; break; }
			     
			     mParseTree *left = $1;
			     mParseTree *right = $3;

			     // if both sides are literals we can calculate mod
			     // now
			     if( $1->type==NODE_LITERAL && $3->type==NODE_LITERAL ){
			       mLiteral *left = (mLiteral*)$1->symbol;
			       mLiteral *right = (mLiteral*)$3->symbol;

			       mEnvironment* env = envStack->top();

			       // calc new value and store its literal into list
			       // and replace old ones in environment
			       mLiteral *newLit = mLiteral::calculate( left, right,
						  NODE_MODULE, literalList, env );

			       if( !newLit ){
				 myerror();
				 cout<<"cannot perform '/' on "<<*left->theClass->name
				     <<" and "<<*right->theClass->name<<endl;
				 $$ = 0;
				 break;
			       }


			       mParseTree *tree=new mParseTree( NODE_LITERAL, newLit );
			       $$ = tree;
			     }else{

			       // otherwise we have a module expression 

			       mParseTree *tree = new mParseTree( NODE_MODULE );

			       // check for implicit promotion
			       if( !tree->promotePrimitivesViaCast(left, right, NODE_MODULE)){
				 myerror();
				 cout<<"cannot perform '%' on "<<$1->getType()
				     <<" and "<<$3->getType()<<endl;
				 $$ = 0;
				 break;
			       }

			       tree->append( $1 );  tree->append( $3 );
			       $$ = tree;
			     }
                           }
                           ;


PowerExpression:    CastExpression { $$=$1; }
                  | PowerExpression '^'  CastExpression { /*$$=(int)pow($1,$3);*/ }

                  // operator ++
                  | PowerExpression OP_INCREMENT  {

		    // do nothing if just importing
		    if( importing ) break;

		    // bail out on error
		    if(!$1){ $$ = 0; break; }
			     

		    // if both sides are literals we can calculate mod
		    // now
		    if( $1->type==NODE_LITERAL ){
		      mLiteral *left = (mLiteral*)$1->symbol;

		      mEnvironment* env = envStack->top();

		      // calc new value and store its literal into list
		      // and replace old ones in environment
		      mLiteral *newLit = mLiteral::calculate( left, 0,
							      NODE_INCREMENT, literalList, env );
		      
		      if( !newLit ){
			myerror();
			cout<<"cannot perform '++' on "<<*left->theClass->name<<endl;
			$$ = 0;
			break;
		      }
		      
		      
		      mParseTree *tree=new mParseTree( NODE_LITERAL, newLit );
		      $$ = tree;
		    }else{
		      
		      // otherwise we have an increment expression which is available only on
		      // Integers and Doubles
		      if( $1->getType() == "Integer" || $1->getType() == "Double" ){
		     		      
		      
			mParseTree *tree = new mParseTree( NODE_INCREMENT, $1->returnType );
			tree->append( $1 );
			$$ = tree;

		      }else{

			myerror();
			cout<<"cannot perform '++' on "<<$1->getType()<<endl;
			$$ = 0;
			break;
		      }
		      		      
		    }
		    
		    
		  }
                  // operator --
                  | PowerExpression OP_DECREMENT    {

		    // do nothing if just importing
		    if( importing ) break;

		    // bail out on error
		    if(!$1){ $$ = 0; break; }
			     

		    // if both sides are literals we can calculate mod
		    // now
		    if( $1->type==NODE_LITERAL ){
		      mLiteral *left = (mLiteral*)$1->symbol;

		      mEnvironment* env = envStack->top();

		      // calc new value and store its literal into list
		      // and replace old ones in environment
		      mLiteral *newLit = mLiteral::calculate( left, 0,
							      NODE_DECREMENT, literalList, env );
		      
		      if( !newLit ){
			myerror();
			cout<<"cannot perform '--' on "<<*left->theClass->name<<endl;
			$$ = 0;
			break;
		      }
		      
		      
		      mParseTree *tree=new mParseTree( NODE_LITERAL, newLit );
		      $$ = tree;
		    }else{
		      
		      // otherwise we have an increment expression which is available only on
		      // Integers and Doubles
		      if( $1->getType() == "Integer" || $1->getType() == "Double" ){
		     		      
		      
			mParseTree *tree = new mParseTree( NODE_DECREMENT, $1->returnType );
			tree->append( $1 );
			$$ = tree;

		      }else{

			myerror();
			cout<<"cannot perform '--' on "<<$1->getType()<<endl;
			$$ = 0;
			break;
		      }
		      		      
		    }
		    
		    
		  }
                  ;



CastExpression:     PrimitiveExpression { $$ = $1; }

                    // actual cast expression
                    |  CastExpression AS Type {

		      // do nothing if just importing
		      if( importing ) break;

		      // check if we can cast 

		      // create CAST node
		      mParseTree *tree = new mParseTree( NODE_COMPLEX_CAST );
		      tree->returnType = $3;

		      tree->append( $1 );   // add expression
		      tree->append( new mParseTree( NODE_TYPE, $3 ) );   // add type

		      $$ = tree;

		     }

                     // is type expression
                     /*|  CastExpression IS Type  {

		      // do nothing if just importing
		      if( importing ) break;

		      // check if we can cast 

		      // create IS node
		      mParseTree *tree = new mParseTree( NODE_IS );
		      tree->returnType = $3;

		      tree->append( $1 );

		      $$ = tree;

		      }*/
                    
                    // parenthesised expression
                    | '(' Expression ')' { $$ = $2;  }
                    ;





PrimitiveExpression:   Literal {
		         
		         // do nothing if just importing
		         if( importing ) break;

		         // append literal to environment
		         mEnvironment* env = envStack->top();			 
			 env->append( $1 );		      

			 // create literal node
			 mParseTree *tree = new mParseTree( NODE_LITERAL, $1 );

			 $$ = tree;

                     }
                     // method invocation with arguments
                     | MethodReferenceWithArgs {

                       // do nothing if just importing
                       if( importing ) break;

		       if( $1 )
			 $1->implicitReference = true;  // call via implicit reference if 1st component
		                                        // is methodcall
                       $$ = $1;

                     }
                     // method without arguments or local variable
                     | FieldReference {		       

		       // do nothing if just importing
		       if( importing ) break;

		       if( $1 )
			 $1->implicitReference = true;  // call via implicit reference if 1st component
		                                        // is methodcall
                       $$ = $1;

                     }
                     // explicit object creation with 'new'
                     | NewExpression {
                       $$ = $1;
                     }

                     /*| ArrayAccess {
                       $$ = $1;

                     }*/

                     // method access on a literal
                     | Literal '.' { 

		       // do nothing if just importing
		       if( !importing ){

			 // type of this literal is domain for method access

			 // append literal to environment
			 mEnvironment* env = envStack->top();			 
			 env->append( $1 );
			 
			 // create literal node
			 mParseTree *tree = new mParseTree( NODE_LITERAL, $1 );
			 
			 partialExpression = tree; 
		       }

		     } 

                       PartialReference {

		       // do nothing if just importing
		       if( importing ) break;

		       $$ = $4;
		       expressionError = false;

                     }
                    
                     // invocation on parenthesised expression
                     | '(' Expression  ')'  '.' { 		       

		       // do nothing if just importing
		       if( !importing ){

			 // returnType of this expression is domain for fieldaccess

			 // we cannot invoke anything on void expression
			 if($2->returnType == 0) expressionError = true;

			 // DODANO
			 //mParseTree *tree = new mParseTree( NODE_PARENTHESES, $2->returnType );
			 //tree->append( $2 );

			 partialExpression = /*tree;*/  $2; 
			 
		       }

                       } 

                       PartialReference {
		       		       
		            // do nothing if just importing
		            if( importing ) break;

		            $$ = $2;			    
			    

			    expressionError = false;			    

			    //cout<<"TOTAL partial expression="<<$2->toString()<<endl;
			    

                     }

                     | OtherStatement {

			 // do nothing if just importing
			 if( importing ) break;
			 
			 $$ = $1;
		     }

                     ;




// ------------ ODSTRANI FieldReference 
PartialReference:  FieldReference {
                     $$ = currentFieldTree;		     
		     
                   }
                   | MethodReferenceWithArgs {
                
                     $$ = currentMethodTree;
                   }
                   ;



MethodReferenceWithArgs:    MethodAccess { $$ = currentMethodTree; }
                        /*| SpecialModifier MethodAccess {
                         }*/
                            ;


FieldReference:     FieldAccess { $$ = currentFieldTree; }
                   /*| SpecialModifier FieldAccess {

                   }*/
                  ;



// NEW MethodAccess syntax: method always carries () with it, whether it has arguments
// or not

/*
MethodAccess:  IDENTIFIER '(' Arguments ')' {

                 // do nothing if just importing
	        if( importing ) break;

                mEnvironment *env = envStack->top();

		// get partial expression if it was pushed onto stack
		//if(expressionStack->size() > 0){
		  
		  //partialExpression = expressionStack->top();
		  



		  //expressionStack->pop();

		//}


                 bool ambiguous = false;

		  // find class method with parameters
		  mMethod* meth;
		  //if( partialExpression )  // MethodAccess on partial expression
		    //meth = partialExpression->returnType->getMethod( $1->at( 0 ), $4, true, ambiguous );
		    //else
		    meth = env->ownerClass->getMethod( $1, $3, true, ambiguous );

		  
		  if( meth != 0 ){
		    		    

		    mMethod* currentMethod = methodStack->top();

		    // constructor cannot be explicitly called
		    if( meth->isConstructor() ){
		      myerror();
		      cout<<"constructor '"<<*meth->name<<"' cannot be invoked directly"<<endl;
		      currentMethodTree = 0;
		      $$ = 0;
		      break;
		    }

		    // non-static methods cannot be called from static
		    if(!partialExpression && currentMethod->isStatic() && !meth->isStatic()){
		      myerror();
		      cout<<"cannot invoke dynamically bound method '"<<*meth->name<<"' from static scope"
			  <<endl;
		      currentMethodTree = 0;
		      $$ = 0;
		      break;
		    }

		    // check access privileges
		    if( !meth->isAccessibleWithin( env->ownerClass ) ){
		      myerror();
		      cout<<"method '"<<*meth->name<<"' cannot be invoked because of insufficient"
			  <<" privileges"<<endl;
		      currentMethodTree = 0;
		      $$ = 0;
		      break;
		    }


		    //cout<<"got method "<<*meth->name<<", now performing cast"<<endl;
		    //exit(1);


		    if( !$4->performArgumentsCast($4, meth ) ){

		      myerror();
		      cout<<"cannot perform cast to call method '"<<*meth->name<<"'"<<endl;
		      currentMethodTree = 0;
		      $$ = 0;
		      break;

		    }

		    // generate tree for method invocation
		    mParseTree *tree = new mParseTree( NODE_METHODCALL, meth, meth->returnType );
		     
		    // add arguments
		    tree->append( $4 );
                    

		    if( partialExpression ){

		      partialExpression->append( tree );
		      tree = partialExpression;		      
		      // return type of whole expression becomes return type of LAST expression
		      tree->returnType = meth->returnType;
		      partialExpression = 0;
		    }

		    currentMethodTree = tree;
		    $$ = tree;

		  }else{

		    myerror();
		    if(ambiguous)
		      cout<<"ambiguous invocation of method '"<<*$1->at( 0 )<<"'"<<endl;
		    else
		      cout<<"method '"<<*$1->at( 0 )<<"' not found!"<<endl;
		    // generate unresolved symbol node
		    //mParseTree *tree = new mParseTree( NODE_UNRESOLVED, $1->at( 0 ) );
		    
		    currentMethodTree = 0;//tree;
		    $$ = 0;//tree;
		  }


               }
               | MethodAccess '.' IDENTIFIER '(' Arguments ')'
               ;
*/


MethodAccess:  QualifiedIdentifier '(' 
                { 

		  // INFIX RULE:

		  // identifier has ben parsed, now deal with partial expression
		  // if it was invoked upon
		  // this is because partial expression is only meaningful for last
		  // identifier in this QualifiedIdentifier, arguments are NOT evaluated
		  // on partialExpression

		  if( !importing && partialExpression ){


		    // remove partial expression and save it on stack
		    expressionStack->push( partialExpression );
		    partialExpression = 0;		    
		    
		  }
		  

                } 

                Arguments ')' {

                // do nothing if just importing
	        if( importing ) break;

                mEnvironment *env = envStack->top();

		// get partial expression if it was pushed onto stack
		if(expressionStack->size() > 0){
		  
		  partialExpression = expressionStack->top();
		  



		  expressionStack->pop();

		}
                
                // this one takes: classmethod(...)


		////////////////////////////////////////////////////
		// 1 component - class method name
		////////////////////////////////////////////////////


                if( $1->size() == 1 ){   // one component means we're accessing
                                         // a class method with parameters
                                         
		  //v funkciji getMethod bomo pogledali, ce so childi NODE_ARGUMENTS NODE_PARAMETERS 

		  bool ambiguous = false;

		  // find class method with parameters
		  mMethod* meth;
		  if( partialExpression )  // MethodAccess on partial expression
		    meth = partialExpression->returnType->getMethod( $1->at( 0 ), $4, true, ambiguous );
		  else meth = env->ownerClass->getMethod( $1->at( 0 ), $4, true, ambiguous );

		  
		  if( meth != 0 ){
		    		    

		    mMethod* currentMethod = methodStack->top();

		    // constructor cannot be explicitly called
		    if( meth->isConstructor() ){
		      myerror();
		      cout<<"constructor '"<<*meth->name<<"' cannot be invoked directly"<<endl;
		      currentMethodTree = 0;
		      $$ = 0;
		      break;
		    }

		    // non-static methods cannot be called from static
		    if(!partialExpression && currentMethod->isStatic() && !meth->isStatic()){
		      myerror();
		      cout<<"cannot invoke dynamically bound method '"<<*meth->name<<"' from static scope"
			  <<endl;
		      currentMethodTree = 0;
		      $$ = 0;
		      break;
		    }

		    // check access privileges
		    if( !meth->isAccessibleWithin( env->ownerClass ) ){
		      myerror();
		      cout<<"method '"<<*meth->name<<"' cannot be invoked because of insufficient"
			  <<" privileges"<<endl;
		      currentMethodTree = 0;
		      $$ = 0;
		      break;
		    }


		    //cout<<"got method "<<*meth->name<<", now performing cast"<<endl;
		    //exit(1);


		    if( !$4->performArgumentsCast($4, meth ) ){

		      myerror();
		      cout<<"cannot perform cast to call method '"<<*meth->name<<"'"<<endl;
		      currentMethodTree = 0;
		      $$ = 0;
		      break;

		    }

		    // generate tree for method invocation
		    mParseTree *tree = new mParseTree( NODE_METHODCALL, meth, meth->returnType );
		     
		    // add arguments
		    tree->append( $4 );
                    

		    if( partialExpression ){

		      partialExpression->append( tree );
		      tree = partialExpression;		      
		      // return type of whole expression becomes return type of LAST expression
		      tree->returnType = meth->returnType;
		      partialExpression = 0;
		    }

		    currentMethodTree = tree;
		    $$ = tree;

		  }else{

		    myerror();
		    if(ambiguous)
		      cout<<"ambiguous invocation of method '"<<*$1->at( 0 )<<"'"<<endl;
		    else
		      cout<<"method '"<<*$1->at( 0 )<<"' not found!"<<endl;
		    // generate unresolved symbol node
		    //mParseTree *tree = new mParseTree( NODE_UNRESOLVED, $1->at( 0 ) );
		    
		    currentMethodTree = 0;//tree;
		    $$ = 0;//tree;
		  }
		  

                }else{ // if( $1->size() == 1 )
                
		  
		  ////////////////////////////////////////////////////
		  // more than 1 component - sequence of invocations
		  ////////////////////////////////////////////////////
		  
		  // more than 1 component indicates that we have a sequence
		  // of method calls
		  // we have two options:
		  // 1. call via variable: var.method1.methodN(...)
		  // 2. call via classmethod: classmethod.method1.methodN(...)

		  // first let's see what component 1 is
		  mSymbol *sym;
		  if( partialExpression ){  // FieldAccess on partial expression		    
		    sym = partialExpression->returnType->getMethod( $1->at( 0 ) );
		  }else{
		    sym = env->getSymbol( $1->at( 0 ) );		  
		  }
                
		  if( sym != 0 ){
		    if( sym->symbolType == SYMBOL_VARIABLE || sym->symbolType == SYMBOL_PARAMETER ){

		      /////////////////////////////////////////////
		      // we're accessing method via local variable
		      /////////////////////////////////////////////
                         
		      // create a variable access node
		      mParseTree *tree = new mParseTree( NODE_VARIABLE, sym );

		      mParseTree *current = tree;
                         
		      // now we create child nodes for every additional
		      // method call. last one is special though,
		      // because it accepts arguments
                         
		      // we need class of our variable so we can check
		      // for methods
		      mClass *domain = sym->theClass;

		      // for every method except last one
		      for(unsigned i = 1; i < $1->size() - 1; i++ ){
			mString *methodName = $1->at( i );
                             
			// now we check for parameterless method
			// 'methodName' in class 'domain'
			mMethod *m = domain->getMethod( methodName );
                             
			if( !m ){

			  myerror();

			  if(domain->ambiguous)
			    cout<<"ambiguous invocation of method '"<<*methodName<<"'"<<endl;
			  else
			  cout<<"method '"<<*methodName<<"' not found in class '"
			      <<*domain->name<<"'"<<endl;
			  domain = 0; 
			  break;

			}


			// check access privileges
			if( !m->isAccessibleWithin( env->ownerClass ) ){
			  myerror();
			  cout<<"method '"<<*m->name<<"' cannot be invoked because of insuficient"
			      <<" privileges"<<endl;
			  domain = 0;
			  break;
			}



			// generate tree for method call and append it
			// to parent                             
			mParseTree *call = new mParseTree( NODE_METHODCALL, m );
			current->append( call );
			current = call;
                             

			// domain for next call is return type of this method
			domain = m->returnType;                             
		      }

		      if( domain ){

			// now we deal with the last one which accepts arguments
			mString *methodName = $1->at( $1->size() - 1 );
                             
			bool ambiguous = false;

			// now we check for method with parameters
			// 'methodName' in class 'domain'
			mMethod *m = domain->getMethod( methodName, $4, true, ambiguous );
                             			
			if( !m ){

			  myerror();

			  if(ambiguous)
			    cout<<"ambiguous invocation of method '"<<*methodName<<"'"<<endl;
			  else
			    cout<<"method '"<<*methodName<<"(" + $4->toStringArguments()
				<<")' not found in class '"
				<<*domain->name<<"'"<<endl;
			  tree = 0;

			}else{


			  // check access privileges
			  if( !m->isAccessibleWithin( env->ownerClass ) ){
			    myerror();
			    cout<<"method '"<<*m->name<<"' cannot be invoked because of insuficient"
				<<" privileges"<<endl;
			    domain = 0;
			    break;
			  }


			  if( !$4->performArgumentsCast($4, m ) ){

			    myerror();
			    cout<<"cannot perform cast to call method '"<<*m->name<<"'"<<endl;
			    currentMethodTree = 0;
			    $$ = 0;
			    break;

			  }

			  // generate tree for method call and append it
			  // to parent
			  mParseTree *call = new mParseTree( NODE_METHODCALL, m );
			  current->append( call );
			  // add arguments
			  call->append( $4 );

			  // returnType of 1st node of sequence calls must be set to returnType
			  // of last method invoked, i.e. in an invocation sequence meth1.meth2.meth3
			  // the returnType becomes that of meth3
			  tree->returnType = m->returnType;

			}
                              
		      }else
			tree = 0;  // 0 on error

		      currentMethodTree = tree;
		      $$ = tree;
                    

     
		    }else if( sym->symbolType == SYMBOL_METHOD ){
                      
		      // we have a method which means we're accessing
		      // a method via a class method

		      mMethod* currentMethod = methodStack->top();

		      // constructor cannot be explicitly called
		      if( ((mMethod*)sym)->isConstructor() ){
			myerror();
			cout<<"constructor '"<<*sym->name<<"' cannot be invoked directly"<<endl;
			currentMethodTree = 0;
			$$ = 0;
			break;
		      }

		      // non-static methods cannot be called from static
		      if(!partialExpression && currentMethod->isStatic() && !((mMethod*)sym)->isStatic()){
			myerror();
			cout<<"cannot invoke dynamically bound method '"<<*sym->name<<"' from static scope"
			    <<endl;
			currentMethodTree = 0;
			$$ = 0;
			break;
		      }

		      // check access privileges
		      if( !((mMethod*)sym)->isAccessibleWithin( env->ownerClass ) ){
			myerror();
			cout<<"method '"<<*sym->name<<"' cannot be invoked because of insuficient"
			    <<" privileges"<<endl;
			currentMethodTree = 0;
			$$ = 0;
			break;
		      }



		      // 1st we create methodcall for class method
		      mParseTree *tree = new mParseTree( NODE_METHODCALL, sym );
		      currentMethodTree = tree;

		      if( partialExpression ){

			partialExpression->append( tree );
			currentMethodTree = partialExpression;
			partialExpression = 0;
		      }

		      mParseTree *current = tree;

		      // now we create child nodes for every additional
		      // method call excepth the last

		      // we need class of our variable so we can check
		      // for methods
		      mClass *domain = ((mMethod*)sym)->returnType;
                         
		      for(unsigned i = 1; i < $1->size() - 1; i++ ){
			mString *methodName = $1->at( i );
                             
			// now we check for parameterless method
			// 'methodName' in class 'domain'
			mMethod *m = domain->getMethod( methodName );
			
			if( !m ){

			  myerror();
			  if(domain->ambiguous)
			    cout<<"ambiguous invocation of method '"<<*methodName<<"'"<<endl;
			  else
			    cout<<"method '"<<*methodName<<"' not found in class '"
				<<*domain->name<<"'"<<endl;
			  domain = 0; break;

			}


			// check access privileges
			if( !m->isAccessibleWithin( env->ownerClass ) ){
			  myerror();
			  cout<<"method '"<<*m->name<<"' cannot be invoked because of insuficient"
			      <<" privileges"<<endl;
			  domain = 0;
			  break;
			}

			
			// generate tree for method call and append it
			// to parent                             
			mParseTree *call = new mParseTree( NODE_METHODCALL, m );
			current->append( call );
			current = call;
                             
			// domain for next call is return type of this method
			domain = m->returnType;                             
		      }

		      if( domain ){

			// now we deal with the last one
			mString *methodName = $1->at( $1->size() - 1 );
                             
			bool ambiguous = false;
			// now we check for method with parameters
			// 'methodName' in class 'domain'
			mMethod *m = domain->getMethod( methodName, $4, true, ambiguous );
                             
			if( !m ){

			  myerror();
			  if(ambiguous)
			    cout<<"ambiguous invocation of method '"<<*methodName<<"'"<<endl;
			  else
			    cout<<"method '"<<*methodName<<"' not found in class '"
				<<*domain->name<<"'"<<endl;

			}else{


			  // check access privileges
			  if( !m->isAccessibleWithin( env->ownerClass ) ){
			    myerror();
			    cout<<"method '"<<*m->name<<"' cannot be invoked because of insuficient"
				<<" privileges"<<endl;
			    domain = 0;
			    break;
			  }
			  

			  if( !$4->performArgumentsCast($4, m ) ){
			    myerror();
			    cout<<"cannot perform cast to call method '"<<*m->name<<"'"<<endl;
			    currentMethodTree = 0;
			    $$ = 0;
			    break;

			  }

			  // generate tree for method call and append it
			  // to parent
			  mParseTree *call = new mParseTree( NODE_METHODCALL, m );
			  current->append( call );

			  // add arguments
			  call->append( $4 );

			  // returnType of 1st node of sequence calls must be set to returnType
			  // of last method invoked, i.e. in an invocation sequence meth1.meth2.meth3
			  // the returnType becomes that of meth3
			  tree->returnType = m->returnType;

			}
                                                    
		      }else
			tree = 0;   // 0 on error
		      
		      $$ = tree;
		    }
                                          
		  }else{

		    myerror();
		    cout<<"no symbol '"<<*$1->at( 0 )<<"' found!"<<endl;
		    // generate unresolved symbol node
		    mParseTree *tree = new mParseTree( NODE_UNRESOLVED, $1->at( 0 ) );
		    
		    currentMethodTree = tree;
		    $$ = tree;

		  }

                }
              }
              | MethodAccess '.' QualifiedIdentifier '(' 

                {
	          // INFIX RULE:

		  // identifier has ben parsed, now deal with partial expression
		  // if it was invoked upon
		  // this is because partial expression is only meaningful for last
		  // identifier in this QualifiedIdentifier, arguments are NOT evaluated
		  // on partialExpression

		  if( !importing && partialExpression ){


		    // remove partial expression and save it on stack
		    expressionStack->push( partialExpression );
		    partialExpression = 0;		    
		    
		  }
		  

                }


                Arguments ')' {


                // do nothing if just importing
	        if( importing ) break;

		mEnvironment *env = envStack->top();


		// get partial expression if it was pushed onto stack
		if(expressionStack->size() > 0){
		  
		  partialExpression = expressionStack->top();
		  


		  expressionStack->pop();

		}


				
		// this one takes *.*.*.A.B.C(...)

	
		// we need returnType of last method in $1 so we can check
		// first method in $3	
		mParseTree *meth = $1->getLastMethodNode();
		
                mParseTree *current = meth;				

                // domain is return type of this last method
		mClass *domain = ((mMethod*)meth->symbol)->returnType;
		

/////////////////////////////////////////////////////////////////
// isAccessibleOutside dodaj
/////////////////////////////////////////////////////////////////

		// now do this shit for every method except the last one
		for(unsigned i = 0; i < $3->size() - 1; i++ ){
                    mString *methodName = $3->at( i );
                             
                    // now we check for parameterless method
                    // 'methodName' in class 'domain'
                    mMethod *m = domain->getMethod( methodName );
                             
                    if( !m ){

		      myerror();
		      if(domain->ambiguous)
			cout<<"ambiguous invocation of method '"<<*methodName<<"'"<<endl;
		      else
			cout<<"method '"<<*methodName<<"' not found in class '"
			    <<*domain->name<<"'"<<endl;
		      break;
		    }

		    // check access privileges
		    if( !m->isAccessibleWithin( env->ownerClass ) ){
		      myerror();
		      cout<<"method '"<<*m->name<<"' cannot be invoked because of insuficient"
			  <<" privileges"<<endl;
		      break;
		    }

                    // generate tree for method call and append it to parent
		    mParseTree *call = new mParseTree( NODE_METHODCALL, m );
		    current->append( call );
		    current = call;
                             
		    // domain for next call is return type of this method
		    domain = m->returnType;                             
		}
		
		// now we deal with the last one which has arguments
		mString *methodName = $3->at( $3->size() - 1 );
                             
		bool ambiguous = false;

		// we check for method with parameters
		// 'methodName' in class 'domain'
		mMethod *m = domain->getMethod( methodName, $6, true, ambiguous );
                             
		if( !m ){

		  myerror();
		  if(ambiguous)
		    cout<<"ambiguous invocation of method '"<<*methodName<<"'"<<endl;
		  else
		    cout<<"method '"<<*methodName<<"' not found in class '"
			<<*domain->name<<"'"<<endl;
		  currentMethodTree = 0;
		  $$ = 0;

		}else{


		  // check access privileges
		  if( !m->isAccessibleWithin( env->ownerClass ) ){
		    myerror();
		    cout<<"method '"<<*m->name<<"' cannot be invoked because of insuficient"
			<<" privileges"<<endl;
		    currentMethodTree = 0;
		    $$ = 0;
		    break;
		  }


		  if( !$6->performArgumentsCast($6, m ) ){

		    myerror();
		    cout<<"cannot perform cast to call method '"<<*m->name<<"'"<<endl;
		    currentMethodTree = 0;
		    $$ = 0;
		    break;

		  }

		  // generate tree for method call and append it to parent
		  mParseTree *call = new mParseTree( NODE_METHODCALL, m );
		  current->append( call );

		  // add arguments
		  call->append( $6 );
		  
		  // returnType of $1 becomes returnType of last method
		  $1->returnType = m->returnType;
		  
		  currentMethodTree = $1;
		  $$ = $1;
		  
		}
		
                         		
	      }
                                                          
              
              // array access
              
              | MethodAccess ArrayAccess {

		 // do nothing if just importing
	         if( importing ) break;

                 cout<<"got array ! "<<endl;


		 // find last methodcall
		 mParseTree *meth = $1->getLastMethodNode();
		 

                 // domain is return type of this last method - must be array of course
		 
		 //mClass *domain = ((mMethod*)meth->symbol)->returnType;

                 // we just put in last method 
		 mParseTree *array = new mParseTree( NODE_ARRAYACCESS, meth->symbol );
		 
		 // append access expressions
		 array->append( $2 );

		 meth->append( array );

		 // UNFINISHED: returnType???

		 //cout<<"meth="<<meth->toString()<<endl;

                 $$ = $1;
              }
                            
              ;




// this is how we acces a field
// field is a variable or parameterless method


               // this one takes A.B.C
FieldAccess:   QualifiedIdentifier {

		// do nothing if just importing
	        if( importing ) break;

		if(expressionError) break;

                // this may be a variable or parameterless method call
                mEnvironment *env = envStack->top();

		////////////////////////////////////////////////////
		// 1 component - simple name
		////////////////////////////////////////////////////
		
		bool ambiguous = false;
                if($1->size() == 1){  // one component means variable access or class method
		  
                   // find a variable or method
                   mSymbol *sym;
		   if( partialExpression ){  // FieldAccess on partial expression

		     // if we're accessing field on partial expression it can only be method
		     // i.e. ( "string" ).print
		     sym = partialExpression->returnType->getMethod( $1->at( 0 ) );
		     ambiguous = partialExpression->returnType->ambiguous;
		   }else{
		     sym = env->getSymbol( $1->at( 0 ) );
		     ambiguous = env->ownerClass->ambiguous;
		   }

                   if(sym != 0){

                      if( sym->symbolType == SYMBOL_VARIABLE || sym->symbolType == SYMBOL_PARAMETER ){


			  // generate tree to access a variable
			  mParseTree *tree = new mParseTree( NODE_VARIABLE, sym );
                         
                         currentFieldTree = tree;                         
                         $$ = tree;

                      }else if( sym->symbolType == SYMBOL_METHOD ){

			mMethod* currentMethod = methodStack->top();

			// constructor cannot be explicitly called
			if( ((mMethod*)sym)->isConstructor() ){
			  myerror();
			  cout<<"constructor '"<<*sym->name<<"' cannot be invoked directly"<<endl;
			  currentFieldTree = 0;
			  $$ = 0;
			  break;
			}



			// non-static methods cannot be called from static
			if(!partialExpression && currentMethod->isStatic() && !((mMethod*)sym)->isStatic()){
			  myerror();
			  cout<<"cannot invoke dynamically bound method '"<<*sym->name<<"' from static scope"
			      <<endl;
			  currentFieldTree = 0;
			  $$ = 0;
			  break;
			}


			// check access privileges for this method
			if( !((mMethod*)sym)->isAccessibleWithin( env->ownerClass ) ){
			  myerror();
			  cout<<"method '"<<*sym->name<<"' cannot be invoked"<<endl
			      <<"because of insufficient privileges"<<endl;
			  //currentMethodTree = 0;
			  currentFieldTree = 0;
			  $$ = 0;
			  break;
			}


			// generate tree for method invocation
			mParseTree *tree = new mParseTree( NODE_METHODCALL, sym, 
							   ((mMethod*)sym)->returnType );

			if( partialExpression ){

			  // we add this methodcall node to the LAST node in partial expression
			  // if partial expression may have compound call, which means that it's NODE_METHODCALL or
			  // NODE_VARIABLE
			  if(partialExpression->type == NODE_METHODCALL || partialExpression->type == NODE_VARIABLE){
			    partialExpression->getLastMethodNode()->append( tree );
			  }else{

			    // otherwise we simply append invocation to partialExpression
			    partialExpression->append( tree );

			  }
  
			  tree = partialExpression;

			  // return type of whole expression becomes return type of LAST expression
			  tree->returnType = ((mMethod*)sym)->returnType;
			  partialExpression = 0;			  
			} 

			currentFieldTree = tree;                         
			$$ = tree;

                      }else if(sym->symbolType == SYMBOL_CLASS){

			// generate tree for class reference
			mParseTree *tree = new mParseTree( NODE_CLASSREF, sym, 
							   ((mClass*)sym) );
			if( partialExpression ){

			  partialExpression->append( tree );
			  tree = partialExpression;
			  // return type of whole expression becomes return type of LAST expression
			  //tree->returnType = ((mMethod*)sym)->returnType;
			  partialExpression = 0;			  
			}

			currentFieldTree = tree;                         
			$$ = tree;

		      }
                      
                      // we found no symbol with that name
                   }else{
		     myerror();
		     if(ambiguous)
		       cout<<"ambiguous invocation of method '"<<*$1->at( 0 )<<"'"<<endl;
		     else
		       cout<<"no symbol '"<<*$1->at( 0 )<<"' found!"<<endl;
                     // generate unresolved symbol node
                     //mParseTree *tree = new mParseTree( NODE_UNRESOLVED, $1->at( 0 ) );
		     
                         
                     currentFieldTree = 0; //tree;
		     $$ = 0;//tree;
                   }
                   
                }else{
                

		  ////////////////////////////////////////////////////
		  // more than 1 component - compound call
		  ////////////////////////////////////////////////////

		  // more than 1 component indicates that this is a
		  // parameterless method call via variable or classmethod
		  // 1st possibility is: variable.method1.method2.methodN
		  // 2nd possibility is: classmethod.method1.method2.methodN

		  // first let's see what this symbol is		  

		  mSymbol *sym;
		  if( partialExpression ){  // FieldAccess on partial expression
		    sym = partialExpression->returnType->getMethod( $1->at( 0 ) );
		    ambiguous = partialExpression->returnType->ambiguous;
		  }else{
		    sym = env->getSymbol( $1->at( 0 ) );
		    ambiguous = env->ownerClass->ambiguous;
		  //cout<<"looking for symbol "<<*$1->at( 0 )<<endl;

		  }


		  if( sym != 0 ){
		    //cout<<"found for symbol "<<*$1->at( 0 )<<endl;

		    if( sym->symbolType == SYMBOL_VARIABLE || sym->symbolType == SYMBOL_PARAMETER ){

		      // we have a variable, so this means we're accessing
		      // a parameterless method via a local variable

		      // 1st we create a variable access node
		      mParseTree *tree = new mParseTree( NODE_VARIABLE, sym );

		      mParseTree *current = tree;

		      // constructor cannot be explicitly called
		      if( ((mMethod*)sym)->isConstructor() ){
			myerror();
			cout<<"constructor '"<<*sym->name<<"' cannot be invoked directly"<<endl;
			currentMethodTree = 0;
			$$ = 0;
			break;
		      }
                         
		      // now we create child nodes for every additional
		      // method call, i.e. in 'var.meth1.meth2' we would
		      // generate method calls for meth1 and meth2

		      // we need class of our variable so we can check
		      // for methods
		      mClass *domain = sym->theClass;

		      for(unsigned i = 1; i < $1->size(); i++ ){
			mString *methodName = $1->at( i );
                             
			// find parameterless method
			// 'methodName' in class 'domain'
			mMethod *m = domain->getMethod( methodName );
			
			if( !m ){

			  myerror();
			  if(domain->ambiguous)
			    cout<<"ambiguous invocation of method '"<<*methodName<<"'"<<endl;
			  else
			    cout<<"method '"<<*methodName<<"' not found in class '"
				<<*domain->name<<"'"<<endl;

			  // candidates are:
			  // domain->getAllMethods( methodName );
			  // don't parse any further
			  tree = 0; break;

			}
			

			// check access privileges for this method
			if( !m->isAccessibleWithin( env->ownerClass ) ){
			  myerror();
			  cout<<"method '"<<*methodName<<"' cannot be invoked"<<endl
			      <<"because of insufficient privileges"<<endl;
			  //currentMethodTree = 0;
			  tree = 0;
			  break;
			}
			
			// generate tree for method call and append it
			// to parent                             
			mParseTree *call = new mParseTree( NODE_METHODCALL, m );
			current->append( call );
			current = call;
			
			// domain for next call is return type of this method
			domain = m->returnType;			
                             
		      }
                       

		      // returnType of variable in sequence calls must be set to returnType
		      // of last method invoked, i.e. in an invocation sequence meth1.meth2.meth3
		      // the returnType becomes that of meth3
		      if(tree) tree->returnType = domain;
  
		      currentFieldTree = tree;
		      $$ = tree;
                         



		    }else if( sym->symbolType == SYMBOL_METHOD ){
                      
		      mMethod* currentMethod = methodStack->top();

		      // we have a method which means we're accessing
		      // a parameterless method via a parameterless class method

		      // constructor cannot be explicitly called
		      if( ((mMethod*)sym)->isConstructor() ){
			myerror();
			cout<<"constructor '"<<*sym->name<<"' cannot be invoked directly"<<endl;
			currentFieldTree = 0;
			$$ = 0;
			break;
		      }



		      // non-static methods cannot be called from static
		      if(!partialExpression && currentMethod->isStatic() && !((mMethod*)sym)->isStatic()){
			myerror();
			cout<<"cannot invoke dynamically bound method '"<<*sym->name<<"' from static scope"
			    <<endl;
			currentFieldTree = 0;
			$$ = 0;
			break;
		      }


		      // check access privileges for this method
		      if( !((mMethod*)sym)->isAccessibleWithin( env->ownerClass ) ){
			myerror();
			cout<<"method '"<<*sym->name<<"' cannot be invoked"<<endl
			    <<"because of insufficient privileges"<<endl;
			currentFieldTree = 0;
			$$ = 0;
			break;
		      }



		      // 1st we create methodcall for class method
		      mParseTree *tree = new mParseTree( NODE_METHODCALL, sym );
		      currentFieldTree = tree;

		      if( partialExpression ){

			partialExpression->append( tree );
			currentFieldTree = partialExpression;
			// return type of whole expression becomes return type of LAST expression
			tree->returnType = ((mMethod*)sym)->returnType;
			partialExpression = 0;
		      }

		      mParseTree *current = tree;		      

		      // now we create child nodes for every additional
		      // method call, i.e. in 'meth.meth1.meth2' we would
		      // generate method calls for meth1 and meth2
		      
		      // we need class of our variable so we can check
		      // for methods
		      mClass *domain = ((mMethod*)sym)->returnType;
		      
		      for(unsigned i = 1; i < $1->size(); i++ ){
			mString *methodName = $1->at( i );
			
			// now we check for parameterless method
			// 'methodName' in class 'domain'
			mMethod *m = domain->getMethod( methodName );
                             
			if( !m ){

			  myerror();
			  if(domain->ambiguous)
			    cout<<"ambiguous invocation of method '"<<*methodName<<"'"<<endl;
			  else
			    cout<<"method '"<<*methodName<<"' not found in class '"
				<<*domain->name<<"'"<<endl;
			  // don't parse any further
			  tree = 0; break;

			}


			// check access privileges for this method
			if( !m->isAccessibleWithin( env->ownerClass ) ){
			  myerror();
			  cout<<"method '"<<*methodName<<"' cannot be invoked"<<endl
			      <<"because of insufficient privileges"<<endl;
			  //currentMethodTree = 0;
			  tree = 0;
			  break;
			}

			// generate tree for method call and append it
			// to parent                             
			mParseTree *call = new mParseTree( NODE_METHODCALL, m );
			current->append( call );
			current = call;
			
			// domain for next call is return type of this method
			domain = m->returnType;                             
		      }
                         
		      // returnType of variable in sequence calls must be set to returnType
		      // of last method invoked, i.e. in an invocation sequence meth1.meth2.meth3
		      // the returnType becomes that of meth3
		      if(tree) tree->returnType = domain;		      

		      $$ = tree;
		    }
                      
                      
		  }else{

		    // we found no symbol with this name
		    myerror();
		    if(ambiguous)
		      cout<<"ambiguous invocation of method '"<<*$1->at( 0 )<<"'"<<endl;
		    else
		      cout<<"no symbol '"<<*$1->at( 0 )<<"' found!"<<endl;
		    // generate unresolved symbol node
		    //mParseTree *tree = new mParseTree( NODE_UNRESOLVED, $1->at( 0 ) );
                         
		    currentFieldTree = 0;//tree;
		    $$ = 0;//tree;
		  }

                } // }else{ // more than one component

               }





               // this one takes A(...).B.C(...).D.E
               | MethodAccess '.' QualifiedIdentifier {

                 // do nothing if just importing
	         if( importing ) break;

		 mEnvironment *env = envStack->top();


                 currentFieldTree = currentMethodTree;

                 // $1 contains sequence of calls now. we must find the last
                 // method called to get its return type
                 mParseTree *meth = currentMethodTree->getLastMethodNode();

                 mParseTree *current = meth;

                 // domain is return type of this last method
                 mClass *domain = ((mMethod*)meth->symbol)->returnType;
		 
                 // now generate parameterless method calls
                 for(unsigned i = 0; i < $3->size(); i++ ){
		   mString *methodName = $3->at( i );
                             
		   // now we check for parameterless method
		   // 'methodName' in class 'domain'
		   mMethod *m = domain->getMethod( methodName );
                             
		   if( !m ){

		     myerror();
		     if(domain->ambiguous)
		       cout<<"ambiguous invocation of method '"<<*methodName<<"'"<<endl;
		     else
		       cout<<"method '"<<*methodName<<"' not found in class '"
			   <<*domain->name<<"'"<<endl;
		     currentFieldTree = 0;
		     break;

		   }


		   // check access privileges for this method
		   if( !m->isAccessibleWithin( env->ownerClass ) ){
		     myerror();
		     cout<<"method '"<<*methodName<<"' cannot be invoked"<<endl
			 <<"because of insufficient privileges"<<endl;
		     currentFieldTree = 0;
		     break;
		   }


		   // generate tree for method call and append it
		   // to parent
		   mParseTree *call = new mParseTree( NODE_METHODCALL, m );
		   current->append( call );
		   current = call;
                             
		   // domain for next call is return type of this method
		   domain = m->returnType;
		 }
                 
		 // returnType of variable in sequence calls must be set to returnType
		 // of last method invoked, i.e. in an invocation sequence meth1.meth2.meth3
		 // the returnType becomes that of meth3
		 if(currentFieldTree) currentFieldTree->returnType = domain;

                 $$ = currentFieldTree;
               }





               | FieldAccess ArrayAccess {

                   // do nothing if just importing
		   if( importing ) break;

                   mParseTree *meth = $1->getLastMethodNode();

                   //mClass *domain = ((mMethod*)meth->symbol)->returnType;

                   // we just put in last method 
		   mParseTree *array = new mParseTree( NODE_ARRAYACCESS, meth->symbol );
		 
		   // append access expressions
		   array->append( $2 );

		   meth->append( array );


		   // UNFINISHED: je $1->returnType ze nastavljen na returnType zadnje metode?

		   //$1->returnType = $2->returnType


		   $$ = $1;
	       }
               | FieldAccess ArrayAccess '.' QualifiedIdentifier {

		   // do nothing if just importing
		   if( importing ) break;
                   
		   mParseTree *meth = $1->getLastMethodNode();

                   mClass *domain = ((mMethod*)meth->symbol)->returnType;

                   // we just put in last method 
		   mParseTree *array = new mParseTree( NODE_ARRAYACCESS, meth->symbol );
		 
		   // append access expressions
		   array->append( $2 );

		   meth->append( array );

		   // and the rest...
		   //array->append( $4 );

		   mParseTree *current = array;

                 // now generate parameterless method calls
                 for(unsigned i = 0; i < $4->size(); i++ ){
                     mString *methodName = $4->at( i );
                             
                     // now we check for parameterless method
                     // 'methodName' in class 'domain'
                     mMethod *m = domain->getMethod( methodName );
                             
                     if( !m ){
		       
		       myerror();
		       cout<<"method '"<<*methodName<<"' not found in class '"
			   <<*domain->name<<"'"<<endl;
		       break;

                     }

                     // generate tree for method call and append it
                     // to parent
                     mParseTree *call = new mParseTree( NODE_METHODCALL, m );
                     current->append( call );
                     current = call;
                             
                     // domain for next call is return type of this method
                     domain = m->returnType;
		 }
 
		   $$ = $1;
	       }
               | FieldAccess ArrayAccess '.' QualifiedIdentifier '(' Arguments ')' {


		   // do nothing if just importing
		   if( importing ) break;

                   mParseTree *meth = $1->getLastMethodNode();

                   mClass *domain = ((mMethod*)meth->symbol)->returnType;

                   // we just put in last method 
		   mParseTree *array = new mParseTree( NODE_ARRAYACCESS, meth->symbol );
		 
		   // append access expressions
		   array->append( $2 );

		   meth->append( array );

		   mParseTree *current = array;

		   // now generate parameterless method calls
		   for(unsigned i = 0; i < $4->size() - 1; i++ ){
                     mString *methodName = $4->at( i );
                             
                     // now we check for parameterless method
                     // 'methodName' in class 'domain'
                     mMethod *m = domain->getMethod( methodName );
                             
                     if( !m ){

		       myerror();
		       cout<<"method '"<<*methodName<<"' not found in class '"
			   <<*domain->name<<"'"<<endl;
		       break;

                     }

                     // generate tree for method call and append it
                     // to parent
                     mParseTree *call = new mParseTree( NODE_METHODCALL, m );
                     current->append( call );
                     current = call;
                             
                     // domain for next call is return type of this method
                     domain = m->returnType;
		 }

		 // now we deal with the last one
		 mString *methodName = $4->at( $4->size() - 1 );

		 bool ambiguous = false;
                             
		 // now we check for method with parameters
		 // 'methodName' in class 'domain'
		 mMethod *m = domain->getMethod( methodName, $6, true, ambiguous );
                             
		 if( !m ){

		   myerror();
		   cout<<"method '"<<*methodName<<"' not found in class '"
		       <<*domain->name<<"'"<<endl;

		 }else{


		   if( !$6->performArgumentsCast($6, m ) ){

		     myerror();
		     cout<<"cannot perform cast to call method '"<<*m->name<<"'"<<endl;
		     currentMethodTree = 0;
		     $$ = 0;
		     break;

		   }

		   // generate tree for method call and append it
		   // to parent
		   mParseTree *call = new mParseTree( NODE_METHODCALL, m );
		   current->append( call );

		   // add arguments
		   call->append( $6 );
		 }                                 

		   $$ = $1;
	       }
               ;

//    -----------------
//   | NODE_ARRAYACCESS| 
//    -----------------
//     /            \ opt
//    /              \
// ---------------   ---------------
//| NODE_ARGUMENTS| |NODE_METHODCALL|
// ---------------   ---------------


ArrayAccess:  '[' Expression ']' {

                // do nothing if just importing
                if( importing ) break;

                // create ARGUMENTS node (for every dimension)
		mParseTree *expr = new mParseTree( NODE_ARGUMENTS ); 
		expr->append( $2 );
		$$ = expr;  

              }

              | ArrayAccess '[' Expression ']'  {

		 // do nothing if just importing
		 if( importing ) break;

	         $1->append( $3 );
		 $$ = $1;
              }
              ;



// arguments may be actual arguments or formal parameters in case of method update
Arguments:     JustArguments
               | MethodParameterList {

		// do nothing if just importing
		if( importing ) break;

		if(!allowParameters){
		  myerror();
		  cout<<"cannot pass parameters like this"<<endl;
		  $$ = 0;
		  break;

		}

		cout<<"got parameter list instead of arguments"<<endl;

		mParseTree *args = new mParseTree( NODE_ARGUMENTS ); 

		// append all parameters
		for( mParameter* param = $1->first(); param != 0; param = $1->next() ){

		  args->append( new mParseTree(NODE_PARAMETER, param) );

		}
		
		$$ = args;


               }
             ;

JustArguments:   Expression {

		// do nothing if just importing
		if( importing ) break;


		// check whether expression is a block containing return
		if($1->closureReturns()){
		  myerror();
		  cout<<"cannot return from escapable block"<<endl;
		  break;
		}

		// check whether expression is a block containing assignment to parent
		// variable
		if($1->closureAssignsToParent()){
		  myerror();
		  cout<<"cannot assign to parent variable from escapable block"<<endl;
		  break;
		}
		
		
		// create arguments node
		mParseTree *args = new mParseTree( NODE_ARGUMENTS ); 
		args->append( $1 );
		$$ = args;
            }
            | JustArguments ','  Expression {

	      // do nothing if just importing
	      if( importing ) break;


	      // check whether expression is a block containing return
	      if($3->closureReturns()){
		myerror();
		cout<<"cannot return from escapable block"<<endl;
		break;
	      }

	      // check whether expression is a block containing assignment to parent
	      // variable
	      if($3->closureAssignsToParent()){
		myerror();
		cout<<"cannot assign to parent variable from escapable block"<<endl;
		$$ = 0;
		break;
	      }
	      
	      $1->append( $3 );
	      $$ = $1;
            }
            ;

            
// object creation with 'new'


                // parameterless constructor
NewExpression:  NEW QualifiedIdentifier {

	          // do nothing if just importing
	          if( importing ) break;


		  mClass* theType = mUtil::getQualifiedType( $2, root );

                  if( theType != 0 ){
                    // create construction node
                    mParseTree *con = new mParseTree( NODE_CONSTRUCTION, theType );

                    // object is created by calling constructor. find parameterless
                    // constructor for class theType


                    mMethod* constructor = theType->getDefaultConstructor();
              
                    if( !constructor ){
                      myerror();
                      cout<<"i need a default constructor to construct '"
                          <<*theType->name<<"' like this"<<endl;
                      $$ = 0;
                    }else{

                      mParseTree *call = new mParseTree( NODE_METHODCALL,
                                                         constructor );
                      con->append( call );
		      con->returnType = theType;
                      $$ = con;
                    }
                  }else{

		    // erroneous type
		    myerror();
		    cout<<"no suitable type '"<<mUtil::getQualifiedTypeName($2)<<"'"<<endl;
		    $$ = 0;
		  }
                }


                 // with parameters
               | NEW QualifiedIdentifier '(' JustArguments ')' {

                 // do nothing if just importing
		 if( importing ) break;


		 mClass* theType = mUtil::getQualifiedType( $2, root );

		 if( theType != 0 ){
                    // create construction node
                    mParseTree *con = new mParseTree( NODE_CONSTRUCTION, theType );

		    bool ambiguous = false;

                    // constructor is a method with the same name as the class
		    // search only this class (not superclasses)
                    mMethod* constructor = theType->getMethod( theType->name, $4, false, ambiguous );
              
		    //cout<<"searching for constructor "<<$4->toString()<<endl;

                    if( !constructor ){
                      myerror();
		      if( theType->ambiguous )
			cout<<"constructor invocation is ambiguous"<<endl;
		      else
			cout<<"no suitable constructor to construct '"
			    <<*theType->name<<"' like this"<<endl;
                      $$ = 0;
		      break;

                    }else{

		      if( !$4->performArgumentsCast($4, constructor ) ){

			myerror();
			cout<<"cannot perform cast to call method '"<<*constructor->name<<"'"<<endl;
			$$ = 0;
			break;

		      }

                      mParseTree *call = new mParseTree( NODE_METHODCALL,
                                                         constructor );
		      // append arguments
		      call->append( $4 );

                      con->append( call );
		      con->returnType = theType;		      
                      $$ = con;
                    }
		 }else{

		   // erroneous type
		   myerror();
		   cout<<"no suitable type '"<<mUtil::getQualifiedTypeName($2)<<"'"<<endl;
		   $$ = 0;
		 }
               }
               ;


%%

/*void dumperr(char const *format,...)
{
 va_list arg;

 char *buff = new char[strlen(format)+4096];

 va_start(arg,format);
 vsprintf(buff,format,arg);
 va_end(arg);

 cout<<"error: "<<buff<<endl;
 delete[] buff;
 //exit(1);
}

void dumpwarn(char const *format,...)
{
 va_list arg;

 char *buff = new char[strlen(format)+4096];

 va_start(arg,format);
 vsprintf(buff,format,arg);
 va_end(arg);

 cout<<"warning: "<<buff<<endl;
 delete[] buff;
}*/


// parse error
int yyerror(char *s){

  cout<<"["<<*currentBufferName<<"] line "<<yylineno<<": "<<s<<" before '"<<yytext<<"'";
  numErrors++;
  return 0;
}

int myerror()
{
  cout<<"["<<*currentBufferName<<"] line "<<yylineno<<": error:  ";
  numErrors++;
  return 0;
}

int myerrorBefore()
{
  cout<<"line "<<yylineno<<": error before '"<<yytext<<"': ";
  numErrors++;
  return 0; 
}

 



// imports class. fileName is classname (not filename!), isThis is true if importing our own class
void importClass(ImportBuffer& buffer, bool isThis)
{  
 
  if( buffer.open ) return;   // already open?

  buffer.open = true;

  if(!isThis){
    
    // filename is classname + ".z0"
    
    // this is for classes in current directory
    mString fileName (*buffer.className);
    fileName += ".z0";
    
    // switch to external file
    if( !switchBuffer( &fileName ) ){

      numErrors++;
      cout<<"cannot open file '"<<fileName<<"' for reading"<<endl;
      return;

    }
  }
  
  
  // add this class to stack
  //importFiles->push( new mString(className) );

  importing = true;

}




// preparses class adding it to root environment. used to perform import of all
// classes included by default: Class, Method, ...
void preparseClass(mString* name)
{


  // check if class already in environment
  if( root->getDeclaredClass( name ) != 0 ) return;


  mString fileName = *name + ".z0";  

  currentBufferName = new mString( fileName );

  
  FILE* fp;

  if((fp=fopen(fileName,"r"))==0){
      cout<<"cannot open "<<fileName<<endl;
      exit(1);
  }
  
  yyin=fp;   // redirect from file

  

  ImportBuffer* buff = new ImportBuffer( name );

  importFiles->push( buff );
  // preparsing is always as if parsing own class (true), because we parse it from 
  // different files
  importClass( *buff, true );


  // add this class to root 
  mClass* theClass = new mClass( new mString( *name ), ACCESS_PUBLIC );
  root->append( theClass );

  yyparse();   // parse definitions

  //
  //importing = false;
  
}




int main(int argc, char **argv)
{

  FILE *fp=0;
  if(argc < 2){
     cout<<"no input file"<<endl;
     exit(1);
  }



  //////////////////////////////////////////////////////////////////////
  // check passed options
  //////////////////////////////////////////////////////////////////////
  
  mOptions options;

  int coption;
  
  int option_index = 0;

  
  option long_options[] = {
    {"addObjectSize", 1, 0, 'a'},  // --addObjectSize=x  or -a x
    {"path", 1, 0, 'p'},           // --path=x  or -p x
    {0, 0, 0, 0}
  };

  
  
  while( true ){

    coption= getopt_long (argc, argv, "a:p:", long_options, &option_index);

    if( coption == -1) break;  // no more options


    switch( coption ){              

    case 'a': 
      options.additionalObjectSize = atoi(optarg);
      break;

    default:
      cout<<"unrecognised option "<<long_options[option_index].name<<endl;
      break;

    }   // switch    
  }  // while true


  // check non option arguments placed at the end by getopt  - the filename
  if (optind < argc) { 
    thisClassFile = argv[optind];
  }
  

  //////////////////////////////////////////////////////////////////////
  // end of options
  //////////////////////////////////////////////////////////////////////




  // check if filename is valid, that is: Classname.z0
  if( !mUtil::fileNameValid(&thisClassFile) ){
    cout<<"invalid filename '"<<thisClassFile<<"'"<<endl;
    exit(1);
  }
  

  // create new type stack
  typeStack = new mStack<mClass>();

  // create new method stack
  methodStack = new mStack<mMethod>();


  // create expression stack
  expressionStack = new mStack<mParseTree>();

  // create new environment stack
  envStack = new mStack<mEnvironment>();
  //envStack->setAutoDelete( true );

  // create root environment
  root = new mEnvironment(ENVIRONMENT_ROOT, new mString( "root" ), 0, 0);
  root->createBuiltinClasses();


  // add classes that are imported by default (meta classes: Class, Method; System class,  
  // wrappers: WString, WInteger,... like java.lang)
  // but for now, we just have to import every class that we need explicitly
  // root->addDefaultClasses( "classes.zip" );  // only .class files, not .z0 files


  envStack->push( root );  

  
  // create new literal list
  literalList = new mList<mSymbol>();
  //literalList->setAutoDelete( true );  
  

  importFiles = new mStack<ImportBuffer>();
  importFiles->setAutoDelete( false /* true*/ ); 



  /////////////////////////////////////////////////////////////////
  // 1st pass is as if our own class is being imported
  /////////////////////////////////////////////////////////////////  
  


  mString ourClassName = mUtil::classNameFromFile(&thisClassFile);

  thisClassName = mUtil::classNameFromFile(&thisClassFile);


  ///////////////////////////////////////////////////////////////////
  // preparse default classes (later default.zip)

  preparseClass( new mString( "Class" ) );
  preparseClass( new mString( "Method" ) );
  ///////////////////////////////////////////////////////////////////
    

  if(root->getClassEnvironment( &ourClassName ) == 0)
    preparseClass( &ourClassName );

        

  /////////////////////////////////////////////////////////////////
  // 2nd pass if there were no errors in 1st pass
  /////////////////////////////////////////////////////////////////
    

  
  if( numErrors == 0 ){    

    // now reopen and start real parsing
    if((fp=fopen(thisClassFile,"r"))==0){
      cout<<"cannot open "<<thisClassFile<<endl;
      exit(1);
    }

    

    // add methods that need external classes for their arguments or return types
    root->updateBuiltinClasses();





    currentBufferName = &thisClassFile;

    yyin=fp;     // redirect from file
    yylineno=1;  // wrap line number    

  
    yyparse();   // full parse
        
    //fclose(fp);

  }


  delete typeStack;
  delete methodStack;
  delete expressionStack;


  // if there were some errors we quit
  if( numErrors == 0 ){


    // calculate literal offsets
    mLiteral::calculateLiteralAddresses( literalList );

    // connect literals to our main class
    mainClass->literalList = literalList;
    mainClass->options = &options;
    


    // generate code for our class
    mainClass->evaluate();

    
    dumper = new mClassDumper( mainClass );


    /*
    
    
    // dump class info
    mEnvironment *env = envStack->top();


    cout<<env->toString()<<endl;    

    
    
    
    // show method table
    cout<<" ******** METHOD TABLE *********"<<endl;
    cout<<mainClass->methodTable->toString()<<endl;
    */  
    


    // dump to class file
    dumper->dump();
    

    delete dumper;    
  

    
    /*
    cout<<"--- literal pool ---"<<endl;
    for(mSymbol *c =  literalList->first(); c != 0; c = literalList->next()){
      if( ! ((mLiteral*)c)->special )
	cout<<c->toString()<<endl;
    }
    */
    
  }

   


  
  importFiles->setAutoDelete(true);
  delete importFiles;
  
  //delete currentBufferName;
  //delete thisClassName;

  
  // now we want them deleted
  envStack->setAutoDelete(true);
  delete envStack;

  delete literalList;


  
}

