#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 38 "parser.y"
  /* includes*/
#include <iostream>
#include <stdio.h>
#include <math.h>
#include <getopt.h>

#include "mString.h"
#include "mGlobals.h"
#include "mLiteral.h"
#include "mParameter.h"
#include "mParseTree.h"
#include "mCode.h"
#include "mEnvironment.h"
#include "mStack.h"
#include "mClassDumper.h"
#include "mClassBuilder.h"
#include "mUtil.h"
#include "mClassExtension.h"
#include "mOptions.h"
#include "mMethodClass.h"


using namespace std;

/* our stdin*/
extern FILE* yyin;

/* our current filename*/
extern mString* currentBufferName;
mString thisClassFile;

/* read token*/
extern char* yytext;

/* current line number in source*/
extern int yylineno;

/* parser*/
extern int yyparse();

/* lexer*/
extern int yylex();

/* switches to another buffer*/
extern bool switchBuffer(mString*);

/* transfers control back to old buffer*/
extern bool deleteBuffer();

/* our error routine*/
int myerror();

/* number of errors after parsing should be 0 to continue with code generation*/
int numErrors = 0;

/* true if error in expression */
bool expressionError = false;

/* true if error in method */
bool methodError = false;


/* the dumper*/
mClassDumper *dumper;


/* environment stack*/
mStack<mEnvironment> *envStack;

/* we declare topmost environment for efficiently accessing classes which*/
/* reside (currently) only in this environment*/
mEnvironment *root;


/* type stack*/
mStack<mClass> *typeStack;

/* current method stack*/
mStack<mMethod> *methodStack;


/* partial expression stack*/
mStack<mParseTree> *expressionStack;

/* true if updating. */
bool performingUpdate = false;


/* true if formal parameters are allowed in method invocation expression*/
bool allowParameters = !false;



/* import stuff*/

/* import buffer has classname and fp*/
class ImportBuffer{
 public:
  ImportBuffer(mString* cname){ className = new mString(*cname); open=false; }
  virtual ~ImportBuffer(){ delete className; }
  mString* className;
  bool open;
};

/* stack of import files*/
mStack<ImportBuffer> *importFiles;

/* this is true when importing a class*/
bool importing = false;

mString thisClassName;
/*bool firstTime=true;*/

/*/////////////////////// literals realted stuff //////////////////////////*/

/* literal list*/
mList<mSymbol> *literalList;

/* the offset of next literal in constant pool*/
int currentLiteralOffset = 0;


/* variable declarations use synthesised attrs*/
mClass *currentType, *mainClass;

/* method currently being compiled*/
mMethod *currentMethod=0;

/* this is the partial expression (used at invocation on expressions and literals)*/
mParseTree* partialExpression = 0;


/* true if Self type*/
bool isSelfType = false;

bool start=true;

/* this is used in FieldReference and MethodAccess*/
mParseTree  *currentMethodTree,*currentFieldTree;  /* blah*/

#line 180 "parser.y"
typedef union{
  int                      intVal;
  double                   doubleVal;
  mString*                 stringVal;
  mList<mString>*          stringList;
  mClass*                  classVal;
  /*mField*                  fieldVal;*/
  /*mList<mField>*           fieldListVal;*/
  /*mMethod*                 methodVal;*/
  mVariable*               variableVal;
  mLiteral*                literalVal;
  mCode*                   codeVal;
  mParseTree*              treeVal;
  mList<mClassExtension>*  extensionList;
  mList<mClass>*           classList;
  /*mParameter*              parameterVal;*/
  mList<mParameter>*       parameterListVal;
  /*mLocalDefinition*        localDefinitionVal;*/
  /*mList<mLocalDefinition>* localDefinitionListVal;*/
  /*mSymbol*                 symbolVal;*/
/*  mEnvironment*            environmentVal;*/

} YYSTYPE;
#line 182 "y.tab.c"
#define YYERRCODE 256
#define CATEGORY 257
#define USE 258
#define CLASS 259
#define FIELD 260
#define METHOD 261
#define IS 262
#define INHERITS 263
#define IMPLEMENTS 264
#define PUBLIC 265
#define PRIVATE 266
#define PROTECTED 267
#define RESTRICTED 268
#define NATIVE 269
#define STATIC 270
#define CONSTRUCTOR 271
#define DESTRUCTOR 272
#define THIS 273
#define SUPER 274
#define AS 275
#define RETURN 276
#define WHILE 277
#define DO 278
#define IF 279
#define THEN 280
#define ELSE 281
#define FOR 282
#define BYTE 283
#define CHAR 284
#define SHORT 285
#define INT 286
#define LONG 287
#define FLOAT 288
#define DOUBLE 289
#define STRING 290
#define VOID 291
#define BOOLEAN 292
#define SELF 293
#define TRUE 294
#define FALSE 295
#define NIL 296
#define NEW 297
#define METHODTYPE 298
#define OP_EQ 299
#define OP_NOT_EQ 300
#define OP_GREATER_OR_EQ 301
#define OP_LESS_OR_EQ 302
#define OP_AND 303
#define OP_OR 304
#define OP_METHODASSIGN 305
#define OP_ADDASSIGN 306
#define OP_DECASSIGN 307
#define OP_MULASSIGN 308
#define OP_DIVASSIGN 309
#define OP_INCREMENT 310
#define OP_DECREMENT 311
#define INTEGER_LITERAL 312
#define DOUBLE_LITERAL 313
#define STRING_LITERAL 314
#define IDENTIFIER 315
const short yylhs[] = {                                        -1,
   51,   51,   30,   30,   24,   24,   24,   24,   24,   24,
    0,    0,   52,   52,   52,   53,   54,   54,   31,   31,
   56,   55,   39,   39,   37,   37,   36,   36,   38,   38,
   57,   57,   58,   59,   59,   62,   60,   63,   61,   34,
   34,   35,   35,   33,   33,   32,   32,   23,   23,   23,
   23,   23,   29,   29,   50,   50,   49,   49,   64,   64,
   65,   48,   48,   66,   21,   21,   41,   41,   40,   40,
   22,   22,   11,   11,   12,   12,   12,   12,   12,   12,
   15,   16,   18,   17,   17,   17,   25,   25,   25,   25,
   25,   26,   26,   26,   26,   26,   26,   26,   26,   26,
   26,   28,   28,   19,   19,    1,    2,    2,    2,    2,
    2,    2,   67,    2,   68,   20,   27,   27,    9,    9,
    9,    9,   10,   10,   10,   10,   10,   10,   10,    5,
    5,    5,    3,    3,    3,    3,    7,    7,    7,    7,
    8,    8,    8,    6,    6,    6,    6,   69,    6,   70,
    6,    6,   14,   14,   43,   45,   71,   44,   72,   44,
   44,   46,   46,   46,   46,   46,   47,   47,   42,   42,
    4,    4,   13,   13,
};
const short yylen[] = {                                         2,
    1,    1,    1,    3,    1,    1,    1,    1,    1,    1,
    1,    2,    1,    1,    1,    3,    3,    2,    1,    3,
    0,    7,    0,    1,    1,    2,    2,    2,    1,    3,
    1,    2,    1,    1,    1,    0,    8,    0,    6,    0,
    3,    2,    4,    0,    1,    1,    2,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    3,    6,    0,    1,
    0,    2,    2,    0,    4,    1,    1,    3,    1,    3,
    2,    1,    3,    2,    1,    1,    1,    1,    1,    1,
    3,    4,    5,    4,    6,    6,    1,    1,    1,    5,
    3,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    3,    1,    1,    1,    1,    3,    3,    3,
    3,    3,    0,    4,    0,    5,    0,    2,    1,    2,
    3,    3,    1,    3,    3,    3,    3,    3,    3,    1,
    3,    3,    1,    3,    3,    3,    1,    3,    2,    2,
    1,    3,    3,    1,    1,    1,    1,    0,    4,    0,
    6,    1,    1,    1,    1,    1,    0,    5,    0,    7,
    2,    1,    3,    2,    4,    7,    3,    4,    1,    1,
    1,    3,    2,    5,
};
const short yydefred[] = {                                      0,
    0,    0,    0,    0,    0,   11,   13,   14,   15,   18,
    3,    0,    0,    0,    0,   12,    2,    1,    0,   16,
    0,   17,    0,    0,   25,    0,   21,    4,    0,    0,
    0,    0,   26,    0,    0,    0,    0,   52,   48,   50,
   49,   51,    0,    0,   31,   33,   34,   35,   53,   54,
   46,    0,    0,   22,   32,   47,    0,    0,    0,   92,
   93,   94,   95,   96,   97,   98,   99,  100,  101,   88,
    0,    0,   87,    0,    0,    0,    0,    0,    0,   42,
    0,   41,   36,   56,    0,   55,   39,   91,  102,    0,
    0,    0,    0,    0,    0,    0,    0,   43,   37,    0,
    0,    0,    0,    0,    0,    8,    9,   10,    0,    5,
    6,    7,    0,    0,    0,    0,  106,    0,    0,  141,
    0,    0,    0,    0,   72,  152,  147,   75,   76,   78,
   77,    0,   80,   63,   66,    0,   64,    0,    0,    0,
    0,    0,   79,    0,   62,  103,    0,   90,    0,    0,
    0,   74,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  145,  146,   71,    0,    0,    0,
    0,    0,  139,  140,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  113,  148,    0,  157,    0,    0,
    0,    0,    0,  118,  115,   73,   81,    0,    0,    0,
    0,  109,  110,  111,  112,  108,    0,    0,    0,    0,
    0,    0,    0,  142,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   67,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   82,    0,    0,  171,    0,
  150,  114,  149,  154,  153,    0,    0,   65,    0,    0,
    0,  159,  167,    0,    0,    0,   58,  116,    0,   83,
    0,  174,    0,   70,   68,  158,    0,  168,    0,    0,
   86,   85,  172,  151,    0,    0,  160,  166,
};
const short yydgoto[] = {                                       5,
  239,  117,  118,  249,  119,  120,  121,  122,  123,  124,
  125,  126,  127,  243,  128,  129,  130,  131,  132,  133,
  134,  135,   43,  136,   72,   73,  148,   90,   51,  151,
   14,   52,   53,   59,  250,   25,   26,   31,   27,  226,
  227,  251,  139,  140,  141,  142,  191,   93,  143,   87,
   20,    6,    7,    8,    9,   34,   44,   45,   46,   47,
   48,   92,   77,   94,   95,  187,  223,  235,  224,  263,
  228,  267,
};
const short yysindex[] = {                                   -133,
   42, -232, -232, -221, -133,    0,    0,    0,    0,    0,
    0,   -9,   64,  -40, -251,    0,    0,    0, -184,    0,
 -232,    0, -232, -232,    0, -251,    0,    0,   64,   64,
   92,   92,    0,   21, -232, -147,   64,    0,    0,    0,
    0,    0, -210,  -76,    0,    0,    0,    0,    0,    0,
    0, -210, -181,    0,    0,    0,  107,  334,   91,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    6, -154,    0,   64,  -10,  334,  -36,  334,  334,    0,
  334,    0,    0,    0,    0,    0,    0,    0,    0,   24,
 -151,  -36,    7,   43,    7,  334,  109,    0,    0,  107,
   89,   47,   47,   47,   47,    0,    0,    0, -232,    0,
    0,    0,   72,   95,  230,  -54,    0,   90,   68,    0,
  -86, -104, -187,  176,    0,    0,    0,    0,    0,    0,
    0, -131,    0,    0,    0,  130,    0,   23,    0,    5,
    0,   86,    0,  133,    0,    0,  334,    0,  109,  -54,
   23,    0,   47,  -96,  -93,   47,   35,   95,   95,   95,
   95,   95,  152,  176,    0,    0,    0,  230,  230,  230,
  230,  230,    0,    0,  230,  334,  230,  230,  230,  230,
  230,  230,  230,  230,    0,    0, -121,    0, -232,   95,
  106,   16, -232,    0,    0,    0,    0,   47,   47,   47,
   95,    0,    0,    0,    0,    0,  159,  -86,  -86,  -86,
   90,   90, -104,    0,  176,  176,   68,   68,   68,   68,
   68,   68,  -63, -232,  147,    0,  -23,   46,   38,  116,
   95, -232,   23,   15,   47,    0,  -71,   47,    0,   58,
    0,    0,    0,    0,    0,   95, -121,    0,  167,  169,
  186,    0,    0,  137,   45, -232,    0,    0, -114,    0,
   95,    0, -232,    0,    0,    0,   46,    0,   46,   38,
    0,    0,    0,    0,  190,  191,    0,    0,
};
const short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  -15,    0,  114,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  143,    0,    0,  -14,  -43,
 -112, -101,    0,    0,    0,    0,  -41,    0,    0,    0,
    0,    0,  -37,    0,    0,    0,    0,    0,    0,    0,
    0,   -7,    0,    0,    0,    0,  -20,    0,  -18,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  388,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -33,    0,    0,    0,    0,    0,
    0,    0,  181,    0,    0,    0,  425,    0,    0,  -56,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  113,    0,    0,    0,    0,  777,  155,    0,
  -27,  141,  -17,  -16,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1081,    0,  455,  702,  886,
  923,  981,    0,  513,    0,    0,    0,    0,  193,    0,
  552,    0,    0,    0,    0,    0, 1121,    0,    0,    0,
    0,    0,    0,  305,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  611, 1023,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1158,   11,  541, 1310,
 1436, 1445, 1252,    0,  430,  572, 1335, 1349, 1505, 1527,
 1533, 1562,    0,    0,   13,    0,    0,    0,  788,    0,
    0,    0,    0,    0,    0,    0, 1216,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  268,  276,
    0,    0,    0,    0,  846,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
const short yygindex[] = {                                      0,
  476,  376,  -26,  117,  349,    0,  -30,  151,    0,  -89,
    0,    0,    0,   84,    0,    0,   93,    0,    0,  104,
  253,    0,    0,    0,   19,    0,  202,    0,  302, 1452,
    0,    0,    0,  255,  299,  336,    0,  339,    0,  118,
    0, -126, 1587,  177, 1616,    0,  233,    0, 1432,  284,
   -8,  377,    0,    0,    0,    0,    0,  343,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,
};
#define YYTABLESIZE 1879
const short yytable[] = {                                      61,
   29,   40,   30,   21,   18,   22,   61,  175,   85,  133,
   27,   23,   24,  133,  133,  133,  133,  133,   18,  133,
  247,   28,   84,  107,  119,  164,  107,  119,   19,   20,
   82,  133,  133,   81,  133,   18,   19,   40,   40,  115,
   38,  107,  119,   19,   20,   79,  114,  134,   54,   18,
  189,  134,  134,  134,  134,  134,   69,  134,   49,   50,
  256,  232,  188,   78,   97,  133,   40,   96,   19,  134,
  134,   69,  134,   18,  201,  107,  119,  252,  115,   29,
   19,   30,   11,   19,  269,  114,   85,  215,  216,   61,
   19,   59,  152,   15,   83,  190,   88,   89,  262,   91,
   10,  261,   40,  134,   38,  190,  231,  167,   38,   19,
  171,  137,  172,  137,  146,  177,  178,   39,   40,   41,
   42,  115,    1,    2,    3,    4,  170,  115,  114,   85,
   28,  168,  162,   57,  114,   35,  169,  208,  209,  210,
  275,  196,  276,   36,  211,  212,   58,   18,   76,    3,
   27,   27,    3,    3,    3,    3,    3,    3,    3,    3,
   80,   28,   28,   98,  104,  194,  147,  144,   85,   85,
  176,    3,    3,  185,    3,  186,  190,  137,  193,   38,
  198,  137,  137,  137,  137,  137,  199,  137,   39,   40,
   41,   42,  207,  225,  214,  123,  231,  100,  123,  137,
  137,   17,  137,    3,  241,    3,    3,  246,  253,  259,
  261,   85,   81,  123,  123,   17,  123,   85,  248,   29,
   29,   30,   30,  173,  174,  257,  266,   61,  133,  268,
  277,  278,   17,  137,  137,  183,   23,  184,  107,  119,
   19,   20,   61,   61,   61,   61,   17,  123,   61,   61,
   61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
   61,   61,   61,   61,   61,   24,  134,  100,   69,  114,
   17,  133,  133,  133,  133,  133,  133,   44,   61,   61,
   61,   61,  101,  102,  103,  104,  119,  119,  105,   60,
   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
  106,  107,  108,  109,   71,   60,  100,   45,  169,  134,
  134,  134,  134,  134,  134,  117,  170,  240,  110,  111,
  112,  113,  102,  103,  104,  213,  242,  105,   60,   61,
   62,   63,   64,   65,   66,   67,   68,   69,   70,  106,
  107,  108,  109,   71,   17,  120,  274,  145,  120,  100,
  195,  271,   85,   56,  149,  100,   75,  110,  111,  112,
  113,   33,   32,  120,  265,  102,  103,  104,    3,  234,
  105,  102,  103,  104,  192,   99,  105,  158,  159,  160,
  161,   16,  106,  107,  108,  109,   55,    3,  106,  107,
  108,  109,    0,    0,    0,    0,  137,  120,    0,    0,
  110,  111,  112,  113,    0,    0,  110,  111,  112,  113,
  123,    3,    3,    3,    3,    3,    3,    3,    0,    0,
    0,    0,    3,    3,   89,    0,    0,    3,   89,   89,
   89,   89,   89,    0,   89,    0,    0,    0,    0,  137,
  137,  137,  137,  137,  137,    0,   89,   89,    0,   89,
  137,  137,    0,  123,  123,  123,  123,  123,  123,    0,
    0,  117,    0,    0,    0,  117,  117,  117,  117,  117,
  121,  117,    0,  121,  179,  180,  181,  182,    0,    0,
   89,   89,    0,  117,  117,    0,  117,    0,  121,    0,
  100,  162,    0,    0,    0,  162,  162,  162,  162,  162,
    0,  162,    0,    0,    0,    0,  102,  103,  104,    0,
   89,  105,    0,  162,  162,    0,  162,  117,  117,    0,
    0,    0,  121,  106,  107,  108,  109,  217,  218,  219,
  220,  221,  222,  202,  203,  204,  205,  206,    0,    0,
    0,  110,  111,  112,   11,  162,    0,  117,  162,   57,
    0,    0,    0,   57,   57,   57,   57,   57,    0,   57,
  120,    0,    0,    0,    0,    0,    0,    0,  116,    0,
  116,   57,   57,    0,   57,    0,  150,  135,    0,    0,
    0,  135,  135,  135,  135,  135,    0,  135,  162,  163,
    0,    0,  162,  162,  162,  162,  162,    0,  162,  135,
  135,    0,  135,    0,    0,   57,   57,  120,  120,    0,
  162,  162,  122,  162,    0,  122,   60,   61,   62,   63,
   64,   65,   66,   67,   68,   69,   70,    0,    0,    0,
  122,   71,    0,  135,    0,   57,    0,   57,    0,    0,
    0,    0,  162,   89,  162,  162,    0,  161,   11,    0,
    0,  161,  161,  161,  161,  161,  161,  161,    0,    0,
    0,    0,   89,    0,  122,  230,    0,    0,    0,  161,
  161,    0,  161,    0,    0,    0,    0,    0,    0,    0,
  117,    0,    0,    0,    0,  121,   89,   89,   89,   89,
   89,   89,    0,    0,    0,    0,    0,   89,   89,  117,
    0,    0,   89,  161,  161,    0,  254,    0,    0,    0,
  162,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  264,    0,  117,  117,  117,  117,  117,  117,  162,
    0,    0,  121,  121,  117,  117,  273,    0,  145,  117,
    0,    0,  145,  145,  145,  145,  145,    0,  145,    0,
    0,    0,    0,  162,  162,  162,  162,  162,  162,  162,
  145,  145,    0,  145,  162,  162,    0,    0,   57,   89,
    0,    0,    0,    0,    0,    0,    0,   57,   57,   57,
   57,    0,    0,    0,    0,    0,    0,   57,    0,   57,
    0,    0,   57,   57,  145,  145,  135,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  162,    0,    0,
    0,   57,   57,   57,   57,   57,   57,  130,    0,  130,
  130,  130,   57,   57,  163,    0,  162,  122,  163,  163,
  163,  163,  163,    0,  163,  130,  130,    0,  130,  135,
  135,  135,  135,  135,  135,    0,  163,  163,    0,  163,
  162,  162,  162,  162,  162,  162,  162,    0,    0,    0,
    0,  162,  162,    0,    0,    0,  161,    0,    0,  130,
    0,    0,    0,    0,  122,  122,    0,    0,  163,    0,
  163,  163,  165,    0,    0,  161,  165,  165,  165,  165,
  165,    0,  165,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  165,  165,    0,  165,    0,  161,
  161,  161,  161,  161,  161,  161,    0,    0,    0,    0,
  161,  161,  155,    0,    0,    0,  155,  155,  155,  155,
  155,    0,  155,    0,    0,    0,  165,    0,  165,  165,
    0,    0,    0,    0,  155,  155,    0,  155,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  145,    0,  146,
    0,    0,    0,  146,  146,  146,  146,  146,    0,  146,
    0,    0,    0,    0,    0,    0,  145,    0,  155,  155,
    0,  146,  146,    0,  146,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  145,  145,  145,  145,  145,  145,  105,    0,    0,    0,
    0,  145,  145,    0,    0,  146,  146,  156,    0,    0,
    0,  156,  156,  156,  156,  156,    0,  156,    0,    0,
    0,    0,  130,    0,    0,    0,    0,    0,    0,  156,
  156,    0,  156,  163,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  164,
    0,    0,  163,  164,  164,  164,  164,  164,    0,  164,
    0,    0,    0,  156,  156,  130,  130,  130,  130,  130,
  130,  164,  164,    0,  164,    0,  163,  163,  163,  163,
  163,  163,  163,    0,    0,    0,    0,  163,  163,    0,
    0,  165,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  164,  164,  144,    0,    0,
  165,  144,  144,  144,  144,  144,    0,  144,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  144,
  144,  155,  144,    0,  165,  165,  165,  165,  165,  165,
  165,    0,    0,    0,    0,  165,  165,  173,    0,    0,
  155,  173,  173,  173,  173,  173,    0,  173,    0,    0,
    0,    0,    0,  144,  144,    0,    0,    0,  146,  173,
  173,    0,  173,    0,  155,  155,  155,  155,  155,  155,
  155,    0,    0,    0,  143,  155,  155,  146,  143,  143,
  143,  143,  143,    0,  143,    0,    0,    0,    0,    0,
    0,    0,    0,  173,  173,    0,  143,  143,    0,  143,
    0,  146,  146,  146,  146,  146,  146,  104,    0,    0,
    0,    0,  146,  146,    0,    0,  156,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  143,  143,   84,    0,    0,  156,   84,   84,   84,   84,
   84,    0,   84,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   84,   84,    0,   84,  164,  156,
  156,  156,  156,  156,  156,  156,    0,    0,  138,    0,
  156,  156,  138,  138,  138,  138,  138,  164,  138,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   84,   84,
  138,  138,    0,  138,    0,    0,    0,    0,    0,    0,
    0,  164,  164,  164,  164,  164,  164,  164,    0,    0,
    0,    0,  164,  164,    0,    0,  144,    0,    0,    0,
    0,    0,    0,    0,  138,  138,  136,    0,    0,    0,
  136,  136,  136,  136,  136,  144,  136,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  136,  136,
    0,  136,    0,    0,    0,  126,  173,    0,  126,  144,
  144,  144,  144,  144,  144,    0,    0,    0,    0,  127,
  144,  144,  127,  126,  126,  173,  126,    0,    0,    0,
    0,    0,  136,    0,    0,    0,    0,  127,  127,    0,
  127,    0,    0,  143,    0,    0,    0,    0,    0,  173,
  173,  173,  173,  173,  173,    0,    0,  126,    0,    0,
  173,  173,  143,    0,    0,    0,    0,    0,    0,    0,
    0,  127,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   12,   13,    0,  143,  143,  143,  143,
  143,  143,    0,    0,    0,    0,    0,  143,  143,    0,
    0,   84,   29,    0,   30,   30,  131,    0,  131,  131,
  131,    0,    0,    0,    0,  132,   37,  132,  132,  132,
   84,    0,    0,    0,  131,  131,    0,  131,    0,    0,
    0,    0,    0,  132,  132,    0,  132,  138,   86,   74,
    0,    0,    0,    0,   84,   84,   84,   84,   84,   84,
    0,    0,    0,   86,    0,   84,   84,   74,  131,   74,
   74,    0,   74,  153,  154,  155,  156,  132,    0,    0,
    0,    0,    0,    0,  138,  128,  138,   74,  128,    0,
  138,  138,  138,  138,  138,  138,    0,    0,    0,    0,
  157,  138,  138,  128,  128,  136,  128,  129,    0,    0,
  129,    0,    0,  124,    0,    0,  124,    0,    0,    0,
    0,    0,    0,    0,  197,  129,  129,  200,  129,    0,
  126,  124,  124,    0,  124,    0,    0,  128,   74,    0,
    0,    0,  125,    0,  127,  125,    0,    0,  136,  136,
  136,  136,  136,  136,    0,    0,    0,    0,    0,  129,
  125,  125,    0,  125,    0,  124,    0,   74,    0,  236,
  237,  238,    0,  126,  126,  126,  126,  126,  126,    0,
  229,    0,    0,    0,  233,    0,    0,  127,  127,  127,
  127,  127,  127,    0,  125,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  258,    0,    0,  260,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  138,
    0,    0,    0,  255,    0,    0,    0,    0,    0,    0,
  272,  131,    0,    0,    0,    0,    0,    0,    0,    0,
  132,  165,    0,    0,    0,    0,    0,  270,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  138,    0,
  138,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  166,    0,    0,    0,  131,  131,  131,  131,  131,  131,
    0,    0,    0,  132,  132,  132,  132,  132,  132,    0,
    0,    0,    0,    0,  165,  165,  165,  165,  165,    0,
  128,  165,    0,  165,  165,  165,  165,  165,  165,  165,
  165,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  129,  166,  166,  166,  166,  166,  124,    0,
  166,    0,  166,  166,  166,  166,  166,  166,  166,  166,
    0,    0,    0,  128,  128,  128,  128,  128,  128,    0,
  244,    0,    0,    0,    0,    0,    0,  125,    0,    0,
    0,    0,    0,    0,    0,  129,  129,  129,  129,  129,
  129,  124,  124,  124,  124,  124,  124,    0,    0,  245,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  244,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  125,  125,  125,  125,  125,  125,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  245,
};
const short yycheck[] = {                                      33,
   44,   58,   44,   44,   59,   14,   40,   94,  123,   37,
  123,  263,  264,   41,   42,   43,   44,   45,   59,   47,
   44,  123,   59,   41,   41,  115,   44,   44,   44,   44,
   41,   59,   60,   44,   62,   59,   46,   58,   59,   33,
   59,   59,   59,   59,   59,   40,   40,   37,  125,   59,
   46,   41,   42,   43,   44,   45,   44,   47,  269,  270,
   46,   46,   40,   58,   41,   93,  123,   44,   46,   59,
   60,   59,   62,   59,   40,   93,   93,   40,   33,  123,
   46,  123,  315,   46,   40,   40,  123,  177,  178,  123,
   46,  125,  101,  315,   76,   91,   78,   79,   41,   81,
   59,   44,  123,   93,  123,   91,   91,  116,  256,   46,
   43,   93,   45,   95,   96,  303,  304,  265,  266,  267,
  268,   33,  256,  257,  258,  259,   37,   33,   40,  123,
  315,   42,   61,  315,   40,   44,   47,  168,  169,  170,
  267,  150,  269,  123,  171,  172,   40,   59,   58,   37,
  263,  264,   40,   41,   42,   43,   44,   45,   46,   47,
  315,  263,  264,  315,  279,  147,   58,  125,  123,  123,
  275,   59,   60,  305,   62,   46,   91,   37,   46,  256,
  277,   41,   42,   43,   44,   45,  280,   47,  265,  266,
  267,  268,   41,  315,  176,   41,   91,  261,   44,   59,
   60,  256,   62,   91,   46,   93,   94,   61,   93,  281,
   44,  123,   44,   59,   60,  256,   62,  123,  227,  263,
  264,  263,  264,  310,  311,  234,   41,  261,  256,   93,
   41,   41,  256,   93,   94,   60,  123,   62,  256,  256,
  256,  256,  276,  277,  278,  279,  256,   93,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,  297,  298,  123,  256,  261,  256,   40,
  256,  299,  300,  301,  302,  303,  304,  315,  312,  313,
  314,  315,  276,  277,  278,  279,  303,  304,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,  297,  298,  125,  261,  315,   41,  299,
  300,  301,  302,  303,  304,  123,   41,  201,  312,  313,
  314,  315,  277,  278,  279,  175,  223,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,  297,  298,  256,   41,  263,   95,   44,  261,
  149,  259,  123,   52,  100,  261,   58,  312,  313,  314,
  315,   26,   24,   59,  247,  277,  278,  279,  256,  193,
  282,  277,  278,  279,  142,   92,  282,  306,  307,  308,
  309,    5,  294,  295,  296,  297,   44,  275,  294,  295,
  296,  297,   -1,   -1,   -1,   -1,  256,   93,   -1,   -1,
  312,  313,  314,  315,   -1,   -1,  312,  313,  314,  315,
  256,  299,  300,  301,  302,  303,  304,  305,   -1,   -1,
   -1,   -1,  310,  311,   37,   -1,   -1,  315,   41,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,  299,
  300,  301,  302,  303,  304,   -1,   59,   60,   -1,   62,
  310,  311,   -1,  299,  300,  301,  302,  303,  304,   -1,
   -1,   37,   -1,   -1,   -1,   41,   42,   43,   44,   45,
   41,   47,   -1,   44,  299,  300,  301,  302,   -1,   -1,
   93,   94,   -1,   59,   60,   -1,   62,   -1,   59,   -1,
  261,   37,   -1,   -1,   -1,   41,   42,   43,   44,   45,
   -1,   47,   -1,   -1,   -1,   -1,  277,  278,  279,   -1,
  123,  282,   -1,   59,   60,   -1,   62,   93,   94,   -1,
   -1,   -1,   93,  294,  295,  296,  297,  179,  180,  181,
  182,  183,  184,  158,  159,  160,  161,  162,   -1,   -1,
   -1,  312,  313,  314,  315,   91,   -1,  123,   94,   37,
   -1,   -1,   -1,   41,   42,   43,   44,   45,   -1,   47,
  256,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,
   95,   59,   60,   -1,   62,   -1,  101,   37,   -1,   -1,
   -1,   41,   42,   43,   44,   45,   -1,   47,   37,  114,
   -1,   -1,   41,   42,   43,   44,   45,   -1,   47,   59,
   60,   -1,   62,   -1,   -1,   93,   94,  303,  304,   -1,
   59,   60,   41,   62,   -1,   44,  283,  284,  285,  286,
  287,  288,  289,  290,  291,  292,  293,   -1,   -1,   -1,
   59,  298,   -1,   93,   -1,  123,   -1,  125,   -1,   -1,
   -1,   -1,   91,  256,   93,   94,   -1,   37,  315,   -1,
   -1,   41,   42,   43,   44,   45,   46,   47,   -1,   -1,
   -1,   -1,  275,   -1,   93,  190,   -1,   -1,   -1,   59,
   60,   -1,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  256,   -1,   -1,   -1,   -1,  256,  299,  300,  301,  302,
  303,  304,   -1,   -1,   -1,   -1,   -1,  310,  311,  275,
   -1,   -1,  315,   93,   94,   -1,  231,   -1,   -1,   -1,
  256,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  246,   -1,  299,  300,  301,  302,  303,  304,  275,
   -1,   -1,  303,  304,  310,  311,  261,   -1,   37,  315,
   -1,   -1,   41,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   -1,  299,  300,  301,  302,  303,  304,  305,
   59,   60,   -1,   62,  310,  311,   -1,   -1,  256,  315,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  265,  266,  267,
  268,   -1,   -1,   -1,   -1,   -1,   -1,  275,   -1,  277,
   -1,   -1,  280,  281,   93,   94,  256,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,   -1,   -1,
   -1,  299,  300,  301,  302,  303,  304,   41,   -1,   43,
   44,   45,  310,  311,   37,   -1,  275,  256,   41,   42,
   43,   44,   45,   -1,   47,   59,   60,   -1,   62,  299,
  300,  301,  302,  303,  304,   -1,   59,   60,   -1,   62,
  299,  300,  301,  302,  303,  304,  305,   -1,   -1,   -1,
   -1,  310,  311,   -1,   -1,   -1,  256,   -1,   -1,   93,
   -1,   -1,   -1,   -1,  303,  304,   -1,   -1,   91,   -1,
   93,   94,   37,   -1,   -1,  275,   41,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   59,   60,   -1,   62,   -1,  299,
  300,  301,  302,  303,  304,  305,   -1,   -1,   -1,   -1,
  310,  311,   37,   -1,   -1,   -1,   41,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   91,   -1,   93,   94,
   -1,   -1,   -1,   -1,   59,   60,   -1,   62,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,   -1,   37,
   -1,   -1,   -1,   41,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,  275,   -1,   93,   94,
   -1,   59,   60,   -1,   62,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  299,  300,  301,  302,  303,  304,  305,   -1,   -1,   -1,
   -1,  310,  311,   -1,   -1,   93,   94,   37,   -1,   -1,
   -1,   41,   42,   43,   44,   45,   -1,   47,   -1,   -1,
   -1,   -1,  256,   -1,   -1,   -1,   -1,   -1,   -1,   59,
   60,   -1,   62,  256,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   37,
   -1,   -1,  275,   41,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   -1,   93,   94,  299,  300,  301,  302,  303,
  304,   59,   60,   -1,   62,   -1,  299,  300,  301,  302,
  303,  304,  305,   -1,   -1,   -1,   -1,  310,  311,   -1,
   -1,  256,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   93,   94,   37,   -1,   -1,
  275,   41,   42,   43,   44,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,
   60,  256,   62,   -1,  299,  300,  301,  302,  303,  304,
  305,   -1,   -1,   -1,   -1,  310,  311,   37,   -1,   -1,
  275,   41,   42,   43,   44,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   93,   94,   -1,   -1,   -1,  256,   59,
   60,   -1,   62,   -1,  299,  300,  301,  302,  303,  304,
  305,   -1,   -1,   -1,   37,  310,  311,  275,   41,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   93,   94,   -1,   59,   60,   -1,   62,
   -1,  299,  300,  301,  302,  303,  304,  305,   -1,   -1,
   -1,   -1,  310,  311,   -1,   -1,  256,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   93,   94,   37,   -1,   -1,  275,   41,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   59,   60,   -1,   62,  256,  299,
  300,  301,  302,  303,  304,  305,   -1,   -1,   37,   -1,
  310,  311,   41,   42,   43,   44,   45,  275,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   94,
   59,   60,   -1,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  299,  300,  301,  302,  303,  304,  305,   -1,   -1,
   -1,   -1,  310,  311,   -1,   -1,  256,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   93,   94,   37,   -1,   -1,   -1,
   41,   42,   43,   44,   45,  275,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   60,
   -1,   62,   -1,   -1,   -1,   41,  256,   -1,   44,  299,
  300,  301,  302,  303,  304,   -1,   -1,   -1,   -1,   41,
  310,  311,   44,   59,   60,  275,   62,   -1,   -1,   -1,
   -1,   -1,   93,   -1,   -1,   -1,   -1,   59,   60,   -1,
   62,   -1,   -1,  256,   -1,   -1,   -1,   -1,   -1,  299,
  300,  301,  302,  303,  304,   -1,   -1,   93,   -1,   -1,
  310,  311,  275,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    2,    3,   -1,  299,  300,  301,  302,
  303,  304,   -1,   -1,   -1,   -1,   -1,  310,  311,   -1,
   -1,  256,   21,   -1,   23,   24,   41,   -1,   43,   44,
   45,   -1,   -1,   -1,   -1,   41,   35,   43,   44,   45,
  275,   -1,   -1,   -1,   59,   60,   -1,   62,   -1,   -1,
   -1,   -1,   -1,   59,   60,   -1,   62,  256,   77,   58,
   -1,   -1,   -1,   -1,  299,  300,  301,  302,  303,  304,
   -1,   -1,   -1,   92,   -1,  310,  311,   76,   93,   78,
   79,   -1,   81,  102,  103,  104,  105,   93,   -1,   -1,
   -1,   -1,   -1,   -1,   93,   41,   95,   96,   44,   -1,
  299,  300,  301,  302,  303,  304,   -1,   -1,   -1,   -1,
  109,  310,  311,   59,   60,  256,   62,   41,   -1,   -1,
   44,   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  153,   59,   60,  156,   62,   -1,
  256,   59,   60,   -1,   62,   -1,   -1,   93,  147,   -1,
   -1,   -1,   41,   -1,  256,   44,   -1,   -1,  299,  300,
  301,  302,  303,  304,   -1,   -1,   -1,   -1,   -1,   93,
   59,   60,   -1,   62,   -1,   93,   -1,  176,   -1,  198,
  199,  200,   -1,  299,  300,  301,  302,  303,  304,   -1,
  189,   -1,   -1,   -1,  193,   -1,   -1,  299,  300,  301,
  302,  303,  304,   -1,   93,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  235,   -1,   -1,  238,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  228,
   -1,   -1,   -1,  232,   -1,   -1,   -1,   -1,   -1,   -1,
  259,  256,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  256,  115,   -1,   -1,   -1,   -1,   -1,  256,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  267,   -1,
  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  115,   -1,   -1,   -1,  299,  300,  301,  302,  303,  304,
   -1,   -1,   -1,  299,  300,  301,  302,  303,  304,   -1,
   -1,   -1,   -1,   -1,  168,  169,  170,  171,  172,   -1,
  256,  175,   -1,  177,  178,  179,  180,  181,  182,  183,
  184,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  256,  168,  169,  170,  171,  172,  256,   -1,
  175,   -1,  177,  178,  179,  180,  181,  182,  183,  184,
   -1,   -1,   -1,  299,  300,  301,  302,  303,  304,   -1,
  224,   -1,   -1,   -1,   -1,   -1,   -1,  256,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  299,  300,  301,  302,  303,
  304,  299,  300,  301,  302,  303,  304,   -1,   -1,  224,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  263,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  299,  300,  301,  302,  303,  304,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  263,
};
#define YYFINAL 5
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 315
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'!'",0,0,0,"'%'",0,0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,0,0,
0,0,0,0,0,"':'","';'","'<'","'='","'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,"'['",0,"']'","'^'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"CATEGORY","USE","CLASS",
"FIELD","METHOD","IS","INHERITS","IMPLEMENTS","PUBLIC","PRIVATE","PROTECTED",
"RESTRICTED","NATIVE","STATIC","CONSTRUCTOR","DESTRUCTOR","THIS","SUPER","AS",
"RETURN","WHILE","DO","IF","THEN","ELSE","FOR","BYTE","CHAR","SHORT","INT",
"LONG","FLOAT","DOUBLE","STRING","VOID","BOOLEAN","SELF","TRUE","FALSE","NIL",
"NEW","METHODTYPE","OP_EQ","OP_NOT_EQ","OP_GREATER_OR_EQ","OP_LESS_OR_EQ",
"OP_AND","OP_OR","OP_METHODASSIGN","OP_ADDASSIGN","OP_DECASSIGN","OP_MULASSIGN",
"OP_DIVASSIGN","OP_INCREMENT","OP_DECREMENT","INTEGER_LITERAL","DOUBLE_LITERAL",
"STRING_LITERAL","IDENTIFIER",
};
const char * const yyrule[] = {
"$accept : Unit",
"Semicolon : ';'",
"Semicolon : error",
"QualifiedIdentifier : IDENTIFIER",
"QualifiedIdentifier : QualifiedIdentifier '.' IDENTIFIER",
"Literal : INTEGER_LITERAL",
"Literal : DOUBLE_LITERAL",
"Literal : STRING_LITERAL",
"Literal : TRUE",
"Literal : FALSE",
"Literal : NIL",
"Unit : UnitSection",
"Unit : Unit UnitSection",
"UnitSection : CategoryStatement",
"UnitSection : IncludeStatement",
"UnitSection : ClassDefinition",
"CategoryStatement : CATEGORY QualifiedIdentifier Semicolon",
"IncludeStatement : USE ExternalClasses Semicolon",
"IncludeStatement : error ';'",
"ExternalClasses : QualifiedIdentifier",
"ExternalClasses : ExternalClasses ',' QualifiedIdentifier",
"$$1 :",
"ClassDefinition : CLASS IDENTIFIER ClassExtensionOpt $$1 '{' FieldDeclarations '}'",
"ClassExtensionOpt :",
"ClassExtensionOpt : ClassExtensions",
"ClassExtensions : ClassExtension",
"ClassExtensions : ClassExtensions ClassExtension",
"ClassExtension : INHERITS ClassList",
"ClassExtension : IMPLEMENTS ClassList",
"ClassList : QualifiedIdentifier",
"ClassList : ClassList ',' QualifiedIdentifier",
"FieldDeclarations : FieldDeclaration",
"FieldDeclarations : FieldDeclarations FieldDeclaration",
"FieldDeclaration : MethodDeclaration",
"MethodDeclaration : FunctionDeclaration",
"MethodDeclaration : ProcedureDeclaration",
"$$2 :",
"FunctionDeclaration : MethodAccessModifier AdditionalMethodModifiersOpt IDENTIFIER MethodParametersOpt ':' Type $$2 MethodBody",
"$$3 :",
"ProcedureDeclaration : MethodAccessModifier AdditionalMethodModifiersOpt IDENTIFIER MethodParametersOpt $$3 MethodBody",
"MethodParametersOpt :",
"MethodParametersOpt : '(' MethodParameterList ')'",
"MethodParameterList : Type IDENTIFIER",
"MethodParameterList : MethodParameterList ',' Type IDENTIFIER",
"AdditionalMethodModifiersOpt :",
"AdditionalMethodModifiersOpt : AdditionalMethodModifiers",
"AdditionalMethodModifiers : AdditionalMethodModifier",
"AdditionalMethodModifiers : AdditionalMethodModifiers AdditionalMethodModifier",
"MethodAccessModifier : PUBLIC",
"MethodAccessModifier : PROTECTED",
"MethodAccessModifier : PRIVATE",
"MethodAccessModifier : RESTRICTED",
"MethodAccessModifier : error",
"AdditionalMethodModifier : NATIVE",
"AdditionalMethodModifier : STATIC",
"MethodBody : Block",
"MethodBody : ';'",
"Block : '{' LocalsOrStatementsOpt '}'",
"Block : '{' LocalsOrStatementsOpt '}' '.' MethodAccess Semicolon",
"LocalsOrStatementsOpt :",
"LocalsOrStatementsOpt : LocalsOrStatements",
"$$4 :",
"LocalsOrStatements : $$4 LocalOrStatement",
"LocalsOrStatements : LocalsOrStatements LocalOrStatement",
"$$5 :",
"LocalOrStatement : Type $$5 LocalVariableDeclarations Semicolon",
"LocalOrStatement : Statement",
"LocalVariableDeclarations : LocalVariableDeclaration",
"LocalVariableDeclarations : LocalVariableDeclarations ',' LocalVariableDeclaration",
"LocalVariableDeclaration : IDENTIFIER",
"LocalVariableDeclaration : IDENTIFIER '=' Expression",
"Statement : Expression Semicolon",
"Statement : ReturnStatement",
"ReturnStatement : RETURN Expression Semicolon",
"ReturnStatement : RETURN Semicolon",
"OtherStatement : WhileStatement",
"OtherStatement : DoWhileStatement",
"OtherStatement : ForStatement",
"OtherStatement : IfStatement",
"OtherStatement : Block",
"OtherStatement : MethodExpression",
"WhileStatement : WHILE Block Block",
"DoWhileStatement : DO Block WHILE Block",
"ForStatement : FOR Block Block Block Block",
"IfStatement : IF Block THEN Block",
"IfStatement : IF Block THEN Block ELSE Block",
"IfStatement : IF Block THEN Block ELSE IfStatement",
"Type : PredefinedType",
"Type : SELF",
"Type : QualifiedIdentifier",
"Type : METHODTYPE '(' MethodTypeParameters ')' ReturnTypeOpt",
"Type : METHODTYPE ':' Type",
"PredefinedType : BYTE",
"PredefinedType : CHAR",
"PredefinedType : SHORT",
"PredefinedType : INT",
"PredefinedType : LONG",
"PredefinedType : FLOAT",
"PredefinedType : DOUBLE",
"PredefinedType : STRING",
"PredefinedType : VOID",
"PredefinedType : BOOLEAN",
"MethodTypeParameters : Type",
"MethodTypeParameters : MethodTypeParameters ',' Type",
"UpdateReference : FieldReference",
"UpdateReference : MethodReferenceWithArgs",
"Expression : AssignmentExpression",
"AssignmentExpression : LogicalExpression",
"AssignmentExpression : IDENTIFIER '=' AssignmentExpression",
"AssignmentExpression : IDENTIFIER OP_ADDASSIGN AssignmentExpression",
"AssignmentExpression : IDENTIFIER OP_DECASSIGN AssignmentExpression",
"AssignmentExpression : IDENTIFIER OP_MULASSIGN AssignmentExpression",
"AssignmentExpression : IDENTIFIER OP_DIVASSIGN AssignmentExpression",
"$$6 :",
"AssignmentExpression : UpdateReference OP_METHODASSIGN $$6 MethodExpression",
"$$7 :",
"MethodExpression : METHOD MethodParametersOpt ReturnTypeOpt $$7 Block",
"ReturnTypeOpt :",
"ReturnTypeOpt : ':' Type",
"LogicalExpression : BooleanExpression",
"LogicalExpression : '!' BooleanExpression",
"LogicalExpression : LogicalExpression OP_AND BooleanExpression",
"LogicalExpression : LogicalExpression OP_OR BooleanExpression",
"BooleanExpression : AdditiveExpression",
"BooleanExpression : BooleanExpression '<' AdditiveExpression",
"BooleanExpression : BooleanExpression '>' AdditiveExpression",
"BooleanExpression : BooleanExpression OP_EQ AdditiveExpression",
"BooleanExpression : BooleanExpression OP_NOT_EQ AdditiveExpression",
"BooleanExpression : BooleanExpression OP_GREATER_OR_EQ AdditiveExpression",
"BooleanExpression : BooleanExpression OP_LESS_OR_EQ AdditiveExpression",
"AdditiveExpression : MultiplicativeExpression",
"AdditiveExpression : AdditiveExpression '+' MultiplicativeExpression",
"AdditiveExpression : AdditiveExpression '-' MultiplicativeExpression",
"MultiplicativeExpression : PowerExpression",
"MultiplicativeExpression : MultiplicativeExpression '*' PowerExpression",
"MultiplicativeExpression : MultiplicativeExpression '/' PowerExpression",
"MultiplicativeExpression : MultiplicativeExpression '%' PowerExpression",
"PowerExpression : CastExpression",
"PowerExpression : PowerExpression '^' CastExpression",
"PowerExpression : PowerExpression OP_INCREMENT",
"PowerExpression : PowerExpression OP_DECREMENT",
"CastExpression : PrimitiveExpression",
"CastExpression : CastExpression AS Type",
"CastExpression : '(' Expression ')'",
"PrimitiveExpression : Literal",
"PrimitiveExpression : MethodReferenceWithArgs",
"PrimitiveExpression : FieldReference",
"PrimitiveExpression : NewExpression",
"$$8 :",
"PrimitiveExpression : Literal '.' $$8 PartialReference",
"$$9 :",
"PrimitiveExpression : '(' Expression ')' '.' $$9 PartialReference",
"PrimitiveExpression : OtherStatement",
"PartialReference : FieldReference",
"PartialReference : MethodReferenceWithArgs",
"MethodReferenceWithArgs : MethodAccess",
"FieldReference : FieldAccess",
"$$10 :",
"MethodAccess : QualifiedIdentifier '(' $$10 Arguments ')'",
"$$11 :",
"MethodAccess : MethodAccess '.' QualifiedIdentifier '(' $$11 Arguments ')'",
"MethodAccess : MethodAccess ArrayAccess",
"FieldAccess : QualifiedIdentifier",
"FieldAccess : MethodAccess '.' QualifiedIdentifier",
"FieldAccess : FieldAccess ArrayAccess",
"FieldAccess : FieldAccess ArrayAccess '.' QualifiedIdentifier",
"FieldAccess : FieldAccess ArrayAccess '.' QualifiedIdentifier '(' Arguments ')'",
"ArrayAccess : '[' Expression ']'",
"ArrayAccess : ArrayAccess '[' Expression ']'",
"Arguments : JustArguments",
"Arguments : MethodParameterList",
"JustArguments : Expression",
"JustArguments : JustArguments ',' Expression",
"NewExpression : NEW QualifiedIdentifier",
"NewExpression : NEW QualifiedIdentifier '(' JustArguments ')'",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 6516 "parser.y"

/*void dumperr(char const *format,...)
{
 va_list arg;

 char *buff = new char[strlen(format)+4096];

 va_start(arg,format);
 vsprintf(buff,format,arg);
 va_end(arg);

 cout<<"error: "<<buff<<endl;
 delete[] buff;
 //exit(1);
}

void dumpwarn(char const *format,...)
{
 va_list arg;

 char *buff = new char[strlen(format)+4096];

 va_start(arg,format);
 vsprintf(buff,format,arg);
 va_end(arg);

 cout<<"warning: "<<buff<<endl;
 delete[] buff;
}*/


// parse error
int yyerror(char *s){

  cout<<"["<<*currentBufferName<<"] line "<<yylineno<<": "<<s<<" before '"<<yytext<<"'";
  numErrors++;
  return 0;
}

int myerror()
{
  cout<<"["<<*currentBufferName<<"] line "<<yylineno<<": error:  ";
  numErrors++;
  return 0;
}

int myerrorBefore()
{
  cout<<"line "<<yylineno<<": error before '"<<yytext<<"': ";
  numErrors++;
  return 0; 
}

 



// imports class. fileName is classname (not filename!), isThis is true if importing our own class
void importClass(ImportBuffer& buffer, bool isThis)
{  
 
  if( buffer.open ) return;   // already open?

  buffer.open = true;

  if(!isThis){
    
    // filename is classname + ".z0"
    
    // this is for classes in current directory
    mString fileName (*buffer.className);
    fileName += ".z0";
    
    // switch to external file
    if( !switchBuffer( &fileName ) ){

      numErrors++;
      cout<<"cannot open file '"<<fileName<<"' for reading"<<endl;
      return;

    }
  }
  
  
  // add this class to stack
  //importFiles->push( new mString(className) );

  importing = true;

}




// preparses class adding it to root environment. used to perform import of all
// classes included by default: Class, Method, ...
void preparseClass(mString* name)
{


  // check if class already in environment
  if( root->getDeclaredClass( name ) != 0 ) return;


  mString fileName = *name + ".z0";  

  currentBufferName = new mString( fileName );

  
  FILE* fp;

  if((fp=fopen(fileName,"r"))==0){
      cout<<"cannot open "<<fileName<<endl;
      exit(1);
  }
  
  yyin=fp;   // redirect from file

  

  ImportBuffer* buff = new ImportBuffer( name );

  importFiles->push( buff );
  // preparsing is always as if parsing own class (true), because we parse it from 
  // different files
  importClass( *buff, true );


  // add this class to root 
  mClass* theClass = new mClass( new mString( *name ), ACCESS_PUBLIC );
  root->append( theClass );

  yyparse();   // parse definitions

  //
  //importing = false;
  
}




int main(int argc, char **argv)
{

  FILE *fp=0;
  if(argc < 2){
     cout<<"no input file"<<endl;
     exit(1);
  }



  //////////////////////////////////////////////////////////////////////
  // check passed options
  //////////////////////////////////////////////////////////////////////
  
  mOptions options;

  int coption;
  
  int option_index = 0;

  
  option long_options[] = {
    {"addObjectSize", 1, 0, 'a'},  // --addObjectSize=x  or -a x
    {"path", 1, 0, 'p'},           // --path=x  or -p x
    {0, 0, 0, 0}
  };

  
  
  while( true ){

    coption= getopt_long (argc, argv, "a:p:", long_options, &option_index);

    if( coption == -1) break;  // no more options


    switch( coption ){              

    case 'a': 
      options.additionalObjectSize = atoi(optarg);
      break;

    default:
      cout<<"unrecognised option "<<long_options[option_index].name<<endl;
      break;

    }   // switch    
  }  // while true


  // check non option arguments placed at the end by getopt  - the filename
  if (optind < argc) { 
    thisClassFile = argv[optind];
  }
  

  //////////////////////////////////////////////////////////////////////
  // end of options
  //////////////////////////////////////////////////////////////////////




  // check if filename is valid, that is: Classname.z0
  if( !mUtil::fileNameValid(&thisClassFile) ){
    cout<<"invalid filename '"<<thisClassFile<<"'"<<endl;
    exit(1);
  }
  

  // create new type stack
  typeStack = new mStack<mClass>();

  // create new method stack
  methodStack = new mStack<mMethod>();


  // create expression stack
  expressionStack = new mStack<mParseTree>();

  // create new environment stack
  envStack = new mStack<mEnvironment>();
  //envStack->setAutoDelete( true );

  // create root environment
  root = new mEnvironment(ENVIRONMENT_ROOT, new mString( "root" ), 0, 0);
  root->createBuiltinClasses();


  // add classes that are imported by default (meta classes: Class, Method; System class,  
  // wrappers: WString, WInteger,... like java.lang)
  // but for now, we just have to import every class that we need explicitly
  // root->addDefaultClasses( "classes.zip" );  // only .class files, not .z0 files


  envStack->push( root );  

  
  // create new literal list
  literalList = new mList<mSymbol>();
  //literalList->setAutoDelete( true );  
  

  importFiles = new mStack<ImportBuffer>();
  importFiles->setAutoDelete( false /* true*/ ); 



  /////////////////////////////////////////////////////////////////
  // 1st pass is as if our own class is being imported
  /////////////////////////////////////////////////////////////////  
  


  mString ourClassName = mUtil::classNameFromFile(&thisClassFile);

  thisClassName = mUtil::classNameFromFile(&thisClassFile);


  ///////////////////////////////////////////////////////////////////
  // preparse default classes (later default.zip)

  preparseClass( new mString( "Class" ) );
  preparseClass( new mString( "Method" ) );
  ///////////////////////////////////////////////////////////////////
    

  if(root->getClassEnvironment( &ourClassName ) == 0)
    preparseClass( &ourClassName );

        

  /////////////////////////////////////////////////////////////////
  // 2nd pass if there were no errors in 1st pass
  /////////////////////////////////////////////////////////////////
    

  
  if( numErrors == 0 ){    

    // now reopen and start real parsing
    if((fp=fopen(thisClassFile,"r"))==0){
      cout<<"cannot open "<<thisClassFile<<endl;
      exit(1);
    }

    

    // add methods that need external classes for their arguments or return types
    root->updateBuiltinClasses();





    currentBufferName = &thisClassFile;

    yyin=fp;     // redirect from file
    yylineno=1;  // wrap line number    

  
    yyparse();   // full parse
        
    //fclose(fp);

  }


  delete typeStack;
  delete methodStack;
  delete expressionStack;


  // if there were some errors we quit
  if( numErrors == 0 ){


    // calculate literal offsets
    mLiteral::calculateLiteralAddresses( literalList );

    // connect literals to our main class
    mainClass->literalList = literalList;
    mainClass->options = &options;
    


    // generate code for our class
    mainClass->evaluate();

    
    dumper = new mClassDumper( mainClass );


    /*
    
    
    // dump class info
    mEnvironment *env = envStack->top();


    cout<<env->toString()<<endl;    

    
    
    
    // show method table
    cout<<" ******** METHOD TABLE *********"<<endl;
    cout<<mainClass->methodTable->toString()<<endl;
    */  
    


    // dump to class file
    dumper->dump();
    

    delete dumper;    
  

    
    /*
    cout<<"--- literal pool ---"<<endl;
    for(mSymbol *c =  literalList->first(); c != 0; c = literalList->next()){
      if( ! ((mLiteral*)c)->special )
	cout<<c->toString()<<endl;
    }
    */
    
  }

   


  
  importFiles->setAutoDelete(true);
  delete importFiles;
  
  //delete currentBufferName;
  //delete thisClassName;

  
  // now we want them deleted
  envStack->setAutoDelete(true);
  delete envStack;

  delete literalList;


  
}

#line 1398 "y.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 2:
#line 275 "parser.y"
{
               cout<<"semicolon expected"<<endl;
               yyerrok;
            }
break;
case 3:
#line 282 "parser.y"
{

                        /* create new list of strings and add the 1st string*/
                        mList<mString> *list = new mList<mString>();
			list->setAutoDelete( true );
                        list->append ( yyvsp[0].stringVal );
                        yyval.stringList = list;
                       }
break;
case 4:
#line 290 "parser.y"
{
                        /* append the rest of the strings*/
                        yyvsp[-2].stringList->append ( yyvsp[0].stringVal );
			yyval.stringList = yyvsp[-2].stringList;
                       }
break;
case 5:
#line 304 "parser.y"
{

	       /* do nothing if just importing*/
	       if( importing ) break;


               /* find class for integer*/
               mString className( "Integer" );
               mSymbol *classOfInteger = root->getSymbol( &className, SYMBOL_CLASS );

               /* constructor itself will create appropriate name for us*/
               /* so we first create it and then check for its existance*/
               mLiteral* newlit = new mLiteral(yyvsp[0].intVal, (mClass*)classOfInteger );
                              
               
               mLiteral* lit = mLiteral::find(newlit->name, literalList);

               if(lit != 0){  /* already exists?*/
		 delete newlit; newlit = lit; newlit->multiple = true;
               }else
                  /* append it to list*/
                  literalList->append( newlit );
                  
               yyval.literalVal = newlit;
            }
break;
case 6:
#line 329 "parser.y"
{

               /* do nothing if just importing*/
	       if( importing ) break;

               /* find class for double*/
               mString className( "Double" );
               mSymbol *classOfDouble = root->getSymbol( &className, SYMBOL_CLASS );

               mLiteral* newlit = new mLiteral(yyvsp[0].doubleVal, (mClass*)classOfDouble );
              
               
               mLiteral* lit = mLiteral::find(newlit->name, literalList);

               if(lit != 0){  /* already exists?*/
                  delete newlit; newlit = lit; newlit->multiple = true;
               }else
                  /* append it to list*/
                  literalList->append( newlit );
                  
               yyval.literalVal = newlit;
            }
break;
case 7:
#line 351 "parser.y"
{

	       /* do nothing if just importing*/
	       if( importing ) break;

               /* find class for string*/
               mString className( "String" );
               mSymbol *classOfString = root->getSymbol( &className, SYMBOL_CLASS );

               mLiteral* newlit = new mLiteral(yyvsp[0].stringVal, (mClass*)classOfString );
                             
               mLiteral* lit = mLiteral::find(newlit->name, literalList);

               if(lit != 0){  /* already exists?*/
                  delete newlit; newlit = lit; newlit->multiple = true;
               }else
                  /* append it to list*/
                  literalList->append( newlit );
                  
               yyval.literalVal = newlit;
            }
break;
case 8:
#line 373 "parser.y"
{

	       /* do nothing if just importing*/
	       if( importing ) break;

               /* find class for string*/
               mString className( "Boolean" );
               mSymbol *classOfBoolean = root->getSymbol( &className, SYMBOL_CLASS );

	       /* true is represented as 1*/
               mLiteral* newlit = new mLiteral(1, (mClass*)classOfBoolean );
                             
               mLiteral* lit = mLiteral::find(newlit->name, literalList);

               if(lit != 0){  /* already exists?*/
                  delete newlit; newlit = lit; newlit->multiple = true;
               }else
                  /* append it to list*/
                  literalList->append( newlit );
                  
               yyval.literalVal = newlit;

	  }
break;
case 9:
#line 396 "parser.y"
{  

	       /* do nothing if just importing*/
	       if( importing ) break;

               /* find class for string*/
               mString className( "Boolean" );
               mSymbol *classOfBoolean = root->getSymbol( &className, SYMBOL_CLASS );

	       /* false is represented as 0*/
               mLiteral* newlit = new mLiteral(0, (mClass*)classOfBoolean );
                             
               mLiteral* lit = mLiteral::find(newlit->name, literalList);

               if(lit != 0){  /* already exists?*/
                  delete newlit; newlit = lit; newlit->multiple = true;
               }else
                  /* append it to list*/
                  literalList->append( newlit );
                  
               yyval.literalVal = newlit;
	  }
break;
case 10:
#line 419 "parser.y"
{

	       /* do nothing if just importing*/
	       if( importing ) break;

               /* find class for Object*/
               mString className( "Object" );
               mSymbol *classOfObject = root->getSymbol( &className, SYMBOL_CLASS );

	       /* nil is special literal (has no value)*/
               mLiteral* newlit = new mLiteral(new mString("nil"), (mClass*)classOfObject, true );
              
               
               mLiteral* lit = mLiteral::find(newlit->name, literalList);

               if(lit != 0){  /* already exists?*/
                  delete newlit; newlit = lit;
               }else
                  /* append it to list*/
                  literalList->append( newlit );
                  
               yyval.literalVal = newlit;
            }
break;
case 16:
#line 465 "parser.y"
{
                   /*cout<<"full name ="<<list2String ( $2 )<<endl;*/

                 }
break;
case 17:
#line 479 "parser.y"
{
                     
                     if(!importing) break;


                     bool somePushed = false;
                     for(mString* name = yyvsp[-1].stringList->first(); name != 0; name = yyvsp[-1].stringList->next()){
		       

		       mClass* theClass = root->getDeclaredClass( name );
		       
		       /* add class only if it hasn't been imported yet*/
		       if( theClass == 0 ){
			 
			 /* create class and add it to root environment so that it*/
			 /* is available henceforth. if the same class is 'used' in*/
			 /* some other file it will already be available*/
			 /* create and add class to environment*/
			 theClass = new mClass( name, ACCESS_PUBLIC );
			 root->append( theClass );


			 /* import external class*/
			 ImportBuffer* buff = new ImportBuffer(name);
			 importFiles->push( buff );
                         somePushed = true;
			 
		       }else{
			 
		       }

                     }

		     /*delete $2;*/

		     /* import 1st class */
		     if( importing && somePushed ){
		      
		       importClass( *importFiles->top(), false );
		     }

                     
                   }
break;
case 18:
#line 522 "parser.y"
{
                       cout<<endl;
                       yyerrok;
                     }
break;
case 19:
#line 530 "parser.y"
{

		     /* create new list of strings and add the 1st string*/
		     mList<mString> *list = new mList<mString>();
		     list->setAutoDelete( true );
		     list->append ( new mString(list2String(yyvsp[0].stringList)) );
		     delete yyvsp[0].stringList;
		     yyval.stringList = list;

                  }
break;
case 20:
#line 541 "parser.y"
{

		     yyvsp[-2].stringList->append ( new mString(list2String(yyvsp[0].stringList)) );
		     delete yyvsp[0].stringList;
		     yyval.stringList = yyvsp[-2].stringList;
                  }
break;
case 21:
#line 556 "parser.y"
{		    

		    if( importing ) {
		      /*cout<<"parsing definitions for class "<<*$2<<endl;*/
		      /*cout<<"currentBufferName="<<*currentBufferName<<endl;*/

		      

		    }

		    /* class name must match filename*/
		    mString fileName(*yyvsp[-1].stringVal);
		    fileName += ".z0";
		    
		    if( fileName != *currentBufferName ){
		      myerror();
		      cout<<"class '"<<*yyvsp[-1].stringVal<<"' doesn't match filename "<<*currentBufferName<<endl;
		    }


		    if( !mSymbol::isValid( yyvsp[-1].stringVal ) ){
		      myerror();
		      cout<<"class '"<<*yyvsp[-1].stringVal<<"' cannot be declared"<<endl;
		    }



                    /* create class symbol and add it to environment		   		    */
		    
		    mEnvironment *env = 0;

		    if( !importing ){

		      
		      /* class must already be in environment*/
		      mClass* c = envStack->top()->getDeclaredClass( yyvsp[-1].stringVal );
		      mainClass = c;
		      
		      env = envStack->top()->getClassEnvironment( yyvsp[-1].stringVal );

		      /* if environment wasn't found it means that class exists but no*/
		      /* environment for it, this is possible only for*/
		      /* class that is being compiled. we create it's environment here*/
		      if(!env){
			 env = new mEnvironment(ENVIRONMENT_CLASS, yyvsp[-1].stringVal, envStack->top(), c);
		      }

		      /* if this is our main class we update return types and parameter types of all*/
		      /* methods in superclasses to this class*/

		      c->updateSelfSuperTypes();

		    }else{

		      mClass *c = 0;
		      
		      /* find class if already in environment*/
		      if( (c = root->getDeclaredClass( yyvsp[-1].stringVal )) == 0 )

			/* create and add class to environment*/
			c = new mClass( yyvsp[-1].stringVal, ACCESS_PUBLIC );

		      

                      /* add superclasses*/
                      if( yyvsp[0].extensionList ){

			for(mClassExtension* ext = yyvsp[0].extensionList->first(); ext != 0; ext = yyvsp[0].extensionList->next()){


			  /* if this is superclass we find it first*/
			  if( ext->type == 0 ){

			    mSymbol *classOfType = root->getSymbol( ext->className, SYMBOL_CLASS );

			    if( classOfType == 0){

			      myerror();
			      cout<<"class '"<<*ext->className<<"' not found"<<endl;

			    }else{
			      

			      /* otherwise we add this class to the list of superclasses*/

			      c->addSuperClass( (mClass*)classOfType );

			      /*cout<<"adding superclass "<<*ext->className<<endl;*/

			    }

			  }  /* if( ext->type == 0 )*/

			}

		      }else{   /*  if( $3 )*/

			/* if no explicit superclass was given then Object is set as default*/
			mString object("Object");
			mSymbol *classObject = root->getSymbol( &object, SYMBOL_CLASS );

			/*cout<<"adding superclass Object"<<endl;*/

			c->addSuperClass( (mClass*)classObject );


		      }


		      /* append it to env only if it's not already*/
		      if( root->getDeclaredClass( yyvsp[-1].stringVal ) == 0 )
			envStack->top()->append( c );
		      
                  
		      /* now create an environment for this class*/
		      env = new mEnvironment(ENVIRONMENT_CLASS, yyvsp[-1].stringVal, envStack->top(), c);
		      
		    }

		    /*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
		    /*c->environment = env; !!!!!!!!!!!!!!!!!!!!!!!!*/
		    /*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/



                    envStack->push( env );
                  }
break;
case 22:
#line 685 "parser.y"
{                    		    

		    if(importing){
		      
		     

		      /* we finish with importing if the only class left on stack is our main class*/
		      
		      if( importFiles->size() == 1 /*&& thisClassName == *importFiles->top()->className*/ ){
			
			importing=false;
		

		      }else{
		
		      }
		      

		      /* remove most recently pushed file*/
		      importFiles->pop();
		      

		      /* are there some more files on stack to import?*/
		      if( importFiles->size() > 1 ){			
			importClass( *importFiles->top(), false );
		      }		      
		     		      		      		      
		    }
		    
		    /* if there were some errors we remove class environment completely*/
		    if( numErrors > 0 ){

		      /* stop parsing if error in external class*/
		      return -1;

		    }
		    
		    envStack->pop();		    

                  }
break;
case 23:
#line 730 "parser.y"
{ yyval.extensionList = 0; }
break;
case 24:
#line 731 "parser.y"
{ yyval.extensionList = yyvsp[0].extensionList; }
break;
case 25:
#line 735 "parser.y"
{

                      /* list is already created here*/
                      yyval.extensionList = yyvsp[0].extensionList;

                    }
break;
case 26:
#line 742 "parser.y"
{

                       /* add all extensions from $2 to our list*/
                       if(yyvsp[0].extensionList){

			 for(mClassExtension* ext = yyvsp[0].extensionList->first(); ext != 0; ext = yyvsp[0].extensionList->next()){

			   /* if( mClassExtension::inList($1) ) already exists...*/
			   yyvsp[-1].extensionList->append( new mClassExtension( ext ) );

			 }

                         delete yyvsp[0].extensionList;

		       }

                    }
break;
case 27:
#line 763 "parser.y"
{ 

                      yyval.extensionList = yyvsp[0].extensionList;

                    }
break;
case 28:
#line 768 "parser.y"
{

                      if(yyvsp[0].extensionList){

			 /* set type of extensions in this list to 1*/

			 yyval.extensionList = yyvsp[0].extensionList;
                      }

                    }
break;
case 29:
#line 782 "parser.y"
{

                /* create new list of classExtensions and add the 1st string*/
                mList<mClassExtension> *list = new mList<mClassExtension>();
		list->setAutoDelete( true );
		list->append ( new mClassExtension(0, new mString(list2String(yyvsp[0].stringList)) ) );
		delete yyvsp[0].stringList;
		yyval.extensionList = list;

              }
break;
case 30:
#line 793 "parser.y"
{

		yyvsp[-2].extensionList->append ( new mClassExtension(0, new mString(list2String(yyvsp[0].stringList)) ));
		delete yyvsp[0].stringList;
		yyval.extensionList = yyvsp[-2].extensionList;
            }
break;
case 33:
#line 811 "parser.y"
{
                     
                    }
break;
case 36:
#line 829 "parser.y"
{    
    /* method must be added as a symbol to class environment before its body*/
    /* because it may reference itself in a recursive manner*/


    if( !mSymbol::isValid( yyvsp[-3].stringVal ) ){
      myerror();
      cout<<"method '"<<*yyvsp[-3].stringVal<<"' cannot be declared"<<endl;
      break;
    }


    /* check if this is 'main' method. 'main' is always a procedure*/
    if( *yyvsp[-3].stringVal == "main"){
       myerror();
       cout<<"method 'main' doesn't return"<<endl;
       break;
    }



    mClass* ownerClass = envStack->top()->ownerClass;



    /* check if this is a constructor. if it is it's an error because constructors*/
    /* don't return.*/
    if(*yyvsp[-3].stringVal == *ownerClass->name ){
       myerror();
       cout<<"constructors don't return"<<endl;
       break;
    }

   


    if(yyvsp[0].classVal == 0){
       myerror();
       cout<<"method '"<<*yyvsp[-3].stringVal<<"' returns unknown type"<<endl;
       break;
    }


    /* check if method with this signature has already been defined*/
    if( importing )
      if( ownerClass->methodDefinedHere( yyvsp[-3].stringVal, yyvsp[-2].parameterListVal ) ){      
	
	myerror();
	cout<<"method '"<<*yyvsp[-3].stringVal<<"' already defined"<<endl;
	break;	
      }        

        
    mEnvironment *env = 0;
    mMethod *meth = 0; 

    if( !importing ){


      /* create method environment*/
      env = new mEnvironment(ENVIRONMENT_METHOD, yyvsp[-3].stringVal, envStack->top(),
			     ownerClass );
      
      /* find method in our main class*/
      meth = ownerClass->getDeclaredMethod( yyvsp[-3].stringVal, yyvsp[-2].parameterListVal );      
      currentMethod = meth;   /* this is the method we are processing at the moment*/

    }else{
      
      /* create new method      */
      /* ( name, return type, access, binding )*/
      meth = new mMethod ( yyvsp[-3].stringVal, yyvsp[0].classVal ,yyvsp[-5].intVal, BIND_NONSTATIC );

      /* check if return type was Self*/
      if(isSelfType)
	meth->returnsSelf = true;

      /* back to false*/
      isSelfType = false;


      currentMethod = meth;   /* this is the method we are processing at the moment*/
            

      /* now add method to class environment. note that method is appended to*/
      /* class env. only as a SYMBOL here so that we can search class*/
      /* environments simply for symbols.*/
      /* class environment also has a child environment for every method*/
      /* which is assigned lower    */
    
      envStack->top()->append( meth );      

    }        
    
    
    /* method environment onto stack*/
    if( !importing ){

      envStack->push( env );
      meth->environment = env;
      methodStack->push( meth );            

    }


    /* finally we add formal parameters to method environment if there are any*/
    /* note: method needs parameters for checking when searching for appropriate method,*/
    /* and environment needs them in searching when a parameter is referenced in code    */

    int currentEntry = 5;  /* default location for 1st parameter on stack is 5 for function*/
                           /* except for static methods which don't expect anything on stack except*/
                           /* parameters*/
                           /* 1 is stack_ptr, 2 is result destination, 3 is return address, 4 is self, */
                           /* 5 is 1st param*/


    if( !importing )
      /* change to static later (the only static method for now is 'main')*/
      if( *meth->name == "main" ){

	currentEntry = 1;

      }else{

	/* we add self to all nonstatic methods*/
	env->addSelf( 4 );  /* for functions it resides at location 4*/

      }


    if(yyvsp[-2].parameterListVal){      

      for( mParameter* param = yyvsp[-2].parameterListVal->first(); param != 0; param = yyvsp[-2].parameterListVal->next() ){
	if( !importing ){
	  param->entry = currentEntry++;
	  env->append( param );
	}else
	  meth->addParameter( param );
      }
      
      delete yyvsp[-2].parameterListVal;
    }

    if( !importing )
      env->currentVariableEntry = currentEntry;     /* set current entry of method env so that child block*/
                                                    /* will know where its own variables start    */
    else{

      /* add it to class*/
      mClass * error = 0;
      
      if(!ownerClass->addMethod( meth, error )){	
	
	myerror();
	cout<<"method '"<<*yyvsp[-3].stringVal<<"' cannot be overriden with incompatible signature from class '"
	    <<*error->name<<"'"<<endl;
	break;	
      }

    }    
    
  }
break;
case 37:
#line 992 "parser.y"
{
  

     /* if no explicit return was given we signal error because functions MUST return excplicitly */

     if( !importing ){


       if(yyvsp[0].treeVal == 0){

	 /* unimplememented method*/
	 /* this means that method block is empty which further means that method is either declared native or*/
	 /* abstract*/
	 
	 
	 /* check if it's native*/
	 if(mUtil::hasNativeModifier(yyvsp[-6].stringList)){
	   

	   /* mark this method native*/
	   currentMethod->setNative();
	   
	   /* first we check if this method is declared NATIVE. if it is we explicitly generate an environment and*/
	   /* closure as if it were an ordinary (implemented) method. But inside closure we add nodes for calling a */
	   /* native method*/
	   
	   
	   /* create empty environment*/
	   mEnvironment *env = new mEnvironment(ENVIRONMENT_BLOCK, 
						new mString("#empty locals"), 
						envStack->top(), 
						envStack->top()->ownerClass );
	   
	   mParseTree *closure = new mParseTree( NODE_CLOSURE );
	   /* return type of closure is Block*/
	   mString block("Block");
	   mSymbol *classOfType = root->getSymbol( &block, SYMBOL_CLASS );		    
	   closure->returnType = (mClass*)classOfType;
	   
	   
	   env->closure = closure;
	   
	   /* this is where we need environment*/
	   closure->env = env;
	   
	   /* we don't push it on stack, because we don't actually need it since we're creating */
	   /* a closure here where it should be popped off*/
	   /* envStack->push( env );*/
	   
	   
	   currentMethod = methodStack->top();
	   
	   
	   /* add literal for native method name*/
	   
	   /* find class for string*/
	   mString className( "String" );
	   mSymbol *classOfString = root->getSymbol( &className, SYMBOL_CLASS );
	   
	   mLiteral* newlit = new mLiteral(currentMethod, (mClass*)classOfString, currentMethod->theClass );
	   
	   mLiteral* lit = mLiteral::find(newlit->name, literalList);
	   
	   if(lit != 0){  /* already exists?*/
	     delete newlit; newlit = lit; newlit->multiple = true;
	   }else
	     /* append it to list*/
	     literalList->append( newlit );

	   
	   
	   /*///////////////////////////////////////////////*/
	   
	   
	   /* now we generate node for native invocation*/
	   
	   mParseTree *tree = new mParseTree( NODE_NATIVECALL, currentMethod, currentMethod->returnType );
	   tree->append( new mParseTree(NODE_LITERAL, newlit, newlit->theClass ) );
	   
	   closure->append( tree );
	   
	   
	 }else{ /* hasNativeModifier*/
	   
	   /* abstract...once*/
	   
	   /* otherwise we have an error because bodyless method must be either native or abstract*/
	   myerror();
	   cout<<"method '"<<*yyvsp[-5].stringVal<<"' must be declared either native or abstract"<<endl;
	   break;
	   
	 }
	 
	 
       }  else {
	 
	 /* implemented method always has one block*/
	 
	 /* check if method was declared native or abstract, if it has we have an error because native and abstract*/
	 /* methods have no implementation*/
	 
	 /* check whether native*/
	 if(mUtil::hasNativeModifier(yyvsp[-6].stringList)){
	   
	   myerror();
	   cout<<"native method '"<<*yyvsp[-5].stringVal<<"' must not be implemented"<<endl;
	   break;
	   
	 }
	 
	 
	 
	 
	 
	 mParseTree* closure = envStack->top()->children->at(0)->closure;
	 
	 if( !closure->endsWithReturn() ){
	   
	   currentMethod = methodStack->top();
	   
	   myerrorBefore();
	   cout<<"method '"<<*currentMethod->name<<"' must return '"<<*currentMethod->returnType->name
	       <<"' at end"<<endl;      
	 }
	 
       }


       
       /* remove this method's environment*/
       if(yyvsp[-2].classVal != 0){
	 envStack->pop();
	 methodStack->pop();
       }
       
     }
     
  }
break;
case 38:
#line 1135 "parser.y"
{
    /* method must be added as a symbol to class environment before its body*/
    /* because it may reference itself in a recursive manner    */
    
    if( !mSymbol::isValid( yyvsp[-1].stringVal ) ){
      myerror();
      cout<<"method '"<<*yyvsp[-1].stringVal<<"' cannot be declared"<<endl;
      break;
    }


    /* returnType of procedure is 0 except for constructors which have a returnType of*/
    /* their own class (this is implicit of course)*/
    mClass *retType = 0;

    mClass* ownerClass = envStack->top()->ownerClass;


    if(*yyvsp[-1].stringVal == *ownerClass->name )
      retType = ownerClass;
    else{
      /* if it's not constructor, we set returnType to Void*/
      mString Void("Void");
      retType = (mClass*)root->getSymbol( &Void, SYMBOL_CLASS );
    }
    

    /* check if method with this signature has already been defined*/
    if( importing )
      if( ownerClass->methodDefinedHere( yyvsp[-1].stringVal, yyvsp[0].parameterListVal ) ){      

	myerror();
	cout<<"method '"<<*yyvsp[-1].stringVal<<"' already defined"<<endl;
	break;

      }

    mEnvironment *env = 0;
    mMethod *meth = 0; 



    if( !importing ){


      /* create method environment*/
      env = new mEnvironment(ENVIRONMENT_METHOD, yyvsp[-1].stringVal, envStack->top(),
			     ownerClass );

      /* find method in our main class*/
      meth = ownerClass->getDeclaredMethod( yyvsp[-1].stringVal, yyvsp[0].parameterListVal );
      currentMethod = meth;   /* this is the method we are processing at the moment      */


    }else{

      /* create new method*/

      /* check if it's 'main'*/
      short binding = BIND_NONSTATIC;
      if( *yyvsp[-1].stringVal == "main") binding = BIND_STATIC;


      /* ( name, return type, access, binding )*/
      meth = new mMethod ( yyvsp[-1].stringVal, retType ,yyvsp[-3].intVal, binding );
      currentMethod = meth;   /* this is the method we are processing at the moment*/
            

      /* now add method to class environment. note that method is appended to*/
      /* class env. only as a SYMBOL here so that we can search class*/
      /* environments simply for symbols.*/
      /* class environment also has a child environment for every method*/
      /* which is assigned lower    */
    
      envStack->top()->append( meth );
      

    }
    

    
    /* method environment onto stack*/
    if( !importing ){

      envStack->push( env );
      meth->environment = env;
      methodStack->push( meth );
      /*currentMethod = meth;   // this is the method we are processing at the moment*/
    }




    int currentEntry = 4;  /* default location for 1st parameter on stack is 4*/
                           /* except for static methods which don't expect anything on stack except*/
                           /* parameters*/

    /* change to static later (the only static method for now is 'main')*/
    if( !importing )
      if( *meth->name == "main" ){
	currentEntry = 1;
      }else{
	
	/* we add self to all nonstatic methods*/
	env->addSelf( 3 );  /* for procedures it resides at location 3*/
	
      }

    /* finally we add formal parameters to method environment if there are any    */
    if(yyvsp[0].parameterListVal){        

      for( mParameter* param = yyvsp[0].parameterListVal->first(); param != 0; param = yyvsp[0].parameterListVal->next() ){
	if( !importing ){
	  param->entry = currentEntry++;
	  env->append( param );
	}else
	  meth->addParameter( param );	
      }      
      delete yyvsp[0].parameterListVal;
    }


    if( !importing ){
      env->currentVariableEntry = currentEntry;   /* set current entry of method env so that child block*/
                                                  /* will know where its own variables start*/

      /*envStack->push( env );*/

      /*meth->environment = env;*/

      /*currentMethod = meth;   // this is the method we are processing at the moment*/
    }else{

      /* add it to class*/
      mClass * error = 0;
      if(!ownerClass->addMethod( meth, error )){
	
	myerror();
	cout<<"method '"<<*yyvsp[-1].stringVal<<"' cannot be overriden with incompatible signature from class '"
	    <<*error->name<<"'"<<endl;
	break;
	
      }

    }

  }
break;
case 39:
#line 1283 "parser.y"
{


  /* if no explicit return was given we add it here (because return is mapped directly to RETURN */
  /* instruction)*/

  if( !importing ){



    if(yyvsp[0].treeVal == 0){   /* no method body!*/

      /* unimplememented method*/
      /* this means that method block is empty which further means that method is either declared native or*/
      /* abstract*/


      /* check if it's native*/
      if(mUtil::hasNativeModifier(yyvsp[-4].stringList)){
	

	/* mark this method native*/
	currentMethod->setNative();

	/* first we check if this method is declared NATIVE. if it is we explicitly generate an environment and*/
	/* closure as if it were an ordinary (implemented) method. But inside closure we add nodes for calling a */
	/* native method*/
	
		
	/* create empty environment*/
	mEnvironment *env = new mEnvironment(ENVIRONMENT_BLOCK, 
					     new mString("#empty locals"), 
					     envStack->top(), 
					     envStack->top()->ownerClass );
	
	mParseTree *closure = new mParseTree( NODE_CLOSURE );
	/* return type of closure is Block*/
	mString block("Block");
	mSymbol *classOfType = root->getSymbol( &block, SYMBOL_CLASS );		    
	closure->returnType = (mClass*)classOfType;
	
	
	env->closure = closure;
	
	/* this is where we need environment*/
	closure->env = env;
	
	/* we don't push it on stack, because we don't actually need it since we're creating a closure here where it should*/
	/* be popped off*/
	/* envStack->push( env );*/
	
	
	currentMethod = methodStack->top();


	/* add literal for native method name*/

	/* find class for string*/
	mString className( "String" );
	mSymbol *classOfString = root->getSymbol( &className, SYMBOL_CLASS );
	
	mLiteral* newlit = new mLiteral(currentMethod, (mClass*)classOfString, currentMethod->theClass );
	
	mLiteral* lit = mLiteral::find(newlit->name, literalList);
	
	if(lit != 0){  /* already exists?*/
	  delete newlit; newlit = lit; newlit->multiple = true;
	}else
	  /* append it to list*/
	  literalList->append( newlit );
	
	/*///////////////////////////////////////////////*/



	
	/* now we generate node for native invocation*/

	mParseTree *tree = new mParseTree( NODE_NATIVECALL, currentMethod, currentMethod->returnType );
	tree->append( new mParseTree(NODE_LITERAL, newlit, newlit->theClass ) );

	closure->append( tree );
       
	
      }else{ /* hasNativeModifier*/

	/* abstract...once*/

	/* otherwise we have an error because bodyless method must be either native or abstract*/
	myerror();
	cout<<"method '"<<*yyvsp[-3].stringVal<<"' must be declared either native or abstract"<<endl;
	break;
	
      }
      

    } else {

      /* implemented method always has one block*/

      /* check if method was declared native or abstract, if it has we have an error because native and abstract*/
      /* methods have no implementation*/

      /* check whether native*/
      if(mUtil::hasNativeModifier(yyvsp[-4].stringList)){

	myerror();
	cout<<"native method '"<<*yyvsp[-3].stringVal<<"' must not be implemented"<<endl;
	break;

      }

      /* ...and abstract here*/



      mParseTree* closure = envStack->top()->children->at(0)->closure;
    

      if( !closure->endsWithReturn() ){
	
	currentMethod = methodStack->top();
	
	if(*currentMethod->name != "main")  /* method main doesn't return*/
	  closure->append( new mParseTree( NODE_RETURN ) );
	
      }    
      
      mClass* ownerClass = envStack->top()->ownerClass;
      
      if(*yyvsp[-3].stringVal == *ownerClass->name ){
	
	/* if this is constructor add invocations of direct parent constructors*/
	for(mClass *super = ownerClass->superClasses->last();  super != 0; 
	    super = ownerClass->superClasses->prev()){
	  
	  if(*super->name == "Object") continue;
	  /*cout<<"adding constructor "<<*super->name<<endl;*/
	  mMethod * ctor = super->getDefaultConstructor();
	  
	  if(!ctor){
	    myerror();
	    cout<<"explicit call of constructor for '"<<*super->name<<"' required"<<endl;
	    break;
	  }
	  
	  closure->addSuperConstructorCall( ctor );
	}
	
      }
                        

    }  /* $6 != 0 (method with block)*/


    /* remove this method's environment*/
    envStack->pop();
    methodStack->pop();

  }

  }
break;
case 40:
#line 1461 "parser.y"
{ yyval.parameterListVal = 0; }
break;
case 41:
#line 1462 "parser.y"
{

		          yyval.parameterListVal = yyvsp[-1].parameterListVal;
                       }
break;
case 42:
#line 1469 "parser.y"
{

		       if( !mSymbol::isValid( yyvsp[0].stringVal ) ){
			 myerror();
			 cout<<"parameter '"<<*yyvsp[0].stringVal<<"' cannot be declared"<<endl;
			 yyval.parameterListVal = 0;
			 break;
		       }

		       /* create parameter and add it to list*/
		       /* which is on top of stack*/
		       if(yyvsp[-1].classVal){			
			 mList<mParameter> *list = new mList<mParameter>();
			 mParameter* param = new mParameter ( yyvsp[0].stringVal, yyvsp[-1].classVal );


			 /* check if type was Self*/
			 if(isSelfType)
			   param->isSelfType = true;
			 
			 /* back to false*/
			 isSelfType = false;

			 list->append ( param  );
			 
			 
			 yyval.parameterListVal = list;
		       }else yyval.parameterListVal = 0;
                     }
break;
case 43:
#line 1498 "parser.y"
{
		         if(yyvsp[-1].classVal){
			   if(!yyvsp[-3].parameterListVal) yyvsp[-3].parameterListVal = new mList<mParameter>();

			   mParameter* param = new mParameter( yyvsp[0].stringVal, yyvsp[-1].classVal );

			   /* check if type was Self*/
			   if(isSelfType)
			     param->isSelfType = true;
			 
			   /* back to false*/
			   isSelfType = false;
			   
			   yyvsp[-3].parameterListVal->append ( param );			   
			 }
			 yyval.parameterListVal = yyvsp[-3].parameterListVal;
                       }
break;
case 44:
#line 1520 "parser.y"
{ yyval.stringList = 0; }
break;
case 45:
#line 1521 "parser.y"
{ yyval.stringList = yyvsp[0].stringList; }
break;
case 46:
#line 1525 "parser.y"
{

		           /* create modifier and add it to list		          			*/
		           mList<mString> *list = new mList<mString>();
			   list->setAutoDelete( true );
			   list->append ( yyvsp[0].stringVal );
			   yyval.stringList = list;		      

                         }
break;
case 47:
#line 1535 "parser.y"
{

                           /* check whether this modifier already exists*/

                           for(mString *mod = yyvsp[-1].stringList->first();  mod != 0; mod = yyvsp[-1].stringList->next()){

			     if( *yyvsp[0].stringVal == *mod ){
			       myerror();
			       cout<<"modifier '"<<*yyvsp[0].stringVal<<"' already present"<<endl;
			       break;
			     }
                           
                           }

			   /* now add it to list*/
			   yyvsp[-1].stringList->append ( yyvsp[0].stringVal );
			   yyval.stringList = yyvsp[-1].stringList;

                         }
break;
case 48:
#line 1559 "parser.y"
{ yyval.intVal = ACCESS_PUBLIC; }
break;
case 49:
#line 1560 "parser.y"
{ yyval.intVal = ACCESS_PROTECTED; }
break;
case 50:
#line 1561 "parser.y"
{ yyval.intVal = ACCESS_PRIVATE; }
break;
case 51:
#line 1562 "parser.y"
{ yyval.intVal = ACCESS_RESTRICTED; }
break;
case 52:
#line 1563 "parser.y"
{
                             cout<<"invalid access modifier"<<endl;
                             /*yyerrok;*/
                           }
break;
case 53:
#line 1570 "parser.y"
{ yyval.stringVal = new mString("native"); }
break;
case 54:
#line 1571 "parser.y"
{ yyval.stringVal = new mString("static"); }
break;
case 55:
#line 1582 "parser.y"
{

            }
break;
case 56:
#line 1586 "parser.y"
{

               /* no block*/
               yyval.treeVal = 0;

            }
break;
case 57:
#line 1596 "parser.y"
{


            /* do nothing if just importing*/
            if( importing ) break;


	    mParseTree* closure = envStack->top()->closure;

	    /* every block except that of top-level method must exit with implicit NODE_BLOCK_EXIT*/
	    /* or explicit return */
	    if( envStack->top()->parent->type != ENVIRONMENT_METHOD ){

	      /* we have nested closure*/

	      if( !closure->endsWithReturn() ){

		/* append exit*/
		closure->append( new mParseTree( NODE_BLOCK_EXIT ) );

	      }
	    }

	    /*cout<<"After block="<<closure->toString()<<endl;*/

            /* block now holds a closure*/
            yyval.treeVal = closure;

            
            /* remove environment for local definitions in this block*/
            envStack->pop();
           }
break;
case 58:
#line 1631 "parser.y"
{

            /* do nothing if just importing*/
	    if( importing ) break;

            envStack->pop();
               /*$$ = $2;*/
         }
break;
case 59:
#line 1648 "parser.y"
{


	                    /* do nothing if just importing*/
	                    if( importing ) break;


                            /* create empty environment*/
                            mEnvironment *env = new mEnvironment(ENVIRONMENT_BLOCK, 
						new mString("#empty locals"), 
						envStack->top(), 
						envStack->top()->ownerClass );


                            mParseTree *closure = new mParseTree( NODE_CLOSURE );
			    /* return type of closure is Block*/
			    mString block("Block");
			    mSymbol *classOfType = root->getSymbol( &block, SYMBOL_CLASS );		    
			    closure->returnType = (mClass*)classOfType;


                            env->closure = closure;

			    /* this is where we need environment*/
			    closure->env = env;
                            
                            /* push on top*/
                            envStack->push( env );
                          }
break;
case 60:
#line 1678 "parser.y"
{
	                   /* environment and its closure are created below*/
                        }
break;
case 61:
#line 1684 "parser.y"
{

                          /* do nothing if just importing*/
			  if( importing ) break;


                          /* this is where we create new environment for*/
                          /* current local definitions*/

			  /* block is either a plain block or a method block in method update*/
			  /* if there is more than 1 method on stack, we are updating method and*/
			  /* hence we have method block*/
			  mEnvironment *env = envStack->top();  /* top environment*/

			  /* 1. if we're not updating a method*/
			  /* 2. if top environment is not UPDATE then we create it here*/
			  /* otherwise we'll just use the already created one in*/
			  /* MethodExpression*/
			  if( !performingUpdate && env->type != ENVIRONMENT_UPDATE ){
			    
			    env = new mEnvironment( ENVIRONMENT_BLOCK,
						    new mString("#locals"),
						    envStack->top(),
						    envStack->top()->ownerClass );
			    /* push on top*/
			    envStack->push( env );
			    
			  }else{
			    /* we already have block environment on stack!*/
			    env = envStack->top();
			  }
			  

			  performingUpdate = false;			 			
			  

                          /* since locals and statements are always within*/
                          /* a block, we also create a closure for this block*/
                          mParseTree *closure = new mParseTree( NODE_CLOSURE );

			  /* return type of closure is Block*/
			  mString block("Block");
			  mSymbol *classOfType = root->getSymbol( &block, SYMBOL_CLASS );		    
			  closure->returnType = (mClass*)classOfType;

                          env->closure = closure;

			  /* this is where we need environment*/
			  closure->env = env;
                          

                          
                       }
break;
case 62:
#line 1739 "parser.y"
{
                       }
break;
case 63:
#line 1742 "parser.y"
{

			 
                      }
break;
case 64:
#line 1750 "parser.y"
{ 
			if(!importing){ 
			  currentType = yyvsp[0].classVal;
			  typeStack->push(yyvsp[0].classVal); 

			}
                  }
break;
case 65:
#line 1757 "parser.y"
{
  
                         if(importing) break;

                         /* remove type of this variable*/
			 typeStack->pop();			 
			 

                  }
break;
case 66:
#line 1766 "parser.y"
{ 

		         if(importing) break;

		         yyval.treeVal=yyvsp[0].treeVal; 
		  }
break;
case 69:
#line 1792 "parser.y"
{

                                /* do nothing if just importing*/
                                if( importing ) break;

                                if( !mSymbol::isValid( yyvsp[0].stringVal ) ){
                                    myerror();
                                    cout<<"variable '"<<*yyvsp[0].stringVal<<"' cannot be declared"<<endl;
                                    break;
                                }

                                /* get active environment from top of stack*/
                                mEnvironment *env = envStack->top();

                                /* first we check if variable with this name*/
                                /* already exists in current environment*/
                                if( env->getLocalSymbol( yyvsp[0].stringVal ) != 0 ){
                                    myerror();
                                    cout<<"variable '"<<*yyvsp[0].stringVal<<"' already defined"<<endl;
                                    break;
                                }

                                /* bail out (don't add this variable) if type*/
                                /* is erroneous*/
                                if(currentType == 0) break;
                                
                                /* create new variable*/
                                /* access is public , binding nonstatic*/
                                mVariable *v = new mVariable( yyvsp[0].stringVal, typeStack->top(), 
							      BIND_NONSTATIC, 
							      env->currentVariableEntry );
				

                                /* ... and add it to active environment*/
                                env->append( v );

                                /* variable is created with NODE_NEW*/
                                mParseTree *tree = new mParseTree( NODE_NEW );

                                tree->append( new mParseTree( NODE_VARIABLE, v ) );

				/* add this variable declaration to closure*/
                                env->closure->append( tree );
                                
                                yyval.treeVal = tree;

                             }
break;
case 70:
#line 1841 "parser.y"
{

			        /* do nothing if just importing*/
			        if( importing ) break;			       				


			        if( !mSymbol::isValid( yyvsp[-2].stringVal ) ){
                                    myerror();
                                    cout<<"variable '"<<*yyvsp[-2].stringVal<<"' cannot be declared"<<endl;
                                    break;
                                }


			        /* bail out (don't create this variable) if type*/
                                /* or expression are erroneous*/
                                if(currentType == 0 || !yyvsp[0].treeVal ) break;

                                /* get active environment from top of stack*/
                                mEnvironment *env = envStack->top();

                                /* check if variable with this name already exists*/
                                if( env->getLocalSymbol( yyvsp[-2].stringVal ) != 0){
                                    myerror();
                                    cout<<"symbol '"<<*yyvsp[-2].stringVal<<"' already defined"<<endl;
                                    break;
                                }
			

				/* perform implicit cast to currentType if necessary*/
                                if( !yyvsp[0].treeVal->performTypeCast( yyvsp[0].treeVal, typeStack->top() ) ){
                                  myerror();
                                  cout<<"cannot perform cast from '"
                                      <<yyvsp[0].treeVal->getType()<<"' to '"
                                      <<*typeStack->top()->name<<"'"<<endl;				  
                                  break;
                                }
								

				/* check whether expression is a block containing return*/
				if(yyvsp[0].treeVal->closureReturns()){
                                    myerror();
                                    cout<<"cannot return from escapable block"<<endl;
				    yyval.treeVal = 0;
                                    break;
                                }


				/* check whether expression is a block containing assignment to parent*/
				/* variable*/
				if(yyvsp[0].treeVal->closureAssignsToParent()){
				  myerror();
				  cout<<"cannot assign to parent variable from escapable block"<<endl;
				  yyval.treeVal = 0;
				  break;
				}


                                /* create new initialised variable*/
                                mVariable *v = new mVariable( yyvsp[-2].stringVal, typeStack->top(), 
					  BIND_NONSTATIC, env->currentVariableEntry );
				

                                /*cout<<"variable "<<*$1<<"'s code: "<<*$3->text<<endl;*/

                                /* and add it to environment*/
                                env->append( v );

                                /* variable is created with NODE_NEW*/
                                mParseTree *tree = new mParseTree( NODE_NEW );
                                
                                tree->append( new mParseTree( NODE_VARIABLE, v ) );

				/* append expression*/
                                tree->append( yyvsp[0].treeVal );                               

				/* add this variable declaration to closure*/
                                env->closure->append( tree );
                                
                                yyval.treeVal = tree;

                           }
break;
case 71:
#line 1927 "parser.y"
{


              /* do nothing if just importing*/
              if( importing ) break;


	      /*cout<<" imam expression  "<<$1->toString()<<endl;*/


              /* get active environment from top of stack*/
              /* this should be closure env*/
              if( yyvsp[-1].treeVal ){
                 mEnvironment *env = envStack->top();

                 /* append to current closure not environment*/

                 env->closure->append( yyvsp[-1].treeVal );

              }
              yyval.treeVal = yyvsp[-1].treeVal;
	      

            }
break;
case 72:
#line 1952 "parser.y"
{

              /* do nothing if just importing*/
              if( importing ) break;

              if( yyvsp[0].treeVal ){
                 mEnvironment *env = envStack->top();

                 /* append to current closure not environment*/
                 env->closure->append( yyvsp[0].treeVal );
              }

	      yyval.treeVal = yyvsp[0].treeVal;
	    }
break;
case 73:
#line 1973 "parser.y"
{
           
                    /* do nothing if just importing*/
	            if( importing ) break;


                    if(!yyvsp[-1].treeVal){ yyval.treeVal=0; break; }    /* error in expression*/
		    
		    mMethod* currentMethod = methodStack->top();


                    /* returning expression from procedure is error*/
		    if(!currentMethod->isFunction()){

		      myerror();
		      cout<<"method '"<<*currentMethod->name<<"'"<<" does not return '"
			  <<yyvsp[-1].treeVal->getType()<<"'"<<endl;
		      yyval.treeVal = 0;
		      break;

		    }

		    /* returning expression from constructor is error*/
		    if( currentMethod->isConstructor() ){
		      myerror();
		      cout<<"constructor '"<<*currentMethod->name<<"'"<<" does not return '"
			  <<yyvsp[-1].treeVal->getType()<<"'"<<endl;
		      yyval.treeVal = 0;
		      break;

		    }
                   
		    /* perform implicit cast to returnType if necessary*/
		    if( !yyvsp[-1].treeVal->performTypeCast( yyvsp[-1].treeVal, currentMethod->returnType ) ){
		      myerror();
		      cout<<"cannot perform cast from '"
			  <<yyvsp[-1].treeVal->getType()<<"' to return type '"
			  <<*currentMethod->returnType->name<<"'"<<endl;
		      yyval.treeVal = 0;
		      break;
		    }


		    /* we have return statement*/
		    envStack->top()->setReturn(true, yylineno);
		     		    		    


		    mParseTree *tree = new mParseTree( NODE_RETURN );

		    /* append expression		    */
		    tree->append( yyvsp[-1].treeVal );
		    yyval.treeVal = tree;

                  }
break;
case 74:
#line 2030 "parser.y"
{


                     /* do nothing if just importing*/
                     if( importing ) break;


		     mMethod* currentMethod = methodStack->top();

                     /* returning nothing from function is error (except for constructors)*/
		    if(currentMethod->isFunction() && !currentMethod->isConstructor() ){
		      myerror();
		      cout<<"method '"<<*currentMethod->name<<"' must return '"
			  <<*currentMethod->returnType->name<<"'"<<endl;
		      yyval.treeVal = 0;
		      break;

		    }


		    /* method main doesn't return*/
		    if(*currentMethod->name == "main"){
		      yyval.treeVal = 0;
		      break;
		    }


		    /* create return node*/
		    mParseTree *tree = new mParseTree( NODE_RETURN );
		    yyval.treeVal = tree;
		     
                  }
break;
case 75:
#line 2066 "parser.y"
{ 
		    
		    yyval.treeVal = yyvsp[0].treeVal; 

		  }
break;
case 76:
#line 2072 "parser.y"
{ 

		    yyval.treeVal = yyvsp[0].treeVal; 

		  }
break;
case 77:
#line 2079 "parser.y"
{ 

		    yyval.treeVal = yyvsp[0].treeVal; 

		  }
break;
case 78:
#line 2085 "parser.y"
{

		    yyval.treeVal = yyvsp[0].treeVal;

                  }
break;
case 79:
#line 2091 "parser.y"
{

                    yyval.treeVal = yyvsp[0].treeVal;

                  }
break;
case 80:
#line 2097 "parser.y"
{
		    
                    yyval.treeVal = yyvsp[0].treeVal;

                  }
break;
case 81:
#line 2123 "parser.y"
{

                  /* do nothing if just importing*/
                  if( importing ) break;


		  /* condition block must hold exactly one boolean expression*/
		  /* get class Boolean*/
		  mString tbool("Boolean");
		  mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );

		  if(!yyvsp[-1].treeVal->isBooleanClosure(classBool)){
		    myerror();
		    cout<<"conditional block for while must have exactly one Boolean expression"<<endl;
		    yyval.treeVal = 0;
		    break;
		  }

                  /* create while node*/
                  mParseTree *tree = new mParseTree( NODE_WHILE );		

		  /* append both blocks*/
		  tree->append( yyvsp[-1].treeVal );  tree->append( yyvsp[0].treeVal );

		  /* return type is While*/
		  mString While("While");
		  mSymbol *classOfType = root->getSymbol( &While, SYMBOL_CLASS );		    
		  tree->returnType = (mClass*)classOfType;
		  

		  yyval.treeVal = tree;

                }
break;
case 82:
#line 2160 "parser.y"
{
 
                   /* do nothing if just importing*/
                  if( importing ) break;


		  /* condition block must hold exactly one boolean expression*/
		  /* get class Boolean*/
		  mString tbool("Boolean");
		  mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );

		  if(!yyvsp[0].treeVal->isBooleanClosure(classBool)){
		    myerror();
		    cout<<"conditional block for while must have exactly one Boolean expression"<<endl;
		    yyval.treeVal = 0;
		    break;
		  }

                  /* create while node*/
                  mParseTree *tree = new mParseTree( NODE_DOWHILE );		

		  /* append both blocks*/
		  tree->append( yyvsp[-2].treeVal );  tree->append( yyvsp[0].treeVal );

		  /* return type is While*/
		  mString DoWhile("DoWhile");
		  mSymbol *classOfType = root->getSymbol( &DoWhile, SYMBOL_CLASS );		    
		  tree->returnType = (mClass*)classOfType;
		  

		  yyval.treeVal = tree;

                }
break;
case 83:
#line 2200 "parser.y"
{

                  /* do nothing if just importing*/
                  if( importing ) break;		  

		  /* condition block must hold exactly one boolean expression*/
		  /* get class Boolean*/
		  mString tbool("Boolean");
		  mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );

		  if(!yyvsp[-2].treeVal->isBooleanClosure(classBool)){
		    myerror();
		    cout<<"conditional block for for must have exactly one Boolean expression"<<endl;
		    yyval.treeVal = 0;
		    break;
		  }

                  /* create while node*/
                  mParseTree *tree = new mParseTree( NODE_FOR );		

		  /* append all blocks*/
		  tree->append( yyvsp[-3].treeVal );  tree->append( yyvsp[-2].treeVal ); tree->append( yyvsp[-1].treeVal ); tree->append( yyvsp[0].treeVal );  

		  /* return type is For*/
		  mString For("For");
		  mSymbol *classOfType = root->getSymbol( &For, SYMBOL_CLASS );		    
		  tree->returnType = (mClass*)classOfType;
		  

		  yyval.treeVal = tree;

		  /* odstranimo spremenljivko iz bloka iz trenutnega okolja */

                }
break;
case 84:
#line 2249 "parser.y"
{

                    /* do nothing if just importing*/
                    if( importing ) break;

                    /* condition block must hold exactly one boolean expression*/
		    /* get class Boolean*/
		    mString tbool("Boolean");
		    mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );
		    
		    if(!yyvsp[-2].treeVal->isBooleanClosure(classBool)){
		      myerror();
		      cout<<"conditional block for if must have exactly one Boolean expression"<<endl;
		      yyval.treeVal = 0;
		      break;
		    }
		    
		    /* create if node*/
		    mParseTree *tree = new mParseTree( NODE_IF );		
		    
		    /* append both blocks*/
		    tree->append( yyvsp[-2].treeVal );  tree->append( yyvsp[0].treeVal );
		    
		    /* return type is If*/
		    mString If("If");
		    mSymbol *classOfType = root->getSymbol( &If, SYMBOL_CLASS );		    
		    tree->returnType = (mClass*)classOfType;
		    
		    
		    yyval.treeVal = tree;
		    
                }
break;
case 85:
#line 2283 "parser.y"
{

                  /* do nothing if just importing*/
                  if( importing ) break;

		  /* condition block must hold exactly one boolean expression*/
		  /* get class Boolean*/
		  mString tbool("Boolean");
		  mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );
		  
		  if(!yyvsp[-4].treeVal->isBooleanClosure(classBool)){
		    myerror();
		    cout<<"conditional block for if must have exactly one Boolean expression"<<endl;
		    yyval.treeVal = 0;
		    break;
		  }
		  
		  /* create if node*/
		  mParseTree *tree = new mParseTree( NODE_IF );		
		  
		  /* append both blocks and else block*/
		  tree->append( yyvsp[-4].treeVal );  tree->append( yyvsp[-2].treeVal );  tree->append( yyvsp[0].treeVal ); 
		  
		  /* return type is If*/
		  mString If("If");
		  mSymbol *classOfType = root->getSymbol( &If, SYMBOL_CLASS );		    
		  tree->returnType = (mClass*)classOfType;
		  
		  
		  yyval.treeVal = tree;
		  
		}
break;
case 86:
#line 2317 "parser.y"
{

                  /* do nothing if just importing*/
                  if( importing ) break;
		  
		  /* condition block must hold exactly one boolean expression*/
		  /* get class Boolean*/
		  mString tbool("Boolean");
		  mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );
		  
		  if(!yyvsp[-4].treeVal->isBooleanClosure(classBool)){
		    myerror();
		    cout<<"conditional block for if must have exactly one Boolean expression"<<endl;
		    yyval.treeVal = 0;
		    break;
		  }
		  
		  /* create if node*/
		  mParseTree *tree = new mParseTree( NODE_IF );		
		  
		  /* append both blocks and else block*/
		  tree->append( yyvsp[-4].treeVal );  tree->append( yyvsp[-2].treeVal );  tree->append( yyvsp[0].treeVal ); 
		  
		  /* return type is If*/
		  mString If("If");
		  mSymbol *classOfType = root->getSymbol( &If, SYMBOL_CLASS );		    
		  tree->returnType = (mClass*)classOfType;
		  
		  
		  yyval.treeVal = tree;

		}
break;
case 87:
#line 2444 "parser.y"
{ yyval.classVal = yyvsp[0].classVal; }
break;
case 88:
#line 2447 "parser.y"
{
	  
           /* check whether we're in a static method because Self type is only*/
           /* available in non-static methods*/
          
           if(currentMethod->isStatic()){
	     myerror();
	     cout<<"Self type is not available in static methods"<<endl;
	     yyval.classVal = 0;
	     break;

           }


           /* Self is simply the type of class we're currently compiling.*/
	   /* find class environment for current class*/
           mClass* c = envStack->top()->getFirstClass();

	   isSelfType = true;

           yyval.classVal = c;

        }
break;
case 89:
#line 2472 "parser.y"
{
        
           /*////////////////////////////////////////////////////////*/
           /* !!!!!! we're dealing with built-in types for now !!!!!!*/
           /*////////////////////////////////////////////////////////*/
           

	  mClass* classOfType = mUtil::getQualifiedType( yyvsp[0].stringList, root );
	  
	  if( classOfType == 0 ){
           

	    /* !!! find external class in current dir !!!*/

	    myerror();
	    cout<<"type '"<<mUtil::getQualifiedTypeName( yyvsp[0].stringList )<<"' not defined"<<endl;
	    yyval.classVal = 0;
	    break;
	  }

	  yyval.classVal = classOfType;
        
	}
break;
case 90:
#line 2497 "parser.y"
{
	  
	  
	  /* check if this method type already exists*/
	  mString type = mMethodClass::getTypeName( yyvsp[-2].classList, yyvsp[0].classVal );
	  mSymbol *classOfType = root->getSymbol( &type, SYMBOL_CLASS );		    

	  if( !classOfType ){
	    
	    /* create new special method type*/

	    /* get generic Method type*/
	    mString tname("Method");
	    mSymbol *generic = root->getSymbol( &tname, SYMBOL_CLASS );	

	    /* get Object class*/
	    mString object("Object");
	    mSymbol *classObject = root->getSymbol( &object, SYMBOL_CLASS );
	    
	    classOfType = new mMethodClass( (mClass*)generic, (mClass*)classObject, yyvsp[-2].classList, yyvsp[0].classVal );
	    

	    /* add it to root environment*/
	    root->append( (mClass*)classOfType );


	  }else{


	    /* we already have this method type*/
	    
	  }

	  
	  yyval.classVal = (mClass*)classOfType;

	}
break;
case 91:
#line 2537 "parser.y"
{


	  /* check if this method type already exists*/
	  mList<mParameter>* parameters = 0;   /* no parameters*/
	  mString type = mMethodClass::getTypeName( parameters, yyvsp[0].classVal );
	  mSymbol *classOfType = root->getSymbol( &type, SYMBOL_CLASS );		    

	  if( !classOfType ){
	    
	    /* create new special method type*/

	    /* get generic Method type*/
	    mString tname("Method");
	    mSymbol *generic = root->getSymbol( &tname, SYMBOL_CLASS );	

	    /* get Object class*/
	    mString object("Object");
	    mSymbol *classObject = root->getSymbol( &object, SYMBOL_CLASS );
	    
	    classOfType = new mMethodClass( (mClass*)generic, (mClass*)classObject, parameters, yyvsp[0].classVal );
	    

	    /* add it to root environment*/
	    root->append( (mClass*)classOfType );


	  }else{


	    /* we already have this method type*/
	    
	  }

	  
	  yyval.classVal = (mClass*)classOfType;

	}
break;
case 92:
#line 2584 "parser.y"
{ yyval.classVal = 0; }
break;
case 93:
#line 2585 "parser.y"
{

                     mString tchar("Character");
                     mSymbol *classOfType = root->getSymbol( &tchar, SYMBOL_CLASS );		    
		     yyval.classVal = (mClass*)classOfType;
		   }
break;
case 94:
#line 2592 "parser.y"
{ yyval.classVal = 0; }
break;
case 95:
#line 2594 "parser.y"
{
		     mString tint("Integer");
                     mSymbol *classOfType = root->getSymbol( &tint, SYMBOL_CLASS );		    
		     yyval.classVal = (mClass*)classOfType;
                   }
break;
case 96:
#line 2600 "parser.y"
{ yyval.classVal = 0; }
break;
case 97:
#line 2601 "parser.y"
{ yyval.classVal = 0; }
break;
case 98:
#line 2603 "parser.y"
{
		     mString tdouble("Double");
                     mSymbol *classOfType = root->getSymbol( &tdouble, SYMBOL_CLASS );
		     yyval.classVal = (mClass*)classOfType;
                   }
break;
case 99:
#line 2609 "parser.y"
{
		     mString tstr("String");
                     mSymbol *classOfType = root->getSymbol( &tstr, SYMBOL_CLASS );		    
		     yyval.classVal = (mClass*)classOfType;
                   }
break;
case 100:
#line 2615 "parser.y"
{ yyval.classVal = 0; }
break;
case 101:
#line 2617 "parser.y"
{ 
		     mString tbool("Boolean");
                     mSymbol *classOfType = root->getSymbol( &tbool, SYMBOL_CLASS );		    
		     yyval.classVal = (mClass*)classOfType;

		   }
break;
case 102:
#line 2628 "parser.y"
{

		       mList<mClass>*  list = new mList<mClass>();
		       list->setAutoDelete ( false );
		       list->append ( yyvsp[0].classVal );		    
		       yyval.classList = list;

			 
			 
                     }
break;
case 103:
#line 2638 "parser.y"
{
		         if(yyvsp[0].classVal){
			   if(!yyvsp[-2].classList) yyvsp[-2].classList = new mList<mClass>();


			 
			   
			   yyvsp[-2].classList->append ( yyvsp[0].classVal );
			 }			
		     }
break;
case 106:
#line 2664 "parser.y"
{                 
                 yyval.treeVal=yyvsp[0].treeVal;
              }
break;
case 107:
#line 2671 "parser.y"
{ yyval.treeVal=yyvsp[0].treeVal; }
break;
case 108:
#line 2677 "parser.y"
{
			  

			  /* do nothing if just importing*/
	                  if( importing ) break;

			  /* bail out on error*/
			  if( !yyvsp[-2].stringVal || !yyvsp[0].treeVal ){ yyval.treeVal = 0; break; }			   
                        

			  /* check whether expression is a block containing return*/
			  if(yyvsp[0].treeVal->closureReturns()){
			    myerror();
			    cout<<"cannot return from escapable block"<<endl;
			    yyval.treeVal = 0;
			    break;
			  }
			  

			  /* check whether expression is a block containing assignment to parent*/
			  /* variable*/
			  if(yyvsp[0].treeVal->closureAssignsToParent()){
			    myerror();
			    cout<<"cannot assign to parent variable from escapable block"<<endl;
			    yyval.treeVal = 0;
			    break;
			  }


			  mEnvironment *env = envStack->top();

			  mSymbol *sym = env->getSymbol( yyvsp[-2].stringVal );			     
			  /*cout<<"done searching local symbol."<<endl;*/

			  if(sym != 0){
			       			       
			    
			    if(!env->symbolIsLocal)
			      env->setParentAssignment(sym->theClass, true, yylineno );

			    if( sym->symbolType == SYMBOL_VARIABLE || 
				sym->symbolType == SYMBOL_PARAMETER ){
			      /* we're assigning to a local variable*/
                              
     
			      /* perform implicit cast to variable's type if necessary*/
			      if( !yyvsp[0].treeVal->performTypeCast( yyvsp[0].treeVal, sym->theClass ) ){
				myerror();
				cout<<"cannot perform cast from '"
				    <<yyvsp[0].treeVal->getType()<<"' to '"
				    <<*sym->theClass->name<<"'"<<endl;
				yyval.treeVal = 0;
				break;
			      }
 			      

			      /* create assign node*/
			      mParseTree *tree = new mParseTree( NODE_ASSIGN );
			      
			      /* create variable node*/
			      mParseTree *var = new mParseTree( NODE_VARIABLE, sym );
			      
			      /* now append variable(left) and expression(right) node*/
			      tree->append( var ); tree->append( yyvsp[0].treeVal );
			      
			      tree->returnType = sym->theClass;
			      
			      yyval.treeVal = tree;			          
			     

			    }else if( sym->symbolType == SYMBOL_METHOD ){
			      
			      /* we have method. error*/
			      myerror();
			      cout<<"cannot assign to method"<<endl;
			      yyval.treeVal=0;
			      break;
			    }
			    
			    
			    
			  }else{ /* sym != 0*/
			    cout<<"no symbol '"<<*yyvsp[-2].stringVal<<"' found!"<<endl;
			    
			    /*mParseTree *tree = new mParseTree( NODE_ASSIGN );*/
			    
			    /* generate unresolved symbol node*/
			    /*mParseTree *var = new mParseTree( NODE_UNRESOLVED, $1->at( 0 ) );*/
			    /*tree->append( var ); tree->append( $4 );*/
			    
			    yyval.treeVal = 0;
			  }
                                                        
			}
break;
case 109:
#line 2776 "parser.y"
{
			  

			  /* do nothing if just importing*/
	                  if( importing ) break;

			  /* bail out on error*/
			  if( !yyvsp[0].treeVal ){ yyval.treeVal = 0; break; }			   
			    			  
			  			  


			  mEnvironment *env = envStack->top();

			  mSymbol *sym = env->getSymbol( yyvsp[-2].stringVal );			     

			  if(sym != 0){
			       			       
			    
			    if(!env->symbolIsLocal)
			      env->setParentAssignment(sym->theClass, true, yylineno );
			    
			    if( sym->symbolType == SYMBOL_VARIABLE || 
				sym->symbolType == SYMBOL_PARAMETER ){

			      /* we're assigning to a local variable*/
			      			      
			     	
			      /* create variable node - this is left node*/
			      mParseTree *var = new mParseTree( NODE_VARIABLE, sym );
		      
			      mParseTree *tree = new mParseTree( NODE_PLUS );
			      
			      /* check for implicit promotion*/
			       
			      if( !tree->promotePrimitivesViaCast(var, yyvsp[0].treeVal, NODE_PLUS)){
				myerror();
				cout<<"cannot perform '+' on "<<var->getType()
				    <<" and "<<yyvsp[0].treeVal->getType()<<endl;				 
				yyval.treeVal = 0;
				break;
			      }

			      
			      /* now append variable(left) and additive expression(right) node*/
			      tree->append( var );  tree->append( yyvsp[0].treeVal );			      


			      /* perform implicit cast to variable's type if necessary*/
			      if( !tree->performTypeCast( tree, sym->theClass ) ){
				myerror();
				cout<<"cannot perform cast from '"
				    <<tree->getType()<<"' to '"
				    <<*sym->theClass->name<<"'"<<endl;
				yyval.treeVal = 0;
				break;
			      }
 			      

			      /* create assign node*/
			      mParseTree *assign = new mParseTree( NODE_ASSIGN, sym->theClass );
			      assign->append( new mParseTree( NODE_VARIABLE, sym ) );  
			      assign->append( tree );
			      
			      
			      yyval.treeVal = assign;
			      
			    }else if( sym->symbolType == SYMBOL_METHOD ){
			      
			      /* we have method. error*/
			      myerror();
			      cout<<"cannot assign to method"<<endl;
			      yyval.treeVal=0;
			      break;
			    }
			    
			    
			    
			  }else{ /* sym != 0*/
			    cout<<"no symbol '"<<*yyvsp[-2].stringVal<<"' found!"<<endl;
			    
			    /*mParseTree *tree = new mParseTree( NODE_ASSIGN );*/
			    
			    /* generate unresolved symbol node*/
			    /*mParseTree *var = new mParseTree( NODE_UNRESOLVED, $1->at( 0 ) );*/
			    /*tree->append( var ); tree->append( $4 );*/
			    
			    yyval.treeVal = 0;
			  }
			  
			}
break;
case 110:
#line 2872 "parser.y"
{
			  

			  /* do nothing if just importing*/
	                  if( importing ) break;

			  /* bail out on error*/
			  if( !yyvsp[0].treeVal ){ yyval.treeVal = 0; break; }			   
			    			  
			  			  


			  mEnvironment *env = envStack->top();

			  mSymbol *sym = env->getSymbol( yyvsp[-2].stringVal );			     

			  if(sym != 0){
			       			       
			    
			    if(!env->symbolIsLocal)
			      env->setParentAssignment(sym->theClass, true, yylineno );
			    
			    if( sym->symbolType == SYMBOL_VARIABLE || 
				sym->symbolType == SYMBOL_PARAMETER ){

			      /* we're assigning to a local variable*/
			      			      
			     	
			      /* create variable node - this is left node*/
			      mParseTree *var = new mParseTree( NODE_VARIABLE, sym );
		      
			      mParseTree *tree = new mParseTree( NODE_MINUS );
			      
			      /* check for implicit promotion*/
			       
			      if( !tree->promotePrimitivesViaCast(var, yyvsp[0].treeVal, NODE_MINUS)){
				myerror();
				cout<<"cannot perform '-' on "<<var->getType()
				    <<" and "<<yyvsp[0].treeVal->getType()<<endl;				 
				yyval.treeVal = 0;
				break;
			      }

			      
			      /* now append variable(left) and additive expression(right) node*/
			      tree->append( var );  tree->append( yyvsp[0].treeVal );			      


			      /* perform implicit cast to variable's type if necessary*/
			      if( !tree->performTypeCast( tree, sym->theClass ) ){
				myerror();
				cout<<"cannot perform cast from '"
				    <<tree->getType()<<"' to '"
				    <<*sym->theClass->name<<"'"<<endl;
				yyval.treeVal = 0;
				break;
			      }
 			      

			      /* create assign node*/
			      mParseTree *assign = new mParseTree( NODE_ASSIGN, sym->theClass );
			      assign->append( new mParseTree( NODE_VARIABLE, sym ) );  
			      assign->append( tree );
			      
			      
			      yyval.treeVal = assign;
			      
			    }else if( sym->symbolType == SYMBOL_METHOD ){
			      
			      /* we have method. error*/
			      myerror();
			      cout<<"cannot assign to method"<<endl;
			      yyval.treeVal=0;
			      break;
			    }
			    
			    
			    
			  }else{ /* sym != 0*/
			    cout<<"no symbol '"<<*yyvsp[-2].stringVal<<"' found!"<<endl;
			    
			    /*mParseTree *tree = new mParseTree( NODE_ASSIGN );*/
			    
			    /* generate unresolved symbol node*/
			    /*mParseTree *var = new mParseTree( NODE_UNRESOLVED, $1->at( 0 ) );*/
			    /*tree->append( var ); tree->append( $4 );*/
			    
			    yyval.treeVal = 0;
			  }
			  
			}
break;
case 111:
#line 2968 "parser.y"
{
			  

			  /* do nothing if just importing*/
	                  if( importing ) break;

			  /* bail out on error*/
			  if( !yyvsp[0].treeVal ){ yyval.treeVal = 0; break; }			   
			    			  
			  			  


			  mEnvironment *env = envStack->top();

			  mSymbol *sym = env->getSymbol( yyvsp[-2].stringVal );			     

			  if(sym != 0){
			       			       
			    
			    if(!env->symbolIsLocal)
			      env->setParentAssignment(sym->theClass, true, yylineno );
			    
			    if( sym->symbolType == SYMBOL_VARIABLE || 
				sym->symbolType == SYMBOL_PARAMETER ){

			      /* we're assigning to a local variable*/
			      			      
			     	
			      /* create variable node - this is left node*/
			      mParseTree *var = new mParseTree( NODE_VARIABLE, sym );
		      
			      mParseTree *tree = new mParseTree( NODE_MULTIPLY );
			      
			      /* check for implicit promotion*/
			       
			      if( !tree->promotePrimitivesViaCast(var, yyvsp[0].treeVal, NODE_MULTIPLY)){
				myerror();
				cout<<"cannot perform '*' on "<<var->getType()
				    <<" and "<<yyvsp[0].treeVal->getType()<<endl;				 
				yyval.treeVal = 0;
				break;
			      }

			      
			      /* now append variable(left) and additive expression(right) node*/
			      tree->append( var );  tree->append( yyvsp[0].treeVal );			      


			      /* perform implicit cast to variable's type if necessary*/
			      if( !tree->performTypeCast( tree, sym->theClass ) ){
				myerror();
				cout<<"cannot perform cast from '"
				    <<tree->getType()<<"' to '"
				    <<*sym->theClass->name<<"'"<<endl;
				yyval.treeVal = 0;
				break;
			      }
 			      

			      /* create assign node*/
			      mParseTree *assign = new mParseTree( NODE_ASSIGN, sym->theClass );
			      assign->append( new mParseTree( NODE_VARIABLE, sym ) );  
			      assign->append( tree );
			      
			      
			      yyval.treeVal = assign;
			      
			    }else if( sym->symbolType == SYMBOL_METHOD ){
			      
			      /* we have method. error*/
			      myerror();
			      cout<<"cannot assign to method"<<endl;
			      yyval.treeVal=0;
			      break;
			    }
			    
			    
			    
			  }else{ /* sym != 0*/
			    cout<<"no symbol '"<<*yyvsp[-2].stringVal<<"' found!"<<endl;
			    
			    /*mParseTree *tree = new mParseTree( NODE_ASSIGN );*/
			    
			    /* generate unresolved symbol node*/
			    /*mParseTree *var = new mParseTree( NODE_UNRESOLVED, $1->at( 0 ) );*/
			    /*tree->append( var ); tree->append( $4 );*/
			    
			    yyval.treeVal = 0;
			  }
			  
			}
break;
case 112:
#line 3064 "parser.y"
{
			  

			  /* do nothing if just importing*/
	                  if( importing ) break;

			  /* bail out on error*/
			  if( !yyvsp[0].treeVal ){ yyval.treeVal = 0; break; }			   
			    			  
			  			  


			  mEnvironment *env = envStack->top();

			  mSymbol *sym = env->getSymbol( yyvsp[-2].stringVal );			     

			  if(sym != 0){
			       			       
			    
			    if(!env->symbolIsLocal)
			      env->setParentAssignment(sym->theClass, true, yylineno );
			    
			    if( sym->symbolType == SYMBOL_VARIABLE || 
				sym->symbolType == SYMBOL_PARAMETER ){

			      /* we're assigning to a local variable*/
			      			      
			     	
			      /* create variable node - this is left node*/
			      mParseTree *var = new mParseTree( NODE_VARIABLE, sym );
		      
			      mParseTree *tree = new mParseTree( NODE_DIVIDE );
			      
			      /* check for implicit promotion*/
			       
			      if( !tree->promotePrimitivesViaCast(var, yyvsp[0].treeVal, NODE_DIVIDE)){
				myerror();
				cout<<"cannot perform '/' on "<<var->getType()
				    <<" and "<<yyvsp[0].treeVal->getType()<<endl;				 
				yyval.treeVal = 0;
				break;
			      }

			      
			      /* now append variable(left) and additive expression(right) node*/
			      tree->append( var );  tree->append( yyvsp[0].treeVal );			      


			      /* perform implicit cast to variable's type if necessary*/
			      if( !tree->performTypeCast( tree, sym->theClass ) ){
				myerror();
				cout<<"cannot perform cast from '"
				    <<tree->getType()<<"' to '"
				    <<*sym->theClass->name<<"'"<<endl;
				yyval.treeVal = 0;
				break;
			      }
 			      

			      /* create assign node*/
			      mParseTree *assign = new mParseTree( NODE_ASSIGN, sym->theClass );
			      assign->append( new mParseTree( NODE_VARIABLE, sym ) );  
			      assign->append( tree );
			      
			      
			      yyval.treeVal = assign;
			      
			    }else if( sym->symbolType == SYMBOL_METHOD ){
			      
			      /* we have method. error*/
			      myerror();
			      cout<<"cannot assign to method"<<endl;
			      yyval.treeVal=0;
			      break;
			    }
			    
			    
			    
			  }else{ /* sym != 0*/
			    cout<<"no symbol '"<<*yyvsp[-2].stringVal<<"' found!"<<endl;
			    
			    /*mParseTree *tree = new mParseTree( NODE_ASSIGN );*/
			    
			    /* generate unresolved symbol node*/
			    /*mParseTree *var = new mParseTree( NODE_UNRESOLVED, $1->at( 0 ) );*/
			    /*tree->append( var ); tree->append( $4 );*/
			    
			    yyval.treeVal = 0;
			  }
			  
			}
break;
case 113:
#line 3160 "parser.y"
{

			  /* do nothing if just importing*/
	                  if( importing ) break;


			  /* !!! TUKAJ JE PRIVZETO false*/
			  /*allowParameters = false;*/


			  /* preveri, ce je UpdateReference pravilen: samo zadnji node lahko*/
			  /* vsebuje tip NODE_PARAMETER v NODE_ARGUMENTS*/

			  cout<<"checking validity of left-hand method update expression"<<endl;
			  
			  /* we're only interested in last method*/
			  mParseTree* last = yyvsp[-1].treeVal->getLastMethodNode();

			  mMethod *method = 0;

			  if(last) method = (mMethod*)last->symbol;

			 
			  if(last && method->numParameters() > 0 ){

			    if( !last->children->at(0)->argumentsMatchExactly() ){

			      myerror();
			      cout<<"parameter types of method in update must match those in declaration"
				  <<endl;
			      yyval.treeVal = 0;
			      break;
			    }
			    
			  }  /*  if(last)*/

			  

			  methodStack->push( method );


			  performingUpdate = true;

			}
break;
case 114:
#line 3211 "parser.y"
{
			  
			  /* do nothing if just importing*/
	                  if( importing ) break;

			  methodStack->pop();
			  

			  /* again: get last method node from left-side expression*/
			  mParseTree* last = yyvsp[-3].treeVal->getLastMethodNode();

			  mMethod *method = 0;

			  /* get the method*/
			  if(last) method = (mMethod*)last->symbol;
			  			
			  /* get method that was pushed inside MethodExpression*/
			  /*mMethod* anonymous =methodStack->top();*/
			  /*methodStack->pop();*/


			  /* assignment expression may be:*/
			  /* - a closure which is effectively a block*/
			  /* - another method reference (from another class or Method type variable)*/

			  mParseTree *block = 0;
			  
			  /* check what type is our method expression*/
			  if( yyvsp[0].treeVal->type == NODE_ANONMETHOD ){
			    
			    /* anonymous method: this means we have 2 children*/
			    /* 1st is cosure and 2nd is parameter list */

			    
			    block = yyvsp[0].treeVal->children->at(0);  /* the block*/
			    mParseTree *params = yyvsp[0].treeVal->children->at(1); /* the params*/


			    /* a function may be assigned to a function, procedure to a*/
			    /* procedure and return types must match*/
			    
			    if( method->returnType != yyvsp[0].treeVal->functionReturnType ){

			      myerror();
			      cout<<"return types of both methods must match."<<endl;
			      yyval.treeVal=0;
			      break;
			    }


			    /* check number of parameters and their types */
			    /* # must match*/
			    if(params->children->size() != method->parameterList->size()){
			      myerror();
			      cout<<"new method must have the same number of parameters as old one."<<endl;
			      yyval.treeVal=0;
			      break;
			    }


			    for(unsigned i=0; i < params->children->size(); i++)
			    
				if( params->children->at(i)->returnType != 
				    method->parameterList->at(i)->theClass ){
				  myerror();
				  cout<<"signatures must match exactly: "
				      <<" expecting '"<<*method->parameterList->at(i)->theClass->name 
				      <<"', found '"<<*params->children->at(i)->returnType->name<<"'."
				      <<endl;
				  yyval.treeVal=0;
				  break;
				}				 			  

			    
			    /*mParseTree *closure = block->env->closure;*/


			    /* this is a top-level method closure*/
			    block->env->methodClosure = true;			    

			    /*
			    // if this is function we must ensure return at end
			    if(!closure->endsWithReturn()){
			      
			      if( method->isFunction()){
				
				myerrorBefore();
				cout<<"method '"<<*method->name<<"' must return '"
				    <<*method->returnType->name<<"' at end"<<endl;
				
			      }else{
				
				
				// Block.exit is already in this closure. remove it!
				closure->removeNode( NODE_BLOCK_EXIT ); 
				
				
				
				// we add explicit return
				closure->append( new mParseTree( NODE_RETURN ) );
				
				//cout<<"Removed Block.exit node"<<endl;
				
			      }
			    }
			    */

			  }else{   /* $4->type == NODE_ANONMETHOD*/


			    /* otherwise we may have method reference*/
			    myerror();
			    cout<<"updating from method reference not yet supported"
				<<endl;
			    yyval.treeVal = 0;
			    break;
			    

			  }
			    
			    
			  /* create method update node*/
			  mParseTree *tree = new mParseTree( NODE_METHODUPDATE, method /*anonymous*/ );
			  
			  
			  /* spremeni strukturo, da bo sledeca*/
			    
			  /*   METHOD_UPDATE*/
			  /*   /         \ */
			  /*  /           \*/
			  /* METHOD_CALL  NODE_CLOSURE			     */
			      
			      
			  /* we don't add single methodcall because the owner of method*/
			  /* that is being updated is our own class*/
			  if( yyvsp[-3].treeVal->isMultiMethodCall()){
				
			    /*cout<<"removing last method node"<<endl;*/
			    /*cout<<"before:"<<$3->toString()<<endl;*/
			  
			    /* remove last methodcall node*/
			    yyvsp[-3].treeVal->removeLastMethodNode();
			    /*cout<<"tree now= "<<$3->toString()<<endl;*/
			    
			    tree->append( yyvsp[-3].treeVal );   
			    
			  }
			  
			  
			  /* append method block or reference*/
			  tree->append( block );
			  
			  
			  /*tree->returnType = $3->returnType;*/
			  
			  
			  yyval.treeVal = tree;
			      
			      
			      
			  /* remove field reference*/
			  /*delete $3;			  */

			}
break;
case 115:
#line 3384 "parser.y"
{
			       /* do nothing if just importing*/
			       if( importing ) break;


			       
			       
			       /* create update environment*/
			       mEnvironment* env = new mEnvironment( ENVIRONMENT_UPDATE,
								     new mString("#locals"),
								     envStack->top(),
								     envStack->top()->ownerClass );
			       

			       /* add self*/
			       int currentEntry = 0;

			       /* if we have return type then we have a procedure otherwise function*/
			       if( yyvsp[0].classVal != 0 ){
				 env->addSelf( 4 );
				 env->currentVariableEntry = currentEntry = 5;
			       }else{
				 env->addSelf( 3 );
				 env->currentVariableEntry = currentEntry = 4;

			       }
			       

			  

			       /* add formal parameters so we may access them inside*/
			       /* update environment - inside new method block			       */

			       mList<mParameter> *list = yyvsp[-1].parameterListVal;
				
			       /* if parameters exist we add them*/
			       if(list != 0)
				 for( mParameter* param = list->first(); 
				      param != 0;  param = list->next() ){
				   
				   
				   param->entry = currentEntry++;
				   
				   env->append( param );

				   /*cout<<"******************** appending param "<<*parameter->name<<endl;*/
				 }
			       
			       /*delete $2;				*/
			       
			       
			       env->currentVariableEntry = currentEntry;
			       
			       /* push update environment*/
			       envStack->push( env );

			       

			       
			       /* create anonymous method*/
			       mMethod* meth = new mMethod ( new mString("anonymous_method"), 
							     yyvsp[0].classVal ,ACCESS_PUBLIC, BIND_NONSTATIC );

			       /* set env and push it because anon method is the same*/
			       /* as ordinary method*/
			       meth->environment = env;
			       meth->theClass = envStack->top()->ownerClass;  /* owner*/
			       methodStack->push( meth );
			       
			       
                             }
break;
case 116:
#line 3457 "parser.y"
{

                             /* do nothing if just importing*/
                             if( importing ) break;

			     
			     /* remove method*/
			     mMethod* meth = methodStack->top();  /* the above method*/
			     methodStack->pop();

			     /* environment has already been popped after Block*/
			     /*envStack->pop();*/


			     mParseTree *closure = yyvsp[0].treeVal->env->closure;

			     /* if this block is function block we must ensure return at end*/
			    if(!closure->endsWithReturn()){
			      
			      if( meth->isFunction()){
				
				myerrorBefore();
				cout<<"anonymous method must return '"
				    <<*meth->returnType->name<<"' at end"<<endl;
				
			      }else{
				
				
				/* Block.exit is already in this closure. remove it!*/
				closure->removeNode( NODE_BLOCK_EXIT ); 
				
								
				/* we add explicit return*/
				closure->append( new mParseTree( NODE_RETURN ) );
								
			      }
			    }


			     /* create NODE_ARGUMENTS and append all parameters*/
			     mParseTree *args = new mParseTree( NODE_ARGUMENTS );
			     mList<mParameter> *list = yyvsp[-3].parameterListVal;
				
			     if(list != 0)
			       for( mParameter* param = list->first(); 
				    param != 0;  param = list->next() ){
				   				   				   
				 args->append( new mParseTree(NODE_PARAMETER, param) );
				 meth->addParameter( param );

			       }


			     /* MethodExpression consists of closure and parameters*/
			     
			     mParseTree *anon = new mParseTree( NODE_ANONMETHOD, meth );
			     anon->append( yyvsp[0].treeVal );   /* closure*/
			     anon->append( args );   /* params*/
			     

			     /* return type of this parsetree is set to generic Method or special */
			     /* Method*/


			     /* find if such Method type already exists*/
			     mString type = mMethodClass::getTypeName( yyvsp[-3].parameterListVal, yyvsp[-2].classVal );
			     mSymbol *classOfType = root->getSymbol( &type, SYMBOL_CLASS );


			     if( !classOfType ){
	    
			       /* create new special method type*/

			       /* get generic Method type*/
			       mString tname("Method");
			       mSymbol *generic = root->getSymbol( &tname, SYMBOL_CLASS );	

			       /* get Object class*/
			       mString object("Object");
			       mSymbol *classObject = root->getSymbol( &object, SYMBOL_CLASS );
	    
			       classOfType = new mMethodClass( (mClass*)generic, (mClass*)classObject, yyvsp[-3].parameterListVal, 
							       yyvsp[-2].classVal );
	    

			       /* add it to root environment*/
			       root->append( (mClass*)classOfType );


			     }else{


			       /* we already have this method type*/
	    
			     }




			     /*mString methodType("Method");*/
			     anon->returnType = (mClass*)classOfType; /*root->getDeclaredClass(&methodType);*/
			     anon->functionReturnType = yyvsp[-2].classVal;
			     
                             yyval.treeVal = anon;			                      


                            }
break;
case 117:
#line 3578 "parser.y"
{  yyval.classVal = 0; }
break;
case 118:
#line 3579 "parser.y"
{ yyval.classVal = yyvsp[0].classVal; }
break;
case 119:
#line 3584 "parser.y"
{ yyval.treeVal=yyvsp[0].treeVal; }
break;
case 120:
#line 3587 "parser.y"
{


                             /* do nothing if just importing*/
                             if( importing ) break;
                           
			     /* bail out on error*/
			     if(!yyvsp[0].treeVal){ yyval.treeVal = 0; break; }
                             
			     mParseTree *right = yyvsp[0].treeVal;
			     
			     /* get class Boolean*/
			     mString tbool("Boolean");
			     mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );
			     
			     /* if right side is a literal we can calculate value */
			     /* now*/
			     if( yyvsp[0].treeVal->type==NODE_LITERAL){
			       mLiteral *right = (mLiteral*)yyvsp[0].treeVal->symbol;
			       
			       mEnvironment* env = envStack->top();
			       			       
			       /* calc new value and store its literal into list,*/
			       /* and replace old ones in environment*/
			       mLiteral *newLit = mLiteral::calculate( right, 0, 
								       NODE_NOT, literalList, env,
								       classBool );

			       
			       /* if operation could not be performed, 0 is returned*/
			       if( !newLit ){
				 myerror();
				 cout<<"cannot perform '!' on "<<*right->theClass->name
				     <<endl;
				 yyval.treeVal = 0;
				 break;
			       }
			       
			       mParseTree *tree=new mParseTree( NODE_LITERAL, newLit,
								newLit->theClass );
			       yyval.treeVal = tree;
			       
			     }else{
			       
			       /* otherwise we have a '!' expression */
			       
			       mParseTree *tree = new mParseTree( NODE_NOT );
			       
			       /* check for implicit promotion*/
			       if( !tree->promoteSinglePrimitiveViaCast(right, NODE_NOT, classBool)){
				 myerror();
				 cout<<"cannot perform '!' on "<<yyvsp[0].treeVal->getType()
				     <<endl;
				 yyval.treeVal = 0;
				 break;
			       }
			       
			       /* add right branch*/
			       tree->append( right );
			       
			       yyval.treeVal = tree;
			       
			       
			     }
			     
			   }
break;
case 121:
#line 3656 "parser.y"
{
			     

                               /* do nothing if just importing*/
			       if( importing ) break;
                           
			       /* bail out on error*/
			       if(!yyvsp[-2].treeVal || ! yyvsp[0].treeVal){ yyval.treeVal = 0; break; }
                             
			       mParseTree *left = yyvsp[-2].treeVal;
			       mParseTree *right = yyvsp[0].treeVal;
			     
			       /* get class Boolean*/
			       mString tbool("Boolean");
			       mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );

			       /* if both sides are literals we can calculate addition*/
			       /* now*/
			       if( yyvsp[-2].treeVal->type==NODE_LITERAL && yyvsp[0].treeVal->type==NODE_LITERAL ){
				 mLiteral *left = (mLiteral*)yyvsp[-2].treeVal->symbol;
				 mLiteral *right = (mLiteral*)yyvsp[0].treeVal->symbol;
				 
				 mEnvironment* env = envStack->top();
				 
				 /* calc new value and store its literal into list,*/
				 /* and replace old ones in environment*/
				 mLiteral *newLit = mLiteral::calculate( left, right,
									 NODE_AND, literalList, env,
									 classBool );
				 
				 /* if addition could not be performed, 0 is returned*/
				 if( !newLit ){
				   myerror();
				   cout<<"cannot perform '&&' on "<<*left->theClass->name
				       <<" and "<<*right->theClass->name<<endl;
				   yyval.treeVal = 0;
				   break;
				 }
				 
				 mParseTree *tree=new mParseTree( NODE_LITERAL, newLit,
								  newLit->theClass );
				 yyval.treeVal = tree;
				 
			       }else{
				 
				 /* otherwise we have a '&&' expression */
   
				 mParseTree *tree = new mParseTree( NODE_AND );

				 /* check for implicit promotion*/
				 if( !tree->promotePrimitivesViaCast(left, right, NODE_AND, classBool)){
				   myerror();
				   cout<<"cannot perform '&&' on "<<yyvsp[-2].treeVal->getType()
				       <<" and "<<yyvsp[0].treeVal->getType()<<endl;
				   yyval.treeVal = 0;
				   break;
				 }
				 
				 /* add left & right branches*/
				 tree->append( left );  tree->append( right );

				 yyval.treeVal = tree;

				 				 
			       }
			     

                           }
break;
case 122:
#line 3726 "parser.y"
{

			     /* do nothing if just importing*/
			       if( importing ) break;
                           
			       /* bail out on error*/
			       if(!yyvsp[-2].treeVal || ! yyvsp[0].treeVal){ yyval.treeVal = 0; break; }
                             
			       mParseTree *left = yyvsp[-2].treeVal;
			       mParseTree *right = yyvsp[0].treeVal;
			     
			       /* get class Boolean*/
			       mString tbool("Boolean");
			       mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );

			       /* if both sides are literals we can calculate addition*/
			       /* now*/
			       if( yyvsp[-2].treeVal->type==NODE_LITERAL && yyvsp[0].treeVal->type==NODE_LITERAL ){
				 mLiteral *left = (mLiteral*)yyvsp[-2].treeVal->symbol;
				 mLiteral *right = (mLiteral*)yyvsp[0].treeVal->symbol;
				 
				 mEnvironment* env = envStack->top();
				 
				 /* calc new value and store its literal into list,*/
				 /* and replace old ones in environment*/
				 mLiteral *newLit = mLiteral::calculate( left, right,
									 NODE_OR, literalList, env,
									 classBool );
				 
				 /* if addition could not be performed, 0 is returned*/
				 if( !newLit ){
				   myerror();
				   cout<<"cannot perform '||' on "<<*left->theClass->name
				       <<" and "<<*right->theClass->name<<endl;
				   yyval.treeVal = 0;
				   break;
				 }
				 
				 mParseTree *tree=new mParseTree( NODE_LITERAL, newLit,
								  newLit->theClass );
				 yyval.treeVal = tree;
				 
			       }else{
				 
				 /* otherwise we have a '&&' expression */
   
				 mParseTree *tree = new mParseTree( NODE_OR );

				 /* check for implicit promotion*/
				 if( !tree->promotePrimitivesViaCast(left, right, NODE_OR, classBool)){
				   myerror();
				   cout<<"cannot perform '||' on "<<yyvsp[-2].treeVal->getType()
				       <<" and "<<yyvsp[0].treeVal->getType()<<endl;
				   yyval.treeVal = 0;
				   break;
				 }
				 
				 /* add left & right branches*/
				 tree->append( left );  tree->append( right );

				 yyval.treeVal = tree;

				 				 
			       }

                           }
break;
case 123:
#line 3796 "parser.y"
{ yyval.treeVal=yyvsp[0].treeVal; }
break;
case 124:
#line 3797 "parser.y"
{

                               /* do nothing if just importing*/
			       if( importing ) break;
                           
			       /* bail out on error*/
			       if(!yyvsp[-2].treeVal || ! yyvsp[0].treeVal){ yyval.treeVal = 0; break; }
                             
			       mParseTree *left = yyvsp[-2].treeVal;
			       mParseTree *right = yyvsp[0].treeVal;
			     
			       /* get class Boolean*/
			       mString tbool("Boolean");
			       mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );

			       /* if both sides are literals we can calculate addition*/
			       /* now*/
			       if( yyvsp[-2].treeVal->type==NODE_LITERAL && yyvsp[0].treeVal->type==NODE_LITERAL ){
				 mLiteral *left = (mLiteral*)yyvsp[-2].treeVal->symbol;
				 mLiteral *right = (mLiteral*)yyvsp[0].treeVal->symbol;
				 
				 mEnvironment* env = envStack->top();
				 
				 /* calc new value and store its literal into list,*/
				 /* and replace old ones in environment*/
				 mLiteral *newLit = mLiteral::calculate( left, right,
									 NODE_LESS, literalList, env,
									 classBool );
				 
				 /* if addition could not be performed, 0 is returned*/
				 if( !newLit ){
				   myerror();
				   cout<<"cannot perform '<' on "<<*left->theClass->name
				       <<" and "<<*right->theClass->name<<endl;
				   yyval.treeVal = 0;
				   break;
				 }
				 
				 mParseTree *tree=new mParseTree( NODE_LITERAL, newLit,
								  newLit->theClass );
				 yyval.treeVal = tree;
				 
			       }else{
				 
				 /* otherwise we have a '<' expression */
   
				 mParseTree *tree = new mParseTree( NODE_LESS );

				 /* check for implicit promotion*/
				 if( !tree->promotePrimitivesViaCast(left, right, NODE_LESS, classBool)){
				   myerror();
				   cout<<"cannot perform '<' on "<<yyvsp[-2].treeVal->getType()
				       <<" and "<<yyvsp[0].treeVal->getType()<<endl;
				   yyval.treeVal = 0;
				   break;
				 }
				 
				 /* add left & right branches*/
				 tree->append( left );  tree->append( right );

				 yyval.treeVal = tree;

				 				 
			       }
                           }
break;
case 125:
#line 3864 "parser.y"
{

			       /* do nothing if just importing*/
			       if( importing ) break;
                           
			       /* bail out on error*/
			       if(!yyvsp[-2].treeVal || ! yyvsp[0].treeVal){ yyval.treeVal = 0; break; }
                             
			       mParseTree *left = yyvsp[-2].treeVal;
			       mParseTree *right = yyvsp[0].treeVal;
			       
			       /* get class Boolean*/
			       mString tbool("Boolean");
			       mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );
			       
			       /* if both sides are literals we can calculate addition*/
			       /* now*/
			       if( yyvsp[-2].treeVal->type==NODE_LITERAL && yyvsp[0].treeVal->type==NODE_LITERAL ){
				 mLiteral *left = (mLiteral*)yyvsp[-2].treeVal->symbol;
				 mLiteral *right = (mLiteral*)yyvsp[0].treeVal->symbol;
				 
				 mEnvironment* env = envStack->top();
				 
				 /* calc new value and store its literal into list,*/
				 /* and replace old ones in environment*/
				 mLiteral *newLit = mLiteral::calculate( left, right,
									 NODE_GREATER, literalList, env,
									 classBool );
				 
				 /* if addition could not be performed, 0 is returned*/
				 if( !newLit ){
				   myerror();
				   cout<<"cannot perform '>' on "<<*left->theClass->name
				       <<" and "<<*right->theClass->name<<endl;
				   yyval.treeVal = 0;
				   break;
				 }
				 
				 mParseTree *tree=new mParseTree( NODE_LITERAL, newLit,
								  newLit->theClass );
				 yyval.treeVal = tree;
				 
			       }else{
				 				 
				 /* otherwise we have a '>' expression */
   
				 mParseTree *tree = new mParseTree( NODE_GREATER );

				 /* check for implicit promotion*/
				 if( !tree->promotePrimitivesViaCast(left, right, NODE_GREATER, classBool)){
				   myerror();
				   cout<<"cannot perform '>' on "<<yyvsp[-2].treeVal->getType()
				       <<" and "<<yyvsp[0].treeVal->getType()<<endl;
				   yyval.treeVal = 0;
				   break;
				 }
				 
				 /* add left & right branches*/
				 tree->append( left );  tree->append( right );

				 yyval.treeVal = tree;
				 
			       }
			       
                           }
break;
case 126:
#line 3931 "parser.y"
{

			       /* do nothing if just importing*/
			       if( importing ) break;
                           
			       /* bail out on error*/
			       if(!yyvsp[-2].treeVal || ! yyvsp[0].treeVal){ yyval.treeVal = 0; break; }
                             
			       mParseTree *left = yyvsp[-2].treeVal;
			       mParseTree *right = yyvsp[0].treeVal;
			     
			       /* get class Boolean*/
			       mString tbool("Boolean");
			       mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );

			       /* if both sides are literals we can calculate equivalence*/
			       /* now*/
			       if( yyvsp[-2].treeVal->type==NODE_LITERAL && yyvsp[0].treeVal->type==NODE_LITERAL ){
				 mLiteral *left = (mLiteral*)yyvsp[-2].treeVal->symbol;
				 mLiteral *right = (mLiteral*)yyvsp[0].treeVal->symbol;
				 
				 mEnvironment* env = envStack->top();
				 
				 /* calc new value and store its literal into list,*/
				 /* and replace old ones in environment*/
				 mLiteral *newLit = mLiteral::calculate( left, right,
									 NODE_EQUALS, literalList, env,
									 classBool );
				 
				 /* if equals could not be performed, 0 is returned*/
				 if( !newLit ){
				   myerror();
				   cout<<"cannot perform '==' on "<<*left->theClass->name
				       <<" and "<<*right->theClass->name<<endl;
				   yyval.treeVal = 0;
				   break;
				 }
				 
				 mParseTree *tree=new mParseTree( NODE_LITERAL, newLit,
								  newLit->theClass );
				 yyval.treeVal = tree;
				 
			       }else{

				 /* first we check if we're dealing with two primitive types*/
				 if(mParseTree::bothPrimitive(left, right)){

				   /* create '==' node*/
				   mParseTree *tree = new mParseTree( NODE_EQUALS );
			
				   /* check for implicit promotion*/
				   if( !tree->promotePrimitivesViaCast(left,right, NODE_EQUALS, classBool)){
				     myerror();
				     cout<<"cannot perform '==' on "<<yyvsp[-2].treeVal->getType()
					 <<" and "<<yyvsp[0].treeVal->getType()<<endl;
				     yyval.treeVal = 0;
				     break;
				   }
				   
				   /* add left & right branches*/
				   tree->append( left );  tree->append( right );
				   
				   yyval.treeVal = tree;
				   
				 }else{  /* mParseTree::bothPrimitive(left, right)*/

				   /* operator == on complex type*/

				   /* for now this means reference comparison, but later this operator*/
				   /* may be redefined*/

				   /* create '==' node*/
				   mParseTree *tree = new mParseTree( NODE_EQUALS );
				   tree->returnType = classBool;

				   /* add left & right branches*/
				   tree->append( left );  tree->append( right );
				   
				   yyval.treeVal = tree;

				 }

			       }

                           }
break;
case 127:
#line 4017 "parser.y"
{

			       /* do nothing if just importing*/
			       if( importing ) break;
                           
			       /* bail out on error*/
			       if(!yyvsp[-2].treeVal || ! yyvsp[0].treeVal){ yyval.treeVal = 0; break; }
                             
			       mParseTree *left = yyvsp[-2].treeVal;
			       mParseTree *right = yyvsp[0].treeVal;
			     
			       /* get class Boolean*/
			       mString tbool("Boolean");
			       mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );

			       /* if both sides are literals we can calculate addition*/
			       /* now*/
			       if( yyvsp[-2].treeVal->type==NODE_LITERAL && yyvsp[0].treeVal->type==NODE_LITERAL ){
				 mLiteral *left = (mLiteral*)yyvsp[-2].treeVal->symbol;
				 mLiteral *right = (mLiteral*)yyvsp[0].treeVal->symbol;
				 
				 mEnvironment* env = envStack->top();
				 
				 /* calc new value and store its literal into list,*/
				 /* and replace old ones in environment*/
				 mLiteral *newLit = mLiteral::calculate( left, right,
									 NODE_NOT_EQUALS, literalList, env,
									 classBool );
				 
				 /* if addition could not be performed, 0 is returned*/
				 if( !newLit ){
				   myerror();
				   cout<<"cannot perform '!=' on "<<*left->theClass->name
				       <<" and "<<*right->theClass->name<<endl;
				   yyval.treeVal = 0;
				   break;
				 }
				 
				 mParseTree *tree=new mParseTree( NODE_LITERAL, newLit,
								  newLit->theClass );
				 yyval.treeVal = tree;
				 
			       }else{
				 
				 /* first we check if we're dealing with two primitive types*/
				 if(mParseTree::bothPrimitive(left, right)){

				   /* create '!=' node*/
				   mParseTree *tree = new mParseTree( NODE_NOT_EQUALS );
				 
				   /* check for implicit promotion*/
				   if( !tree->promotePrimitivesViaCast(left, right, NODE_NOT_EQUALS, 
								       classBool)){
				     myerror();
				     cout<<"cannot perform '!=' on "<<yyvsp[-2].treeVal->getType()
					 <<" and "<<yyvsp[0].treeVal->getType()<<endl;
				     yyval.treeVal = 0;
				     break;
				   }
				   
				   /* add left & right branches*/
				   tree->append( left );  tree->append( right );
				 
				   yyval.treeVal = tree;

				 }else{  /* mParseTree::bothPrimitive(left, right)*/


				   /* operator != on complex type*/

				   /* for now this means reference comparison, but later this operator*/
				   /* may be redefined*/

				   /* create '!=' node*/
				   mParseTree *tree = new mParseTree( NODE_NOT_EQUALS );
				   tree->returnType = classBool;

				   /* add left & right branches*/
				   tree->append( left );  tree->append( right );
				   
				   yyval.treeVal = tree;

				 }

			       }

			       
                           }
break;
case 128:
#line 4106 "parser.y"
{

			       /* do nothing if just importing*/
			       if( importing ) break;
			       
			       /* bail out on error*/
			       if(!yyvsp[-2].treeVal || ! yyvsp[0].treeVal){ yyval.treeVal = 0; break; }
                             
			       mParseTree *left = yyvsp[-2].treeVal;
			       mParseTree *right = yyvsp[0].treeVal;
			     
			       /* get class Boolean*/
			       mString tbool("Boolean");
			       mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );

			       /* if both sides are literals we can calculate addition*/
			       /* now*/
			       if( yyvsp[-2].treeVal->type==NODE_LITERAL && yyvsp[0].treeVal->type==NODE_LITERAL ){
				 mLiteral *left = (mLiteral*)yyvsp[-2].treeVal->symbol;
				 mLiteral *right = (mLiteral*)yyvsp[0].treeVal->symbol;
				 
				 mEnvironment* env = envStack->top();
				 
				 /* calc new value and store its literal into list,*/
				 /* and replace old ones in environment*/
				 mLiteral *newLit = mLiteral::calculate( left, right,
									 NODE_GREATER_OR_EQUALS, 
									 literalList, env, classBool );
				 
				 /* if addition could not be performed, 0 is returned*/
				 if( !newLit ){
				   myerror();
				   cout<<"cannot perform '>=' on "<<*left->theClass->name
				       <<" and "<<*right->theClass->name<<endl;
				   yyval.treeVal = 0;
				   break;
				 }
				 
				 mParseTree *tree=new mParseTree( NODE_LITERAL, newLit,
								  newLit->theClass );
				 yyval.treeVal = tree;
				 
			       }else{

                           
				 /* create '>=' node*/
				 mParseTree *tree = new mParseTree( NODE_GREATER_OR_EQUALS );
				 
				 /* check for implicit promotion*/
				 if( !tree->promotePrimitivesViaCast(left, right, NODE_GREATER_OR_EQUALS, 
								     classBool)){
				   myerror();
				   cout<<"cannot perform '>=' on "<<yyvsp[-2].treeVal->getType()
				       <<" and "<<yyvsp[0].treeVal->getType()<<endl;
				   yyval.treeVal = 0;
				   break;
				 }

				 /* add left & right branches*/
				 tree->append( left );  tree->append( right );
				 
				 yyval.treeVal = tree;
			       }

                           }
break;
case 129:
#line 4172 "parser.y"
{

			       /* do nothing if just importing*/
			       if( importing ) break;
                           
			       /* bail out on error*/
			       if(!yyvsp[-2].treeVal || ! yyvsp[0].treeVal){ yyval.treeVal = 0; break; }
                             
			       mParseTree *left = yyvsp[-2].treeVal;
			       mParseTree *right = yyvsp[0].treeVal;
			     
			       /* get class Boolean*/
			       mString tbool("Boolean");
			       mClass* classBool = (mClass*)root->getSymbol( &tbool, SYMBOL_CLASS );

			       /* if both sides are literals we can calculate addition*/
			       /* now*/
			       if( yyvsp[-2].treeVal->type==NODE_LITERAL && yyvsp[0].treeVal->type==NODE_LITERAL ){
				 mLiteral *left = (mLiteral*)yyvsp[-2].treeVal->symbol;
				 mLiteral *right = (mLiteral*)yyvsp[0].treeVal->symbol;
				 
				 mEnvironment* env = envStack->top();
				 
				 /* calc new value and store its literal into list,*/
				 /* and replace old ones in environment*/
				 mLiteral *newLit = mLiteral::calculate( left, right,
									 NODE_LESS_OR_EQUALS, 
									 literalList, env, classBool );
				 
				 /* if addition could not be performed, 0 is returned*/
				 if( !newLit ){
				   myerror();
				   cout<<"cannot perform '<=' on "<<*left->theClass->name
				       <<" and "<<*right->theClass->name<<endl;
				   yyval.treeVal = 0;
				   break;
				 }
				 
				 mParseTree *tree=new mParseTree( NODE_LITERAL, newLit,
								  newLit->theClass );
				 yyval.treeVal = tree;
				 
			       }else{
				 
				 /* create '<=' node*/
				 mParseTree *tree = new mParseTree( NODE_LESS_OR_EQUALS );
				 
				 /* check for implicit promotion*/
				 if( !tree->promotePrimitivesViaCast(left, right, NODE_LESS_OR_EQUALS, 
								     classBool)){
				   myerror();
				   cout<<"cannot perform '<=' on "<<yyvsp[-2].treeVal->getType()
				       <<" and "<<yyvsp[0].treeVal->getType()<<endl;
				   yyval.treeVal = 0;
				   break;
				 }

				 /* add left & right branches*/
				 tree->append( left );  tree->append( right );
				 
				 yyval.treeVal = tree;
			       }
			       
                           }
break;
case 130:
#line 4239 "parser.y"
{ yyval.treeVal=yyvsp[0].treeVal; }
break;
case 131:
#line 4240 "parser.y"
{

			     /* do nothing if just importing*/
			     if( importing ) break;

			     /* bail out on error*/
			     if(!yyvsp[-2].treeVal || ! yyvsp[0].treeVal){ yyval.treeVal = 0; break; }
                             
			     mParseTree *left = yyvsp[-2].treeVal;
			     mParseTree *right = yyvsp[0].treeVal;
			     
			     /* if both sides are literals we can calculate addition*/
			     /* now*/
			     if( yyvsp[-2].treeVal->type==NODE_LITERAL && yyvsp[0].treeVal->type==NODE_LITERAL ){
			       mLiteral *left = (mLiteral*)yyvsp[-2].treeVal->symbol;
			       mLiteral *right = (mLiteral*)yyvsp[0].treeVal->symbol;

			       mEnvironment* env = envStack->top();

			       /* calc new value and store its literal into list,*/
			       /* and replace old ones in environment*/
			       mLiteral *newLit = mLiteral::calculate( left, right,
						  NODE_PLUS, literalList, env );

			       /* if addition could not be performed, 0 is returned*/
			       if( !newLit ){
				 myerror();
				 cout<<"cannot perform '+' on "<<*left->theClass->name
				     <<" and "<<*right->theClass->name<<endl;
				 yyval.treeVal = 0;
				 break;
			       }

			       mParseTree *tree=new mParseTree( NODE_LITERAL, newLit,
								newLit->theClass );
			       yyval.treeVal = tree;
			     }else{

			       /* otherwise we have an addition expression */

			       /* 1st we check primitive types*/
			       /*if(mParseTree::primitiveTypes(left,right)){*/

			       /* create '+' node*/
			       mParseTree *tree = new mParseTree( NODE_PLUS );
			       			      			       
			       /* check for implicit promotion*/
			       if( !tree->promotePrimitivesViaCast(left, right, NODE_PLUS)){
				 myerror();
				 cout<<"cannot perform '+' on "<<yyvsp[-2].treeVal->getType()
				     <<" and "<<yyvsp[0].treeVal->getType()<<endl;				 
				 yyval.treeVal = 0;
				 break;
			       }
			       

			       /* add left & right branches*/
			       tree->append( left );  tree->append( right );

			       yyval.treeVal = tree;
			       /*}else{ */
			         /* now we deal with user defined types */
			         /* because we may have operators defined!!*/
			     }
                             
                           }
break;
case 132:
#line 4306 "parser.y"
{

			     /* do nothing if just importing*/
			     if( importing ) break;
        
			     /* bail out on error*/
			     if(!yyvsp[-2].treeVal || ! yyvsp[0].treeVal){ yyval.treeVal = 0; break; }

			     mParseTree *left = yyvsp[-2].treeVal;
			     mParseTree *right = yyvsp[0].treeVal;

			     /* if both sides are literals we can calculate addition*/
			     /* now*/
			     if( yyvsp[-2].treeVal->type==NODE_LITERAL && yyvsp[0].treeVal->type==NODE_LITERAL ){
			       mLiteral *left = (mLiteral*)yyvsp[-2].treeVal->symbol;
			       mLiteral *right = (mLiteral*)yyvsp[0].treeVal->symbol;

			       mEnvironment* env = envStack->top();

			       /* calc new value and store its literal into list*/
			       /* and replace old ones in environment*/
			       mLiteral *newLit = mLiteral::calculate( left, right,
						  NODE_MINUS, literalList, env );

			       /* if subtraction could not be performed, 0 is returned*/
			       if( !newLit ){
				 myerror();
				 cout<<"cannot perform '-' on "<<*left->theClass->name
				     <<" and "<<*right->theClass->name<<endl;
				 yyval.treeVal = 0;
				 break;
			       }

			       mParseTree *tree=new mParseTree( NODE_LITERAL, newLit );
			       yyval.treeVal = tree;

			     }else{

			       /* otherwise we have a subtraction expression */
   
			       mParseTree *tree = new mParseTree( NODE_MINUS );

			       /* check for implicit promotion*/
			       if( !tree->promotePrimitivesViaCast(left, right, NODE_MINUS)){
				 myerror();
				 cout<<"cannot perform '-' on "<<yyvsp[-2].treeVal->getType()
				     <<" and "<<yyvsp[0].treeVal->getType()<<endl;
				 yyval.treeVal = 0;
				 break;
			       }
			       
			       /* add left & right branches*/
			       tree->append( left );  tree->append( right );

			       yyval.treeVal = tree;
			     }
                           }
break;
case 133:
#line 4367 "parser.y"
{ yyval.treeVal=yyvsp[0].treeVal; }
break;
case 134:
#line 4368 "parser.y"
{

			     /* do nothing if just importing*/
			     if( importing ) break;

			     /* bail out on error*/
			     if(!yyvsp[-2].treeVal || ! yyvsp[0].treeVal){ yyval.treeVal = 0; break; }

			     mParseTree *left = yyvsp[-2].treeVal;
			     mParseTree *right = yyvsp[0].treeVal;

			     /* if both sides are literals we can calculate addition*/
			     /* now*/
			     if( yyvsp[-2].treeVal->type==NODE_LITERAL && yyvsp[0].treeVal->type==NODE_LITERAL ){
			       mLiteral *left = (mLiteral*)yyvsp[-2].treeVal->symbol;
			       mLiteral *right = (mLiteral*)yyvsp[0].treeVal->symbol;

			       mEnvironment* env = envStack->top();

			       /* calc new value and store its literal into list*/
			       /* and replace old ones in environment*/
			       mLiteral *newLit = mLiteral::calculate( left, right,
						  NODE_MULTIPLY, literalList, env );


			       if( !newLit ){
				 myerror();
				 cout<<"cannot perform '*' on "<<*left->theClass->name
				     <<" and "<<*right->theClass->name<<endl;
				 yyval.treeVal = 0;
				 break;
			       }

			       mParseTree *tree=new mParseTree( NODE_LITERAL, newLit );
			       yyval.treeVal = tree;

			     }else{

			       /* otherwise we have a multiplication expression*/

			       mParseTree *tree = new mParseTree( NODE_MULTIPLY );

			       /* check for implicit promotion*/
			       if( !tree->promotePrimitivesViaCast(left, right, NODE_MULTIPLY)){
				 myerror();
				 cout<<"cannot perform '*' on "<<yyvsp[-2].treeVal->getType()
				     <<" and "<<yyvsp[0].treeVal->getType()<<endl;
				 yyval.treeVal = 0;
				 break;
			       }

			       tree->append( left );  tree->append( right );
			       yyval.treeVal = tree;
			     }

                           }
break;
case 135:
#line 4424 "parser.y"
{

			     /* do nothing if just importing*/
			     if( importing ) break;

			     /* bail out on error*/
			     if(!yyvsp[-2].treeVal || ! yyvsp[0].treeVal){ yyval.treeVal = 0; break; }
			     
			     mParseTree *left = yyvsp[-2].treeVal;
			     mParseTree *right = yyvsp[0].treeVal;

			     /* if both sides are literals we can calculate addition*/
			     /* now*/
			     if( yyvsp[-2].treeVal->type==NODE_LITERAL && yyvsp[0].treeVal->type==NODE_LITERAL ){
			       mLiteral *left = (mLiteral*)yyvsp[-2].treeVal->symbol;
			       mLiteral *right = (mLiteral*)yyvsp[0].treeVal->symbol;

			       mEnvironment* env = envStack->top();

			       /* calc new value and store its literal into list*/
			       /* and replace old ones in environment*/
			       mLiteral *newLit = mLiteral::calculate( left, right,
						  NODE_DIVIDE, literalList, env );

			       if( !newLit ){
				 myerror();
				 cout<<"cannot perform '/' on "<<*left->theClass->name
				     <<" and "<<*right->theClass->name<<endl;
				 yyval.treeVal = 0;
				 break;
			       }


			       mParseTree *tree=new mParseTree( NODE_LITERAL, newLit );
			       yyval.treeVal = tree;
			     }else{

			       /* otherwise we have a division expression */

			       mParseTree *tree = new mParseTree( NODE_DIVIDE );

			       /* check for implicit promotion*/
			       if( !tree->promotePrimitivesViaCast(left, right, NODE_DIVIDE)){
				 myerror();
				 cout<<"cannot perform '*' on "<<yyvsp[-2].treeVal->getType()
				     <<" and "<<yyvsp[0].treeVal->getType()<<endl;
				 yyval.treeVal = 0;
				 break;
			       }

			       tree->append( yyvsp[-2].treeVal );  tree->append( yyvsp[0].treeVal );
			       yyval.treeVal = tree;
			     }
                           }
break;
case 136:
#line 4479 "parser.y"
{

			     /* do nothing if just importing*/
			     if( importing ) break;

			     /* bail out on error*/
			     if(!yyvsp[-2].treeVal || ! yyvsp[0].treeVal){ yyval.treeVal = 0; break; }
			     
			     mParseTree *left = yyvsp[-2].treeVal;
			     mParseTree *right = yyvsp[0].treeVal;

			     /* if both sides are literals we can calculate mod*/
			     /* now*/
			     if( yyvsp[-2].treeVal->type==NODE_LITERAL && yyvsp[0].treeVal->type==NODE_LITERAL ){
			       mLiteral *left = (mLiteral*)yyvsp[-2].treeVal->symbol;
			       mLiteral *right = (mLiteral*)yyvsp[0].treeVal->symbol;

			       mEnvironment* env = envStack->top();

			       /* calc new value and store its literal into list*/
			       /* and replace old ones in environment*/
			       mLiteral *newLit = mLiteral::calculate( left, right,
						  NODE_MODULE, literalList, env );

			       if( !newLit ){
				 myerror();
				 cout<<"cannot perform '/' on "<<*left->theClass->name
				     <<" and "<<*right->theClass->name<<endl;
				 yyval.treeVal = 0;
				 break;
			       }


			       mParseTree *tree=new mParseTree( NODE_LITERAL, newLit );
			       yyval.treeVal = tree;
			     }else{

			       /* otherwise we have a module expression */

			       mParseTree *tree = new mParseTree( NODE_MODULE );

			       /* check for implicit promotion*/
			       if( !tree->promotePrimitivesViaCast(left, right, NODE_MODULE)){
				 myerror();
				 cout<<"cannot perform '%' on "<<yyvsp[-2].treeVal->getType()
				     <<" and "<<yyvsp[0].treeVal->getType()<<endl;
				 yyval.treeVal = 0;
				 break;
			       }

			       tree->append( yyvsp[-2].treeVal );  tree->append( yyvsp[0].treeVal );
			       yyval.treeVal = tree;
			     }
                           }
break;
case 137:
#line 4536 "parser.y"
{ yyval.treeVal=yyvsp[0].treeVal; }
break;
case 138:
#line 4537 "parser.y"
{ /*$$=(int)pow($1,$3);*/ }
break;
case 139:
#line 4540 "parser.y"
{

		    /* do nothing if just importing*/
		    if( importing ) break;

		    /* bail out on error*/
		    if(!yyvsp[-1].treeVal){ yyval.treeVal = 0; break; }
			     

		    /* if both sides are literals we can calculate mod*/
		    /* now*/
		    if( yyvsp[-1].treeVal->type==NODE_LITERAL ){
		      mLiteral *left = (mLiteral*)yyvsp[-1].treeVal->symbol;

		      mEnvironment* env = envStack->top();

		      /* calc new value and store its literal into list*/
		      /* and replace old ones in environment*/
		      mLiteral *newLit = mLiteral::calculate( left, 0,
							      NODE_INCREMENT, literalList, env );
		      
		      if( !newLit ){
			myerror();
			cout<<"cannot perform '++' on "<<*left->theClass->name<<endl;
			yyval.treeVal = 0;
			break;
		      }
		      
		      
		      mParseTree *tree=new mParseTree( NODE_LITERAL, newLit );
		      yyval.treeVal = tree;
		    }else{
		      
		      /* otherwise we have an increment expression which is available only on*/
		      /* Integers and Doubles*/
		      if( yyvsp[-1].treeVal->getType() == "Integer" || yyvsp[-1].treeVal->getType() == "Double" ){
		     		      
		      
			mParseTree *tree = new mParseTree( NODE_INCREMENT, yyvsp[-1].treeVal->returnType );
			tree->append( yyvsp[-1].treeVal );
			yyval.treeVal = tree;

		      }else{

			myerror();
			cout<<"cannot perform '++' on "<<yyvsp[-1].treeVal->getType()<<endl;
			yyval.treeVal = 0;
			break;
		      }
		      		      
		    }
		    
		    
		  }
break;
case 140:
#line 4595 "parser.y"
{

		    /* do nothing if just importing*/
		    if( importing ) break;

		    /* bail out on error*/
		    if(!yyvsp[-1].treeVal){ yyval.treeVal = 0; break; }
			     

		    /* if both sides are literals we can calculate mod*/
		    /* now*/
		    if( yyvsp[-1].treeVal->type==NODE_LITERAL ){
		      mLiteral *left = (mLiteral*)yyvsp[-1].treeVal->symbol;

		      mEnvironment* env = envStack->top();

		      /* calc new value and store its literal into list*/
		      /* and replace old ones in environment*/
		      mLiteral *newLit = mLiteral::calculate( left, 0,
							      NODE_DECREMENT, literalList, env );
		      
		      if( !newLit ){
			myerror();
			cout<<"cannot perform '--' on "<<*left->theClass->name<<endl;
			yyval.treeVal = 0;
			break;
		      }
		      
		      
		      mParseTree *tree=new mParseTree( NODE_LITERAL, newLit );
		      yyval.treeVal = tree;
		    }else{
		      
		      /* otherwise we have an increment expression which is available only on*/
		      /* Integers and Doubles*/
		      if( yyvsp[-1].treeVal->getType() == "Integer" || yyvsp[-1].treeVal->getType() == "Double" ){
		     		      
		      
			mParseTree *tree = new mParseTree( NODE_DECREMENT, yyvsp[-1].treeVal->returnType );
			tree->append( yyvsp[-1].treeVal );
			yyval.treeVal = tree;

		      }else{

			myerror();
			cout<<"cannot perform '--' on "<<yyvsp[-1].treeVal->getType()<<endl;
			yyval.treeVal = 0;
			break;
		      }
		      		      
		    }
		    
		    
		  }
break;
case 141:
#line 4653 "parser.y"
{ yyval.treeVal = yyvsp[0].treeVal; }
break;
case 142:
#line 4656 "parser.y"
{

		      /* do nothing if just importing*/
		      if( importing ) break;

		      /* check if we can cast */

		      /* create CAST node*/
		      mParseTree *tree = new mParseTree( NODE_COMPLEX_CAST );
		      tree->returnType = yyvsp[0].classVal;

		      tree->append( yyvsp[-2].treeVal );   /* add expression*/
		      tree->append( new mParseTree( NODE_TYPE, yyvsp[0].classVal ) );   /* add type*/

		      yyval.treeVal = tree;

		     }
break;
case 143:
#line 4693 "parser.y"
{ yyval.treeVal = yyvsp[-1].treeVal;  }
break;
case 144:
#line 4700 "parser.y"
{
		         
		         /* do nothing if just importing*/
		         if( importing ) break;

		         /* append literal to environment*/
		         mEnvironment* env = envStack->top();			 
			 env->append( yyvsp[0].literalVal );		      

			 /* create literal node*/
			 mParseTree *tree = new mParseTree( NODE_LITERAL, yyvsp[0].literalVal );

			 yyval.treeVal = tree;

                     }
break;
case 145:
#line 4716 "parser.y"
{

                       /* do nothing if just importing*/
                       if( importing ) break;

		       if( yyvsp[0].treeVal )
			 yyvsp[0].treeVal->implicitReference = true;  /* call via implicit reference if 1st component*/
		                                        /* is methodcall*/
                       yyval.treeVal = yyvsp[0].treeVal;

                     }
break;
case 146:
#line 4728 "parser.y"
{		       

		       /* do nothing if just importing*/
		       if( importing ) break;

		       if( yyvsp[0].treeVal )
			 yyvsp[0].treeVal->implicitReference = true;  /* call via implicit reference if 1st component*/
		                                        /* is methodcall*/
                       yyval.treeVal = yyvsp[0].treeVal;

                     }
break;
case 147:
#line 4740 "parser.y"
{
                       yyval.treeVal = yyvsp[0].treeVal;
                     }
break;
case 148:
#line 4750 "parser.y"
{ 

		       /* do nothing if just importing*/
		       if( !importing ){

			 /* type of this literal is domain for method access*/

			 /* append literal to environment*/
			 mEnvironment* env = envStack->top();			 
			 env->append( yyvsp[-1].literalVal );
			 
			 /* create literal node*/
			 mParseTree *tree = new mParseTree( NODE_LITERAL, yyvsp[-1].literalVal );
			 
			 partialExpression = tree; 
		       }

		     }
break;
case 149:
#line 4769 "parser.y"
{

		       /* do nothing if just importing*/
		       if( importing ) break;

		       yyval.treeVal = yyvsp[0].treeVal;
		       expressionError = false;

                     }
break;
case 150:
#line 4780 "parser.y"
{ 		       

		       /* do nothing if just importing*/
		       if( !importing ){

			 /* returnType of this expression is domain for fieldaccess*/

			 /* we cannot invoke anything on void expression*/
			 if(yyvsp[-2].treeVal->returnType == 0) expressionError = true;

			 /* DODANO*/
			 /*mParseTree *tree = new mParseTree( NODE_PARENTHESES, $2->returnType );*/
			 /*tree->append( $2 );*/

			 partialExpression = /*tree;*/  yyvsp[-2].treeVal; 
			 
		       }

                       }
break;
case 151:
#line 4800 "parser.y"
{
		       		       
		            /* do nothing if just importing*/
		            if( importing ) break;

		            yyval.treeVal = yyvsp[-4].treeVal;			    
			    

			    expressionError = false;			    

			    /*cout<<"TOTAL partial expression="<<$2->toString()<<endl;*/
			    

                     }
break;
case 152:
#line 4815 "parser.y"
{

			 /* do nothing if just importing*/
			 if( importing ) break;
			 
			 yyval.treeVal = yyvsp[0].treeVal;
		     }
break;
case 153:
#line 4829 "parser.y"
{
                     yyval.treeVal = currentFieldTree;		     
		     
                   }
break;
case 154:
#line 4833 "parser.y"
{
                
                     yyval.treeVal = currentMethodTree;
                   }
break;
case 155:
#line 4841 "parser.y"
{ yyval.treeVal = currentMethodTree; }
break;
case 156:
#line 4847 "parser.y"
{ yyval.treeVal = currentFieldTree; }
break;
case 157:
#line 4979 "parser.y"
{ 

		  /* INFIX RULE:*/

		  /* identifier has ben parsed, now deal with partial expression*/
		  /* if it was invoked upon*/
		  /* this is because partial expression is only meaningful for last*/
		  /* identifier in this QualifiedIdentifier, arguments are NOT evaluated*/
		  /* on partialExpression*/

		  if( !importing && partialExpression ){


		    /* remove partial expression and save it on stack*/
		    expressionStack->push( partialExpression );
		    partialExpression = 0;		    
		    
		  }
		  

                }
break;
case 158:
#line 5001 "parser.y"
{

                /* do nothing if just importing*/
	        if( importing ) break;

                mEnvironment *env = envStack->top();

		/* get partial expression if it was pushed onto stack*/
		if(expressionStack->size() > 0){
		  
		  partialExpression = expressionStack->top();
		  



		  expressionStack->pop();

		}
                
                /* this one takes: classmethod(...)*/


		/*//////////////////////////////////////////////////*/
		/* 1 component - class method name*/
		/*//////////////////////////////////////////////////*/


                if( yyvsp[-4].stringList->size() == 1 ){   /* one component means we're accessing*/
                                         /* a class method with parameters*/
                                         
		  /*v funkciji getMethod bomo pogledali, ce so childi NODE_ARGUMENTS NODE_PARAMETERS */

		  bool ambiguous = false;

		  /* find class method with parameters*/
		  mMethod* meth;
		  if( partialExpression )  /* MethodAccess on partial expression*/
		    meth = partialExpression->returnType->getMethod( yyvsp[-4].stringList->at( 0 ), yyvsp[-1].treeVal, true, ambiguous );
		  else meth = env->ownerClass->getMethod( yyvsp[-4].stringList->at( 0 ), yyvsp[-1].treeVal, true, ambiguous );

		  
		  if( meth != 0 ){
		    		    

		    mMethod* currentMethod = methodStack->top();

		    /* constructor cannot be explicitly called*/
		    if( meth->isConstructor() ){
		      myerror();
		      cout<<"constructor '"<<*meth->name<<"' cannot be invoked directly"<<endl;
		      currentMethodTree = 0;
		      yyval.treeVal = 0;
		      break;
		    }

		    /* non-static methods cannot be called from static*/
		    if(!partialExpression && currentMethod->isStatic() && !meth->isStatic()){
		      myerror();
		      cout<<"cannot invoke dynamically bound method '"<<*meth->name<<"' from static scope"
			  <<endl;
		      currentMethodTree = 0;
		      yyval.treeVal = 0;
		      break;
		    }

		    /* check access privileges*/
		    if( !meth->isAccessibleWithin( env->ownerClass ) ){
		      myerror();
		      cout<<"method '"<<*meth->name<<"' cannot be invoked because of insufficient"
			  <<" privileges"<<endl;
		      currentMethodTree = 0;
		      yyval.treeVal = 0;
		      break;
		    }


		    /*cout<<"got method "<<*meth->name<<", now performing cast"<<endl;*/
		    /*exit(1);*/


		    if( !yyvsp[-1].treeVal->performArgumentsCast(yyvsp[-1].treeVal, meth ) ){

		      myerror();
		      cout<<"cannot perform cast to call method '"<<*meth->name<<"'"<<endl;
		      currentMethodTree = 0;
		      yyval.treeVal = 0;
		      break;

		    }

		    /* generate tree for method invocation*/
		    mParseTree *tree = new mParseTree( NODE_METHODCALL, meth, meth->returnType );
		     
		    /* add arguments*/
		    tree->append( yyvsp[-1].treeVal );
                    

		    if( partialExpression ){

		      partialExpression->append( tree );
		      tree = partialExpression;		      
		      /* return type of whole expression becomes return type of LAST expression*/
		      tree->returnType = meth->returnType;
		      partialExpression = 0;
		    }

		    currentMethodTree = tree;
		    yyval.treeVal = tree;

		  }else{

		    myerror();
		    if(ambiguous)
		      cout<<"ambiguous invocation of method '"<<*yyvsp[-4].stringList->at( 0 )<<"'"<<endl;
		    else
		      cout<<"method '"<<*yyvsp[-4].stringList->at( 0 )<<"' not found!"<<endl;
		    /* generate unresolved symbol node*/
		    /*mParseTree *tree = new mParseTree( NODE_UNRESOLVED, $1->at( 0 ) );*/
		    
		    currentMethodTree = 0;/*tree;*/
		    yyval.treeVal = 0;/*tree;*/
		  }
		  

                }else{ /* if( $1->size() == 1 )*/
                
		  
		  /*//////////////////////////////////////////////////*/
		  /* more than 1 component - sequence of invocations*/
		  /*//////////////////////////////////////////////////*/
		  
		  /* more than 1 component indicates that we have a sequence*/
		  /* of method calls*/
		  /* we have two options:*/
		  /* 1. call via variable: var.method1.methodN(...)*/
		  /* 2. call via classmethod: classmethod.method1.methodN(...)*/

		  /* first let's see what component 1 is*/
		  mSymbol *sym;
		  if( partialExpression ){  /* FieldAccess on partial expression		    */
		    sym = partialExpression->returnType->getMethod( yyvsp[-4].stringList->at( 0 ) );
		  }else{
		    sym = env->getSymbol( yyvsp[-4].stringList->at( 0 ) );		  
		  }
                
		  if( sym != 0 ){
		    if( sym->symbolType == SYMBOL_VARIABLE || sym->symbolType == SYMBOL_PARAMETER ){

		      /*///////////////////////////////////////////*/
		      /* we're accessing method via local variable*/
		      /*///////////////////////////////////////////*/
                         
		      /* create a variable access node*/
		      mParseTree *tree = new mParseTree( NODE_VARIABLE, sym );

		      mParseTree *current = tree;
                         
		      /* now we create child nodes for every additional*/
		      /* method call. last one is special though,*/
		      /* because it accepts arguments*/
                         
		      /* we need class of our variable so we can check*/
		      /* for methods*/
		      mClass *domain = sym->theClass;

		      /* for every method except last one*/
		      for(unsigned i = 1; i < yyvsp[-4].stringList->size() - 1; i++ ){
			mString *methodName = yyvsp[-4].stringList->at( i );
                             
			/* now we check for parameterless method*/
			/* 'methodName' in class 'domain'*/
			mMethod *m = domain->getMethod( methodName );
                             
			if( !m ){

			  myerror();

			  if(domain->ambiguous)
			    cout<<"ambiguous invocation of method '"<<*methodName<<"'"<<endl;
			  else
			  cout<<"method '"<<*methodName<<"' not found in class '"
			      <<*domain->name<<"'"<<endl;
			  domain = 0; 
			  break;

			}


			/* check access privileges*/
			if( !m->isAccessibleWithin( env->ownerClass ) ){
			  myerror();
			  cout<<"method '"<<*m->name<<"' cannot be invoked because of insuficient"
			      <<" privileges"<<endl;
			  domain = 0;
			  break;
			}



			/* generate tree for method call and append it*/
			/* to parent                             */
			mParseTree *call = new mParseTree( NODE_METHODCALL, m );
			current->append( call );
			current = call;
                             

			/* domain for next call is return type of this method*/
			domain = m->returnType;                             
		      }

		      if( domain ){

			/* now we deal with the last one which accepts arguments*/
			mString *methodName = yyvsp[-4].stringList->at( yyvsp[-4].stringList->size() - 1 );
                             
			bool ambiguous = false;

			/* now we check for method with parameters*/
			/* 'methodName' in class 'domain'*/
			mMethod *m = domain->getMethod( methodName, yyvsp[-1].treeVal, true, ambiguous );
                             			
			if( !m ){

			  myerror();

			  if(ambiguous)
			    cout<<"ambiguous invocation of method '"<<*methodName<<"'"<<endl;
			  else
			    cout<<"method '"<<*methodName<<"(" + yyvsp[-1].treeVal->toStringArguments()
				<<")' not found in class '"
				<<*domain->name<<"'"<<endl;
			  tree = 0;

			}else{


			  /* check access privileges*/
			  if( !m->isAccessibleWithin( env->ownerClass ) ){
			    myerror();
			    cout<<"method '"<<*m->name<<"' cannot be invoked because of insuficient"
				<<" privileges"<<endl;
			    domain = 0;
			    break;
			  }


			  if( !yyvsp[-1].treeVal->performArgumentsCast(yyvsp[-1].treeVal, m ) ){

			    myerror();
			    cout<<"cannot perform cast to call method '"<<*m->name<<"'"<<endl;
			    currentMethodTree = 0;
			    yyval.treeVal = 0;
			    break;

			  }

			  /* generate tree for method call and append it*/
			  /* to parent*/
			  mParseTree *call = new mParseTree( NODE_METHODCALL, m );
			  current->append( call );
			  /* add arguments*/
			  call->append( yyvsp[-1].treeVal );

			  /* returnType of 1st node of sequence calls must be set to returnType*/
			  /* of last method invoked, i.e. in an invocation sequence meth1.meth2.meth3*/
			  /* the returnType becomes that of meth3*/
			  tree->returnType = m->returnType;

			}
                              
		      }else
			tree = 0;  /* 0 on error*/

		      currentMethodTree = tree;
		      yyval.treeVal = tree;
                    

     
		    }else if( sym->symbolType == SYMBOL_METHOD ){
                      
		      /* we have a method which means we're accessing*/
		      /* a method via a class method*/

		      mMethod* currentMethod = methodStack->top();

		      /* constructor cannot be explicitly called*/
		      if( ((mMethod*)sym)->isConstructor() ){
			myerror();
			cout<<"constructor '"<<*sym->name<<"' cannot be invoked directly"<<endl;
			currentMethodTree = 0;
			yyval.treeVal = 0;
			break;
		      }

		      /* non-static methods cannot be called from static*/
		      if(!partialExpression && currentMethod->isStatic() && !((mMethod*)sym)->isStatic()){
			myerror();
			cout<<"cannot invoke dynamically bound method '"<<*sym->name<<"' from static scope"
			    <<endl;
			currentMethodTree = 0;
			yyval.treeVal = 0;
			break;
		      }

		      /* check access privileges*/
		      if( !((mMethod*)sym)->isAccessibleWithin( env->ownerClass ) ){
			myerror();
			cout<<"method '"<<*sym->name<<"' cannot be invoked because of insuficient"
			    <<" privileges"<<endl;
			currentMethodTree = 0;
			yyval.treeVal = 0;
			break;
		      }



		      /* 1st we create methodcall for class method*/
		      mParseTree *tree = new mParseTree( NODE_METHODCALL, sym );
		      currentMethodTree = tree;

		      if( partialExpression ){

			partialExpression->append( tree );
			currentMethodTree = partialExpression;
			partialExpression = 0;
		      }

		      mParseTree *current = tree;

		      /* now we create child nodes for every additional*/
		      /* method call excepth the last*/

		      /* we need class of our variable so we can check*/
		      /* for methods*/
		      mClass *domain = ((mMethod*)sym)->returnType;
                         
		      for(unsigned i = 1; i < yyvsp[-4].stringList->size() - 1; i++ ){
			mString *methodName = yyvsp[-4].stringList->at( i );
                             
			/* now we check for parameterless method*/
			/* 'methodName' in class 'domain'*/
			mMethod *m = domain->getMethod( methodName );
			
			if( !m ){

			  myerror();
			  if(domain->ambiguous)
			    cout<<"ambiguous invocation of method '"<<*methodName<<"'"<<endl;
			  else
			    cout<<"method '"<<*methodName<<"' not found in class '"
				<<*domain->name<<"'"<<endl;
			  domain = 0; break;

			}


			/* check access privileges*/
			if( !m->isAccessibleWithin( env->ownerClass ) ){
			  myerror();
			  cout<<"method '"<<*m->name<<"' cannot be invoked because of insuficient"
			      <<" privileges"<<endl;
			  domain = 0;
			  break;
			}

			
			/* generate tree for method call and append it*/
			/* to parent                             */
			mParseTree *call = new mParseTree( NODE_METHODCALL, m );
			current->append( call );
			current = call;
                             
			/* domain for next call is return type of this method*/
			domain = m->returnType;                             
		      }

		      if( domain ){

			/* now we deal with the last one*/
			mString *methodName = yyvsp[-4].stringList->at( yyvsp[-4].stringList->size() - 1 );
                             
			bool ambiguous = false;
			/* now we check for method with parameters*/
			/* 'methodName' in class 'domain'*/
			mMethod *m = domain->getMethod( methodName, yyvsp[-1].treeVal, true, ambiguous );
                             
			if( !m ){

			  myerror();
			  if(ambiguous)
			    cout<<"ambiguous invocation of method '"<<*methodName<<"'"<<endl;
			  else
			    cout<<"method '"<<*methodName<<"' not found in class '"
				<<*domain->name<<"'"<<endl;

			}else{


			  /* check access privileges*/
			  if( !m->isAccessibleWithin( env->ownerClass ) ){
			    myerror();
			    cout<<"method '"<<*m->name<<"' cannot be invoked because of insuficient"
				<<" privileges"<<endl;
			    domain = 0;
			    break;
			  }
			  

			  if( !yyvsp[-1].treeVal->performArgumentsCast(yyvsp[-1].treeVal, m ) ){
			    myerror();
			    cout<<"cannot perform cast to call method '"<<*m->name<<"'"<<endl;
			    currentMethodTree = 0;
			    yyval.treeVal = 0;
			    break;

			  }

			  /* generate tree for method call and append it*/
			  /* to parent*/
			  mParseTree *call = new mParseTree( NODE_METHODCALL, m );
			  current->append( call );

			  /* add arguments*/
			  call->append( yyvsp[-1].treeVal );

			  /* returnType of 1st node of sequence calls must be set to returnType*/
			  /* of last method invoked, i.e. in an invocation sequence meth1.meth2.meth3*/
			  /* the returnType becomes that of meth3*/
			  tree->returnType = m->returnType;

			}
                                                    
		      }else
			tree = 0;   /* 0 on error*/
		      
		      yyval.treeVal = tree;
		    }
                                          
		  }else{

		    myerror();
		    cout<<"no symbol '"<<*yyvsp[-4].stringList->at( 0 )<<"' found!"<<endl;
		    /* generate unresolved symbol node*/
		    mParseTree *tree = new mParseTree( NODE_UNRESOLVED, yyvsp[-4].stringList->at( 0 ) );
		    
		    currentMethodTree = tree;
		    yyval.treeVal = tree;

		  }

                }
              }
break;
case 159:
#line 5455 "parser.y"
{
	          /* INFIX RULE:*/

		  /* identifier has ben parsed, now deal with partial expression*/
		  /* if it was invoked upon*/
		  /* this is because partial expression is only meaningful for last*/
		  /* identifier in this QualifiedIdentifier, arguments are NOT evaluated*/
		  /* on partialExpression*/

		  if( !importing && partialExpression ){


		    /* remove partial expression and save it on stack*/
		    expressionStack->push( partialExpression );
		    partialExpression = 0;		    
		    
		  }
		  

                }
break;
case 160:
#line 5477 "parser.y"
{


                /* do nothing if just importing*/
	        if( importing ) break;

		mEnvironment *env = envStack->top();


		/* get partial expression if it was pushed onto stack*/
		if(expressionStack->size() > 0){
		  
		  partialExpression = expressionStack->top();
		  


		  expressionStack->pop();

		}


				
		/* this one takes *.*.*.A.B.C(...)*/

	
		/* we need returnType of last method in $1 so we can check*/
		/* first method in $3	*/
		mParseTree *meth = yyvsp[-6].treeVal->getLastMethodNode();
		
                mParseTree *current = meth;				

                /* domain is return type of this last method*/
		mClass *domain = ((mMethod*)meth->symbol)->returnType;
		

/*///////////////////////////////////////////////////////////////*/
/* isAccessibleOutside dodaj*/
/*///////////////////////////////////////////////////////////////*/

		/* now do this shit for every method except the last one*/
		for(unsigned i = 0; i < yyvsp[-4].stringList->size() - 1; i++ ){
                    mString *methodName = yyvsp[-4].stringList->at( i );
                             
                    /* now we check for parameterless method*/
                    /* 'methodName' in class 'domain'*/
                    mMethod *m = domain->getMethod( methodName );
                             
                    if( !m ){

		      myerror();
		      if(domain->ambiguous)
			cout<<"ambiguous invocation of method '"<<*methodName<<"'"<<endl;
		      else
			cout<<"method '"<<*methodName<<"' not found in class '"
			    <<*domain->name<<"'"<<endl;
		      break;
		    }

		    /* check access privileges*/
		    if( !m->isAccessibleWithin( env->ownerClass ) ){
		      myerror();
		      cout<<"method '"<<*m->name<<"' cannot be invoked because of insuficient"
			  <<" privileges"<<endl;
		      break;
		    }

                    /* generate tree for method call and append it to parent*/
		    mParseTree *call = new mParseTree( NODE_METHODCALL, m );
		    current->append( call );
		    current = call;
                             
		    /* domain for next call is return type of this method*/
		    domain = m->returnType;                             
		}
		
		/* now we deal with the last one which has arguments*/
		mString *methodName = yyvsp[-4].stringList->at( yyvsp[-4].stringList->size() - 1 );
                             
		bool ambiguous = false;

		/* we check for method with parameters*/
		/* 'methodName' in class 'domain'*/
		mMethod *m = domain->getMethod( methodName, yyvsp[-1].treeVal, true, ambiguous );
                             
		if( !m ){

		  myerror();
		  if(ambiguous)
		    cout<<"ambiguous invocation of method '"<<*methodName<<"'"<<endl;
		  else
		    cout<<"method '"<<*methodName<<"' not found in class '"
			<<*domain->name<<"'"<<endl;
		  currentMethodTree = 0;
		  yyval.treeVal = 0;

		}else{


		  /* check access privileges*/
		  if( !m->isAccessibleWithin( env->ownerClass ) ){
		    myerror();
		    cout<<"method '"<<*m->name<<"' cannot be invoked because of insuficient"
			<<" privileges"<<endl;
		    currentMethodTree = 0;
		    yyval.treeVal = 0;
		    break;
		  }


		  if( !yyvsp[-1].treeVal->performArgumentsCast(yyvsp[-1].treeVal, m ) ){

		    myerror();
		    cout<<"cannot perform cast to call method '"<<*m->name<<"'"<<endl;
		    currentMethodTree = 0;
		    yyval.treeVal = 0;
		    break;

		  }

		  /* generate tree for method call and append it to parent*/
		  mParseTree *call = new mParseTree( NODE_METHODCALL, m );
		  current->append( call );

		  /* add arguments*/
		  call->append( yyvsp[-1].treeVal );
		  
		  /* returnType of $1 becomes returnType of last method*/
		  yyvsp[-6].treeVal->returnType = m->returnType;
		  
		  currentMethodTree = yyvsp[-6].treeVal;
		  yyval.treeVal = yyvsp[-6].treeVal;
		  
		}
		
                         		
	      }
break;
case 161:
#line 5617 "parser.y"
{

		 /* do nothing if just importing*/
	         if( importing ) break;

                 cout<<"got array ! "<<endl;


		 /* find last methodcall*/
		 mParseTree *meth = yyvsp[-1].treeVal->getLastMethodNode();
		 

                 /* domain is return type of this last method - must be array of course*/
		 
		 /*mClass *domain = ((mMethod*)meth->symbol)->returnType;*/

                 /* we just put in last method */
		 mParseTree *array = new mParseTree( NODE_ARRAYACCESS, meth->symbol );
		 
		 /* append access expressions*/
		 array->append( yyvsp[0].treeVal );

		 meth->append( array );

		 /* UNFINISHED: returnType???*/

		 /*cout<<"meth="<<meth->toString()<<endl;*/

                 yyval.treeVal = yyvsp[-1].treeVal;
              }
break;
case 162:
#line 5658 "parser.y"
{

		/* do nothing if just importing*/
	        if( importing ) break;

		if(expressionError) break;

                /* this may be a variable or parameterless method call*/
                mEnvironment *env = envStack->top();

		/*//////////////////////////////////////////////////*/
		/* 1 component - simple name*/
		/*//////////////////////////////////////////////////*/
		
		bool ambiguous = false;
                if(yyvsp[0].stringList->size() == 1){  /* one component means variable access or class method*/
		  
                   /* find a variable or method*/
                   mSymbol *sym;
		   if( partialExpression ){  /* FieldAccess on partial expression*/

		     /* if we're accessing field on partial expression it can only be method*/
		     /* i.e. ( "string" ).print*/
		     sym = partialExpression->returnType->getMethod( yyvsp[0].stringList->at( 0 ) );
		     ambiguous = partialExpression->returnType->ambiguous;
		   }else{
		     sym = env->getSymbol( yyvsp[0].stringList->at( 0 ) );
		     ambiguous = env->ownerClass->ambiguous;
		   }

                   if(sym != 0){

                      if( sym->symbolType == SYMBOL_VARIABLE || sym->symbolType == SYMBOL_PARAMETER ){


			  /* generate tree to access a variable*/
			  mParseTree *tree = new mParseTree( NODE_VARIABLE, sym );
                         
                         currentFieldTree = tree;                         
                         yyval.treeVal = tree;

                      }else if( sym->symbolType == SYMBOL_METHOD ){

			mMethod* currentMethod = methodStack->top();

			/* constructor cannot be explicitly called*/
			if( ((mMethod*)sym)->isConstructor() ){
			  myerror();
			  cout<<"constructor '"<<*sym->name<<"' cannot be invoked directly"<<endl;
			  currentFieldTree = 0;
			  yyval.treeVal = 0;
			  break;
			}



			/* non-static methods cannot be called from static*/
			if(!partialExpression && currentMethod->isStatic() && !((mMethod*)sym)->isStatic()){
			  myerror();
			  cout<<"cannot invoke dynamically bound method '"<<*sym->name<<"' from static scope"
			      <<endl;
			  currentFieldTree = 0;
			  yyval.treeVal = 0;
			  break;
			}


			/* check access privileges for this method*/
			if( !((mMethod*)sym)->isAccessibleWithin( env->ownerClass ) ){
			  myerror();
			  cout<<"method '"<<*sym->name<<"' cannot be invoked"<<endl
			      <<"because of insufficient privileges"<<endl;
			  /*currentMethodTree = 0;*/
			  currentFieldTree = 0;
			  yyval.treeVal = 0;
			  break;
			}


			/* generate tree for method invocation*/
			mParseTree *tree = new mParseTree( NODE_METHODCALL, sym, 
							   ((mMethod*)sym)->returnType );

			if( partialExpression ){

			  /* we add this methodcall node to the LAST node in partial expression*/
			  /* if partial expression may have compound call, which means that it's NODE_METHODCALL or*/
			  /* NODE_VARIABLE*/
			  if(partialExpression->type == NODE_METHODCALL || partialExpression->type == NODE_VARIABLE){
			    partialExpression->getLastMethodNode()->append( tree );
			  }else{

			    /* otherwise we simply append invocation to partialExpression*/
			    partialExpression->append( tree );

			  }
  
			  tree = partialExpression;

			  /* return type of whole expression becomes return type of LAST expression*/
			  tree->returnType = ((mMethod*)sym)->returnType;
			  partialExpression = 0;			  
			} 

			currentFieldTree = tree;                         
			yyval.treeVal = tree;

                      }else if(sym->symbolType == SYMBOL_CLASS){

			/* generate tree for class reference*/
			mParseTree *tree = new mParseTree( NODE_CLASSREF, sym, 
							   ((mClass*)sym) );
			if( partialExpression ){

			  partialExpression->append( tree );
			  tree = partialExpression;
			  /* return type of whole expression becomes return type of LAST expression*/
			  /*tree->returnType = ((mMethod*)sym)->returnType;*/
			  partialExpression = 0;			  
			}

			currentFieldTree = tree;                         
			yyval.treeVal = tree;

		      }
                      
                      /* we found no symbol with that name*/
                   }else{
		     myerror();
		     if(ambiguous)
		       cout<<"ambiguous invocation of method '"<<*yyvsp[0].stringList->at( 0 )<<"'"<<endl;
		     else
		       cout<<"no symbol '"<<*yyvsp[0].stringList->at( 0 )<<"' found!"<<endl;
                     /* generate unresolved symbol node*/
                     /*mParseTree *tree = new mParseTree( NODE_UNRESOLVED, $1->at( 0 ) );*/
		     
                         
                     currentFieldTree = 0; /*tree;*/
		     yyval.treeVal = 0;/*tree;*/
                   }
                   
                }else{
                

		  /*//////////////////////////////////////////////////*/
		  /* more than 1 component - compound call*/
		  /*//////////////////////////////////////////////////*/

		  /* more than 1 component indicates that this is a*/
		  /* parameterless method call via variable or classmethod*/
		  /* 1st possibility is: variable.method1.method2.methodN*/
		  /* 2nd possibility is: classmethod.method1.method2.methodN*/

		  /* first let's see what this symbol is		  */

		  mSymbol *sym;
		  if( partialExpression ){  /* FieldAccess on partial expression*/
		    sym = partialExpression->returnType->getMethod( yyvsp[0].stringList->at( 0 ) );
		    ambiguous = partialExpression->returnType->ambiguous;
		  }else{
		    sym = env->getSymbol( yyvsp[0].stringList->at( 0 ) );
		    ambiguous = env->ownerClass->ambiguous;
		  /*cout<<"looking for symbol "<<*$1->at( 0 )<<endl;*/

		  }


		  if( sym != 0 ){
		    /*cout<<"found for symbol "<<*$1->at( 0 )<<endl;*/

		    if( sym->symbolType == SYMBOL_VARIABLE || sym->symbolType == SYMBOL_PARAMETER ){

		      /* we have a variable, so this means we're accessing*/
		      /* a parameterless method via a local variable*/

		      /* 1st we create a variable access node*/
		      mParseTree *tree = new mParseTree( NODE_VARIABLE, sym );

		      mParseTree *current = tree;

		      /* constructor cannot be explicitly called*/
		      if( ((mMethod*)sym)->isConstructor() ){
			myerror();
			cout<<"constructor '"<<*sym->name<<"' cannot be invoked directly"<<endl;
			currentMethodTree = 0;
			yyval.treeVal = 0;
			break;
		      }
                         
		      /* now we create child nodes for every additional*/
		      /* method call, i.e. in 'var.meth1.meth2' we would*/
		      /* generate method calls for meth1 and meth2*/

		      /* we need class of our variable so we can check*/
		      /* for methods*/
		      mClass *domain = sym->theClass;

		      for(unsigned i = 1; i < yyvsp[0].stringList->size(); i++ ){
			mString *methodName = yyvsp[0].stringList->at( i );
                             
			/* find parameterless method*/
			/* 'methodName' in class 'domain'*/
			mMethod *m = domain->getMethod( methodName );
			
			if( !m ){

			  myerror();
			  if(domain->ambiguous)
			    cout<<"ambiguous invocation of method '"<<*methodName<<"'"<<endl;
			  else
			    cout<<"method '"<<*methodName<<"' not found in class '"
				<<*domain->name<<"'"<<endl;

			  /* candidates are:*/
			  /* domain->getAllMethods( methodName );*/
			  /* don't parse any further*/
			  tree = 0; break;

			}
			

			/* check access privileges for this method*/
			if( !m->isAccessibleWithin( env->ownerClass ) ){
			  myerror();
			  cout<<"method '"<<*methodName<<"' cannot be invoked"<<endl
			      <<"because of insufficient privileges"<<endl;
			  /*currentMethodTree = 0;*/
			  tree = 0;
			  break;
			}
			
			/* generate tree for method call and append it*/
			/* to parent                             */
			mParseTree *call = new mParseTree( NODE_METHODCALL, m );
			current->append( call );
			current = call;
			
			/* domain for next call is return type of this method*/
			domain = m->returnType;			
                             
		      }
                       

		      /* returnType of variable in sequence calls must be set to returnType*/
		      /* of last method invoked, i.e. in an invocation sequence meth1.meth2.meth3*/
		      /* the returnType becomes that of meth3*/
		      if(tree) tree->returnType = domain;
  
		      currentFieldTree = tree;
		      yyval.treeVal = tree;
                         



		    }else if( sym->symbolType == SYMBOL_METHOD ){
                      
		      mMethod* currentMethod = methodStack->top();

		      /* we have a method which means we're accessing*/
		      /* a parameterless method via a parameterless class method*/

		      /* constructor cannot be explicitly called*/
		      if( ((mMethod*)sym)->isConstructor() ){
			myerror();
			cout<<"constructor '"<<*sym->name<<"' cannot be invoked directly"<<endl;
			currentFieldTree = 0;
			yyval.treeVal = 0;
			break;
		      }



		      /* non-static methods cannot be called from static*/
		      if(!partialExpression && currentMethod->isStatic() && !((mMethod*)sym)->isStatic()){
			myerror();
			cout<<"cannot invoke dynamically bound method '"<<*sym->name<<"' from static scope"
			    <<endl;
			currentFieldTree = 0;
			yyval.treeVal = 0;
			break;
		      }


		      /* check access privileges for this method*/
		      if( !((mMethod*)sym)->isAccessibleWithin( env->ownerClass ) ){
			myerror();
			cout<<"method '"<<*sym->name<<"' cannot be invoked"<<endl
			    <<"because of insufficient privileges"<<endl;
			currentFieldTree = 0;
			yyval.treeVal = 0;
			break;
		      }



		      /* 1st we create methodcall for class method*/
		      mParseTree *tree = new mParseTree( NODE_METHODCALL, sym );
		      currentFieldTree = tree;

		      if( partialExpression ){

			partialExpression->append( tree );
			currentFieldTree = partialExpression;
			/* return type of whole expression becomes return type of LAST expression*/
			tree->returnType = ((mMethod*)sym)->returnType;
			partialExpression = 0;
		      }

		      mParseTree *current = tree;		      

		      /* now we create child nodes for every additional*/
		      /* method call, i.e. in 'meth.meth1.meth2' we would*/
		      /* generate method calls for meth1 and meth2*/
		      
		      /* we need class of our variable so we can check*/
		      /* for methods*/
		      mClass *domain = ((mMethod*)sym)->returnType;
		      
		      for(unsigned i = 1; i < yyvsp[0].stringList->size(); i++ ){
			mString *methodName = yyvsp[0].stringList->at( i );
			
			/* now we check for parameterless method*/
			/* 'methodName' in class 'domain'*/
			mMethod *m = domain->getMethod( methodName );
                             
			if( !m ){

			  myerror();
			  if(domain->ambiguous)
			    cout<<"ambiguous invocation of method '"<<*methodName<<"'"<<endl;
			  else
			    cout<<"method '"<<*methodName<<"' not found in class '"
				<<*domain->name<<"'"<<endl;
			  /* don't parse any further*/
			  tree = 0; break;

			}


			/* check access privileges for this method*/
			if( !m->isAccessibleWithin( env->ownerClass ) ){
			  myerror();
			  cout<<"method '"<<*methodName<<"' cannot be invoked"<<endl
			      <<"because of insufficient privileges"<<endl;
			  /*currentMethodTree = 0;*/
			  tree = 0;
			  break;
			}

			/* generate tree for method call and append it*/
			/* to parent                             */
			mParseTree *call = new mParseTree( NODE_METHODCALL, m );
			current->append( call );
			current = call;
			
			/* domain for next call is return type of this method*/
			domain = m->returnType;                             
		      }
                         
		      /* returnType of variable in sequence calls must be set to returnType*/
		      /* of last method invoked, i.e. in an invocation sequence meth1.meth2.meth3*/
		      /* the returnType becomes that of meth3*/
		      if(tree) tree->returnType = domain;		      

		      yyval.treeVal = tree;
		    }
                      
                      
		  }else{

		    /* we found no symbol with this name*/
		    myerror();
		    if(ambiguous)
		      cout<<"ambiguous invocation of method '"<<*yyvsp[0].stringList->at( 0 )<<"'"<<endl;
		    else
		      cout<<"no symbol '"<<*yyvsp[0].stringList->at( 0 )<<"' found!"<<endl;
		    /* generate unresolved symbol node*/
		    /*mParseTree *tree = new mParseTree( NODE_UNRESOLVED, $1->at( 0 ) );*/
                         
		    currentFieldTree = 0;/*tree;*/
		    yyval.treeVal = 0;/*tree;*/
		  }

                } /* }else{ // more than one component*/

               }
break;
case 163:
#line 6050 "parser.y"
{

                 /* do nothing if just importing*/
	         if( importing ) break;

		 mEnvironment *env = envStack->top();


                 currentFieldTree = currentMethodTree;

                 /* $1 contains sequence of calls now. we must find the last*/
                 /* method called to get its return type*/
                 mParseTree *meth = currentMethodTree->getLastMethodNode();

                 mParseTree *current = meth;

                 /* domain is return type of this last method*/
                 mClass *domain = ((mMethod*)meth->symbol)->returnType;
		 
                 /* now generate parameterless method calls*/
                 for(unsigned i = 0; i < yyvsp[0].stringList->size(); i++ ){
		   mString *methodName = yyvsp[0].stringList->at( i );
                             
		   /* now we check for parameterless method*/
		   /* 'methodName' in class 'domain'*/
		   mMethod *m = domain->getMethod( methodName );
                             
		   if( !m ){

		     myerror();
		     if(domain->ambiguous)
		       cout<<"ambiguous invocation of method '"<<*methodName<<"'"<<endl;
		     else
		       cout<<"method '"<<*methodName<<"' not found in class '"
			   <<*domain->name<<"'"<<endl;
		     currentFieldTree = 0;
		     break;

		   }


		   /* check access privileges for this method*/
		   if( !m->isAccessibleWithin( env->ownerClass ) ){
		     myerror();
		     cout<<"method '"<<*methodName<<"' cannot be invoked"<<endl
			 <<"because of insufficient privileges"<<endl;
		     currentFieldTree = 0;
		     break;
		   }


		   /* generate tree for method call and append it*/
		   /* to parent*/
		   mParseTree *call = new mParseTree( NODE_METHODCALL, m );
		   current->append( call );
		   current = call;
                             
		   /* domain for next call is return type of this method*/
		   domain = m->returnType;
		 }
                 
		 /* returnType of variable in sequence calls must be set to returnType*/
		 /* of last method invoked, i.e. in an invocation sequence meth1.meth2.meth3*/
		 /* the returnType becomes that of meth3*/
		 if(currentFieldTree) currentFieldTree->returnType = domain;

                 yyval.treeVal = currentFieldTree;
               }
break;
case 164:
#line 6123 "parser.y"
{

                   /* do nothing if just importing*/
		   if( importing ) break;

                   mParseTree *meth = yyvsp[-1].treeVal->getLastMethodNode();

                   /*mClass *domain = ((mMethod*)meth->symbol)->returnType;*/

                   /* we just put in last method */
		   mParseTree *array = new mParseTree( NODE_ARRAYACCESS, meth->symbol );
		 
		   /* append access expressions*/
		   array->append( yyvsp[0].treeVal );

		   meth->append( array );


		   /* UNFINISHED: je $1->returnType ze nastavljen na returnType zadnje metode?*/

		   /*$1->returnType = $2->returnType*/


		   yyval.treeVal = yyvsp[-1].treeVal;
	       }
break;
case 165:
#line 6148 "parser.y"
{

		   /* do nothing if just importing*/
		   if( importing ) break;
                   
		   mParseTree *meth = yyvsp[-3].treeVal->getLastMethodNode();

                   mClass *domain = ((mMethod*)meth->symbol)->returnType;

                   /* we just put in last method */
		   mParseTree *array = new mParseTree( NODE_ARRAYACCESS, meth->symbol );
		 
		   /* append access expressions*/
		   array->append( yyvsp[-2].treeVal );

		   meth->append( array );

		   /* and the rest...*/
		   /*array->append( $4 );*/

		   mParseTree *current = array;

                 /* now generate parameterless method calls*/
                 for(unsigned i = 0; i < yyvsp[0].stringList->size(); i++ ){
                     mString *methodName = yyvsp[0].stringList->at( i );
                             
                     /* now we check for parameterless method*/
                     /* 'methodName' in class 'domain'*/
                     mMethod *m = domain->getMethod( methodName );
                             
                     if( !m ){
		       
		       myerror();
		       cout<<"method '"<<*methodName<<"' not found in class '"
			   <<*domain->name<<"'"<<endl;
		       break;

                     }

                     /* generate tree for method call and append it*/
                     /* to parent*/
                     mParseTree *call = new mParseTree( NODE_METHODCALL, m );
                     current->append( call );
                     current = call;
                             
                     /* domain for next call is return type of this method*/
                     domain = m->returnType;
		 }
 
		   yyval.treeVal = yyvsp[-3].treeVal;
	       }
break;
case 166:
#line 6199 "parser.y"
{


		   /* do nothing if just importing*/
		   if( importing ) break;

                   mParseTree *meth = yyvsp[-6].treeVal->getLastMethodNode();

                   mClass *domain = ((mMethod*)meth->symbol)->returnType;

                   /* we just put in last method */
		   mParseTree *array = new mParseTree( NODE_ARRAYACCESS, meth->symbol );
		 
		   /* append access expressions*/
		   array->append( yyvsp[-5].treeVal );

		   meth->append( array );

		   mParseTree *current = array;

		   /* now generate parameterless method calls*/
		   for(unsigned i = 0; i < yyvsp[-3].stringList->size() - 1; i++ ){
                     mString *methodName = yyvsp[-3].stringList->at( i );
                             
                     /* now we check for parameterless method*/
                     /* 'methodName' in class 'domain'*/
                     mMethod *m = domain->getMethod( methodName );
                             
                     if( !m ){

		       myerror();
		       cout<<"method '"<<*methodName<<"' not found in class '"
			   <<*domain->name<<"'"<<endl;
		       break;

                     }

                     /* generate tree for method call and append it*/
                     /* to parent*/
                     mParseTree *call = new mParseTree( NODE_METHODCALL, m );
                     current->append( call );
                     current = call;
                             
                     /* domain for next call is return type of this method*/
                     domain = m->returnType;
		 }

		 /* now we deal with the last one*/
		 mString *methodName = yyvsp[-3].stringList->at( yyvsp[-3].stringList->size() - 1 );

		 bool ambiguous = false;
                             
		 /* now we check for method with parameters*/
		 /* 'methodName' in class 'domain'*/
		 mMethod *m = domain->getMethod( methodName, yyvsp[-1].treeVal, true, ambiguous );
                             
		 if( !m ){

		   myerror();
		   cout<<"method '"<<*methodName<<"' not found in class '"
		       <<*domain->name<<"'"<<endl;

		 }else{


		   if( !yyvsp[-1].treeVal->performArgumentsCast(yyvsp[-1].treeVal, m ) ){

		     myerror();
		     cout<<"cannot perform cast to call method '"<<*m->name<<"'"<<endl;
		     currentMethodTree = 0;
		     yyval.treeVal = 0;
		     break;

		   }

		   /* generate tree for method call and append it*/
		   /* to parent*/
		   mParseTree *call = new mParseTree( NODE_METHODCALL, m );
		   current->append( call );

		   /* add arguments*/
		   call->append( yyvsp[-1].treeVal );
		 }                                 

		   yyval.treeVal = yyvsp[-6].treeVal;
	       }
break;
case 167:
#line 6297 "parser.y"
{

                /* do nothing if just importing*/
                if( importing ) break;

                /* create ARGUMENTS node (for every dimension)*/
		mParseTree *expr = new mParseTree( NODE_ARGUMENTS ); 
		expr->append( yyvsp[-1].treeVal );
		yyval.treeVal = expr;  

              }
break;
case 168:
#line 6309 "parser.y"
{

		 /* do nothing if just importing*/
		 if( importing ) break;

	         yyvsp[-3].treeVal->append( yyvsp[-1].treeVal );
		 yyval.treeVal = yyvsp[-3].treeVal;
              }
break;
case 170:
#line 6323 "parser.y"
{

		/* do nothing if just importing*/
		if( importing ) break;

		if(!allowParameters){
		  myerror();
		  cout<<"cannot pass parameters like this"<<endl;
		  yyval.treeVal = 0;
		  break;

		}

		cout<<"got parameter list instead of arguments"<<endl;

		mParseTree *args = new mParseTree( NODE_ARGUMENTS ); 

		/* append all parameters*/
		for( mParameter* param = yyvsp[0].parameterListVal->first(); param != 0; param = yyvsp[0].parameterListVal->next() ){

		  args->append( new mParseTree(NODE_PARAMETER, param) );

		}
		
		yyval.treeVal = args;


               }
break;
case 171:
#line 6353 "parser.y"
{

		/* do nothing if just importing*/
		if( importing ) break;


		/* check whether expression is a block containing return*/
		if(yyvsp[0].treeVal->closureReturns()){
		  myerror();
		  cout<<"cannot return from escapable block"<<endl;
		  break;
		}

		/* check whether expression is a block containing assignment to parent*/
		/* variable*/
		if(yyvsp[0].treeVal->closureAssignsToParent()){
		  myerror();
		  cout<<"cannot assign to parent variable from escapable block"<<endl;
		  break;
		}
		
		
		/* create arguments node*/
		mParseTree *args = new mParseTree( NODE_ARGUMENTS ); 
		args->append( yyvsp[0].treeVal );
		yyval.treeVal = args;
            }
break;
case 172:
#line 6380 "parser.y"
{

	      /* do nothing if just importing*/
	      if( importing ) break;


	      /* check whether expression is a block containing return*/
	      if(yyvsp[0].treeVal->closureReturns()){
		myerror();
		cout<<"cannot return from escapable block"<<endl;
		break;
	      }

	      /* check whether expression is a block containing assignment to parent*/
	      /* variable*/
	      if(yyvsp[0].treeVal->closureAssignsToParent()){
		myerror();
		cout<<"cannot assign to parent variable from escapable block"<<endl;
		yyval.treeVal = 0;
		break;
	      }
	      
	      yyvsp[-2].treeVal->append( yyvsp[0].treeVal );
	      yyval.treeVal = yyvsp[-2].treeVal;
            }
break;
case 173:
#line 6412 "parser.y"
{

	          /* do nothing if just importing*/
	          if( importing ) break;


		  mClass* theType = mUtil::getQualifiedType( yyvsp[0].stringList, root );

                  if( theType != 0 ){
                    /* create construction node*/
                    mParseTree *con = new mParseTree( NODE_CONSTRUCTION, theType );

                    /* object is created by calling constructor. find parameterless*/
                    /* constructor for class theType*/


                    mMethod* constructor = theType->getDefaultConstructor();
              
                    if( !constructor ){
                      myerror();
                      cout<<"i need a default constructor to construct '"
                          <<*theType->name<<"' like this"<<endl;
                      yyval.treeVal = 0;
                    }else{

                      mParseTree *call = new mParseTree( NODE_METHODCALL,
                                                         constructor );
                      con->append( call );
		      con->returnType = theType;
                      yyval.treeVal = con;
                    }
                  }else{

		    /* erroneous type*/
		    myerror();
		    cout<<"no suitable type '"<<mUtil::getQualifiedTypeName(yyvsp[0].stringList)<<"'"<<endl;
		    yyval.treeVal = 0;
		  }
                }
break;
case 174:
#line 6454 "parser.y"
{

                 /* do nothing if just importing*/
		 if( importing ) break;


		 mClass* theType = mUtil::getQualifiedType( yyvsp[-3].stringList, root );

		 if( theType != 0 ){
                    /* create construction node*/
                    mParseTree *con = new mParseTree( NODE_CONSTRUCTION, theType );

		    bool ambiguous = false;

                    /* constructor is a method with the same name as the class*/
		    /* search only this class (not superclasses)*/
                    mMethod* constructor = theType->getMethod( theType->name, yyvsp[-1].treeVal, false, ambiguous );
              
		    /*cout<<"searching for constructor "<<$4->toString()<<endl;*/

                    if( !constructor ){
                      myerror();
		      if( theType->ambiguous )
			cout<<"constructor invocation is ambiguous"<<endl;
		      else
			cout<<"no suitable constructor to construct '"
			    <<*theType->name<<"' like this"<<endl;
                      yyval.treeVal = 0;
		      break;

                    }else{

		      if( !yyvsp[-1].treeVal->performArgumentsCast(yyvsp[-1].treeVal, constructor ) ){

			myerror();
			cout<<"cannot perform cast to call method '"<<*constructor->name<<"'"<<endl;
			yyval.treeVal = 0;
			break;

		      }

                      mParseTree *call = new mParseTree( NODE_METHODCALL,
                                                         constructor );
		      /* append arguments*/
		      call->append( yyvsp[-1].treeVal );

                      con->append( call );
		      con->returnType = theType;		      
                      yyval.treeVal = con;
                    }
		 }else{

		   /* erroneous type*/
		   myerror();
		   cout<<"no suitable type '"<<mUtil::getQualifiedTypeName(yyvsp[-3].stringList)<<"'"<<endl;
		   yyval.treeVal = 0;
		 }
               }
break;
#line 7521 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
